//megafunction wizard: %Altera SOPC Builder%
//GENERATION: STANDARD
//VERSION: WM1.0


//Legal Notice: (C)2012 Altera Corporation. All rights reserved.  Your
//use of Altera Corporation's design tools, logic functions and other
//software and tools, and its AMPP partner logic functions, and any
//output files any of the foregoing (including device programming or
//simulation files), and any associated documentation or information are
//expressly subject to the terms and conditions of the Altera Program
//License Subscription Agreement or other applicable license agreement,
//including, without limitation, that your use is for the sole purpose
//of programming logic devices manufactured by Altera and sold by Altera
//or its authorized distributors.  Please refer to the applicable
//agreement for further details.

// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module adc_data_ready_s1_arbitrator (
                                      // inputs:
                                       adc_data_ready_s1_readdata,
                                       clk,
                                       cpu_data_master_address_to_slave,
                                       cpu_data_master_read,
                                       cpu_data_master_write,
                                       reset_n,

                                      // outputs:
                                       adc_data_ready_s1_address,
                                       adc_data_ready_s1_readdata_from_sa,
                                       adc_data_ready_s1_reset_n,
                                       cpu_data_master_granted_adc_data_ready_s1,
                                       cpu_data_master_qualified_request_adc_data_ready_s1,
                                       cpu_data_master_read_data_valid_adc_data_ready_s1,
                                       cpu_data_master_requests_adc_data_ready_s1,
                                       d1_adc_data_ready_s1_end_xfer
                                    )
;

  output  [  1: 0] adc_data_ready_s1_address;
  output  [ 31: 0] adc_data_ready_s1_readdata_from_sa;
  output           adc_data_ready_s1_reset_n;
  output           cpu_data_master_granted_adc_data_ready_s1;
  output           cpu_data_master_qualified_request_adc_data_ready_s1;
  output           cpu_data_master_read_data_valid_adc_data_ready_s1;
  output           cpu_data_master_requests_adc_data_ready_s1;
  output           d1_adc_data_ready_s1_end_xfer;
  input   [ 31: 0] adc_data_ready_s1_readdata;
  input            clk;
  input   [ 16: 0] cpu_data_master_address_to_slave;
  input            cpu_data_master_read;
  input            cpu_data_master_write;
  input            reset_n;

  wire    [  1: 0] adc_data_ready_s1_address;
  wire             adc_data_ready_s1_allgrants;
  wire             adc_data_ready_s1_allow_new_arb_cycle;
  wire             adc_data_ready_s1_any_bursting_master_saved_grant;
  wire             adc_data_ready_s1_any_continuerequest;
  wire             adc_data_ready_s1_arb_counter_enable;
  reg              adc_data_ready_s1_arb_share_counter;
  wire             adc_data_ready_s1_arb_share_counter_next_value;
  wire             adc_data_ready_s1_arb_share_set_values;
  wire             adc_data_ready_s1_beginbursttransfer_internal;
  wire             adc_data_ready_s1_begins_xfer;
  wire             adc_data_ready_s1_end_xfer;
  wire             adc_data_ready_s1_firsttransfer;
  wire             adc_data_ready_s1_grant_vector;
  wire             adc_data_ready_s1_in_a_read_cycle;
  wire             adc_data_ready_s1_in_a_write_cycle;
  wire             adc_data_ready_s1_master_qreq_vector;
  wire             adc_data_ready_s1_non_bursting_master_requests;
  wire    [ 31: 0] adc_data_ready_s1_readdata_from_sa;
  reg              adc_data_ready_s1_reg_firsttransfer;
  wire             adc_data_ready_s1_reset_n;
  reg              adc_data_ready_s1_slavearbiterlockenable;
  wire             adc_data_ready_s1_slavearbiterlockenable2;
  wire             adc_data_ready_s1_unreg_firsttransfer;
  wire             adc_data_ready_s1_waits_for_read;
  wire             adc_data_ready_s1_waits_for_write;
  wire             cpu_data_master_arbiterlock;
  wire             cpu_data_master_arbiterlock2;
  wire             cpu_data_master_continuerequest;
  wire             cpu_data_master_granted_adc_data_ready_s1;
  wire             cpu_data_master_qualified_request_adc_data_ready_s1;
  wire             cpu_data_master_read_data_valid_adc_data_ready_s1;
  wire             cpu_data_master_requests_adc_data_ready_s1;
  wire             cpu_data_master_saved_grant_adc_data_ready_s1;
  reg              d1_adc_data_ready_s1_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_adc_data_ready_s1;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [ 16: 0] shifted_address_to_adc_data_ready_s1_from_cpu_data_master;
  wire             wait_for_adc_data_ready_s1_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else 
        d1_reasons_to_wait <= ~adc_data_ready_s1_end_xfer;
    end


  assign adc_data_ready_s1_begins_xfer = ~d1_reasons_to_wait & ((cpu_data_master_qualified_request_adc_data_ready_s1));
  //assign adc_data_ready_s1_readdata_from_sa = adc_data_ready_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign adc_data_ready_s1_readdata_from_sa = adc_data_ready_s1_readdata;

  assign cpu_data_master_requests_adc_data_ready_s1 = (({cpu_data_master_address_to_slave[16 : 4] , 4'b0} == 17'h110) & (cpu_data_master_read | cpu_data_master_write)) & cpu_data_master_read;
  //adc_data_ready_s1_arb_share_counter set values, which is an e_mux
  assign adc_data_ready_s1_arb_share_set_values = 1;

  //adc_data_ready_s1_non_bursting_master_requests mux, which is an e_mux
  assign adc_data_ready_s1_non_bursting_master_requests = cpu_data_master_requests_adc_data_ready_s1;

  //adc_data_ready_s1_any_bursting_master_saved_grant mux, which is an e_mux
  assign adc_data_ready_s1_any_bursting_master_saved_grant = 0;

  //adc_data_ready_s1_arb_share_counter_next_value assignment, which is an e_assign
  assign adc_data_ready_s1_arb_share_counter_next_value = adc_data_ready_s1_firsttransfer ? (adc_data_ready_s1_arb_share_set_values - 1) : |adc_data_ready_s1_arb_share_counter ? (adc_data_ready_s1_arb_share_counter - 1) : 0;

  //adc_data_ready_s1_allgrants all slave grants, which is an e_mux
  assign adc_data_ready_s1_allgrants = |adc_data_ready_s1_grant_vector;

  //adc_data_ready_s1_end_xfer assignment, which is an e_assign
  assign adc_data_ready_s1_end_xfer = ~(adc_data_ready_s1_waits_for_read | adc_data_ready_s1_waits_for_write);

  //end_xfer_arb_share_counter_term_adc_data_ready_s1 arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_adc_data_ready_s1 = adc_data_ready_s1_end_xfer & (~adc_data_ready_s1_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //adc_data_ready_s1_arb_share_counter arbitration counter enable, which is an e_assign
  assign adc_data_ready_s1_arb_counter_enable = (end_xfer_arb_share_counter_term_adc_data_ready_s1 & adc_data_ready_s1_allgrants) | (end_xfer_arb_share_counter_term_adc_data_ready_s1 & ~adc_data_ready_s1_non_bursting_master_requests);

  //adc_data_ready_s1_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          adc_data_ready_s1_arb_share_counter <= 0;
      else if (adc_data_ready_s1_arb_counter_enable)
          adc_data_ready_s1_arb_share_counter <= adc_data_ready_s1_arb_share_counter_next_value;
    end


  //adc_data_ready_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          adc_data_ready_s1_slavearbiterlockenable <= 0;
      else if ((|adc_data_ready_s1_master_qreq_vector & end_xfer_arb_share_counter_term_adc_data_ready_s1) | (end_xfer_arb_share_counter_term_adc_data_ready_s1 & ~adc_data_ready_s1_non_bursting_master_requests))
          adc_data_ready_s1_slavearbiterlockenable <= |adc_data_ready_s1_arb_share_counter_next_value;
    end


  //cpu/data_master adc_data_ready/s1 arbiterlock, which is an e_assign
  assign cpu_data_master_arbiterlock = adc_data_ready_s1_slavearbiterlockenable & cpu_data_master_continuerequest;

  //adc_data_ready_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign adc_data_ready_s1_slavearbiterlockenable2 = |adc_data_ready_s1_arb_share_counter_next_value;

  //cpu/data_master adc_data_ready/s1 arbiterlock2, which is an e_assign
  assign cpu_data_master_arbiterlock2 = adc_data_ready_s1_slavearbiterlockenable2 & cpu_data_master_continuerequest;

  //adc_data_ready_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  assign adc_data_ready_s1_any_continuerequest = 1;

  //cpu_data_master_continuerequest continued request, which is an e_assign
  assign cpu_data_master_continuerequest = 1;

  assign cpu_data_master_qualified_request_adc_data_ready_s1 = cpu_data_master_requests_adc_data_ready_s1;
  //master is always granted when requested
  assign cpu_data_master_granted_adc_data_ready_s1 = cpu_data_master_qualified_request_adc_data_ready_s1;

  //cpu/data_master saved-grant adc_data_ready/s1, which is an e_assign
  assign cpu_data_master_saved_grant_adc_data_ready_s1 = cpu_data_master_requests_adc_data_ready_s1;

  //allow new arb cycle for adc_data_ready/s1, which is an e_assign
  assign adc_data_ready_s1_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign adc_data_ready_s1_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign adc_data_ready_s1_master_qreq_vector = 1;

  //adc_data_ready_s1_reset_n assignment, which is an e_assign
  assign adc_data_ready_s1_reset_n = reset_n;

  //adc_data_ready_s1_firsttransfer first transaction, which is an e_assign
  assign adc_data_ready_s1_firsttransfer = adc_data_ready_s1_begins_xfer ? adc_data_ready_s1_unreg_firsttransfer : adc_data_ready_s1_reg_firsttransfer;

  //adc_data_ready_s1_unreg_firsttransfer first transaction, which is an e_assign
  assign adc_data_ready_s1_unreg_firsttransfer = ~(adc_data_ready_s1_slavearbiterlockenable & adc_data_ready_s1_any_continuerequest);

  //adc_data_ready_s1_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          adc_data_ready_s1_reg_firsttransfer <= 1'b1;
      else if (adc_data_ready_s1_begins_xfer)
          adc_data_ready_s1_reg_firsttransfer <= adc_data_ready_s1_unreg_firsttransfer;
    end


  //adc_data_ready_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign adc_data_ready_s1_beginbursttransfer_internal = adc_data_ready_s1_begins_xfer;

  assign shifted_address_to_adc_data_ready_s1_from_cpu_data_master = cpu_data_master_address_to_slave;
  //adc_data_ready_s1_address mux, which is an e_mux
  assign adc_data_ready_s1_address = shifted_address_to_adc_data_ready_s1_from_cpu_data_master >> 2;

  //d1_adc_data_ready_s1_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_adc_data_ready_s1_end_xfer <= 1;
      else 
        d1_adc_data_ready_s1_end_xfer <= adc_data_ready_s1_end_xfer;
    end


  //adc_data_ready_s1_waits_for_read in a cycle, which is an e_mux
  assign adc_data_ready_s1_waits_for_read = adc_data_ready_s1_in_a_read_cycle & adc_data_ready_s1_begins_xfer;

  //adc_data_ready_s1_in_a_read_cycle assignment, which is an e_assign
  assign adc_data_ready_s1_in_a_read_cycle = cpu_data_master_granted_adc_data_ready_s1 & cpu_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = adc_data_ready_s1_in_a_read_cycle;

  //adc_data_ready_s1_waits_for_write in a cycle, which is an e_mux
  assign adc_data_ready_s1_waits_for_write = adc_data_ready_s1_in_a_write_cycle & 0;

  //adc_data_ready_s1_in_a_write_cycle assignment, which is an e_assign
  assign adc_data_ready_s1_in_a_write_cycle = cpu_data_master_granted_adc_data_ready_s1 & cpu_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = adc_data_ready_s1_in_a_write_cycle;

  assign wait_for_adc_data_ready_s1_counter = 0;

//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //adc_data_ready/s1 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else 
        enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module altpll_0_pll_slave_arbitrator (
                                       // inputs:
                                        altpll_0_pll_slave_readdata,
                                        clk,
                                        reset_n,
                                        uC_clock_0_out_address_to_slave,
                                        uC_clock_0_out_read,
                                        uC_clock_0_out_write,
                                        uC_clock_0_out_writedata,

                                       // outputs:
                                        altpll_0_pll_slave_address,
                                        altpll_0_pll_slave_read,
                                        altpll_0_pll_slave_readdata_from_sa,
                                        altpll_0_pll_slave_reset,
                                        altpll_0_pll_slave_write,
                                        altpll_0_pll_slave_writedata,
                                        d1_altpll_0_pll_slave_end_xfer,
                                        uC_clock_0_out_granted_altpll_0_pll_slave,
                                        uC_clock_0_out_qualified_request_altpll_0_pll_slave,
                                        uC_clock_0_out_read_data_valid_altpll_0_pll_slave,
                                        uC_clock_0_out_requests_altpll_0_pll_slave
                                     )
;

  output  [  1: 0] altpll_0_pll_slave_address;
  output           altpll_0_pll_slave_read;
  output  [ 31: 0] altpll_0_pll_slave_readdata_from_sa;
  output           altpll_0_pll_slave_reset;
  output           altpll_0_pll_slave_write;
  output  [ 31: 0] altpll_0_pll_slave_writedata;
  output           d1_altpll_0_pll_slave_end_xfer;
  output           uC_clock_0_out_granted_altpll_0_pll_slave;
  output           uC_clock_0_out_qualified_request_altpll_0_pll_slave;
  output           uC_clock_0_out_read_data_valid_altpll_0_pll_slave;
  output           uC_clock_0_out_requests_altpll_0_pll_slave;
  input   [ 31: 0] altpll_0_pll_slave_readdata;
  input            clk;
  input            reset_n;
  input   [  3: 0] uC_clock_0_out_address_to_slave;
  input            uC_clock_0_out_read;
  input            uC_clock_0_out_write;
  input   [ 31: 0] uC_clock_0_out_writedata;

  wire    [  1: 0] altpll_0_pll_slave_address;
  wire             altpll_0_pll_slave_allgrants;
  wire             altpll_0_pll_slave_allow_new_arb_cycle;
  wire             altpll_0_pll_slave_any_bursting_master_saved_grant;
  wire             altpll_0_pll_slave_any_continuerequest;
  wire             altpll_0_pll_slave_arb_counter_enable;
  reg              altpll_0_pll_slave_arb_share_counter;
  wire             altpll_0_pll_slave_arb_share_counter_next_value;
  wire             altpll_0_pll_slave_arb_share_set_values;
  wire             altpll_0_pll_slave_beginbursttransfer_internal;
  wire             altpll_0_pll_slave_begins_xfer;
  wire             altpll_0_pll_slave_end_xfer;
  wire             altpll_0_pll_slave_firsttransfer;
  wire             altpll_0_pll_slave_grant_vector;
  wire             altpll_0_pll_slave_in_a_read_cycle;
  wire             altpll_0_pll_slave_in_a_write_cycle;
  wire             altpll_0_pll_slave_master_qreq_vector;
  wire             altpll_0_pll_slave_non_bursting_master_requests;
  wire             altpll_0_pll_slave_read;
  wire    [ 31: 0] altpll_0_pll_slave_readdata_from_sa;
  reg              altpll_0_pll_slave_reg_firsttransfer;
  wire             altpll_0_pll_slave_reset;
  reg              altpll_0_pll_slave_slavearbiterlockenable;
  wire             altpll_0_pll_slave_slavearbiterlockenable2;
  wire             altpll_0_pll_slave_unreg_firsttransfer;
  wire             altpll_0_pll_slave_waits_for_read;
  wire             altpll_0_pll_slave_waits_for_write;
  wire             altpll_0_pll_slave_write;
  wire    [ 31: 0] altpll_0_pll_slave_writedata;
  reg              d1_altpll_0_pll_slave_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_altpll_0_pll_slave;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [  3: 0] shifted_address_to_altpll_0_pll_slave_from_uC_clock_0_out;
  wire             uC_clock_0_out_arbiterlock;
  wire             uC_clock_0_out_arbiterlock2;
  wire             uC_clock_0_out_continuerequest;
  wire             uC_clock_0_out_granted_altpll_0_pll_slave;
  wire             uC_clock_0_out_qualified_request_altpll_0_pll_slave;
  wire             uC_clock_0_out_read_data_valid_altpll_0_pll_slave;
  wire             uC_clock_0_out_requests_altpll_0_pll_slave;
  wire             uC_clock_0_out_saved_grant_altpll_0_pll_slave;
  wire             wait_for_altpll_0_pll_slave_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else 
        d1_reasons_to_wait <= ~altpll_0_pll_slave_end_xfer;
    end


  assign altpll_0_pll_slave_begins_xfer = ~d1_reasons_to_wait & ((uC_clock_0_out_qualified_request_altpll_0_pll_slave));
  //assign altpll_0_pll_slave_readdata_from_sa = altpll_0_pll_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign altpll_0_pll_slave_readdata_from_sa = altpll_0_pll_slave_readdata;

  assign uC_clock_0_out_requests_altpll_0_pll_slave = (1) & (uC_clock_0_out_read | uC_clock_0_out_write);
  //altpll_0_pll_slave_arb_share_counter set values, which is an e_mux
  assign altpll_0_pll_slave_arb_share_set_values = 1;

  //altpll_0_pll_slave_non_bursting_master_requests mux, which is an e_mux
  assign altpll_0_pll_slave_non_bursting_master_requests = uC_clock_0_out_requests_altpll_0_pll_slave;

  //altpll_0_pll_slave_any_bursting_master_saved_grant mux, which is an e_mux
  assign altpll_0_pll_slave_any_bursting_master_saved_grant = 0;

  //altpll_0_pll_slave_arb_share_counter_next_value assignment, which is an e_assign
  assign altpll_0_pll_slave_arb_share_counter_next_value = altpll_0_pll_slave_firsttransfer ? (altpll_0_pll_slave_arb_share_set_values - 1) : |altpll_0_pll_slave_arb_share_counter ? (altpll_0_pll_slave_arb_share_counter - 1) : 0;

  //altpll_0_pll_slave_allgrants all slave grants, which is an e_mux
  assign altpll_0_pll_slave_allgrants = |altpll_0_pll_slave_grant_vector;

  //altpll_0_pll_slave_end_xfer assignment, which is an e_assign
  assign altpll_0_pll_slave_end_xfer = ~(altpll_0_pll_slave_waits_for_read | altpll_0_pll_slave_waits_for_write);

  //end_xfer_arb_share_counter_term_altpll_0_pll_slave arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_altpll_0_pll_slave = altpll_0_pll_slave_end_xfer & (~altpll_0_pll_slave_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //altpll_0_pll_slave_arb_share_counter arbitration counter enable, which is an e_assign
  assign altpll_0_pll_slave_arb_counter_enable = (end_xfer_arb_share_counter_term_altpll_0_pll_slave & altpll_0_pll_slave_allgrants) | (end_xfer_arb_share_counter_term_altpll_0_pll_slave & ~altpll_0_pll_slave_non_bursting_master_requests);

  //altpll_0_pll_slave_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          altpll_0_pll_slave_arb_share_counter <= 0;
      else if (altpll_0_pll_slave_arb_counter_enable)
          altpll_0_pll_slave_arb_share_counter <= altpll_0_pll_slave_arb_share_counter_next_value;
    end


  //altpll_0_pll_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          altpll_0_pll_slave_slavearbiterlockenable <= 0;
      else if ((|altpll_0_pll_slave_master_qreq_vector & end_xfer_arb_share_counter_term_altpll_0_pll_slave) | (end_xfer_arb_share_counter_term_altpll_0_pll_slave & ~altpll_0_pll_slave_non_bursting_master_requests))
          altpll_0_pll_slave_slavearbiterlockenable <= |altpll_0_pll_slave_arb_share_counter_next_value;
    end


  //uC_clock_0/out altpll_0/pll_slave arbiterlock, which is an e_assign
  assign uC_clock_0_out_arbiterlock = altpll_0_pll_slave_slavearbiterlockenable & uC_clock_0_out_continuerequest;

  //altpll_0_pll_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign altpll_0_pll_slave_slavearbiterlockenable2 = |altpll_0_pll_slave_arb_share_counter_next_value;

  //uC_clock_0/out altpll_0/pll_slave arbiterlock2, which is an e_assign
  assign uC_clock_0_out_arbiterlock2 = altpll_0_pll_slave_slavearbiterlockenable2 & uC_clock_0_out_continuerequest;

  //altpll_0_pll_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  assign altpll_0_pll_slave_any_continuerequest = 1;

  //uC_clock_0_out_continuerequest continued request, which is an e_assign
  assign uC_clock_0_out_continuerequest = 1;

  assign uC_clock_0_out_qualified_request_altpll_0_pll_slave = uC_clock_0_out_requests_altpll_0_pll_slave;
  //altpll_0_pll_slave_writedata mux, which is an e_mux
  assign altpll_0_pll_slave_writedata = uC_clock_0_out_writedata;

  //master is always granted when requested
  assign uC_clock_0_out_granted_altpll_0_pll_slave = uC_clock_0_out_qualified_request_altpll_0_pll_slave;

  //uC_clock_0/out saved-grant altpll_0/pll_slave, which is an e_assign
  assign uC_clock_0_out_saved_grant_altpll_0_pll_slave = uC_clock_0_out_requests_altpll_0_pll_slave;

  //allow new arb cycle for altpll_0/pll_slave, which is an e_assign
  assign altpll_0_pll_slave_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign altpll_0_pll_slave_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign altpll_0_pll_slave_master_qreq_vector = 1;

  //~altpll_0_pll_slave_reset assignment, which is an e_assign
  assign altpll_0_pll_slave_reset = ~reset_n;

  //altpll_0_pll_slave_firsttransfer first transaction, which is an e_assign
  assign altpll_0_pll_slave_firsttransfer = altpll_0_pll_slave_begins_xfer ? altpll_0_pll_slave_unreg_firsttransfer : altpll_0_pll_slave_reg_firsttransfer;

  //altpll_0_pll_slave_unreg_firsttransfer first transaction, which is an e_assign
  assign altpll_0_pll_slave_unreg_firsttransfer = ~(altpll_0_pll_slave_slavearbiterlockenable & altpll_0_pll_slave_any_continuerequest);

  //altpll_0_pll_slave_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          altpll_0_pll_slave_reg_firsttransfer <= 1'b1;
      else if (altpll_0_pll_slave_begins_xfer)
          altpll_0_pll_slave_reg_firsttransfer <= altpll_0_pll_slave_unreg_firsttransfer;
    end


  //altpll_0_pll_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign altpll_0_pll_slave_beginbursttransfer_internal = altpll_0_pll_slave_begins_xfer;

  //altpll_0_pll_slave_read assignment, which is an e_mux
  assign altpll_0_pll_slave_read = uC_clock_0_out_granted_altpll_0_pll_slave & uC_clock_0_out_read;

  //altpll_0_pll_slave_write assignment, which is an e_mux
  assign altpll_0_pll_slave_write = uC_clock_0_out_granted_altpll_0_pll_slave & uC_clock_0_out_write;

  assign shifted_address_to_altpll_0_pll_slave_from_uC_clock_0_out = uC_clock_0_out_address_to_slave;
  //altpll_0_pll_slave_address mux, which is an e_mux
  assign altpll_0_pll_slave_address = shifted_address_to_altpll_0_pll_slave_from_uC_clock_0_out >> 2;

  //d1_altpll_0_pll_slave_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_altpll_0_pll_slave_end_xfer <= 1;
      else 
        d1_altpll_0_pll_slave_end_xfer <= altpll_0_pll_slave_end_xfer;
    end


  //altpll_0_pll_slave_waits_for_read in a cycle, which is an e_mux
  assign altpll_0_pll_slave_waits_for_read = altpll_0_pll_slave_in_a_read_cycle & 0;

  //altpll_0_pll_slave_in_a_read_cycle assignment, which is an e_assign
  assign altpll_0_pll_slave_in_a_read_cycle = uC_clock_0_out_granted_altpll_0_pll_slave & uC_clock_0_out_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = altpll_0_pll_slave_in_a_read_cycle;

  //altpll_0_pll_slave_waits_for_write in a cycle, which is an e_mux
  assign altpll_0_pll_slave_waits_for_write = altpll_0_pll_slave_in_a_write_cycle & 0;

  //altpll_0_pll_slave_in_a_write_cycle assignment, which is an e_assign
  assign altpll_0_pll_slave_in_a_write_cycle = uC_clock_0_out_granted_altpll_0_pll_slave & uC_clock_0_out_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = altpll_0_pll_slave_in_a_write_cycle;

  assign wait_for_altpll_0_pll_slave_counter = 0;

//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //altpll_0/pll_slave enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else 
        enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module cpu_jtag_debug_module_arbitrator (
                                          // inputs:
                                           clk,
                                           cpu_data_master_address_to_slave,
                                           cpu_data_master_byteenable,
                                           cpu_data_master_debugaccess,
                                           cpu_data_master_read,
                                           cpu_data_master_waitrequest,
                                           cpu_data_master_write,
                                           cpu_data_master_writedata,
                                           cpu_instruction_master_address_to_slave,
                                           cpu_instruction_master_read,
                                           cpu_jtag_debug_module_readdata,
                                           cpu_jtag_debug_module_resetrequest,
                                           reset_n,

                                          // outputs:
                                           cpu_data_master_granted_cpu_jtag_debug_module,
                                           cpu_data_master_qualified_request_cpu_jtag_debug_module,
                                           cpu_data_master_read_data_valid_cpu_jtag_debug_module,
                                           cpu_data_master_requests_cpu_jtag_debug_module,
                                           cpu_instruction_master_granted_cpu_jtag_debug_module,
                                           cpu_instruction_master_qualified_request_cpu_jtag_debug_module,
                                           cpu_instruction_master_read_data_valid_cpu_jtag_debug_module,
                                           cpu_instruction_master_requests_cpu_jtag_debug_module,
                                           cpu_jtag_debug_module_address,
                                           cpu_jtag_debug_module_begintransfer,
                                           cpu_jtag_debug_module_byteenable,
                                           cpu_jtag_debug_module_chipselect,
                                           cpu_jtag_debug_module_debugaccess,
                                           cpu_jtag_debug_module_readdata_from_sa,
                                           cpu_jtag_debug_module_reset_n,
                                           cpu_jtag_debug_module_resetrequest_from_sa,
                                           cpu_jtag_debug_module_write,
                                           cpu_jtag_debug_module_writedata,
                                           d1_cpu_jtag_debug_module_end_xfer
                                        )
;

  output           cpu_data_master_granted_cpu_jtag_debug_module;
  output           cpu_data_master_qualified_request_cpu_jtag_debug_module;
  output           cpu_data_master_read_data_valid_cpu_jtag_debug_module;
  output           cpu_data_master_requests_cpu_jtag_debug_module;
  output           cpu_instruction_master_granted_cpu_jtag_debug_module;
  output           cpu_instruction_master_qualified_request_cpu_jtag_debug_module;
  output           cpu_instruction_master_read_data_valid_cpu_jtag_debug_module;
  output           cpu_instruction_master_requests_cpu_jtag_debug_module;
  output  [  8: 0] cpu_jtag_debug_module_address;
  output           cpu_jtag_debug_module_begintransfer;
  output  [  3: 0] cpu_jtag_debug_module_byteenable;
  output           cpu_jtag_debug_module_chipselect;
  output           cpu_jtag_debug_module_debugaccess;
  output  [ 31: 0] cpu_jtag_debug_module_readdata_from_sa;
  output           cpu_jtag_debug_module_reset_n;
  output           cpu_jtag_debug_module_resetrequest_from_sa;
  output           cpu_jtag_debug_module_write;
  output  [ 31: 0] cpu_jtag_debug_module_writedata;
  output           d1_cpu_jtag_debug_module_end_xfer;
  input            clk;
  input   [ 16: 0] cpu_data_master_address_to_slave;
  input   [  3: 0] cpu_data_master_byteenable;
  input            cpu_data_master_debugaccess;
  input            cpu_data_master_read;
  input            cpu_data_master_waitrequest;
  input            cpu_data_master_write;
  input   [ 31: 0] cpu_data_master_writedata;
  input   [ 16: 0] cpu_instruction_master_address_to_slave;
  input            cpu_instruction_master_read;
  input   [ 31: 0] cpu_jtag_debug_module_readdata;
  input            cpu_jtag_debug_module_resetrequest;
  input            reset_n;

  wire             cpu_data_master_arbiterlock;
  wire             cpu_data_master_arbiterlock2;
  wire             cpu_data_master_continuerequest;
  wire             cpu_data_master_granted_cpu_jtag_debug_module;
  wire             cpu_data_master_qualified_request_cpu_jtag_debug_module;
  wire             cpu_data_master_read_data_valid_cpu_jtag_debug_module;
  wire             cpu_data_master_requests_cpu_jtag_debug_module;
  wire             cpu_data_master_saved_grant_cpu_jtag_debug_module;
  wire             cpu_instruction_master_arbiterlock;
  wire             cpu_instruction_master_arbiterlock2;
  wire             cpu_instruction_master_continuerequest;
  wire             cpu_instruction_master_granted_cpu_jtag_debug_module;
  wire             cpu_instruction_master_qualified_request_cpu_jtag_debug_module;
  wire             cpu_instruction_master_read_data_valid_cpu_jtag_debug_module;
  wire             cpu_instruction_master_requests_cpu_jtag_debug_module;
  wire             cpu_instruction_master_saved_grant_cpu_jtag_debug_module;
  wire    [  8: 0] cpu_jtag_debug_module_address;
  wire             cpu_jtag_debug_module_allgrants;
  wire             cpu_jtag_debug_module_allow_new_arb_cycle;
  wire             cpu_jtag_debug_module_any_bursting_master_saved_grant;
  wire             cpu_jtag_debug_module_any_continuerequest;
  reg     [  1: 0] cpu_jtag_debug_module_arb_addend;
  wire             cpu_jtag_debug_module_arb_counter_enable;
  reg              cpu_jtag_debug_module_arb_share_counter;
  wire             cpu_jtag_debug_module_arb_share_counter_next_value;
  wire             cpu_jtag_debug_module_arb_share_set_values;
  wire    [  1: 0] cpu_jtag_debug_module_arb_winner;
  wire             cpu_jtag_debug_module_arbitration_holdoff_internal;
  wire             cpu_jtag_debug_module_beginbursttransfer_internal;
  wire             cpu_jtag_debug_module_begins_xfer;
  wire             cpu_jtag_debug_module_begintransfer;
  wire    [  3: 0] cpu_jtag_debug_module_byteenable;
  wire             cpu_jtag_debug_module_chipselect;
  wire    [  3: 0] cpu_jtag_debug_module_chosen_master_double_vector;
  wire    [  1: 0] cpu_jtag_debug_module_chosen_master_rot_left;
  wire             cpu_jtag_debug_module_debugaccess;
  wire             cpu_jtag_debug_module_end_xfer;
  wire             cpu_jtag_debug_module_firsttransfer;
  wire    [  1: 0] cpu_jtag_debug_module_grant_vector;
  wire             cpu_jtag_debug_module_in_a_read_cycle;
  wire             cpu_jtag_debug_module_in_a_write_cycle;
  wire    [  1: 0] cpu_jtag_debug_module_master_qreq_vector;
  wire             cpu_jtag_debug_module_non_bursting_master_requests;
  wire    [ 31: 0] cpu_jtag_debug_module_readdata_from_sa;
  reg              cpu_jtag_debug_module_reg_firsttransfer;
  wire             cpu_jtag_debug_module_reset_n;
  wire             cpu_jtag_debug_module_resetrequest_from_sa;
  reg     [  1: 0] cpu_jtag_debug_module_saved_chosen_master_vector;
  reg              cpu_jtag_debug_module_slavearbiterlockenable;
  wire             cpu_jtag_debug_module_slavearbiterlockenable2;
  wire             cpu_jtag_debug_module_unreg_firsttransfer;
  wire             cpu_jtag_debug_module_waits_for_read;
  wire             cpu_jtag_debug_module_waits_for_write;
  wire             cpu_jtag_debug_module_write;
  wire    [ 31: 0] cpu_jtag_debug_module_writedata;
  reg              d1_cpu_jtag_debug_module_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_cpu_jtag_debug_module;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  reg              last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module;
  reg              last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module;
  wire    [ 16: 0] shifted_address_to_cpu_jtag_debug_module_from_cpu_data_master;
  wire    [ 16: 0] shifted_address_to_cpu_jtag_debug_module_from_cpu_instruction_master;
  wire             wait_for_cpu_jtag_debug_module_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else 
        d1_reasons_to_wait <= ~cpu_jtag_debug_module_end_xfer;
    end


  assign cpu_jtag_debug_module_begins_xfer = ~d1_reasons_to_wait & ((cpu_data_master_qualified_request_cpu_jtag_debug_module | cpu_instruction_master_qualified_request_cpu_jtag_debug_module));
  //assign cpu_jtag_debug_module_readdata_from_sa = cpu_jtag_debug_module_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign cpu_jtag_debug_module_readdata_from_sa = cpu_jtag_debug_module_readdata;

  assign cpu_data_master_requests_cpu_jtag_debug_module = ({cpu_data_master_address_to_slave[16 : 11] , 11'b0} == 17'h800) & (cpu_data_master_read | cpu_data_master_write);
  //cpu_jtag_debug_module_arb_share_counter set values, which is an e_mux
  assign cpu_jtag_debug_module_arb_share_set_values = 1;

  //cpu_jtag_debug_module_non_bursting_master_requests mux, which is an e_mux
  assign cpu_jtag_debug_module_non_bursting_master_requests = cpu_data_master_requests_cpu_jtag_debug_module |
    cpu_instruction_master_requests_cpu_jtag_debug_module |
    cpu_data_master_requests_cpu_jtag_debug_module |
    cpu_instruction_master_requests_cpu_jtag_debug_module;

  //cpu_jtag_debug_module_any_bursting_master_saved_grant mux, which is an e_mux
  assign cpu_jtag_debug_module_any_bursting_master_saved_grant = 0;

  //cpu_jtag_debug_module_arb_share_counter_next_value assignment, which is an e_assign
  assign cpu_jtag_debug_module_arb_share_counter_next_value = cpu_jtag_debug_module_firsttransfer ? (cpu_jtag_debug_module_arb_share_set_values - 1) : |cpu_jtag_debug_module_arb_share_counter ? (cpu_jtag_debug_module_arb_share_counter - 1) : 0;

  //cpu_jtag_debug_module_allgrants all slave grants, which is an e_mux
  assign cpu_jtag_debug_module_allgrants = (|cpu_jtag_debug_module_grant_vector) |
    (|cpu_jtag_debug_module_grant_vector) |
    (|cpu_jtag_debug_module_grant_vector) |
    (|cpu_jtag_debug_module_grant_vector);

  //cpu_jtag_debug_module_end_xfer assignment, which is an e_assign
  assign cpu_jtag_debug_module_end_xfer = ~(cpu_jtag_debug_module_waits_for_read | cpu_jtag_debug_module_waits_for_write);

  //end_xfer_arb_share_counter_term_cpu_jtag_debug_module arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_cpu_jtag_debug_module = cpu_jtag_debug_module_end_xfer & (~cpu_jtag_debug_module_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //cpu_jtag_debug_module_arb_share_counter arbitration counter enable, which is an e_assign
  assign cpu_jtag_debug_module_arb_counter_enable = (end_xfer_arb_share_counter_term_cpu_jtag_debug_module & cpu_jtag_debug_module_allgrants) | (end_xfer_arb_share_counter_term_cpu_jtag_debug_module & ~cpu_jtag_debug_module_non_bursting_master_requests);

  //cpu_jtag_debug_module_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_jtag_debug_module_arb_share_counter <= 0;
      else if (cpu_jtag_debug_module_arb_counter_enable)
          cpu_jtag_debug_module_arb_share_counter <= cpu_jtag_debug_module_arb_share_counter_next_value;
    end


  //cpu_jtag_debug_module_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_jtag_debug_module_slavearbiterlockenable <= 0;
      else if ((|cpu_jtag_debug_module_master_qreq_vector & end_xfer_arb_share_counter_term_cpu_jtag_debug_module) | (end_xfer_arb_share_counter_term_cpu_jtag_debug_module & ~cpu_jtag_debug_module_non_bursting_master_requests))
          cpu_jtag_debug_module_slavearbiterlockenable <= |cpu_jtag_debug_module_arb_share_counter_next_value;
    end


  //cpu/data_master cpu/jtag_debug_module arbiterlock, which is an e_assign
  assign cpu_data_master_arbiterlock = cpu_jtag_debug_module_slavearbiterlockenable & cpu_data_master_continuerequest;

  //cpu_jtag_debug_module_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign cpu_jtag_debug_module_slavearbiterlockenable2 = |cpu_jtag_debug_module_arb_share_counter_next_value;

  //cpu/data_master cpu/jtag_debug_module arbiterlock2, which is an e_assign
  assign cpu_data_master_arbiterlock2 = cpu_jtag_debug_module_slavearbiterlockenable2 & cpu_data_master_continuerequest;

  //cpu/instruction_master cpu/jtag_debug_module arbiterlock, which is an e_assign
  assign cpu_instruction_master_arbiterlock = cpu_jtag_debug_module_slavearbiterlockenable & cpu_instruction_master_continuerequest;

  //cpu/instruction_master cpu/jtag_debug_module arbiterlock2, which is an e_assign
  assign cpu_instruction_master_arbiterlock2 = cpu_jtag_debug_module_slavearbiterlockenable2 & cpu_instruction_master_continuerequest;

  //cpu/instruction_master granted cpu/jtag_debug_module last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module <= 0;
      else 
        last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module <= cpu_instruction_master_saved_grant_cpu_jtag_debug_module ? 1 : (cpu_jtag_debug_module_arbitration_holdoff_internal | ~cpu_instruction_master_requests_cpu_jtag_debug_module) ? 0 : last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module;
    end


  //cpu_instruction_master_continuerequest continued request, which is an e_mux
  assign cpu_instruction_master_continuerequest = last_cycle_cpu_instruction_master_granted_slave_cpu_jtag_debug_module & cpu_instruction_master_requests_cpu_jtag_debug_module;

  //cpu_jtag_debug_module_any_continuerequest at least one master continues requesting, which is an e_mux
  assign cpu_jtag_debug_module_any_continuerequest = cpu_instruction_master_continuerequest |
    cpu_data_master_continuerequest;

  assign cpu_data_master_qualified_request_cpu_jtag_debug_module = cpu_data_master_requests_cpu_jtag_debug_module & ~(((~cpu_data_master_waitrequest) & cpu_data_master_write) | cpu_instruction_master_arbiterlock);
  //cpu_jtag_debug_module_writedata mux, which is an e_mux
  assign cpu_jtag_debug_module_writedata = cpu_data_master_writedata;

  assign cpu_instruction_master_requests_cpu_jtag_debug_module = (({cpu_instruction_master_address_to_slave[16 : 11] , 11'b0} == 17'h800) & (cpu_instruction_master_read)) & cpu_instruction_master_read;
  //cpu/data_master granted cpu/jtag_debug_module last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module <= 0;
      else 
        last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module <= cpu_data_master_saved_grant_cpu_jtag_debug_module ? 1 : (cpu_jtag_debug_module_arbitration_holdoff_internal | ~cpu_data_master_requests_cpu_jtag_debug_module) ? 0 : last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module;
    end


  //cpu_data_master_continuerequest continued request, which is an e_mux
  assign cpu_data_master_continuerequest = last_cycle_cpu_data_master_granted_slave_cpu_jtag_debug_module & cpu_data_master_requests_cpu_jtag_debug_module;

  assign cpu_instruction_master_qualified_request_cpu_jtag_debug_module = cpu_instruction_master_requests_cpu_jtag_debug_module & ~(cpu_data_master_arbiterlock);
  //allow new arb cycle for cpu/jtag_debug_module, which is an e_assign
  assign cpu_jtag_debug_module_allow_new_arb_cycle = ~cpu_data_master_arbiterlock & ~cpu_instruction_master_arbiterlock;

  //cpu/instruction_master assignment into master qualified-requests vector for cpu/jtag_debug_module, which is an e_assign
  assign cpu_jtag_debug_module_master_qreq_vector[0] = cpu_instruction_master_qualified_request_cpu_jtag_debug_module;

  //cpu/instruction_master grant cpu/jtag_debug_module, which is an e_assign
  assign cpu_instruction_master_granted_cpu_jtag_debug_module = cpu_jtag_debug_module_grant_vector[0];

  //cpu/instruction_master saved-grant cpu/jtag_debug_module, which is an e_assign
  assign cpu_instruction_master_saved_grant_cpu_jtag_debug_module = cpu_jtag_debug_module_arb_winner[0] && cpu_instruction_master_requests_cpu_jtag_debug_module;

  //cpu/data_master assignment into master qualified-requests vector for cpu/jtag_debug_module, which is an e_assign
  assign cpu_jtag_debug_module_master_qreq_vector[1] = cpu_data_master_qualified_request_cpu_jtag_debug_module;

  //cpu/data_master grant cpu/jtag_debug_module, which is an e_assign
  assign cpu_data_master_granted_cpu_jtag_debug_module = cpu_jtag_debug_module_grant_vector[1];

  //cpu/data_master saved-grant cpu/jtag_debug_module, which is an e_assign
  assign cpu_data_master_saved_grant_cpu_jtag_debug_module = cpu_jtag_debug_module_arb_winner[1] && cpu_data_master_requests_cpu_jtag_debug_module;

  //cpu/jtag_debug_module chosen-master double-vector, which is an e_assign
  assign cpu_jtag_debug_module_chosen_master_double_vector = {cpu_jtag_debug_module_master_qreq_vector, cpu_jtag_debug_module_master_qreq_vector} & ({~cpu_jtag_debug_module_master_qreq_vector, ~cpu_jtag_debug_module_master_qreq_vector} + cpu_jtag_debug_module_arb_addend);

  //stable onehot encoding of arb winner
  assign cpu_jtag_debug_module_arb_winner = (cpu_jtag_debug_module_allow_new_arb_cycle & | cpu_jtag_debug_module_grant_vector) ? cpu_jtag_debug_module_grant_vector : cpu_jtag_debug_module_saved_chosen_master_vector;

  //saved cpu_jtag_debug_module_grant_vector, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_jtag_debug_module_saved_chosen_master_vector <= 0;
      else if (cpu_jtag_debug_module_allow_new_arb_cycle)
          cpu_jtag_debug_module_saved_chosen_master_vector <= |cpu_jtag_debug_module_grant_vector ? cpu_jtag_debug_module_grant_vector : cpu_jtag_debug_module_saved_chosen_master_vector;
    end


  //onehot encoding of chosen master
  assign cpu_jtag_debug_module_grant_vector = {(cpu_jtag_debug_module_chosen_master_double_vector[1] | cpu_jtag_debug_module_chosen_master_double_vector[3]),
    (cpu_jtag_debug_module_chosen_master_double_vector[0] | cpu_jtag_debug_module_chosen_master_double_vector[2])};

  //cpu/jtag_debug_module chosen master rotated left, which is an e_assign
  assign cpu_jtag_debug_module_chosen_master_rot_left = (cpu_jtag_debug_module_arb_winner << 1) ? (cpu_jtag_debug_module_arb_winner << 1) : 1;

  //cpu/jtag_debug_module's addend for next-master-grant
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_jtag_debug_module_arb_addend <= 1;
      else if (|cpu_jtag_debug_module_grant_vector)
          cpu_jtag_debug_module_arb_addend <= cpu_jtag_debug_module_end_xfer? cpu_jtag_debug_module_chosen_master_rot_left : cpu_jtag_debug_module_grant_vector;
    end


  assign cpu_jtag_debug_module_begintransfer = cpu_jtag_debug_module_begins_xfer;
  //cpu_jtag_debug_module_reset_n assignment, which is an e_assign
  assign cpu_jtag_debug_module_reset_n = reset_n;

  //assign cpu_jtag_debug_module_resetrequest_from_sa = cpu_jtag_debug_module_resetrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign cpu_jtag_debug_module_resetrequest_from_sa = cpu_jtag_debug_module_resetrequest;

  assign cpu_jtag_debug_module_chipselect = cpu_data_master_granted_cpu_jtag_debug_module | cpu_instruction_master_granted_cpu_jtag_debug_module;
  //cpu_jtag_debug_module_firsttransfer first transaction, which is an e_assign
  assign cpu_jtag_debug_module_firsttransfer = cpu_jtag_debug_module_begins_xfer ? cpu_jtag_debug_module_unreg_firsttransfer : cpu_jtag_debug_module_reg_firsttransfer;

  //cpu_jtag_debug_module_unreg_firsttransfer first transaction, which is an e_assign
  assign cpu_jtag_debug_module_unreg_firsttransfer = ~(cpu_jtag_debug_module_slavearbiterlockenable & cpu_jtag_debug_module_any_continuerequest);

  //cpu_jtag_debug_module_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_jtag_debug_module_reg_firsttransfer <= 1'b1;
      else if (cpu_jtag_debug_module_begins_xfer)
          cpu_jtag_debug_module_reg_firsttransfer <= cpu_jtag_debug_module_unreg_firsttransfer;
    end


  //cpu_jtag_debug_module_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign cpu_jtag_debug_module_beginbursttransfer_internal = cpu_jtag_debug_module_begins_xfer;

  //cpu_jtag_debug_module_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  assign cpu_jtag_debug_module_arbitration_holdoff_internal = cpu_jtag_debug_module_begins_xfer & cpu_jtag_debug_module_firsttransfer;

  //cpu_jtag_debug_module_write assignment, which is an e_mux
  assign cpu_jtag_debug_module_write = cpu_data_master_granted_cpu_jtag_debug_module & cpu_data_master_write;

  assign shifted_address_to_cpu_jtag_debug_module_from_cpu_data_master = cpu_data_master_address_to_slave;
  //cpu_jtag_debug_module_address mux, which is an e_mux
  assign cpu_jtag_debug_module_address = (cpu_data_master_granted_cpu_jtag_debug_module)? (shifted_address_to_cpu_jtag_debug_module_from_cpu_data_master >> 2) :
    (shifted_address_to_cpu_jtag_debug_module_from_cpu_instruction_master >> 2);

  assign shifted_address_to_cpu_jtag_debug_module_from_cpu_instruction_master = cpu_instruction_master_address_to_slave;
  //d1_cpu_jtag_debug_module_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_cpu_jtag_debug_module_end_xfer <= 1;
      else 
        d1_cpu_jtag_debug_module_end_xfer <= cpu_jtag_debug_module_end_xfer;
    end


  //cpu_jtag_debug_module_waits_for_read in a cycle, which is an e_mux
  assign cpu_jtag_debug_module_waits_for_read = cpu_jtag_debug_module_in_a_read_cycle & cpu_jtag_debug_module_begins_xfer;

  //cpu_jtag_debug_module_in_a_read_cycle assignment, which is an e_assign
  assign cpu_jtag_debug_module_in_a_read_cycle = (cpu_data_master_granted_cpu_jtag_debug_module & cpu_data_master_read) | (cpu_instruction_master_granted_cpu_jtag_debug_module & cpu_instruction_master_read);

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = cpu_jtag_debug_module_in_a_read_cycle;

  //cpu_jtag_debug_module_waits_for_write in a cycle, which is an e_mux
  assign cpu_jtag_debug_module_waits_for_write = cpu_jtag_debug_module_in_a_write_cycle & 0;

  //cpu_jtag_debug_module_in_a_write_cycle assignment, which is an e_assign
  assign cpu_jtag_debug_module_in_a_write_cycle = cpu_data_master_granted_cpu_jtag_debug_module & cpu_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = cpu_jtag_debug_module_in_a_write_cycle;

  assign wait_for_cpu_jtag_debug_module_counter = 0;
  //cpu_jtag_debug_module_byteenable byte enable port mux, which is an e_mux
  assign cpu_jtag_debug_module_byteenable = (cpu_data_master_granted_cpu_jtag_debug_module)? cpu_data_master_byteenable :
    -1;

  //debugaccess mux, which is an e_mux
  assign cpu_jtag_debug_module_debugaccess = (cpu_data_master_granted_cpu_jtag_debug_module)? cpu_data_master_debugaccess :
    0;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //cpu/jtag_debug_module enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else 
        enable_nonzero_assertions <= 1'b1;
    end


  //grant signals are active simultaneously, which is an e_process
  always @(posedge clk)
    begin
      if (cpu_data_master_granted_cpu_jtag_debug_module + cpu_instruction_master_granted_cpu_jtag_debug_module > 1)
        begin
          $write("%0d ns: > 1 of grant signals are active simultaneously", $time);
          $stop;
        end
    end


  //saved_grant signals are active simultaneously, which is an e_process
  always @(posedge clk)
    begin
      if (cpu_data_master_saved_grant_cpu_jtag_debug_module + cpu_instruction_master_saved_grant_cpu_jtag_debug_module > 1)
        begin
          $write("%0d ns: > 1 of saved_grant signals are active simultaneously", $time);
          $stop;
        end
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module cpu_data_master_arbitrator (
                                    // inputs:
                                     adc_data_ready_s1_readdata_from_sa,
                                     clk,
                                     cpu_data_master_address,
                                     cpu_data_master_granted_adc_data_ready_s1,
                                     cpu_data_master_granted_cpu_jtag_debug_module,
                                     cpu_data_master_granted_ctrl_s1,
                                     cpu_data_master_granted_epcs_flash_controller_epcs_control_port,
                                     cpu_data_master_granted_gpio_s1,
                                     cpu_data_master_granted_jtag_uart_avalon_jtag_slave,
                                     cpu_data_master_granted_led_s1,
                                     cpu_data_master_granted_onchip_ram_s1,
                                     cpu_data_master_granted_opencores_i2c_0_avalon_slave,
                                     cpu_data_master_granted_opencores_i2c_1_avalon_slave,
                                     cpu_data_master_granted_spi_0_p0_spi_control_port,
                                     cpu_data_master_granted_spi_0_p1_spi_control_port,
                                     cpu_data_master_granted_spi_1_p0_spi_control_port,
                                     cpu_data_master_granted_spi_1_p1_spi_control_port,
                                     cpu_data_master_granted_sysid_control_slave,
                                     cpu_data_master_granted_timer_s1,
                                     cpu_data_master_granted_uCProbe_uart_avalon_jtag_slave,
                                     cpu_data_master_granted_uC_clock_0_in,
                                     cpu_data_master_qualified_request_adc_data_ready_s1,
                                     cpu_data_master_qualified_request_cpu_jtag_debug_module,
                                     cpu_data_master_qualified_request_ctrl_s1,
                                     cpu_data_master_qualified_request_epcs_flash_controller_epcs_control_port,
                                     cpu_data_master_qualified_request_gpio_s1,
                                     cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave,
                                     cpu_data_master_qualified_request_led_s1,
                                     cpu_data_master_qualified_request_onchip_ram_s1,
                                     cpu_data_master_qualified_request_opencores_i2c_0_avalon_slave,
                                     cpu_data_master_qualified_request_opencores_i2c_1_avalon_slave,
                                     cpu_data_master_qualified_request_spi_0_p0_spi_control_port,
                                     cpu_data_master_qualified_request_spi_0_p1_spi_control_port,
                                     cpu_data_master_qualified_request_spi_1_p0_spi_control_port,
                                     cpu_data_master_qualified_request_spi_1_p1_spi_control_port,
                                     cpu_data_master_qualified_request_sysid_control_slave,
                                     cpu_data_master_qualified_request_timer_s1,
                                     cpu_data_master_qualified_request_uCProbe_uart_avalon_jtag_slave,
                                     cpu_data_master_qualified_request_uC_clock_0_in,
                                     cpu_data_master_read,
                                     cpu_data_master_read_data_valid_adc_data_ready_s1,
                                     cpu_data_master_read_data_valid_cpu_jtag_debug_module,
                                     cpu_data_master_read_data_valid_ctrl_s1,
                                     cpu_data_master_read_data_valid_epcs_flash_controller_epcs_control_port,
                                     cpu_data_master_read_data_valid_gpio_s1,
                                     cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave,
                                     cpu_data_master_read_data_valid_led_s1,
                                     cpu_data_master_read_data_valid_onchip_ram_s1,
                                     cpu_data_master_read_data_valid_opencores_i2c_0_avalon_slave,
                                     cpu_data_master_read_data_valid_opencores_i2c_1_avalon_slave,
                                     cpu_data_master_read_data_valid_spi_0_p0_spi_control_port,
                                     cpu_data_master_read_data_valid_spi_0_p1_spi_control_port,
                                     cpu_data_master_read_data_valid_spi_1_p0_spi_control_port,
                                     cpu_data_master_read_data_valid_spi_1_p1_spi_control_port,
                                     cpu_data_master_read_data_valid_sysid_control_slave,
                                     cpu_data_master_read_data_valid_timer_s1,
                                     cpu_data_master_read_data_valid_uCProbe_uart_avalon_jtag_slave,
                                     cpu_data_master_read_data_valid_uC_clock_0_in,
                                     cpu_data_master_requests_adc_data_ready_s1,
                                     cpu_data_master_requests_cpu_jtag_debug_module,
                                     cpu_data_master_requests_ctrl_s1,
                                     cpu_data_master_requests_epcs_flash_controller_epcs_control_port,
                                     cpu_data_master_requests_gpio_s1,
                                     cpu_data_master_requests_jtag_uart_avalon_jtag_slave,
                                     cpu_data_master_requests_led_s1,
                                     cpu_data_master_requests_onchip_ram_s1,
                                     cpu_data_master_requests_opencores_i2c_0_avalon_slave,
                                     cpu_data_master_requests_opencores_i2c_1_avalon_slave,
                                     cpu_data_master_requests_spi_0_p0_spi_control_port,
                                     cpu_data_master_requests_spi_0_p1_spi_control_port,
                                     cpu_data_master_requests_spi_1_p0_spi_control_port,
                                     cpu_data_master_requests_spi_1_p1_spi_control_port,
                                     cpu_data_master_requests_sysid_control_slave,
                                     cpu_data_master_requests_timer_s1,
                                     cpu_data_master_requests_uCProbe_uart_avalon_jtag_slave,
                                     cpu_data_master_requests_uC_clock_0_in,
                                     cpu_data_master_write,
                                     cpu_jtag_debug_module_readdata_from_sa,
                                     ctrl_s1_readdata_from_sa,
                                     d1_adc_data_ready_s1_end_xfer,
                                     d1_cpu_jtag_debug_module_end_xfer,
                                     d1_ctrl_s1_end_xfer,
                                     d1_epcs_flash_controller_epcs_control_port_end_xfer,
                                     d1_gpio_s1_end_xfer,
                                     d1_jtag_uart_avalon_jtag_slave_end_xfer,
                                     d1_led_s1_end_xfer,
                                     d1_onchip_ram_s1_end_xfer,
                                     d1_opencores_i2c_0_avalon_slave_end_xfer,
                                     d1_opencores_i2c_1_avalon_slave_end_xfer,
                                     d1_spi_0_p0_spi_control_port_end_xfer,
                                     d1_spi_0_p1_spi_control_port_end_xfer,
                                     d1_spi_1_p0_spi_control_port_end_xfer,
                                     d1_spi_1_p1_spi_control_port_end_xfer,
                                     d1_sysid_control_slave_end_xfer,
                                     d1_timer_s1_end_xfer,
                                     d1_uCProbe_uart_avalon_jtag_slave_end_xfer,
                                     d1_uC_clock_0_in_end_xfer,
                                     epcs_flash_controller_epcs_control_port_irq_from_sa,
                                     epcs_flash_controller_epcs_control_port_readdata_from_sa,
                                     gpio_s1_readdata_from_sa,
                                     jtag_uart_avalon_jtag_slave_irq_from_sa,
                                     jtag_uart_avalon_jtag_slave_readdata_from_sa,
                                     jtag_uart_avalon_jtag_slave_waitrequest_from_sa,
                                     led_s1_readdata_from_sa,
                                     onchip_ram_s1_readdata_from_sa,
                                     opencores_i2c_0_avalon_slave_irq_from_sa,
                                     opencores_i2c_0_avalon_slave_readdata_from_sa,
                                     opencores_i2c_0_avalon_slave_waitrequest_n_from_sa,
                                     opencores_i2c_1_avalon_slave_irq_from_sa,
                                     opencores_i2c_1_avalon_slave_readdata_from_sa,
                                     opencores_i2c_1_avalon_slave_waitrequest_n_from_sa,
                                     registered_cpu_data_master_read_data_valid_onchip_ram_s1,
                                     reset_n,
                                     spi_0_p0_spi_control_port_irq_from_sa,
                                     spi_0_p0_spi_control_port_readdata_from_sa,
                                     spi_0_p1_spi_control_port_irq_from_sa,
                                     spi_0_p1_spi_control_port_readdata_from_sa,
                                     spi_1_p0_spi_control_port_irq_from_sa,
                                     spi_1_p0_spi_control_port_readdata_from_sa,
                                     spi_1_p1_spi_control_port_irq_from_sa,
                                     spi_1_p1_spi_control_port_readdata_from_sa,
                                     sysid_control_slave_readdata_from_sa,
                                     timer_s1_irq_from_sa,
                                     timer_s1_readdata_from_sa,
                                     uCProbe_uart_avalon_jtag_slave_irq_from_sa,
                                     uCProbe_uart_avalon_jtag_slave_readdata_from_sa,
                                     uCProbe_uart_avalon_jtag_slave_waitrequest_from_sa,
                                     uC_clock_0_in_readdata_from_sa,
                                     uC_clock_0_in_waitrequest_from_sa,

                                    // outputs:
                                     cpu_data_master_address_to_slave,
                                     cpu_data_master_irq,
                                     cpu_data_master_readdata,
                                     cpu_data_master_waitrequest
                                  )
;

  output  [ 16: 0] cpu_data_master_address_to_slave;
  output  [ 31: 0] cpu_data_master_irq;
  output  [ 31: 0] cpu_data_master_readdata;
  output           cpu_data_master_waitrequest;
  input   [ 31: 0] adc_data_ready_s1_readdata_from_sa;
  input            clk;
  input   [ 16: 0] cpu_data_master_address;
  input            cpu_data_master_granted_adc_data_ready_s1;
  input            cpu_data_master_granted_cpu_jtag_debug_module;
  input            cpu_data_master_granted_ctrl_s1;
  input            cpu_data_master_granted_epcs_flash_controller_epcs_control_port;
  input            cpu_data_master_granted_gpio_s1;
  input            cpu_data_master_granted_jtag_uart_avalon_jtag_slave;
  input            cpu_data_master_granted_led_s1;
  input            cpu_data_master_granted_onchip_ram_s1;
  input            cpu_data_master_granted_opencores_i2c_0_avalon_slave;
  input            cpu_data_master_granted_opencores_i2c_1_avalon_slave;
  input            cpu_data_master_granted_spi_0_p0_spi_control_port;
  input            cpu_data_master_granted_spi_0_p1_spi_control_port;
  input            cpu_data_master_granted_spi_1_p0_spi_control_port;
  input            cpu_data_master_granted_spi_1_p1_spi_control_port;
  input            cpu_data_master_granted_sysid_control_slave;
  input            cpu_data_master_granted_timer_s1;
  input            cpu_data_master_granted_uCProbe_uart_avalon_jtag_slave;
  input            cpu_data_master_granted_uC_clock_0_in;
  input            cpu_data_master_qualified_request_adc_data_ready_s1;
  input            cpu_data_master_qualified_request_cpu_jtag_debug_module;
  input            cpu_data_master_qualified_request_ctrl_s1;
  input            cpu_data_master_qualified_request_epcs_flash_controller_epcs_control_port;
  input            cpu_data_master_qualified_request_gpio_s1;
  input            cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave;
  input            cpu_data_master_qualified_request_led_s1;
  input            cpu_data_master_qualified_request_onchip_ram_s1;
  input            cpu_data_master_qualified_request_opencores_i2c_0_avalon_slave;
  input            cpu_data_master_qualified_request_opencores_i2c_1_avalon_slave;
  input            cpu_data_master_qualified_request_spi_0_p0_spi_control_port;
  input            cpu_data_master_qualified_request_spi_0_p1_spi_control_port;
  input            cpu_data_master_qualified_request_spi_1_p0_spi_control_port;
  input            cpu_data_master_qualified_request_spi_1_p1_spi_control_port;
  input            cpu_data_master_qualified_request_sysid_control_slave;
  input            cpu_data_master_qualified_request_timer_s1;
  input            cpu_data_master_qualified_request_uCProbe_uart_avalon_jtag_slave;
  input            cpu_data_master_qualified_request_uC_clock_0_in;
  input            cpu_data_master_read;
  input            cpu_data_master_read_data_valid_adc_data_ready_s1;
  input            cpu_data_master_read_data_valid_cpu_jtag_debug_module;
  input            cpu_data_master_read_data_valid_ctrl_s1;
  input            cpu_data_master_read_data_valid_epcs_flash_controller_epcs_control_port;
  input            cpu_data_master_read_data_valid_gpio_s1;
  input            cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave;
  input            cpu_data_master_read_data_valid_led_s1;
  input            cpu_data_master_read_data_valid_onchip_ram_s1;
  input            cpu_data_master_read_data_valid_opencores_i2c_0_avalon_slave;
  input            cpu_data_master_read_data_valid_opencores_i2c_1_avalon_slave;
  input            cpu_data_master_read_data_valid_spi_0_p0_spi_control_port;
  input            cpu_data_master_read_data_valid_spi_0_p1_spi_control_port;
  input            cpu_data_master_read_data_valid_spi_1_p0_spi_control_port;
  input            cpu_data_master_read_data_valid_spi_1_p1_spi_control_port;
  input            cpu_data_master_read_data_valid_sysid_control_slave;
  input            cpu_data_master_read_data_valid_timer_s1;
  input            cpu_data_master_read_data_valid_uCProbe_uart_avalon_jtag_slave;
  input            cpu_data_master_read_data_valid_uC_clock_0_in;
  input            cpu_data_master_requests_adc_data_ready_s1;
  input            cpu_data_master_requests_cpu_jtag_debug_module;
  input            cpu_data_master_requests_ctrl_s1;
  input            cpu_data_master_requests_epcs_flash_controller_epcs_control_port;
  input            cpu_data_master_requests_gpio_s1;
  input            cpu_data_master_requests_jtag_uart_avalon_jtag_slave;
  input            cpu_data_master_requests_led_s1;
  input            cpu_data_master_requests_onchip_ram_s1;
  input            cpu_data_master_requests_opencores_i2c_0_avalon_slave;
  input            cpu_data_master_requests_opencores_i2c_1_avalon_slave;
  input            cpu_data_master_requests_spi_0_p0_spi_control_port;
  input            cpu_data_master_requests_spi_0_p1_spi_control_port;
  input            cpu_data_master_requests_spi_1_p0_spi_control_port;
  input            cpu_data_master_requests_spi_1_p1_spi_control_port;
  input            cpu_data_master_requests_sysid_control_slave;
  input            cpu_data_master_requests_timer_s1;
  input            cpu_data_master_requests_uCProbe_uart_avalon_jtag_slave;
  input            cpu_data_master_requests_uC_clock_0_in;
  input            cpu_data_master_write;
  input   [ 31: 0] cpu_jtag_debug_module_readdata_from_sa;
  input   [ 31: 0] ctrl_s1_readdata_from_sa;
  input            d1_adc_data_ready_s1_end_xfer;
  input            d1_cpu_jtag_debug_module_end_xfer;
  input            d1_ctrl_s1_end_xfer;
  input            d1_epcs_flash_controller_epcs_control_port_end_xfer;
  input            d1_gpio_s1_end_xfer;
  input            d1_jtag_uart_avalon_jtag_slave_end_xfer;
  input            d1_led_s1_end_xfer;
  input            d1_onchip_ram_s1_end_xfer;
  input            d1_opencores_i2c_0_avalon_slave_end_xfer;
  input            d1_opencores_i2c_1_avalon_slave_end_xfer;
  input            d1_spi_0_p0_spi_control_port_end_xfer;
  input            d1_spi_0_p1_spi_control_port_end_xfer;
  input            d1_spi_1_p0_spi_control_port_end_xfer;
  input            d1_spi_1_p1_spi_control_port_end_xfer;
  input            d1_sysid_control_slave_end_xfer;
  input            d1_timer_s1_end_xfer;
  input            d1_uCProbe_uart_avalon_jtag_slave_end_xfer;
  input            d1_uC_clock_0_in_end_xfer;
  input            epcs_flash_controller_epcs_control_port_irq_from_sa;
  input   [ 31: 0] epcs_flash_controller_epcs_control_port_readdata_from_sa;
  input   [ 31: 0] gpio_s1_readdata_from_sa;
  input            jtag_uart_avalon_jtag_slave_irq_from_sa;
  input   [ 31: 0] jtag_uart_avalon_jtag_slave_readdata_from_sa;
  input            jtag_uart_avalon_jtag_slave_waitrequest_from_sa;
  input   [ 31: 0] led_s1_readdata_from_sa;
  input   [ 31: 0] onchip_ram_s1_readdata_from_sa;
  input            opencores_i2c_0_avalon_slave_irq_from_sa;
  input   [  7: 0] opencores_i2c_0_avalon_slave_readdata_from_sa;
  input            opencores_i2c_0_avalon_slave_waitrequest_n_from_sa;
  input            opencores_i2c_1_avalon_slave_irq_from_sa;
  input   [  7: 0] opencores_i2c_1_avalon_slave_readdata_from_sa;
  input            opencores_i2c_1_avalon_slave_waitrequest_n_from_sa;
  input            registered_cpu_data_master_read_data_valid_onchip_ram_s1;
  input            reset_n;
  input            spi_0_p0_spi_control_port_irq_from_sa;
  input   [ 15: 0] spi_0_p0_spi_control_port_readdata_from_sa;
  input            spi_0_p1_spi_control_port_irq_from_sa;
  input   [ 15: 0] spi_0_p1_spi_control_port_readdata_from_sa;
  input            spi_1_p0_spi_control_port_irq_from_sa;
  input   [ 15: 0] spi_1_p0_spi_control_port_readdata_from_sa;
  input            spi_1_p1_spi_control_port_irq_from_sa;
  input   [ 15: 0] spi_1_p1_spi_control_port_readdata_from_sa;
  input   [ 31: 0] sysid_control_slave_readdata_from_sa;
  input            timer_s1_irq_from_sa;
  input   [ 15: 0] timer_s1_readdata_from_sa;
  input            uCProbe_uart_avalon_jtag_slave_irq_from_sa;
  input   [ 31: 0] uCProbe_uart_avalon_jtag_slave_readdata_from_sa;
  input            uCProbe_uart_avalon_jtag_slave_waitrequest_from_sa;
  input   [ 31: 0] uC_clock_0_in_readdata_from_sa;
  input            uC_clock_0_in_waitrequest_from_sa;

  wire    [ 16: 0] cpu_data_master_address_to_slave;
  wire    [ 31: 0] cpu_data_master_irq;
  wire    [ 31: 0] cpu_data_master_readdata;
  wire             cpu_data_master_run;
  reg              cpu_data_master_waitrequest;
  wire    [ 31: 0] p1_registered_cpu_data_master_readdata;
  wire             r_0;
  wire             r_1;
  wire             r_2;
  wire             r_3;
  reg     [ 31: 0] registered_cpu_data_master_readdata;
  //r_0 master_run cascaded wait assignment, which is an e_assign
  assign r_0 = 1 & ((~cpu_data_master_qualified_request_adc_data_ready_s1 | ~cpu_data_master_read | (1 & 1 & cpu_data_master_read))) & ((~cpu_data_master_qualified_request_adc_data_ready_s1 | ~cpu_data_master_write | (1 & cpu_data_master_write))) & 1 & (cpu_data_master_qualified_request_cpu_jtag_debug_module | ~cpu_data_master_requests_cpu_jtag_debug_module) & (cpu_data_master_granted_cpu_jtag_debug_module | ~cpu_data_master_qualified_request_cpu_jtag_debug_module) & ((~cpu_data_master_qualified_request_cpu_jtag_debug_module | ~cpu_data_master_read | (1 & 1 & cpu_data_master_read))) & ((~cpu_data_master_qualified_request_cpu_jtag_debug_module | ~cpu_data_master_write | (1 & cpu_data_master_write))) & 1 & (cpu_data_master_qualified_request_ctrl_s1 | ~cpu_data_master_requests_ctrl_s1) & ((~cpu_data_master_qualified_request_ctrl_s1 | ~cpu_data_master_read | (1 & 1 & cpu_data_master_read))) & ((~cpu_data_master_qualified_request_ctrl_s1 | ~cpu_data_master_write | (1 & cpu_data_master_write))) & 1 & (cpu_data_master_qualified_request_epcs_flash_controller_epcs_control_port | ~cpu_data_master_requests_epcs_flash_controller_epcs_control_port) & (cpu_data_master_granted_epcs_flash_controller_epcs_control_port | ~cpu_data_master_qualified_request_epcs_flash_controller_epcs_control_port) & ((~cpu_data_master_qualified_request_epcs_flash_controller_epcs_control_port | ~(cpu_data_master_read | cpu_data_master_write) | (1 & 1 & (cpu_data_master_read | cpu_data_master_write)))) & ((~cpu_data_master_qualified_request_epcs_flash_controller_epcs_control_port | ~(cpu_data_master_read | cpu_data_master_write) | (1 & 1 & (cpu_data_master_read | cpu_data_master_write)))) & 1 & (cpu_data_master_qualified_request_gpio_s1 | ~cpu_data_master_requests_gpio_s1) & ((~cpu_data_master_qualified_request_gpio_s1 | ~cpu_data_master_read | (1 & 1 & cpu_data_master_read)));

  //cascaded wait assignment, which is an e_assign
  assign cpu_data_master_run = r_0 & r_1 & r_2 & r_3;

  //r_1 master_run cascaded wait assignment, which is an e_assign
  assign r_1 = ((~cpu_data_master_qualified_request_gpio_s1 | ~cpu_data_master_write | (1 & cpu_data_master_write))) & 1 & (cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave | ~cpu_data_master_requests_jtag_uart_avalon_jtag_slave) & ((~cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave | ~(cpu_data_master_read | cpu_data_master_write) | (1 & ~jtag_uart_avalon_jtag_slave_waitrequest_from_sa & (cpu_data_master_read | cpu_data_master_write)))) & ((~cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave | ~(cpu_data_master_read | cpu_data_master_write) | (1 & ~jtag_uart_avalon_jtag_slave_waitrequest_from_sa & (cpu_data_master_read | cpu_data_master_write)))) & 1 & (cpu_data_master_qualified_request_led_s1 | ~cpu_data_master_requests_led_s1) & ((~cpu_data_master_qualified_request_led_s1 | ~cpu_data_master_read | (1 & 1 & cpu_data_master_read))) & ((~cpu_data_master_qualified_request_led_s1 | ~cpu_data_master_write | (1 & cpu_data_master_write))) & 1 & (cpu_data_master_qualified_request_onchip_ram_s1 | registered_cpu_data_master_read_data_valid_onchip_ram_s1 | ~cpu_data_master_requests_onchip_ram_s1) & (cpu_data_master_granted_onchip_ram_s1 | ~cpu_data_master_qualified_request_onchip_ram_s1) & ((~cpu_data_master_qualified_request_onchip_ram_s1 | ~cpu_data_master_read | (registered_cpu_data_master_read_data_valid_onchip_ram_s1 & cpu_data_master_read))) & ((~cpu_data_master_qualified_request_onchip_ram_s1 | ~(cpu_data_master_read | cpu_data_master_write) | (1 & (cpu_data_master_read | cpu_data_master_write)))) & 1 & (cpu_data_master_qualified_request_opencores_i2c_0_avalon_slave | ~cpu_data_master_requests_opencores_i2c_0_avalon_slave) & ((~cpu_data_master_qualified_request_opencores_i2c_0_avalon_slave | ~(cpu_data_master_read | cpu_data_master_write) | (1 & opencores_i2c_0_avalon_slave_waitrequest_n_from_sa & (cpu_data_master_read | cpu_data_master_write)))) & ((~cpu_data_master_qualified_request_opencores_i2c_0_avalon_slave | ~(cpu_data_master_read | cpu_data_master_write) | (1 & opencores_i2c_0_avalon_slave_waitrequest_n_from_sa & (cpu_data_master_read | cpu_data_master_write)))) & 1 & (cpu_data_master_qualified_request_opencores_i2c_1_avalon_slave | ~cpu_data_master_requests_opencores_i2c_1_avalon_slave);

  //r_2 master_run cascaded wait assignment, which is an e_assign
  assign r_2 = ((~cpu_data_master_qualified_request_opencores_i2c_1_avalon_slave | ~(cpu_data_master_read | cpu_data_master_write) | (1 & opencores_i2c_1_avalon_slave_waitrequest_n_from_sa & (cpu_data_master_read | cpu_data_master_write)))) & ((~cpu_data_master_qualified_request_opencores_i2c_1_avalon_slave | ~(cpu_data_master_read | cpu_data_master_write) | (1 & opencores_i2c_1_avalon_slave_waitrequest_n_from_sa & (cpu_data_master_read | cpu_data_master_write)))) & 1 & ((~cpu_data_master_qualified_request_spi_0_p0_spi_control_port | ~(cpu_data_master_read | cpu_data_master_write) | (1 & 1 & (cpu_data_master_read | cpu_data_master_write)))) & ((~cpu_data_master_qualified_request_spi_0_p0_spi_control_port | ~(cpu_data_master_read | cpu_data_master_write) | (1 & 1 & (cpu_data_master_read | cpu_data_master_write)))) & 1 & ((~cpu_data_master_qualified_request_spi_0_p1_spi_control_port | ~(cpu_data_master_read | cpu_data_master_write) | (1 & 1 & (cpu_data_master_read | cpu_data_master_write)))) & ((~cpu_data_master_qualified_request_spi_0_p1_spi_control_port | ~(cpu_data_master_read | cpu_data_master_write) | (1 & 1 & (cpu_data_master_read | cpu_data_master_write)))) & 1 & ((~cpu_data_master_qualified_request_spi_1_p0_spi_control_port | ~(cpu_data_master_read | cpu_data_master_write) | (1 & 1 & (cpu_data_master_read | cpu_data_master_write)))) & ((~cpu_data_master_qualified_request_spi_1_p0_spi_control_port | ~(cpu_data_master_read | cpu_data_master_write) | (1 & 1 & (cpu_data_master_read | cpu_data_master_write)))) & 1 & ((~cpu_data_master_qualified_request_spi_1_p1_spi_control_port | ~(cpu_data_master_read | cpu_data_master_write) | (1 & 1 & (cpu_data_master_read | cpu_data_master_write)))) & ((~cpu_data_master_qualified_request_spi_1_p1_spi_control_port | ~(cpu_data_master_read | cpu_data_master_write) | (1 & 1 & (cpu_data_master_read | cpu_data_master_write)))) & 1 & ((~cpu_data_master_qualified_request_sysid_control_slave | ~cpu_data_master_read | (1 & 1 & cpu_data_master_read))) & ((~cpu_data_master_qualified_request_sysid_control_slave | ~cpu_data_master_write | (1 & cpu_data_master_write))) & 1 & (cpu_data_master_qualified_request_timer_s1 | ~cpu_data_master_requests_timer_s1) & ((~cpu_data_master_qualified_request_timer_s1 | ~cpu_data_master_read | (1 & 1 & cpu_data_master_read)));

  //r_3 master_run cascaded wait assignment, which is an e_assign
  assign r_3 = ((~cpu_data_master_qualified_request_timer_s1 | ~cpu_data_master_write | (1 & cpu_data_master_write))) & 1 & (cpu_data_master_qualified_request_uCProbe_uart_avalon_jtag_slave | ~cpu_data_master_requests_uCProbe_uart_avalon_jtag_slave) & ((~cpu_data_master_qualified_request_uCProbe_uart_avalon_jtag_slave | ~(cpu_data_master_read | cpu_data_master_write) | (1 & ~uCProbe_uart_avalon_jtag_slave_waitrequest_from_sa & (cpu_data_master_read | cpu_data_master_write)))) & ((~cpu_data_master_qualified_request_uCProbe_uart_avalon_jtag_slave | ~(cpu_data_master_read | cpu_data_master_write) | (1 & ~uCProbe_uart_avalon_jtag_slave_waitrequest_from_sa & (cpu_data_master_read | cpu_data_master_write)))) & 1 & (cpu_data_master_qualified_request_uC_clock_0_in | ~cpu_data_master_requests_uC_clock_0_in) & ((~cpu_data_master_qualified_request_uC_clock_0_in | ~(cpu_data_master_read | cpu_data_master_write) | (1 & ~uC_clock_0_in_waitrequest_from_sa & (cpu_data_master_read | cpu_data_master_write)))) & ((~cpu_data_master_qualified_request_uC_clock_0_in | ~(cpu_data_master_read | cpu_data_master_write) | (1 & ~uC_clock_0_in_waitrequest_from_sa & (cpu_data_master_read | cpu_data_master_write))));

  //optimize select-logic by passing only those address bits which matter.
  assign cpu_data_master_address_to_slave = cpu_data_master_address[16 : 0];

  //cpu/data_master readdata mux, which is an e_mux
  assign cpu_data_master_readdata = ({32 {~cpu_data_master_requests_adc_data_ready_s1}} | adc_data_ready_s1_readdata_from_sa) &
    ({32 {~cpu_data_master_requests_cpu_jtag_debug_module}} | cpu_jtag_debug_module_readdata_from_sa) &
    ({32 {~cpu_data_master_requests_ctrl_s1}} | ctrl_s1_readdata_from_sa) &
    ({32 {~cpu_data_master_requests_epcs_flash_controller_epcs_control_port}} | epcs_flash_controller_epcs_control_port_readdata_from_sa) &
    ({32 {~cpu_data_master_requests_gpio_s1}} | gpio_s1_readdata_from_sa) &
    ({32 {~cpu_data_master_requests_jtag_uart_avalon_jtag_slave}} | registered_cpu_data_master_readdata) &
    ({32 {~cpu_data_master_requests_led_s1}} | led_s1_readdata_from_sa) &
    ({32 {~cpu_data_master_requests_onchip_ram_s1}} | onchip_ram_s1_readdata_from_sa) &
    ({32 {~cpu_data_master_requests_opencores_i2c_0_avalon_slave}} | registered_cpu_data_master_readdata) &
    ({32 {~cpu_data_master_requests_opencores_i2c_1_avalon_slave}} | registered_cpu_data_master_readdata) &
    ({32 {~cpu_data_master_requests_spi_0_p0_spi_control_port}} | spi_0_p0_spi_control_port_readdata_from_sa) &
    ({32 {~cpu_data_master_requests_spi_0_p1_spi_control_port}} | spi_0_p1_spi_control_port_readdata_from_sa) &
    ({32 {~cpu_data_master_requests_spi_1_p0_spi_control_port}} | spi_1_p0_spi_control_port_readdata_from_sa) &
    ({32 {~cpu_data_master_requests_spi_1_p1_spi_control_port}} | spi_1_p1_spi_control_port_readdata_from_sa) &
    ({32 {~cpu_data_master_requests_sysid_control_slave}} | sysid_control_slave_readdata_from_sa) &
    ({32 {~cpu_data_master_requests_timer_s1}} | timer_s1_readdata_from_sa) &
    ({32 {~cpu_data_master_requests_uCProbe_uart_avalon_jtag_slave}} | registered_cpu_data_master_readdata) &
    ({32 {~cpu_data_master_requests_uC_clock_0_in}} | registered_cpu_data_master_readdata);

  //actual waitrequest port, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_data_master_waitrequest <= ~0;
      else 
        cpu_data_master_waitrequest <= ~((~(cpu_data_master_read | cpu_data_master_write))? 0: (cpu_data_master_run & cpu_data_master_waitrequest));
    end


  //irq assign, which is an e_assign
  assign cpu_data_master_irq = {1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    1'b0,
    opencores_i2c_1_avalon_slave_irq_from_sa,
    opencores_i2c_0_avalon_slave_irq_from_sa,
    spi_1_p1_spi_control_port_irq_from_sa,
    spi_1_p0_spi_control_port_irq_from_sa,
    spi_0_p1_spi_control_port_irq_from_sa,
    spi_0_p0_spi_control_port_irq_from_sa,
    timer_s1_irq_from_sa,
    epcs_flash_controller_epcs_control_port_irq_from_sa,
    uCProbe_uart_avalon_jtag_slave_irq_from_sa,
    jtag_uart_avalon_jtag_slave_irq_from_sa};

  //unpredictable registered wait state incoming data, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          registered_cpu_data_master_readdata <= 0;
      else 
        registered_cpu_data_master_readdata <= p1_registered_cpu_data_master_readdata;
    end


  //registered readdata mux, which is an e_mux
  assign p1_registered_cpu_data_master_readdata = ({32 {~cpu_data_master_requests_jtag_uart_avalon_jtag_slave}} | jtag_uart_avalon_jtag_slave_readdata_from_sa) &
    ({32 {~cpu_data_master_requests_opencores_i2c_0_avalon_slave}} | opencores_i2c_0_avalon_slave_readdata_from_sa) &
    ({32 {~cpu_data_master_requests_opencores_i2c_1_avalon_slave}} | opencores_i2c_1_avalon_slave_readdata_from_sa) &
    ({32 {~cpu_data_master_requests_uCProbe_uart_avalon_jtag_slave}} | uCProbe_uart_avalon_jtag_slave_readdata_from_sa) &
    ({32 {~cpu_data_master_requests_uC_clock_0_in}} | uC_clock_0_in_readdata_from_sa);


endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module cpu_instruction_master_arbitrator (
                                           // inputs:
                                            clk,
                                            cpu_instruction_master_address,
                                            cpu_instruction_master_granted_cpu_jtag_debug_module,
                                            cpu_instruction_master_granted_epcs_flash_controller_epcs_control_port,
                                            cpu_instruction_master_granted_onchip_ram_s1,
                                            cpu_instruction_master_qualified_request_cpu_jtag_debug_module,
                                            cpu_instruction_master_qualified_request_epcs_flash_controller_epcs_control_port,
                                            cpu_instruction_master_qualified_request_onchip_ram_s1,
                                            cpu_instruction_master_read,
                                            cpu_instruction_master_read_data_valid_cpu_jtag_debug_module,
                                            cpu_instruction_master_read_data_valid_epcs_flash_controller_epcs_control_port,
                                            cpu_instruction_master_read_data_valid_onchip_ram_s1,
                                            cpu_instruction_master_requests_cpu_jtag_debug_module,
                                            cpu_instruction_master_requests_epcs_flash_controller_epcs_control_port,
                                            cpu_instruction_master_requests_onchip_ram_s1,
                                            cpu_jtag_debug_module_readdata_from_sa,
                                            d1_cpu_jtag_debug_module_end_xfer,
                                            d1_epcs_flash_controller_epcs_control_port_end_xfer,
                                            d1_onchip_ram_s1_end_xfer,
                                            epcs_flash_controller_epcs_control_port_readdata_from_sa,
                                            onchip_ram_s1_readdata_from_sa,
                                            reset_n,

                                           // outputs:
                                            cpu_instruction_master_address_to_slave,
                                            cpu_instruction_master_readdata,
                                            cpu_instruction_master_waitrequest
                                         )
;

  output  [ 16: 0] cpu_instruction_master_address_to_slave;
  output  [ 31: 0] cpu_instruction_master_readdata;
  output           cpu_instruction_master_waitrequest;
  input            clk;
  input   [ 16: 0] cpu_instruction_master_address;
  input            cpu_instruction_master_granted_cpu_jtag_debug_module;
  input            cpu_instruction_master_granted_epcs_flash_controller_epcs_control_port;
  input            cpu_instruction_master_granted_onchip_ram_s1;
  input            cpu_instruction_master_qualified_request_cpu_jtag_debug_module;
  input            cpu_instruction_master_qualified_request_epcs_flash_controller_epcs_control_port;
  input            cpu_instruction_master_qualified_request_onchip_ram_s1;
  input            cpu_instruction_master_read;
  input            cpu_instruction_master_read_data_valid_cpu_jtag_debug_module;
  input            cpu_instruction_master_read_data_valid_epcs_flash_controller_epcs_control_port;
  input            cpu_instruction_master_read_data_valid_onchip_ram_s1;
  input            cpu_instruction_master_requests_cpu_jtag_debug_module;
  input            cpu_instruction_master_requests_epcs_flash_controller_epcs_control_port;
  input            cpu_instruction_master_requests_onchip_ram_s1;
  input   [ 31: 0] cpu_jtag_debug_module_readdata_from_sa;
  input            d1_cpu_jtag_debug_module_end_xfer;
  input            d1_epcs_flash_controller_epcs_control_port_end_xfer;
  input            d1_onchip_ram_s1_end_xfer;
  input   [ 31: 0] epcs_flash_controller_epcs_control_port_readdata_from_sa;
  input   [ 31: 0] onchip_ram_s1_readdata_from_sa;
  input            reset_n;

  reg              active_and_waiting_last_time;
  reg     [ 16: 0] cpu_instruction_master_address_last_time;
  wire    [ 16: 0] cpu_instruction_master_address_to_slave;
  reg              cpu_instruction_master_read_last_time;
  wire    [ 31: 0] cpu_instruction_master_readdata;
  wire             cpu_instruction_master_run;
  wire             cpu_instruction_master_waitrequest;
  wire             r_0;
  wire             r_1;
  //r_0 master_run cascaded wait assignment, which is an e_assign
  assign r_0 = 1 & (cpu_instruction_master_qualified_request_cpu_jtag_debug_module | ~cpu_instruction_master_requests_cpu_jtag_debug_module) & (cpu_instruction_master_granted_cpu_jtag_debug_module | ~cpu_instruction_master_qualified_request_cpu_jtag_debug_module) & ((~cpu_instruction_master_qualified_request_cpu_jtag_debug_module | ~cpu_instruction_master_read | (1 & ~d1_cpu_jtag_debug_module_end_xfer & cpu_instruction_master_read))) & 1 & (cpu_instruction_master_qualified_request_epcs_flash_controller_epcs_control_port | ~cpu_instruction_master_requests_epcs_flash_controller_epcs_control_port) & (cpu_instruction_master_granted_epcs_flash_controller_epcs_control_port | ~cpu_instruction_master_qualified_request_epcs_flash_controller_epcs_control_port) & ((~cpu_instruction_master_qualified_request_epcs_flash_controller_epcs_control_port | ~(cpu_instruction_master_read) | (1 & ~d1_epcs_flash_controller_epcs_control_port_end_xfer & (cpu_instruction_master_read))));

  //cascaded wait assignment, which is an e_assign
  assign cpu_instruction_master_run = r_0 & r_1;

  //r_1 master_run cascaded wait assignment, which is an e_assign
  assign r_1 = 1 & (cpu_instruction_master_qualified_request_onchip_ram_s1 | cpu_instruction_master_read_data_valid_onchip_ram_s1 | ~cpu_instruction_master_requests_onchip_ram_s1) & (cpu_instruction_master_granted_onchip_ram_s1 | ~cpu_instruction_master_qualified_request_onchip_ram_s1) & ((~cpu_instruction_master_qualified_request_onchip_ram_s1 | ~cpu_instruction_master_read | (cpu_instruction_master_read_data_valid_onchip_ram_s1 & cpu_instruction_master_read)));

  //optimize select-logic by passing only those address bits which matter.
  assign cpu_instruction_master_address_to_slave = cpu_instruction_master_address[16 : 0];

  //cpu/instruction_master readdata mux, which is an e_mux
  assign cpu_instruction_master_readdata = ({32 {~cpu_instruction_master_requests_cpu_jtag_debug_module}} | cpu_jtag_debug_module_readdata_from_sa) &
    ({32 {~cpu_instruction_master_requests_epcs_flash_controller_epcs_control_port}} | epcs_flash_controller_epcs_control_port_readdata_from_sa) &
    ({32 {~cpu_instruction_master_requests_onchip_ram_s1}} | onchip_ram_s1_readdata_from_sa);

  //actual waitrequest port, which is an e_assign
  assign cpu_instruction_master_waitrequest = ~cpu_instruction_master_run;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //cpu_instruction_master_address check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_instruction_master_address_last_time <= 0;
      else 
        cpu_instruction_master_address_last_time <= cpu_instruction_master_address;
    end


  //cpu/instruction_master waited last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          active_and_waiting_last_time <= 0;
      else 
        active_and_waiting_last_time <= cpu_instruction_master_waitrequest & (cpu_instruction_master_read);
    end


  //cpu_instruction_master_address matches last port_name, which is an e_process
  always @(posedge clk)
    begin
      if (active_and_waiting_last_time & (cpu_instruction_master_address != cpu_instruction_master_address_last_time))
        begin
          $write("%0d ns: cpu_instruction_master_address did not heed wait!!!", $time);
          $stop;
        end
    end


  //cpu_instruction_master_read check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_instruction_master_read_last_time <= 0;
      else 
        cpu_instruction_master_read_last_time <= cpu_instruction_master_read;
    end


  //cpu_instruction_master_read matches last port_name, which is an e_process
  always @(posedge clk)
    begin
      if (active_and_waiting_last_time & (cpu_instruction_master_read != cpu_instruction_master_read_last_time))
        begin
          $write("%0d ns: cpu_instruction_master_read did not heed wait!!!", $time);
          $stop;
        end
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module ctrl_s1_arbitrator (
                            // inputs:
                             clk,
                             cpu_data_master_address_to_slave,
                             cpu_data_master_read,
                             cpu_data_master_waitrequest,
                             cpu_data_master_write,
                             cpu_data_master_writedata,
                             ctrl_s1_readdata,
                             reset_n,

                            // outputs:
                             cpu_data_master_granted_ctrl_s1,
                             cpu_data_master_qualified_request_ctrl_s1,
                             cpu_data_master_read_data_valid_ctrl_s1,
                             cpu_data_master_requests_ctrl_s1,
                             ctrl_s1_address,
                             ctrl_s1_chipselect,
                             ctrl_s1_readdata_from_sa,
                             ctrl_s1_reset_n,
                             ctrl_s1_write_n,
                             ctrl_s1_writedata,
                             d1_ctrl_s1_end_xfer
                          )
;

  output           cpu_data_master_granted_ctrl_s1;
  output           cpu_data_master_qualified_request_ctrl_s1;
  output           cpu_data_master_read_data_valid_ctrl_s1;
  output           cpu_data_master_requests_ctrl_s1;
  output  [  1: 0] ctrl_s1_address;
  output           ctrl_s1_chipselect;
  output  [ 31: 0] ctrl_s1_readdata_from_sa;
  output           ctrl_s1_reset_n;
  output           ctrl_s1_write_n;
  output  [ 31: 0] ctrl_s1_writedata;
  output           d1_ctrl_s1_end_xfer;
  input            clk;
  input   [ 16: 0] cpu_data_master_address_to_slave;
  input            cpu_data_master_read;
  input            cpu_data_master_waitrequest;
  input            cpu_data_master_write;
  input   [ 31: 0] cpu_data_master_writedata;
  input   [ 31: 0] ctrl_s1_readdata;
  input            reset_n;

  wire             cpu_data_master_arbiterlock;
  wire             cpu_data_master_arbiterlock2;
  wire             cpu_data_master_continuerequest;
  wire             cpu_data_master_granted_ctrl_s1;
  wire             cpu_data_master_qualified_request_ctrl_s1;
  wire             cpu_data_master_read_data_valid_ctrl_s1;
  wire             cpu_data_master_requests_ctrl_s1;
  wire             cpu_data_master_saved_grant_ctrl_s1;
  wire    [  1: 0] ctrl_s1_address;
  wire             ctrl_s1_allgrants;
  wire             ctrl_s1_allow_new_arb_cycle;
  wire             ctrl_s1_any_bursting_master_saved_grant;
  wire             ctrl_s1_any_continuerequest;
  wire             ctrl_s1_arb_counter_enable;
  reg              ctrl_s1_arb_share_counter;
  wire             ctrl_s1_arb_share_counter_next_value;
  wire             ctrl_s1_arb_share_set_values;
  wire             ctrl_s1_beginbursttransfer_internal;
  wire             ctrl_s1_begins_xfer;
  wire             ctrl_s1_chipselect;
  wire             ctrl_s1_end_xfer;
  wire             ctrl_s1_firsttransfer;
  wire             ctrl_s1_grant_vector;
  wire             ctrl_s1_in_a_read_cycle;
  wire             ctrl_s1_in_a_write_cycle;
  wire             ctrl_s1_master_qreq_vector;
  wire             ctrl_s1_non_bursting_master_requests;
  wire    [ 31: 0] ctrl_s1_readdata_from_sa;
  reg              ctrl_s1_reg_firsttransfer;
  wire             ctrl_s1_reset_n;
  reg              ctrl_s1_slavearbiterlockenable;
  wire             ctrl_s1_slavearbiterlockenable2;
  wire             ctrl_s1_unreg_firsttransfer;
  wire             ctrl_s1_waits_for_read;
  wire             ctrl_s1_waits_for_write;
  wire             ctrl_s1_write_n;
  wire    [ 31: 0] ctrl_s1_writedata;
  reg              d1_ctrl_s1_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_ctrl_s1;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [ 16: 0] shifted_address_to_ctrl_s1_from_cpu_data_master;
  wire             wait_for_ctrl_s1_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else 
        d1_reasons_to_wait <= ~ctrl_s1_end_xfer;
    end


  assign ctrl_s1_begins_xfer = ~d1_reasons_to_wait & ((cpu_data_master_qualified_request_ctrl_s1));
  //assign ctrl_s1_readdata_from_sa = ctrl_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign ctrl_s1_readdata_from_sa = ctrl_s1_readdata;

  assign cpu_data_master_requests_ctrl_s1 = ({cpu_data_master_address_to_slave[16 : 4] , 4'b0} == 17'h20a0) & (cpu_data_master_read | cpu_data_master_write);
  //ctrl_s1_arb_share_counter set values, which is an e_mux
  assign ctrl_s1_arb_share_set_values = 1;

  //ctrl_s1_non_bursting_master_requests mux, which is an e_mux
  assign ctrl_s1_non_bursting_master_requests = cpu_data_master_requests_ctrl_s1;

  //ctrl_s1_any_bursting_master_saved_grant mux, which is an e_mux
  assign ctrl_s1_any_bursting_master_saved_grant = 0;

  //ctrl_s1_arb_share_counter_next_value assignment, which is an e_assign
  assign ctrl_s1_arb_share_counter_next_value = ctrl_s1_firsttransfer ? (ctrl_s1_arb_share_set_values - 1) : |ctrl_s1_arb_share_counter ? (ctrl_s1_arb_share_counter - 1) : 0;

  //ctrl_s1_allgrants all slave grants, which is an e_mux
  assign ctrl_s1_allgrants = |ctrl_s1_grant_vector;

  //ctrl_s1_end_xfer assignment, which is an e_assign
  assign ctrl_s1_end_xfer = ~(ctrl_s1_waits_for_read | ctrl_s1_waits_for_write);

  //end_xfer_arb_share_counter_term_ctrl_s1 arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_ctrl_s1 = ctrl_s1_end_xfer & (~ctrl_s1_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //ctrl_s1_arb_share_counter arbitration counter enable, which is an e_assign
  assign ctrl_s1_arb_counter_enable = (end_xfer_arb_share_counter_term_ctrl_s1 & ctrl_s1_allgrants) | (end_xfer_arb_share_counter_term_ctrl_s1 & ~ctrl_s1_non_bursting_master_requests);

  //ctrl_s1_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          ctrl_s1_arb_share_counter <= 0;
      else if (ctrl_s1_arb_counter_enable)
          ctrl_s1_arb_share_counter <= ctrl_s1_arb_share_counter_next_value;
    end


  //ctrl_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          ctrl_s1_slavearbiterlockenable <= 0;
      else if ((|ctrl_s1_master_qreq_vector & end_xfer_arb_share_counter_term_ctrl_s1) | (end_xfer_arb_share_counter_term_ctrl_s1 & ~ctrl_s1_non_bursting_master_requests))
          ctrl_s1_slavearbiterlockenable <= |ctrl_s1_arb_share_counter_next_value;
    end


  //cpu/data_master ctrl/s1 arbiterlock, which is an e_assign
  assign cpu_data_master_arbiterlock = ctrl_s1_slavearbiterlockenable & cpu_data_master_continuerequest;

  //ctrl_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign ctrl_s1_slavearbiterlockenable2 = |ctrl_s1_arb_share_counter_next_value;

  //cpu/data_master ctrl/s1 arbiterlock2, which is an e_assign
  assign cpu_data_master_arbiterlock2 = ctrl_s1_slavearbiterlockenable2 & cpu_data_master_continuerequest;

  //ctrl_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  assign ctrl_s1_any_continuerequest = 1;

  //cpu_data_master_continuerequest continued request, which is an e_assign
  assign cpu_data_master_continuerequest = 1;

  assign cpu_data_master_qualified_request_ctrl_s1 = cpu_data_master_requests_ctrl_s1 & ~(((~cpu_data_master_waitrequest) & cpu_data_master_write));
  //ctrl_s1_writedata mux, which is an e_mux
  assign ctrl_s1_writedata = cpu_data_master_writedata;

  //master is always granted when requested
  assign cpu_data_master_granted_ctrl_s1 = cpu_data_master_qualified_request_ctrl_s1;

  //cpu/data_master saved-grant ctrl/s1, which is an e_assign
  assign cpu_data_master_saved_grant_ctrl_s1 = cpu_data_master_requests_ctrl_s1;

  //allow new arb cycle for ctrl/s1, which is an e_assign
  assign ctrl_s1_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign ctrl_s1_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign ctrl_s1_master_qreq_vector = 1;

  //ctrl_s1_reset_n assignment, which is an e_assign
  assign ctrl_s1_reset_n = reset_n;

  assign ctrl_s1_chipselect = cpu_data_master_granted_ctrl_s1;
  //ctrl_s1_firsttransfer first transaction, which is an e_assign
  assign ctrl_s1_firsttransfer = ctrl_s1_begins_xfer ? ctrl_s1_unreg_firsttransfer : ctrl_s1_reg_firsttransfer;

  //ctrl_s1_unreg_firsttransfer first transaction, which is an e_assign
  assign ctrl_s1_unreg_firsttransfer = ~(ctrl_s1_slavearbiterlockenable & ctrl_s1_any_continuerequest);

  //ctrl_s1_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          ctrl_s1_reg_firsttransfer <= 1'b1;
      else if (ctrl_s1_begins_xfer)
          ctrl_s1_reg_firsttransfer <= ctrl_s1_unreg_firsttransfer;
    end


  //ctrl_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign ctrl_s1_beginbursttransfer_internal = ctrl_s1_begins_xfer;

  //~ctrl_s1_write_n assignment, which is an e_mux
  assign ctrl_s1_write_n = ~(cpu_data_master_granted_ctrl_s1 & cpu_data_master_write);

  assign shifted_address_to_ctrl_s1_from_cpu_data_master = cpu_data_master_address_to_slave;
  //ctrl_s1_address mux, which is an e_mux
  assign ctrl_s1_address = shifted_address_to_ctrl_s1_from_cpu_data_master >> 2;

  //d1_ctrl_s1_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_ctrl_s1_end_xfer <= 1;
      else 
        d1_ctrl_s1_end_xfer <= ctrl_s1_end_xfer;
    end


  //ctrl_s1_waits_for_read in a cycle, which is an e_mux
  assign ctrl_s1_waits_for_read = ctrl_s1_in_a_read_cycle & ctrl_s1_begins_xfer;

  //ctrl_s1_in_a_read_cycle assignment, which is an e_assign
  assign ctrl_s1_in_a_read_cycle = cpu_data_master_granted_ctrl_s1 & cpu_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = ctrl_s1_in_a_read_cycle;

  //ctrl_s1_waits_for_write in a cycle, which is an e_mux
  assign ctrl_s1_waits_for_write = ctrl_s1_in_a_write_cycle & 0;

  //ctrl_s1_in_a_write_cycle assignment, which is an e_assign
  assign ctrl_s1_in_a_write_cycle = cpu_data_master_granted_ctrl_s1 & cpu_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = ctrl_s1_in_a_write_cycle;

  assign wait_for_ctrl_s1_counter = 0;

//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //ctrl/s1 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else 
        enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module epcs_flash_controller_epcs_control_port_arbitrator (
                                                            // inputs:
                                                             clk,
                                                             cpu_data_master_address_to_slave,
                                                             cpu_data_master_read,
                                                             cpu_data_master_write,
                                                             cpu_data_master_writedata,
                                                             cpu_instruction_master_address_to_slave,
                                                             cpu_instruction_master_read,
                                                             epcs_flash_controller_epcs_control_port_dataavailable,
                                                             epcs_flash_controller_epcs_control_port_endofpacket,
                                                             epcs_flash_controller_epcs_control_port_irq,
                                                             epcs_flash_controller_epcs_control_port_readdata,
                                                             epcs_flash_controller_epcs_control_port_readyfordata,
                                                             reset_n,

                                                            // outputs:
                                                             cpu_data_master_granted_epcs_flash_controller_epcs_control_port,
                                                             cpu_data_master_qualified_request_epcs_flash_controller_epcs_control_port,
                                                             cpu_data_master_read_data_valid_epcs_flash_controller_epcs_control_port,
                                                             cpu_data_master_requests_epcs_flash_controller_epcs_control_port,
                                                             cpu_instruction_master_granted_epcs_flash_controller_epcs_control_port,
                                                             cpu_instruction_master_qualified_request_epcs_flash_controller_epcs_control_port,
                                                             cpu_instruction_master_read_data_valid_epcs_flash_controller_epcs_control_port,
                                                             cpu_instruction_master_requests_epcs_flash_controller_epcs_control_port,
                                                             d1_epcs_flash_controller_epcs_control_port_end_xfer,
                                                             epcs_flash_controller_epcs_control_port_address,
                                                             epcs_flash_controller_epcs_control_port_chipselect,
                                                             epcs_flash_controller_epcs_control_port_dataavailable_from_sa,
                                                             epcs_flash_controller_epcs_control_port_endofpacket_from_sa,
                                                             epcs_flash_controller_epcs_control_port_irq_from_sa,
                                                             epcs_flash_controller_epcs_control_port_read_n,
                                                             epcs_flash_controller_epcs_control_port_readdata_from_sa,
                                                             epcs_flash_controller_epcs_control_port_readyfordata_from_sa,
                                                             epcs_flash_controller_epcs_control_port_reset_n,
                                                             epcs_flash_controller_epcs_control_port_write_n,
                                                             epcs_flash_controller_epcs_control_port_writedata
                                                          )
;

  output           cpu_data_master_granted_epcs_flash_controller_epcs_control_port;
  output           cpu_data_master_qualified_request_epcs_flash_controller_epcs_control_port;
  output           cpu_data_master_read_data_valid_epcs_flash_controller_epcs_control_port;
  output           cpu_data_master_requests_epcs_flash_controller_epcs_control_port;
  output           cpu_instruction_master_granted_epcs_flash_controller_epcs_control_port;
  output           cpu_instruction_master_qualified_request_epcs_flash_controller_epcs_control_port;
  output           cpu_instruction_master_read_data_valid_epcs_flash_controller_epcs_control_port;
  output           cpu_instruction_master_requests_epcs_flash_controller_epcs_control_port;
  output           d1_epcs_flash_controller_epcs_control_port_end_xfer;
  output  [  8: 0] epcs_flash_controller_epcs_control_port_address;
  output           epcs_flash_controller_epcs_control_port_chipselect;
  output           epcs_flash_controller_epcs_control_port_dataavailable_from_sa;
  output           epcs_flash_controller_epcs_control_port_endofpacket_from_sa;
  output           epcs_flash_controller_epcs_control_port_irq_from_sa;
  output           epcs_flash_controller_epcs_control_port_read_n;
  output  [ 31: 0] epcs_flash_controller_epcs_control_port_readdata_from_sa;
  output           epcs_flash_controller_epcs_control_port_readyfordata_from_sa;
  output           epcs_flash_controller_epcs_control_port_reset_n;
  output           epcs_flash_controller_epcs_control_port_write_n;
  output  [ 31: 0] epcs_flash_controller_epcs_control_port_writedata;
  input            clk;
  input   [ 16: 0] cpu_data_master_address_to_slave;
  input            cpu_data_master_read;
  input            cpu_data_master_write;
  input   [ 31: 0] cpu_data_master_writedata;
  input   [ 16: 0] cpu_instruction_master_address_to_slave;
  input            cpu_instruction_master_read;
  input            epcs_flash_controller_epcs_control_port_dataavailable;
  input            epcs_flash_controller_epcs_control_port_endofpacket;
  input            epcs_flash_controller_epcs_control_port_irq;
  input   [ 31: 0] epcs_flash_controller_epcs_control_port_readdata;
  input            epcs_flash_controller_epcs_control_port_readyfordata;
  input            reset_n;

  wire             cpu_data_master_arbiterlock;
  wire             cpu_data_master_arbiterlock2;
  wire             cpu_data_master_continuerequest;
  wire             cpu_data_master_granted_epcs_flash_controller_epcs_control_port;
  wire             cpu_data_master_qualified_request_epcs_flash_controller_epcs_control_port;
  wire             cpu_data_master_read_data_valid_epcs_flash_controller_epcs_control_port;
  wire             cpu_data_master_requests_epcs_flash_controller_epcs_control_port;
  wire             cpu_data_master_saved_grant_epcs_flash_controller_epcs_control_port;
  wire             cpu_instruction_master_arbiterlock;
  wire             cpu_instruction_master_arbiterlock2;
  wire             cpu_instruction_master_continuerequest;
  wire             cpu_instruction_master_granted_epcs_flash_controller_epcs_control_port;
  wire             cpu_instruction_master_qualified_request_epcs_flash_controller_epcs_control_port;
  wire             cpu_instruction_master_read_data_valid_epcs_flash_controller_epcs_control_port;
  wire             cpu_instruction_master_requests_epcs_flash_controller_epcs_control_port;
  wire             cpu_instruction_master_saved_grant_epcs_flash_controller_epcs_control_port;
  reg              d1_epcs_flash_controller_epcs_control_port_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_epcs_flash_controller_epcs_control_port;
  wire    [  8: 0] epcs_flash_controller_epcs_control_port_address;
  wire             epcs_flash_controller_epcs_control_port_allgrants;
  wire             epcs_flash_controller_epcs_control_port_allow_new_arb_cycle;
  wire             epcs_flash_controller_epcs_control_port_any_bursting_master_saved_grant;
  wire             epcs_flash_controller_epcs_control_port_any_continuerequest;
  reg     [  1: 0] epcs_flash_controller_epcs_control_port_arb_addend;
  wire             epcs_flash_controller_epcs_control_port_arb_counter_enable;
  reg              epcs_flash_controller_epcs_control_port_arb_share_counter;
  wire             epcs_flash_controller_epcs_control_port_arb_share_counter_next_value;
  wire             epcs_flash_controller_epcs_control_port_arb_share_set_values;
  wire    [  1: 0] epcs_flash_controller_epcs_control_port_arb_winner;
  wire             epcs_flash_controller_epcs_control_port_arbitration_holdoff_internal;
  wire             epcs_flash_controller_epcs_control_port_beginbursttransfer_internal;
  wire             epcs_flash_controller_epcs_control_port_begins_xfer;
  wire             epcs_flash_controller_epcs_control_port_chipselect;
  wire    [  3: 0] epcs_flash_controller_epcs_control_port_chosen_master_double_vector;
  wire    [  1: 0] epcs_flash_controller_epcs_control_port_chosen_master_rot_left;
  wire             epcs_flash_controller_epcs_control_port_dataavailable_from_sa;
  wire             epcs_flash_controller_epcs_control_port_end_xfer;
  wire             epcs_flash_controller_epcs_control_port_endofpacket_from_sa;
  wire             epcs_flash_controller_epcs_control_port_firsttransfer;
  wire    [  1: 0] epcs_flash_controller_epcs_control_port_grant_vector;
  wire             epcs_flash_controller_epcs_control_port_in_a_read_cycle;
  wire             epcs_flash_controller_epcs_control_port_in_a_write_cycle;
  wire             epcs_flash_controller_epcs_control_port_irq_from_sa;
  wire    [  1: 0] epcs_flash_controller_epcs_control_port_master_qreq_vector;
  wire             epcs_flash_controller_epcs_control_port_non_bursting_master_requests;
  wire             epcs_flash_controller_epcs_control_port_read_n;
  wire    [ 31: 0] epcs_flash_controller_epcs_control_port_readdata_from_sa;
  wire             epcs_flash_controller_epcs_control_port_readyfordata_from_sa;
  reg              epcs_flash_controller_epcs_control_port_reg_firsttransfer;
  wire             epcs_flash_controller_epcs_control_port_reset_n;
  reg     [  1: 0] epcs_flash_controller_epcs_control_port_saved_chosen_master_vector;
  reg              epcs_flash_controller_epcs_control_port_slavearbiterlockenable;
  wire             epcs_flash_controller_epcs_control_port_slavearbiterlockenable2;
  wire             epcs_flash_controller_epcs_control_port_unreg_firsttransfer;
  wire             epcs_flash_controller_epcs_control_port_waits_for_read;
  wire             epcs_flash_controller_epcs_control_port_waits_for_write;
  wire             epcs_flash_controller_epcs_control_port_write_n;
  wire    [ 31: 0] epcs_flash_controller_epcs_control_port_writedata;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  reg              last_cycle_cpu_data_master_granted_slave_epcs_flash_controller_epcs_control_port;
  reg              last_cycle_cpu_instruction_master_granted_slave_epcs_flash_controller_epcs_control_port;
  wire    [ 16: 0] shifted_address_to_epcs_flash_controller_epcs_control_port_from_cpu_data_master;
  wire    [ 16: 0] shifted_address_to_epcs_flash_controller_epcs_control_port_from_cpu_instruction_master;
  wire             wait_for_epcs_flash_controller_epcs_control_port_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else 
        d1_reasons_to_wait <= ~epcs_flash_controller_epcs_control_port_end_xfer;
    end


  assign epcs_flash_controller_epcs_control_port_begins_xfer = ~d1_reasons_to_wait & ((cpu_data_master_qualified_request_epcs_flash_controller_epcs_control_port | cpu_instruction_master_qualified_request_epcs_flash_controller_epcs_control_port));
  //assign epcs_flash_controller_epcs_control_port_readdata_from_sa = epcs_flash_controller_epcs_control_port_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_readdata_from_sa = epcs_flash_controller_epcs_control_port_readdata;

  assign cpu_data_master_requests_epcs_flash_controller_epcs_control_port = ({cpu_data_master_address_to_slave[16 : 11] , 11'b0} == 17'h1800) & (cpu_data_master_read | cpu_data_master_write);
  //assign epcs_flash_controller_epcs_control_port_dataavailable_from_sa = epcs_flash_controller_epcs_control_port_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_dataavailable_from_sa = epcs_flash_controller_epcs_control_port_dataavailable;

  //assign epcs_flash_controller_epcs_control_port_readyfordata_from_sa = epcs_flash_controller_epcs_control_port_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_readyfordata_from_sa = epcs_flash_controller_epcs_control_port_readyfordata;

  //epcs_flash_controller_epcs_control_port_arb_share_counter set values, which is an e_mux
  assign epcs_flash_controller_epcs_control_port_arb_share_set_values = 1;

  //epcs_flash_controller_epcs_control_port_non_bursting_master_requests mux, which is an e_mux
  assign epcs_flash_controller_epcs_control_port_non_bursting_master_requests = cpu_data_master_requests_epcs_flash_controller_epcs_control_port |
    cpu_instruction_master_requests_epcs_flash_controller_epcs_control_port |
    cpu_data_master_requests_epcs_flash_controller_epcs_control_port |
    cpu_instruction_master_requests_epcs_flash_controller_epcs_control_port;

  //epcs_flash_controller_epcs_control_port_any_bursting_master_saved_grant mux, which is an e_mux
  assign epcs_flash_controller_epcs_control_port_any_bursting_master_saved_grant = 0;

  //epcs_flash_controller_epcs_control_port_arb_share_counter_next_value assignment, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_arb_share_counter_next_value = epcs_flash_controller_epcs_control_port_firsttransfer ? (epcs_flash_controller_epcs_control_port_arb_share_set_values - 1) : |epcs_flash_controller_epcs_control_port_arb_share_counter ? (epcs_flash_controller_epcs_control_port_arb_share_counter - 1) : 0;

  //epcs_flash_controller_epcs_control_port_allgrants all slave grants, which is an e_mux
  assign epcs_flash_controller_epcs_control_port_allgrants = (|epcs_flash_controller_epcs_control_port_grant_vector) |
    (|epcs_flash_controller_epcs_control_port_grant_vector) |
    (|epcs_flash_controller_epcs_control_port_grant_vector) |
    (|epcs_flash_controller_epcs_control_port_grant_vector);

  //epcs_flash_controller_epcs_control_port_end_xfer assignment, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_end_xfer = ~(epcs_flash_controller_epcs_control_port_waits_for_read | epcs_flash_controller_epcs_control_port_waits_for_write);

  //end_xfer_arb_share_counter_term_epcs_flash_controller_epcs_control_port arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_epcs_flash_controller_epcs_control_port = epcs_flash_controller_epcs_control_port_end_xfer & (~epcs_flash_controller_epcs_control_port_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //epcs_flash_controller_epcs_control_port_arb_share_counter arbitration counter enable, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_arb_counter_enable = (end_xfer_arb_share_counter_term_epcs_flash_controller_epcs_control_port & epcs_flash_controller_epcs_control_port_allgrants) | (end_xfer_arb_share_counter_term_epcs_flash_controller_epcs_control_port & ~epcs_flash_controller_epcs_control_port_non_bursting_master_requests);

  //epcs_flash_controller_epcs_control_port_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          epcs_flash_controller_epcs_control_port_arb_share_counter <= 0;
      else if (epcs_flash_controller_epcs_control_port_arb_counter_enable)
          epcs_flash_controller_epcs_control_port_arb_share_counter <= epcs_flash_controller_epcs_control_port_arb_share_counter_next_value;
    end


  //epcs_flash_controller_epcs_control_port_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          epcs_flash_controller_epcs_control_port_slavearbiterlockenable <= 0;
      else if ((|epcs_flash_controller_epcs_control_port_master_qreq_vector & end_xfer_arb_share_counter_term_epcs_flash_controller_epcs_control_port) | (end_xfer_arb_share_counter_term_epcs_flash_controller_epcs_control_port & ~epcs_flash_controller_epcs_control_port_non_bursting_master_requests))
          epcs_flash_controller_epcs_control_port_slavearbiterlockenable <= |epcs_flash_controller_epcs_control_port_arb_share_counter_next_value;
    end


  //cpu/data_master epcs_flash_controller/epcs_control_port arbiterlock, which is an e_assign
  assign cpu_data_master_arbiterlock = epcs_flash_controller_epcs_control_port_slavearbiterlockenable & cpu_data_master_continuerequest;

  //epcs_flash_controller_epcs_control_port_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_slavearbiterlockenable2 = |epcs_flash_controller_epcs_control_port_arb_share_counter_next_value;

  //cpu/data_master epcs_flash_controller/epcs_control_port arbiterlock2, which is an e_assign
  assign cpu_data_master_arbiterlock2 = epcs_flash_controller_epcs_control_port_slavearbiterlockenable2 & cpu_data_master_continuerequest;

  //cpu/instruction_master epcs_flash_controller/epcs_control_port arbiterlock, which is an e_assign
  assign cpu_instruction_master_arbiterlock = epcs_flash_controller_epcs_control_port_slavearbiterlockenable & cpu_instruction_master_continuerequest;

  //cpu/instruction_master epcs_flash_controller/epcs_control_port arbiterlock2, which is an e_assign
  assign cpu_instruction_master_arbiterlock2 = epcs_flash_controller_epcs_control_port_slavearbiterlockenable2 & cpu_instruction_master_continuerequest;

  //cpu/instruction_master granted epcs_flash_controller/epcs_control_port last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_instruction_master_granted_slave_epcs_flash_controller_epcs_control_port <= 0;
      else 
        last_cycle_cpu_instruction_master_granted_slave_epcs_flash_controller_epcs_control_port <= cpu_instruction_master_saved_grant_epcs_flash_controller_epcs_control_port ? 1 : (epcs_flash_controller_epcs_control_port_arbitration_holdoff_internal | ~cpu_instruction_master_requests_epcs_flash_controller_epcs_control_port) ? 0 : last_cycle_cpu_instruction_master_granted_slave_epcs_flash_controller_epcs_control_port;
    end


  //cpu_instruction_master_continuerequest continued request, which is an e_mux
  assign cpu_instruction_master_continuerequest = last_cycle_cpu_instruction_master_granted_slave_epcs_flash_controller_epcs_control_port & cpu_instruction_master_requests_epcs_flash_controller_epcs_control_port;

  //epcs_flash_controller_epcs_control_port_any_continuerequest at least one master continues requesting, which is an e_mux
  assign epcs_flash_controller_epcs_control_port_any_continuerequest = cpu_instruction_master_continuerequest |
    cpu_data_master_continuerequest;

  assign cpu_data_master_qualified_request_epcs_flash_controller_epcs_control_port = cpu_data_master_requests_epcs_flash_controller_epcs_control_port & ~(cpu_instruction_master_arbiterlock);
  //epcs_flash_controller_epcs_control_port_writedata mux, which is an e_mux
  assign epcs_flash_controller_epcs_control_port_writedata = cpu_data_master_writedata;

  //assign epcs_flash_controller_epcs_control_port_endofpacket_from_sa = epcs_flash_controller_epcs_control_port_endofpacket so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_endofpacket_from_sa = epcs_flash_controller_epcs_control_port_endofpacket;

  assign cpu_instruction_master_requests_epcs_flash_controller_epcs_control_port = (({cpu_instruction_master_address_to_slave[16 : 11] , 11'b0} == 17'h1800) & (cpu_instruction_master_read)) & cpu_instruction_master_read;
  //cpu/data_master granted epcs_flash_controller/epcs_control_port last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_data_master_granted_slave_epcs_flash_controller_epcs_control_port <= 0;
      else 
        last_cycle_cpu_data_master_granted_slave_epcs_flash_controller_epcs_control_port <= cpu_data_master_saved_grant_epcs_flash_controller_epcs_control_port ? 1 : (epcs_flash_controller_epcs_control_port_arbitration_holdoff_internal | ~cpu_data_master_requests_epcs_flash_controller_epcs_control_port) ? 0 : last_cycle_cpu_data_master_granted_slave_epcs_flash_controller_epcs_control_port;
    end


  //cpu_data_master_continuerequest continued request, which is an e_mux
  assign cpu_data_master_continuerequest = last_cycle_cpu_data_master_granted_slave_epcs_flash_controller_epcs_control_port & cpu_data_master_requests_epcs_flash_controller_epcs_control_port;

  assign cpu_instruction_master_qualified_request_epcs_flash_controller_epcs_control_port = cpu_instruction_master_requests_epcs_flash_controller_epcs_control_port & ~(cpu_data_master_arbiterlock);
  //allow new arb cycle for epcs_flash_controller/epcs_control_port, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_allow_new_arb_cycle = ~cpu_data_master_arbiterlock & ~cpu_instruction_master_arbiterlock;

  //cpu/instruction_master assignment into master qualified-requests vector for epcs_flash_controller/epcs_control_port, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_master_qreq_vector[0] = cpu_instruction_master_qualified_request_epcs_flash_controller_epcs_control_port;

  //cpu/instruction_master grant epcs_flash_controller/epcs_control_port, which is an e_assign
  assign cpu_instruction_master_granted_epcs_flash_controller_epcs_control_port = epcs_flash_controller_epcs_control_port_grant_vector[0];

  //cpu/instruction_master saved-grant epcs_flash_controller/epcs_control_port, which is an e_assign
  assign cpu_instruction_master_saved_grant_epcs_flash_controller_epcs_control_port = epcs_flash_controller_epcs_control_port_arb_winner[0] && cpu_instruction_master_requests_epcs_flash_controller_epcs_control_port;

  //cpu/data_master assignment into master qualified-requests vector for epcs_flash_controller/epcs_control_port, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_master_qreq_vector[1] = cpu_data_master_qualified_request_epcs_flash_controller_epcs_control_port;

  //cpu/data_master grant epcs_flash_controller/epcs_control_port, which is an e_assign
  assign cpu_data_master_granted_epcs_flash_controller_epcs_control_port = epcs_flash_controller_epcs_control_port_grant_vector[1];

  //cpu/data_master saved-grant epcs_flash_controller/epcs_control_port, which is an e_assign
  assign cpu_data_master_saved_grant_epcs_flash_controller_epcs_control_port = epcs_flash_controller_epcs_control_port_arb_winner[1] && cpu_data_master_requests_epcs_flash_controller_epcs_control_port;

  //epcs_flash_controller/epcs_control_port chosen-master double-vector, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_chosen_master_double_vector = {epcs_flash_controller_epcs_control_port_master_qreq_vector, epcs_flash_controller_epcs_control_port_master_qreq_vector} & ({~epcs_flash_controller_epcs_control_port_master_qreq_vector, ~epcs_flash_controller_epcs_control_port_master_qreq_vector} + epcs_flash_controller_epcs_control_port_arb_addend);

  //stable onehot encoding of arb winner
  assign epcs_flash_controller_epcs_control_port_arb_winner = (epcs_flash_controller_epcs_control_port_allow_new_arb_cycle & | epcs_flash_controller_epcs_control_port_grant_vector) ? epcs_flash_controller_epcs_control_port_grant_vector : epcs_flash_controller_epcs_control_port_saved_chosen_master_vector;

  //saved epcs_flash_controller_epcs_control_port_grant_vector, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          epcs_flash_controller_epcs_control_port_saved_chosen_master_vector <= 0;
      else if (epcs_flash_controller_epcs_control_port_allow_new_arb_cycle)
          epcs_flash_controller_epcs_control_port_saved_chosen_master_vector <= |epcs_flash_controller_epcs_control_port_grant_vector ? epcs_flash_controller_epcs_control_port_grant_vector : epcs_flash_controller_epcs_control_port_saved_chosen_master_vector;
    end


  //onehot encoding of chosen master
  assign epcs_flash_controller_epcs_control_port_grant_vector = {(epcs_flash_controller_epcs_control_port_chosen_master_double_vector[1] | epcs_flash_controller_epcs_control_port_chosen_master_double_vector[3]),
    (epcs_flash_controller_epcs_control_port_chosen_master_double_vector[0] | epcs_flash_controller_epcs_control_port_chosen_master_double_vector[2])};

  //epcs_flash_controller/epcs_control_port chosen master rotated left, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_chosen_master_rot_left = (epcs_flash_controller_epcs_control_port_arb_winner << 1) ? (epcs_flash_controller_epcs_control_port_arb_winner << 1) : 1;

  //epcs_flash_controller/epcs_control_port's addend for next-master-grant
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          epcs_flash_controller_epcs_control_port_arb_addend <= 1;
      else if (|epcs_flash_controller_epcs_control_port_grant_vector)
          epcs_flash_controller_epcs_control_port_arb_addend <= epcs_flash_controller_epcs_control_port_end_xfer? epcs_flash_controller_epcs_control_port_chosen_master_rot_left : epcs_flash_controller_epcs_control_port_grant_vector;
    end


  //epcs_flash_controller_epcs_control_port_reset_n assignment, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_reset_n = reset_n;

  assign epcs_flash_controller_epcs_control_port_chipselect = cpu_data_master_granted_epcs_flash_controller_epcs_control_port | cpu_instruction_master_granted_epcs_flash_controller_epcs_control_port;
  //epcs_flash_controller_epcs_control_port_firsttransfer first transaction, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_firsttransfer = epcs_flash_controller_epcs_control_port_begins_xfer ? epcs_flash_controller_epcs_control_port_unreg_firsttransfer : epcs_flash_controller_epcs_control_port_reg_firsttransfer;

  //epcs_flash_controller_epcs_control_port_unreg_firsttransfer first transaction, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_unreg_firsttransfer = ~(epcs_flash_controller_epcs_control_port_slavearbiterlockenable & epcs_flash_controller_epcs_control_port_any_continuerequest);

  //epcs_flash_controller_epcs_control_port_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          epcs_flash_controller_epcs_control_port_reg_firsttransfer <= 1'b1;
      else if (epcs_flash_controller_epcs_control_port_begins_xfer)
          epcs_flash_controller_epcs_control_port_reg_firsttransfer <= epcs_flash_controller_epcs_control_port_unreg_firsttransfer;
    end


  //epcs_flash_controller_epcs_control_port_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_beginbursttransfer_internal = epcs_flash_controller_epcs_control_port_begins_xfer;

  //epcs_flash_controller_epcs_control_port_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_arbitration_holdoff_internal = epcs_flash_controller_epcs_control_port_begins_xfer & epcs_flash_controller_epcs_control_port_firsttransfer;

  //~epcs_flash_controller_epcs_control_port_read_n assignment, which is an e_mux
  assign epcs_flash_controller_epcs_control_port_read_n = ~((cpu_data_master_granted_epcs_flash_controller_epcs_control_port & cpu_data_master_read) | (cpu_instruction_master_granted_epcs_flash_controller_epcs_control_port & cpu_instruction_master_read));

  //~epcs_flash_controller_epcs_control_port_write_n assignment, which is an e_mux
  assign epcs_flash_controller_epcs_control_port_write_n = ~(cpu_data_master_granted_epcs_flash_controller_epcs_control_port & cpu_data_master_write);

  assign shifted_address_to_epcs_flash_controller_epcs_control_port_from_cpu_data_master = cpu_data_master_address_to_slave;
  //epcs_flash_controller_epcs_control_port_address mux, which is an e_mux
  assign epcs_flash_controller_epcs_control_port_address = (cpu_data_master_granted_epcs_flash_controller_epcs_control_port)? (shifted_address_to_epcs_flash_controller_epcs_control_port_from_cpu_data_master >> 2) :
    (shifted_address_to_epcs_flash_controller_epcs_control_port_from_cpu_instruction_master >> 2);

  assign shifted_address_to_epcs_flash_controller_epcs_control_port_from_cpu_instruction_master = cpu_instruction_master_address_to_slave;
  //d1_epcs_flash_controller_epcs_control_port_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_epcs_flash_controller_epcs_control_port_end_xfer <= 1;
      else 
        d1_epcs_flash_controller_epcs_control_port_end_xfer <= epcs_flash_controller_epcs_control_port_end_xfer;
    end


  //epcs_flash_controller_epcs_control_port_waits_for_read in a cycle, which is an e_mux
  assign epcs_flash_controller_epcs_control_port_waits_for_read = epcs_flash_controller_epcs_control_port_in_a_read_cycle & epcs_flash_controller_epcs_control_port_begins_xfer;

  //epcs_flash_controller_epcs_control_port_in_a_read_cycle assignment, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_in_a_read_cycle = (cpu_data_master_granted_epcs_flash_controller_epcs_control_port & cpu_data_master_read) | (cpu_instruction_master_granted_epcs_flash_controller_epcs_control_port & cpu_instruction_master_read);

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = epcs_flash_controller_epcs_control_port_in_a_read_cycle;

  //epcs_flash_controller_epcs_control_port_waits_for_write in a cycle, which is an e_mux
  assign epcs_flash_controller_epcs_control_port_waits_for_write = epcs_flash_controller_epcs_control_port_in_a_write_cycle & epcs_flash_controller_epcs_control_port_begins_xfer;

  //epcs_flash_controller_epcs_control_port_in_a_write_cycle assignment, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_in_a_write_cycle = cpu_data_master_granted_epcs_flash_controller_epcs_control_port & cpu_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = epcs_flash_controller_epcs_control_port_in_a_write_cycle;

  assign wait_for_epcs_flash_controller_epcs_control_port_counter = 0;
  //assign epcs_flash_controller_epcs_control_port_irq_from_sa = epcs_flash_controller_epcs_control_port_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign epcs_flash_controller_epcs_control_port_irq_from_sa = epcs_flash_controller_epcs_control_port_irq;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //epcs_flash_controller/epcs_control_port enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else 
        enable_nonzero_assertions <= 1'b1;
    end


  //grant signals are active simultaneously, which is an e_process
  always @(posedge clk)
    begin
      if (cpu_data_master_granted_epcs_flash_controller_epcs_control_port + cpu_instruction_master_granted_epcs_flash_controller_epcs_control_port > 1)
        begin
          $write("%0d ns: > 1 of grant signals are active simultaneously", $time);
          $stop;
        end
    end


  //saved_grant signals are active simultaneously, which is an e_process
  always @(posedge clk)
    begin
      if (cpu_data_master_saved_grant_epcs_flash_controller_epcs_control_port + cpu_instruction_master_saved_grant_epcs_flash_controller_epcs_control_port > 1)
        begin
          $write("%0d ns: > 1 of saved_grant signals are active simultaneously", $time);
          $stop;
        end
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module gpio_s1_arbitrator (
                            // inputs:
                             clk,
                             cpu_data_master_address_to_slave,
                             cpu_data_master_read,
                             cpu_data_master_waitrequest,
                             cpu_data_master_write,
                             cpu_data_master_writedata,
                             gpio_s1_readdata,
                             reset_n,

                            // outputs:
                             cpu_data_master_granted_gpio_s1,
                             cpu_data_master_qualified_request_gpio_s1,
                             cpu_data_master_read_data_valid_gpio_s1,
                             cpu_data_master_requests_gpio_s1,
                             d1_gpio_s1_end_xfer,
                             gpio_s1_address,
                             gpio_s1_chipselect,
                             gpio_s1_readdata_from_sa,
                             gpio_s1_reset_n,
                             gpio_s1_write_n,
                             gpio_s1_writedata
                          )
;

  output           cpu_data_master_granted_gpio_s1;
  output           cpu_data_master_qualified_request_gpio_s1;
  output           cpu_data_master_read_data_valid_gpio_s1;
  output           cpu_data_master_requests_gpio_s1;
  output           d1_gpio_s1_end_xfer;
  output  [  2: 0] gpio_s1_address;
  output           gpio_s1_chipselect;
  output  [ 31: 0] gpio_s1_readdata_from_sa;
  output           gpio_s1_reset_n;
  output           gpio_s1_write_n;
  output  [ 31: 0] gpio_s1_writedata;
  input            clk;
  input   [ 16: 0] cpu_data_master_address_to_slave;
  input            cpu_data_master_read;
  input            cpu_data_master_waitrequest;
  input            cpu_data_master_write;
  input   [ 31: 0] cpu_data_master_writedata;
  input   [ 31: 0] gpio_s1_readdata;
  input            reset_n;

  wire             cpu_data_master_arbiterlock;
  wire             cpu_data_master_arbiterlock2;
  wire             cpu_data_master_continuerequest;
  wire             cpu_data_master_granted_gpio_s1;
  wire             cpu_data_master_qualified_request_gpio_s1;
  wire             cpu_data_master_read_data_valid_gpio_s1;
  wire             cpu_data_master_requests_gpio_s1;
  wire             cpu_data_master_saved_grant_gpio_s1;
  reg              d1_gpio_s1_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_gpio_s1;
  wire    [  2: 0] gpio_s1_address;
  wire             gpio_s1_allgrants;
  wire             gpio_s1_allow_new_arb_cycle;
  wire             gpio_s1_any_bursting_master_saved_grant;
  wire             gpio_s1_any_continuerequest;
  wire             gpio_s1_arb_counter_enable;
  reg              gpio_s1_arb_share_counter;
  wire             gpio_s1_arb_share_counter_next_value;
  wire             gpio_s1_arb_share_set_values;
  wire             gpio_s1_beginbursttransfer_internal;
  wire             gpio_s1_begins_xfer;
  wire             gpio_s1_chipselect;
  wire             gpio_s1_end_xfer;
  wire             gpio_s1_firsttransfer;
  wire             gpio_s1_grant_vector;
  wire             gpio_s1_in_a_read_cycle;
  wire             gpio_s1_in_a_write_cycle;
  wire             gpio_s1_master_qreq_vector;
  wire             gpio_s1_non_bursting_master_requests;
  wire    [ 31: 0] gpio_s1_readdata_from_sa;
  reg              gpio_s1_reg_firsttransfer;
  wire             gpio_s1_reset_n;
  reg              gpio_s1_slavearbiterlockenable;
  wire             gpio_s1_slavearbiterlockenable2;
  wire             gpio_s1_unreg_firsttransfer;
  wire             gpio_s1_waits_for_read;
  wire             gpio_s1_waits_for_write;
  wire             gpio_s1_write_n;
  wire    [ 31: 0] gpio_s1_writedata;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [ 16: 0] shifted_address_to_gpio_s1_from_cpu_data_master;
  wire             wait_for_gpio_s1_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else 
        d1_reasons_to_wait <= ~gpio_s1_end_xfer;
    end


  assign gpio_s1_begins_xfer = ~d1_reasons_to_wait & ((cpu_data_master_qualified_request_gpio_s1));
  //assign gpio_s1_readdata_from_sa = gpio_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign gpio_s1_readdata_from_sa = gpio_s1_readdata;

  assign cpu_data_master_requests_gpio_s1 = ({cpu_data_master_address_to_slave[16 : 5] , 5'b0} == 17'h2080) & (cpu_data_master_read | cpu_data_master_write);
  //gpio_s1_arb_share_counter set values, which is an e_mux
  assign gpio_s1_arb_share_set_values = 1;

  //gpio_s1_non_bursting_master_requests mux, which is an e_mux
  assign gpio_s1_non_bursting_master_requests = cpu_data_master_requests_gpio_s1;

  //gpio_s1_any_bursting_master_saved_grant mux, which is an e_mux
  assign gpio_s1_any_bursting_master_saved_grant = 0;

  //gpio_s1_arb_share_counter_next_value assignment, which is an e_assign
  assign gpio_s1_arb_share_counter_next_value = gpio_s1_firsttransfer ? (gpio_s1_arb_share_set_values - 1) : |gpio_s1_arb_share_counter ? (gpio_s1_arb_share_counter - 1) : 0;

  //gpio_s1_allgrants all slave grants, which is an e_mux
  assign gpio_s1_allgrants = |gpio_s1_grant_vector;

  //gpio_s1_end_xfer assignment, which is an e_assign
  assign gpio_s1_end_xfer = ~(gpio_s1_waits_for_read | gpio_s1_waits_for_write);

  //end_xfer_arb_share_counter_term_gpio_s1 arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_gpio_s1 = gpio_s1_end_xfer & (~gpio_s1_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //gpio_s1_arb_share_counter arbitration counter enable, which is an e_assign
  assign gpio_s1_arb_counter_enable = (end_xfer_arb_share_counter_term_gpio_s1 & gpio_s1_allgrants) | (end_xfer_arb_share_counter_term_gpio_s1 & ~gpio_s1_non_bursting_master_requests);

  //gpio_s1_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          gpio_s1_arb_share_counter <= 0;
      else if (gpio_s1_arb_counter_enable)
          gpio_s1_arb_share_counter <= gpio_s1_arb_share_counter_next_value;
    end


  //gpio_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          gpio_s1_slavearbiterlockenable <= 0;
      else if ((|gpio_s1_master_qreq_vector & end_xfer_arb_share_counter_term_gpio_s1) | (end_xfer_arb_share_counter_term_gpio_s1 & ~gpio_s1_non_bursting_master_requests))
          gpio_s1_slavearbiterlockenable <= |gpio_s1_arb_share_counter_next_value;
    end


  //cpu/data_master gpio/s1 arbiterlock, which is an e_assign
  assign cpu_data_master_arbiterlock = gpio_s1_slavearbiterlockenable & cpu_data_master_continuerequest;

  //gpio_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign gpio_s1_slavearbiterlockenable2 = |gpio_s1_arb_share_counter_next_value;

  //cpu/data_master gpio/s1 arbiterlock2, which is an e_assign
  assign cpu_data_master_arbiterlock2 = gpio_s1_slavearbiterlockenable2 & cpu_data_master_continuerequest;

  //gpio_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  assign gpio_s1_any_continuerequest = 1;

  //cpu_data_master_continuerequest continued request, which is an e_assign
  assign cpu_data_master_continuerequest = 1;

  assign cpu_data_master_qualified_request_gpio_s1 = cpu_data_master_requests_gpio_s1 & ~(((~cpu_data_master_waitrequest) & cpu_data_master_write));
  //gpio_s1_writedata mux, which is an e_mux
  assign gpio_s1_writedata = cpu_data_master_writedata;

  //master is always granted when requested
  assign cpu_data_master_granted_gpio_s1 = cpu_data_master_qualified_request_gpio_s1;

  //cpu/data_master saved-grant gpio/s1, which is an e_assign
  assign cpu_data_master_saved_grant_gpio_s1 = cpu_data_master_requests_gpio_s1;

  //allow new arb cycle for gpio/s1, which is an e_assign
  assign gpio_s1_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign gpio_s1_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign gpio_s1_master_qreq_vector = 1;

  //gpio_s1_reset_n assignment, which is an e_assign
  assign gpio_s1_reset_n = reset_n;

  assign gpio_s1_chipselect = cpu_data_master_granted_gpio_s1;
  //gpio_s1_firsttransfer first transaction, which is an e_assign
  assign gpio_s1_firsttransfer = gpio_s1_begins_xfer ? gpio_s1_unreg_firsttransfer : gpio_s1_reg_firsttransfer;

  //gpio_s1_unreg_firsttransfer first transaction, which is an e_assign
  assign gpio_s1_unreg_firsttransfer = ~(gpio_s1_slavearbiterlockenable & gpio_s1_any_continuerequest);

  //gpio_s1_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          gpio_s1_reg_firsttransfer <= 1'b1;
      else if (gpio_s1_begins_xfer)
          gpio_s1_reg_firsttransfer <= gpio_s1_unreg_firsttransfer;
    end


  //gpio_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign gpio_s1_beginbursttransfer_internal = gpio_s1_begins_xfer;

  //~gpio_s1_write_n assignment, which is an e_mux
  assign gpio_s1_write_n = ~(cpu_data_master_granted_gpio_s1 & cpu_data_master_write);

  assign shifted_address_to_gpio_s1_from_cpu_data_master = cpu_data_master_address_to_slave;
  //gpio_s1_address mux, which is an e_mux
  assign gpio_s1_address = shifted_address_to_gpio_s1_from_cpu_data_master >> 2;

  //d1_gpio_s1_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_gpio_s1_end_xfer <= 1;
      else 
        d1_gpio_s1_end_xfer <= gpio_s1_end_xfer;
    end


  //gpio_s1_waits_for_read in a cycle, which is an e_mux
  assign gpio_s1_waits_for_read = gpio_s1_in_a_read_cycle & gpio_s1_begins_xfer;

  //gpio_s1_in_a_read_cycle assignment, which is an e_assign
  assign gpio_s1_in_a_read_cycle = cpu_data_master_granted_gpio_s1 & cpu_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = gpio_s1_in_a_read_cycle;

  //gpio_s1_waits_for_write in a cycle, which is an e_mux
  assign gpio_s1_waits_for_write = gpio_s1_in_a_write_cycle & 0;

  //gpio_s1_in_a_write_cycle assignment, which is an e_assign
  assign gpio_s1_in_a_write_cycle = cpu_data_master_granted_gpio_s1 & cpu_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = gpio_s1_in_a_write_cycle;

  assign wait_for_gpio_s1_counter = 0;

//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //gpio/s1 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else 
        enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module jtag_uart_avalon_jtag_slave_arbitrator (
                                                // inputs:
                                                 clk,
                                                 cpu_data_master_address_to_slave,
                                                 cpu_data_master_read,
                                                 cpu_data_master_waitrequest,
                                                 cpu_data_master_write,
                                                 cpu_data_master_writedata,
                                                 jtag_uart_avalon_jtag_slave_dataavailable,
                                                 jtag_uart_avalon_jtag_slave_irq,
                                                 jtag_uart_avalon_jtag_slave_readdata,
                                                 jtag_uart_avalon_jtag_slave_readyfordata,
                                                 jtag_uart_avalon_jtag_slave_waitrequest,
                                                 reset_n,

                                                // outputs:
                                                 cpu_data_master_granted_jtag_uart_avalon_jtag_slave,
                                                 cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave,
                                                 cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave,
                                                 cpu_data_master_requests_jtag_uart_avalon_jtag_slave,
                                                 d1_jtag_uart_avalon_jtag_slave_end_xfer,
                                                 jtag_uart_avalon_jtag_slave_address,
                                                 jtag_uart_avalon_jtag_slave_chipselect,
                                                 jtag_uart_avalon_jtag_slave_dataavailable_from_sa,
                                                 jtag_uart_avalon_jtag_slave_irq_from_sa,
                                                 jtag_uart_avalon_jtag_slave_read_n,
                                                 jtag_uart_avalon_jtag_slave_readdata_from_sa,
                                                 jtag_uart_avalon_jtag_slave_readyfordata_from_sa,
                                                 jtag_uart_avalon_jtag_slave_reset_n,
                                                 jtag_uart_avalon_jtag_slave_waitrequest_from_sa,
                                                 jtag_uart_avalon_jtag_slave_write_n,
                                                 jtag_uart_avalon_jtag_slave_writedata
                                              )
;

  output           cpu_data_master_granted_jtag_uart_avalon_jtag_slave;
  output           cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave;
  output           cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave;
  output           cpu_data_master_requests_jtag_uart_avalon_jtag_slave;
  output           d1_jtag_uart_avalon_jtag_slave_end_xfer;
  output           jtag_uart_avalon_jtag_slave_address;
  output           jtag_uart_avalon_jtag_slave_chipselect;
  output           jtag_uart_avalon_jtag_slave_dataavailable_from_sa;
  output           jtag_uart_avalon_jtag_slave_irq_from_sa;
  output           jtag_uart_avalon_jtag_slave_read_n;
  output  [ 31: 0] jtag_uart_avalon_jtag_slave_readdata_from_sa;
  output           jtag_uart_avalon_jtag_slave_readyfordata_from_sa;
  output           jtag_uart_avalon_jtag_slave_reset_n;
  output           jtag_uart_avalon_jtag_slave_waitrequest_from_sa;
  output           jtag_uart_avalon_jtag_slave_write_n;
  output  [ 31: 0] jtag_uart_avalon_jtag_slave_writedata;
  input            clk;
  input   [ 16: 0] cpu_data_master_address_to_slave;
  input            cpu_data_master_read;
  input            cpu_data_master_waitrequest;
  input            cpu_data_master_write;
  input   [ 31: 0] cpu_data_master_writedata;
  input            jtag_uart_avalon_jtag_slave_dataavailable;
  input            jtag_uart_avalon_jtag_slave_irq;
  input   [ 31: 0] jtag_uart_avalon_jtag_slave_readdata;
  input            jtag_uart_avalon_jtag_slave_readyfordata;
  input            jtag_uart_avalon_jtag_slave_waitrequest;
  input            reset_n;

  wire             cpu_data_master_arbiterlock;
  wire             cpu_data_master_arbiterlock2;
  wire             cpu_data_master_continuerequest;
  wire             cpu_data_master_granted_jtag_uart_avalon_jtag_slave;
  wire             cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave;
  wire             cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave;
  wire             cpu_data_master_requests_jtag_uart_avalon_jtag_slave;
  wire             cpu_data_master_saved_grant_jtag_uart_avalon_jtag_slave;
  reg              d1_jtag_uart_avalon_jtag_slave_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire             jtag_uart_avalon_jtag_slave_address;
  wire             jtag_uart_avalon_jtag_slave_allgrants;
  wire             jtag_uart_avalon_jtag_slave_allow_new_arb_cycle;
  wire             jtag_uart_avalon_jtag_slave_any_bursting_master_saved_grant;
  wire             jtag_uart_avalon_jtag_slave_any_continuerequest;
  wire             jtag_uart_avalon_jtag_slave_arb_counter_enable;
  reg              jtag_uart_avalon_jtag_slave_arb_share_counter;
  wire             jtag_uart_avalon_jtag_slave_arb_share_counter_next_value;
  wire             jtag_uart_avalon_jtag_slave_arb_share_set_values;
  wire             jtag_uart_avalon_jtag_slave_beginbursttransfer_internal;
  wire             jtag_uart_avalon_jtag_slave_begins_xfer;
  wire             jtag_uart_avalon_jtag_slave_chipselect;
  wire             jtag_uart_avalon_jtag_slave_dataavailable_from_sa;
  wire             jtag_uart_avalon_jtag_slave_end_xfer;
  wire             jtag_uart_avalon_jtag_slave_firsttransfer;
  wire             jtag_uart_avalon_jtag_slave_grant_vector;
  wire             jtag_uart_avalon_jtag_slave_in_a_read_cycle;
  wire             jtag_uart_avalon_jtag_slave_in_a_write_cycle;
  wire             jtag_uart_avalon_jtag_slave_irq_from_sa;
  wire             jtag_uart_avalon_jtag_slave_master_qreq_vector;
  wire             jtag_uart_avalon_jtag_slave_non_bursting_master_requests;
  wire             jtag_uart_avalon_jtag_slave_read_n;
  wire    [ 31: 0] jtag_uart_avalon_jtag_slave_readdata_from_sa;
  wire             jtag_uart_avalon_jtag_slave_readyfordata_from_sa;
  reg              jtag_uart_avalon_jtag_slave_reg_firsttransfer;
  wire             jtag_uart_avalon_jtag_slave_reset_n;
  reg              jtag_uart_avalon_jtag_slave_slavearbiterlockenable;
  wire             jtag_uart_avalon_jtag_slave_slavearbiterlockenable2;
  wire             jtag_uart_avalon_jtag_slave_unreg_firsttransfer;
  wire             jtag_uart_avalon_jtag_slave_waitrequest_from_sa;
  wire             jtag_uart_avalon_jtag_slave_waits_for_read;
  wire             jtag_uart_avalon_jtag_slave_waits_for_write;
  wire             jtag_uart_avalon_jtag_slave_write_n;
  wire    [ 31: 0] jtag_uart_avalon_jtag_slave_writedata;
  wire    [ 16: 0] shifted_address_to_jtag_uart_avalon_jtag_slave_from_cpu_data_master;
  wire             wait_for_jtag_uart_avalon_jtag_slave_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else 
        d1_reasons_to_wait <= ~jtag_uart_avalon_jtag_slave_end_xfer;
    end


  assign jtag_uart_avalon_jtag_slave_begins_xfer = ~d1_reasons_to_wait & ((cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave));
  //assign jtag_uart_avalon_jtag_slave_readdata_from_sa = jtag_uart_avalon_jtag_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_readdata_from_sa = jtag_uart_avalon_jtag_slave_readdata;

  assign cpu_data_master_requests_jtag_uart_avalon_jtag_slave = ({cpu_data_master_address_to_slave[16 : 3] , 3'b0} == 17'h90) & (cpu_data_master_read | cpu_data_master_write);
  //assign jtag_uart_avalon_jtag_slave_dataavailable_from_sa = jtag_uart_avalon_jtag_slave_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_dataavailable_from_sa = jtag_uart_avalon_jtag_slave_dataavailable;

  //assign jtag_uart_avalon_jtag_slave_readyfordata_from_sa = jtag_uart_avalon_jtag_slave_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_readyfordata_from_sa = jtag_uart_avalon_jtag_slave_readyfordata;

  //assign jtag_uart_avalon_jtag_slave_waitrequest_from_sa = jtag_uart_avalon_jtag_slave_waitrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_waitrequest_from_sa = jtag_uart_avalon_jtag_slave_waitrequest;

  //jtag_uart_avalon_jtag_slave_arb_share_counter set values, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_arb_share_set_values = 1;

  //jtag_uart_avalon_jtag_slave_non_bursting_master_requests mux, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_non_bursting_master_requests = cpu_data_master_requests_jtag_uart_avalon_jtag_slave;

  //jtag_uart_avalon_jtag_slave_any_bursting_master_saved_grant mux, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_any_bursting_master_saved_grant = 0;

  //jtag_uart_avalon_jtag_slave_arb_share_counter_next_value assignment, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_arb_share_counter_next_value = jtag_uart_avalon_jtag_slave_firsttransfer ? (jtag_uart_avalon_jtag_slave_arb_share_set_values - 1) : |jtag_uart_avalon_jtag_slave_arb_share_counter ? (jtag_uart_avalon_jtag_slave_arb_share_counter - 1) : 0;

  //jtag_uart_avalon_jtag_slave_allgrants all slave grants, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_allgrants = |jtag_uart_avalon_jtag_slave_grant_vector;

  //jtag_uart_avalon_jtag_slave_end_xfer assignment, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_end_xfer = ~(jtag_uart_avalon_jtag_slave_waits_for_read | jtag_uart_avalon_jtag_slave_waits_for_write);

  //end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave = jtag_uart_avalon_jtag_slave_end_xfer & (~jtag_uart_avalon_jtag_slave_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //jtag_uart_avalon_jtag_slave_arb_share_counter arbitration counter enable, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_arb_counter_enable = (end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave & jtag_uart_avalon_jtag_slave_allgrants) | (end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave & ~jtag_uart_avalon_jtag_slave_non_bursting_master_requests);

  //jtag_uart_avalon_jtag_slave_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          jtag_uart_avalon_jtag_slave_arb_share_counter <= 0;
      else if (jtag_uart_avalon_jtag_slave_arb_counter_enable)
          jtag_uart_avalon_jtag_slave_arb_share_counter <= jtag_uart_avalon_jtag_slave_arb_share_counter_next_value;
    end


  //jtag_uart_avalon_jtag_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          jtag_uart_avalon_jtag_slave_slavearbiterlockenable <= 0;
      else if ((|jtag_uart_avalon_jtag_slave_master_qreq_vector & end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave) | (end_xfer_arb_share_counter_term_jtag_uart_avalon_jtag_slave & ~jtag_uart_avalon_jtag_slave_non_bursting_master_requests))
          jtag_uart_avalon_jtag_slave_slavearbiterlockenable <= |jtag_uart_avalon_jtag_slave_arb_share_counter_next_value;
    end


  //cpu/data_master jtag_uart/avalon_jtag_slave arbiterlock, which is an e_assign
  assign cpu_data_master_arbiterlock = jtag_uart_avalon_jtag_slave_slavearbiterlockenable & cpu_data_master_continuerequest;

  //jtag_uart_avalon_jtag_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_slavearbiterlockenable2 = |jtag_uart_avalon_jtag_slave_arb_share_counter_next_value;

  //cpu/data_master jtag_uart/avalon_jtag_slave arbiterlock2, which is an e_assign
  assign cpu_data_master_arbiterlock2 = jtag_uart_avalon_jtag_slave_slavearbiterlockenable2 & cpu_data_master_continuerequest;

  //jtag_uart_avalon_jtag_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_any_continuerequest = 1;

  //cpu_data_master_continuerequest continued request, which is an e_assign
  assign cpu_data_master_continuerequest = 1;

  assign cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave = cpu_data_master_requests_jtag_uart_avalon_jtag_slave & ~((cpu_data_master_read & (~cpu_data_master_waitrequest)) | ((~cpu_data_master_waitrequest) & cpu_data_master_write));
  //jtag_uart_avalon_jtag_slave_writedata mux, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_writedata = cpu_data_master_writedata;

  //master is always granted when requested
  assign cpu_data_master_granted_jtag_uart_avalon_jtag_slave = cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave;

  //cpu/data_master saved-grant jtag_uart/avalon_jtag_slave, which is an e_assign
  assign cpu_data_master_saved_grant_jtag_uart_avalon_jtag_slave = cpu_data_master_requests_jtag_uart_avalon_jtag_slave;

  //allow new arb cycle for jtag_uart/avalon_jtag_slave, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign jtag_uart_avalon_jtag_slave_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign jtag_uart_avalon_jtag_slave_master_qreq_vector = 1;

  //jtag_uart_avalon_jtag_slave_reset_n assignment, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_reset_n = reset_n;

  assign jtag_uart_avalon_jtag_slave_chipselect = cpu_data_master_granted_jtag_uart_avalon_jtag_slave;
  //jtag_uart_avalon_jtag_slave_firsttransfer first transaction, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_firsttransfer = jtag_uart_avalon_jtag_slave_begins_xfer ? jtag_uart_avalon_jtag_slave_unreg_firsttransfer : jtag_uart_avalon_jtag_slave_reg_firsttransfer;

  //jtag_uart_avalon_jtag_slave_unreg_firsttransfer first transaction, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_unreg_firsttransfer = ~(jtag_uart_avalon_jtag_slave_slavearbiterlockenable & jtag_uart_avalon_jtag_slave_any_continuerequest);

  //jtag_uart_avalon_jtag_slave_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          jtag_uart_avalon_jtag_slave_reg_firsttransfer <= 1'b1;
      else if (jtag_uart_avalon_jtag_slave_begins_xfer)
          jtag_uart_avalon_jtag_slave_reg_firsttransfer <= jtag_uart_avalon_jtag_slave_unreg_firsttransfer;
    end


  //jtag_uart_avalon_jtag_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_beginbursttransfer_internal = jtag_uart_avalon_jtag_slave_begins_xfer;

  //~jtag_uart_avalon_jtag_slave_read_n assignment, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_read_n = ~(cpu_data_master_granted_jtag_uart_avalon_jtag_slave & cpu_data_master_read);

  //~jtag_uart_avalon_jtag_slave_write_n assignment, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_write_n = ~(cpu_data_master_granted_jtag_uart_avalon_jtag_slave & cpu_data_master_write);

  assign shifted_address_to_jtag_uart_avalon_jtag_slave_from_cpu_data_master = cpu_data_master_address_to_slave;
  //jtag_uart_avalon_jtag_slave_address mux, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_address = shifted_address_to_jtag_uart_avalon_jtag_slave_from_cpu_data_master >> 2;

  //d1_jtag_uart_avalon_jtag_slave_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_jtag_uart_avalon_jtag_slave_end_xfer <= 1;
      else 
        d1_jtag_uart_avalon_jtag_slave_end_xfer <= jtag_uart_avalon_jtag_slave_end_xfer;
    end


  //jtag_uart_avalon_jtag_slave_waits_for_read in a cycle, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_waits_for_read = jtag_uart_avalon_jtag_slave_in_a_read_cycle & jtag_uart_avalon_jtag_slave_waitrequest_from_sa;

  //jtag_uart_avalon_jtag_slave_in_a_read_cycle assignment, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_in_a_read_cycle = cpu_data_master_granted_jtag_uart_avalon_jtag_slave & cpu_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = jtag_uart_avalon_jtag_slave_in_a_read_cycle;

  //jtag_uart_avalon_jtag_slave_waits_for_write in a cycle, which is an e_mux
  assign jtag_uart_avalon_jtag_slave_waits_for_write = jtag_uart_avalon_jtag_slave_in_a_write_cycle & jtag_uart_avalon_jtag_slave_waitrequest_from_sa;

  //jtag_uart_avalon_jtag_slave_in_a_write_cycle assignment, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_in_a_write_cycle = cpu_data_master_granted_jtag_uart_avalon_jtag_slave & cpu_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = jtag_uart_avalon_jtag_slave_in_a_write_cycle;

  assign wait_for_jtag_uart_avalon_jtag_slave_counter = 0;
  //assign jtag_uart_avalon_jtag_slave_irq_from_sa = jtag_uart_avalon_jtag_slave_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign jtag_uart_avalon_jtag_slave_irq_from_sa = jtag_uart_avalon_jtag_slave_irq;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //jtag_uart/avalon_jtag_slave enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else 
        enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module led_s1_arbitrator (
                           // inputs:
                            clk,
                            cpu_data_master_address_to_slave,
                            cpu_data_master_read,
                            cpu_data_master_waitrequest,
                            cpu_data_master_write,
                            cpu_data_master_writedata,
                            led_s1_readdata,
                            reset_n,

                           // outputs:
                            cpu_data_master_granted_led_s1,
                            cpu_data_master_qualified_request_led_s1,
                            cpu_data_master_read_data_valid_led_s1,
                            cpu_data_master_requests_led_s1,
                            d1_led_s1_end_xfer,
                            led_s1_address,
                            led_s1_chipselect,
                            led_s1_readdata_from_sa,
                            led_s1_reset_n,
                            led_s1_write_n,
                            led_s1_writedata
                         )
;

  output           cpu_data_master_granted_led_s1;
  output           cpu_data_master_qualified_request_led_s1;
  output           cpu_data_master_read_data_valid_led_s1;
  output           cpu_data_master_requests_led_s1;
  output           d1_led_s1_end_xfer;
  output  [  1: 0] led_s1_address;
  output           led_s1_chipselect;
  output  [ 31: 0] led_s1_readdata_from_sa;
  output           led_s1_reset_n;
  output           led_s1_write_n;
  output  [ 31: 0] led_s1_writedata;
  input            clk;
  input   [ 16: 0] cpu_data_master_address_to_slave;
  input            cpu_data_master_read;
  input            cpu_data_master_waitrequest;
  input            cpu_data_master_write;
  input   [ 31: 0] cpu_data_master_writedata;
  input   [ 31: 0] led_s1_readdata;
  input            reset_n;

  wire             cpu_data_master_arbiterlock;
  wire             cpu_data_master_arbiterlock2;
  wire             cpu_data_master_continuerequest;
  wire             cpu_data_master_granted_led_s1;
  wire             cpu_data_master_qualified_request_led_s1;
  wire             cpu_data_master_read_data_valid_led_s1;
  wire             cpu_data_master_requests_led_s1;
  wire             cpu_data_master_saved_grant_led_s1;
  reg              d1_led_s1_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_led_s1;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [  1: 0] led_s1_address;
  wire             led_s1_allgrants;
  wire             led_s1_allow_new_arb_cycle;
  wire             led_s1_any_bursting_master_saved_grant;
  wire             led_s1_any_continuerequest;
  wire             led_s1_arb_counter_enable;
  reg              led_s1_arb_share_counter;
  wire             led_s1_arb_share_counter_next_value;
  wire             led_s1_arb_share_set_values;
  wire             led_s1_beginbursttransfer_internal;
  wire             led_s1_begins_xfer;
  wire             led_s1_chipselect;
  wire             led_s1_end_xfer;
  wire             led_s1_firsttransfer;
  wire             led_s1_grant_vector;
  wire             led_s1_in_a_read_cycle;
  wire             led_s1_in_a_write_cycle;
  wire             led_s1_master_qreq_vector;
  wire             led_s1_non_bursting_master_requests;
  wire    [ 31: 0] led_s1_readdata_from_sa;
  reg              led_s1_reg_firsttransfer;
  wire             led_s1_reset_n;
  reg              led_s1_slavearbiterlockenable;
  wire             led_s1_slavearbiterlockenable2;
  wire             led_s1_unreg_firsttransfer;
  wire             led_s1_waits_for_read;
  wire             led_s1_waits_for_write;
  wire             led_s1_write_n;
  wire    [ 31: 0] led_s1_writedata;
  wire    [ 16: 0] shifted_address_to_led_s1_from_cpu_data_master;
  wire             wait_for_led_s1_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else 
        d1_reasons_to_wait <= ~led_s1_end_xfer;
    end


  assign led_s1_begins_xfer = ~d1_reasons_to_wait & ((cpu_data_master_qualified_request_led_s1));
  //assign led_s1_readdata_from_sa = led_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign led_s1_readdata_from_sa = led_s1_readdata;

  assign cpu_data_master_requests_led_s1 = ({cpu_data_master_address_to_slave[16 : 4] , 4'b0} == 17'h100) & (cpu_data_master_read | cpu_data_master_write);
  //led_s1_arb_share_counter set values, which is an e_mux
  assign led_s1_arb_share_set_values = 1;

  //led_s1_non_bursting_master_requests mux, which is an e_mux
  assign led_s1_non_bursting_master_requests = cpu_data_master_requests_led_s1;

  //led_s1_any_bursting_master_saved_grant mux, which is an e_mux
  assign led_s1_any_bursting_master_saved_grant = 0;

  //led_s1_arb_share_counter_next_value assignment, which is an e_assign
  assign led_s1_arb_share_counter_next_value = led_s1_firsttransfer ? (led_s1_arb_share_set_values - 1) : |led_s1_arb_share_counter ? (led_s1_arb_share_counter - 1) : 0;

  //led_s1_allgrants all slave grants, which is an e_mux
  assign led_s1_allgrants = |led_s1_grant_vector;

  //led_s1_end_xfer assignment, which is an e_assign
  assign led_s1_end_xfer = ~(led_s1_waits_for_read | led_s1_waits_for_write);

  //end_xfer_arb_share_counter_term_led_s1 arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_led_s1 = led_s1_end_xfer & (~led_s1_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //led_s1_arb_share_counter arbitration counter enable, which is an e_assign
  assign led_s1_arb_counter_enable = (end_xfer_arb_share_counter_term_led_s1 & led_s1_allgrants) | (end_xfer_arb_share_counter_term_led_s1 & ~led_s1_non_bursting_master_requests);

  //led_s1_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          led_s1_arb_share_counter <= 0;
      else if (led_s1_arb_counter_enable)
          led_s1_arb_share_counter <= led_s1_arb_share_counter_next_value;
    end


  //led_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          led_s1_slavearbiterlockenable <= 0;
      else if ((|led_s1_master_qreq_vector & end_xfer_arb_share_counter_term_led_s1) | (end_xfer_arb_share_counter_term_led_s1 & ~led_s1_non_bursting_master_requests))
          led_s1_slavearbiterlockenable <= |led_s1_arb_share_counter_next_value;
    end


  //cpu/data_master led/s1 arbiterlock, which is an e_assign
  assign cpu_data_master_arbiterlock = led_s1_slavearbiterlockenable & cpu_data_master_continuerequest;

  //led_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign led_s1_slavearbiterlockenable2 = |led_s1_arb_share_counter_next_value;

  //cpu/data_master led/s1 arbiterlock2, which is an e_assign
  assign cpu_data_master_arbiterlock2 = led_s1_slavearbiterlockenable2 & cpu_data_master_continuerequest;

  //led_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  assign led_s1_any_continuerequest = 1;

  //cpu_data_master_continuerequest continued request, which is an e_assign
  assign cpu_data_master_continuerequest = 1;

  assign cpu_data_master_qualified_request_led_s1 = cpu_data_master_requests_led_s1 & ~(((~cpu_data_master_waitrequest) & cpu_data_master_write));
  //led_s1_writedata mux, which is an e_mux
  assign led_s1_writedata = cpu_data_master_writedata;

  //master is always granted when requested
  assign cpu_data_master_granted_led_s1 = cpu_data_master_qualified_request_led_s1;

  //cpu/data_master saved-grant led/s1, which is an e_assign
  assign cpu_data_master_saved_grant_led_s1 = cpu_data_master_requests_led_s1;

  //allow new arb cycle for led/s1, which is an e_assign
  assign led_s1_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign led_s1_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign led_s1_master_qreq_vector = 1;

  //led_s1_reset_n assignment, which is an e_assign
  assign led_s1_reset_n = reset_n;

  assign led_s1_chipselect = cpu_data_master_granted_led_s1;
  //led_s1_firsttransfer first transaction, which is an e_assign
  assign led_s1_firsttransfer = led_s1_begins_xfer ? led_s1_unreg_firsttransfer : led_s1_reg_firsttransfer;

  //led_s1_unreg_firsttransfer first transaction, which is an e_assign
  assign led_s1_unreg_firsttransfer = ~(led_s1_slavearbiterlockenable & led_s1_any_continuerequest);

  //led_s1_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          led_s1_reg_firsttransfer <= 1'b1;
      else if (led_s1_begins_xfer)
          led_s1_reg_firsttransfer <= led_s1_unreg_firsttransfer;
    end


  //led_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign led_s1_beginbursttransfer_internal = led_s1_begins_xfer;

  //~led_s1_write_n assignment, which is an e_mux
  assign led_s1_write_n = ~(cpu_data_master_granted_led_s1 & cpu_data_master_write);

  assign shifted_address_to_led_s1_from_cpu_data_master = cpu_data_master_address_to_slave;
  //led_s1_address mux, which is an e_mux
  assign led_s1_address = shifted_address_to_led_s1_from_cpu_data_master >> 2;

  //d1_led_s1_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_led_s1_end_xfer <= 1;
      else 
        d1_led_s1_end_xfer <= led_s1_end_xfer;
    end


  //led_s1_waits_for_read in a cycle, which is an e_mux
  assign led_s1_waits_for_read = led_s1_in_a_read_cycle & led_s1_begins_xfer;

  //led_s1_in_a_read_cycle assignment, which is an e_assign
  assign led_s1_in_a_read_cycle = cpu_data_master_granted_led_s1 & cpu_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = led_s1_in_a_read_cycle;

  //led_s1_waits_for_write in a cycle, which is an e_mux
  assign led_s1_waits_for_write = led_s1_in_a_write_cycle & 0;

  //led_s1_in_a_write_cycle assignment, which is an e_assign
  assign led_s1_in_a_write_cycle = cpu_data_master_granted_led_s1 & cpu_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = led_s1_in_a_write_cycle;

  assign wait_for_led_s1_counter = 0;

//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //led/s1 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else 
        enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module mm_console_master_master_arbitrator (
                                             // inputs:
                                              clk,
                                              d1_onchip_ram_s1_end_xfer,
                                              mm_console_master_granted_onchip_ram_s1,
                                              mm_console_master_master_address,
                                              mm_console_master_master_byteenable,
                                              mm_console_master_master_read,
                                              mm_console_master_master_write,
                                              mm_console_master_master_writedata,
                                              mm_console_master_qualified_request_onchip_ram_s1,
                                              mm_console_master_read_data_valid_onchip_ram_s1,
                                              mm_console_master_requests_onchip_ram_s1,
                                              onchip_ram_s1_readdata_from_sa,
                                              reset_n,

                                             // outputs:
                                              mm_console_master_latency_counter,
                                              mm_console_master_master_address_to_slave,
                                              mm_console_master_master_readdata,
                                              mm_console_master_master_readdatavalid,
                                              mm_console_master_master_reset,
                                              mm_console_master_master_waitrequest
                                           )
;

  output           mm_console_master_latency_counter;
  output  [ 31: 0] mm_console_master_master_address_to_slave;
  output  [ 31: 0] mm_console_master_master_readdata;
  output           mm_console_master_master_readdatavalid;
  output           mm_console_master_master_reset;
  output           mm_console_master_master_waitrequest;
  input            clk;
  input            d1_onchip_ram_s1_end_xfer;
  input            mm_console_master_granted_onchip_ram_s1;
  input   [ 31: 0] mm_console_master_master_address;
  input   [  3: 0] mm_console_master_master_byteenable;
  input            mm_console_master_master_read;
  input            mm_console_master_master_write;
  input   [ 31: 0] mm_console_master_master_writedata;
  input            mm_console_master_qualified_request_onchip_ram_s1;
  input            mm_console_master_read_data_valid_onchip_ram_s1;
  input            mm_console_master_requests_onchip_ram_s1;
  input   [ 31: 0] onchip_ram_s1_readdata_from_sa;
  input            reset_n;

  reg              active_and_waiting_last_time;
  wire             latency_load_value;
  reg              mm_console_master_latency_counter;
  reg     [ 31: 0] mm_console_master_master_address_last_time;
  wire    [ 31: 0] mm_console_master_master_address_to_slave;
  reg     [  3: 0] mm_console_master_master_byteenable_last_time;
  wire             mm_console_master_master_is_granted_some_slave;
  reg              mm_console_master_master_read_but_no_slave_selected;
  reg              mm_console_master_master_read_last_time;
  wire    [ 31: 0] mm_console_master_master_readdata;
  wire             mm_console_master_master_readdatavalid;
  wire             mm_console_master_master_reset;
  wire             mm_console_master_master_run;
  wire             mm_console_master_master_waitrequest;
  reg              mm_console_master_master_write_last_time;
  reg     [ 31: 0] mm_console_master_master_writedata_last_time;
  wire             p1_mm_console_master_latency_counter;
  wire             pre_flush_mm_console_master_master_readdatavalid;
  wire             r_1;
  //r_1 master_run cascaded wait assignment, which is an e_assign
  assign r_1 = 1 & (mm_console_master_qualified_request_onchip_ram_s1 | ~mm_console_master_requests_onchip_ram_s1) & (mm_console_master_granted_onchip_ram_s1 | ~mm_console_master_qualified_request_onchip_ram_s1) & ((~mm_console_master_qualified_request_onchip_ram_s1 | ~mm_console_master_master_read | (1 & mm_console_master_master_read))) & ((~mm_console_master_qualified_request_onchip_ram_s1 | ~(mm_console_master_master_read | mm_console_master_master_write) | (1 & (mm_console_master_master_read | mm_console_master_master_write))));

  //cascaded wait assignment, which is an e_assign
  assign mm_console_master_master_run = r_1;

  //optimize select-logic by passing only those address bits which matter.
  assign mm_console_master_master_address_to_slave = {16'b1,
    mm_console_master_master_address[15 : 0]};

  //mm_console_master_master_read_but_no_slave_selected assignment, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          mm_console_master_master_read_but_no_slave_selected <= 0;
      else 
        mm_console_master_master_read_but_no_slave_selected <= mm_console_master_master_read & mm_console_master_master_run & ~mm_console_master_master_is_granted_some_slave;
    end


  //some slave is getting selected, which is an e_mux
  assign mm_console_master_master_is_granted_some_slave = mm_console_master_granted_onchip_ram_s1;

  //latent slave read data valids which may be flushed, which is an e_mux
  assign pre_flush_mm_console_master_master_readdatavalid = mm_console_master_read_data_valid_onchip_ram_s1;

  //latent slave read data valid which is not flushed, which is an e_mux
  assign mm_console_master_master_readdatavalid = mm_console_master_master_read_but_no_slave_selected |
    pre_flush_mm_console_master_master_readdatavalid;

  //mm_console_master/master readdata mux, which is an e_mux
  assign mm_console_master_master_readdata = onchip_ram_s1_readdata_from_sa;

  //actual waitrequest port, which is an e_assign
  assign mm_console_master_master_waitrequest = ~mm_console_master_master_run;

  //latent max counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          mm_console_master_latency_counter <= 0;
      else 
        mm_console_master_latency_counter <= p1_mm_console_master_latency_counter;
    end


  //latency counter load mux, which is an e_mux
  assign p1_mm_console_master_latency_counter = ((mm_console_master_master_run & mm_console_master_master_read))? latency_load_value :
    (mm_console_master_latency_counter)? mm_console_master_latency_counter - 1 :
    0;

  //read latency load values, which is an e_mux
  assign latency_load_value = {1 {mm_console_master_requests_onchip_ram_s1}} & 1;

  //~mm_console_master_master_reset assignment, which is an e_assign
  assign mm_console_master_master_reset = ~reset_n;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //mm_console_master_master_address check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          mm_console_master_master_address_last_time <= 0;
      else 
        mm_console_master_master_address_last_time <= mm_console_master_master_address;
    end


  //mm_console_master/master waited last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          active_and_waiting_last_time <= 0;
      else 
        active_and_waiting_last_time <= mm_console_master_master_waitrequest & (mm_console_master_master_read | mm_console_master_master_write);
    end


  //mm_console_master_master_address matches last port_name, which is an e_process
  always @(posedge clk)
    begin
      if (active_and_waiting_last_time & (mm_console_master_master_address != mm_console_master_master_address_last_time))
        begin
          $write("%0d ns: mm_console_master_master_address did not heed wait!!!", $time);
          $stop;
        end
    end


  //mm_console_master_master_byteenable check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          mm_console_master_master_byteenable_last_time <= 0;
      else 
        mm_console_master_master_byteenable_last_time <= mm_console_master_master_byteenable;
    end


  //mm_console_master_master_byteenable matches last port_name, which is an e_process
  always @(posedge clk)
    begin
      if (active_and_waiting_last_time & (mm_console_master_master_byteenable != mm_console_master_master_byteenable_last_time))
        begin
          $write("%0d ns: mm_console_master_master_byteenable did not heed wait!!!", $time);
          $stop;
        end
    end


  //mm_console_master_master_read check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          mm_console_master_master_read_last_time <= 0;
      else 
        mm_console_master_master_read_last_time <= mm_console_master_master_read;
    end


  //mm_console_master_master_read matches last port_name, which is an e_process
  always @(posedge clk)
    begin
      if (active_and_waiting_last_time & (mm_console_master_master_read != mm_console_master_master_read_last_time))
        begin
          $write("%0d ns: mm_console_master_master_read did not heed wait!!!", $time);
          $stop;
        end
    end


  //mm_console_master_master_write check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          mm_console_master_master_write_last_time <= 0;
      else 
        mm_console_master_master_write_last_time <= mm_console_master_master_write;
    end


  //mm_console_master_master_write matches last port_name, which is an e_process
  always @(posedge clk)
    begin
      if (active_and_waiting_last_time & (mm_console_master_master_write != mm_console_master_master_write_last_time))
        begin
          $write("%0d ns: mm_console_master_master_write did not heed wait!!!", $time);
          $stop;
        end
    end


  //mm_console_master_master_writedata check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          mm_console_master_master_writedata_last_time <= 0;
      else 
        mm_console_master_master_writedata_last_time <= mm_console_master_master_writedata;
    end


  //mm_console_master_master_writedata matches last port_name, which is an e_process
  always @(posedge clk)
    begin
      if (active_and_waiting_last_time & (mm_console_master_master_writedata != mm_console_master_master_writedata_last_time) & mm_console_master_master_write)
        begin
          $write("%0d ns: mm_console_master_master_writedata did not heed wait!!!", $time);
          $stop;
        end
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module onchip_ram_s1_arbitrator (
                                  // inputs:
                                   clk,
                                   cpu_data_master_address_to_slave,
                                   cpu_data_master_byteenable,
                                   cpu_data_master_read,
                                   cpu_data_master_waitrequest,
                                   cpu_data_master_write,
                                   cpu_data_master_writedata,
                                   cpu_instruction_master_address_to_slave,
                                   cpu_instruction_master_read,
                                   mm_console_master_latency_counter,
                                   mm_console_master_master_address_to_slave,
                                   mm_console_master_master_byteenable,
                                   mm_console_master_master_read,
                                   mm_console_master_master_write,
                                   mm_console_master_master_writedata,
                                   onchip_ram_s1_readdata,
                                   reset_n,

                                  // outputs:
                                   cpu_data_master_granted_onchip_ram_s1,
                                   cpu_data_master_qualified_request_onchip_ram_s1,
                                   cpu_data_master_read_data_valid_onchip_ram_s1,
                                   cpu_data_master_requests_onchip_ram_s1,
                                   cpu_instruction_master_granted_onchip_ram_s1,
                                   cpu_instruction_master_qualified_request_onchip_ram_s1,
                                   cpu_instruction_master_read_data_valid_onchip_ram_s1,
                                   cpu_instruction_master_requests_onchip_ram_s1,
                                   d1_onchip_ram_s1_end_xfer,
                                   mm_console_master_granted_onchip_ram_s1,
                                   mm_console_master_qualified_request_onchip_ram_s1,
                                   mm_console_master_read_data_valid_onchip_ram_s1,
                                   mm_console_master_requests_onchip_ram_s1,
                                   onchip_ram_s1_address,
                                   onchip_ram_s1_byteenable,
                                   onchip_ram_s1_chipselect,
                                   onchip_ram_s1_clken,
                                   onchip_ram_s1_readdata_from_sa,
                                   onchip_ram_s1_reset,
                                   onchip_ram_s1_write,
                                   onchip_ram_s1_writedata,
                                   registered_cpu_data_master_read_data_valid_onchip_ram_s1
                                )
;

  output           cpu_data_master_granted_onchip_ram_s1;
  output           cpu_data_master_qualified_request_onchip_ram_s1;
  output           cpu_data_master_read_data_valid_onchip_ram_s1;
  output           cpu_data_master_requests_onchip_ram_s1;
  output           cpu_instruction_master_granted_onchip_ram_s1;
  output           cpu_instruction_master_qualified_request_onchip_ram_s1;
  output           cpu_instruction_master_read_data_valid_onchip_ram_s1;
  output           cpu_instruction_master_requests_onchip_ram_s1;
  output           d1_onchip_ram_s1_end_xfer;
  output           mm_console_master_granted_onchip_ram_s1;
  output           mm_console_master_qualified_request_onchip_ram_s1;
  output           mm_console_master_read_data_valid_onchip_ram_s1;
  output           mm_console_master_requests_onchip_ram_s1;
  output  [ 13: 0] onchip_ram_s1_address;
  output  [  3: 0] onchip_ram_s1_byteenable;
  output           onchip_ram_s1_chipselect;
  output           onchip_ram_s1_clken;
  output  [ 31: 0] onchip_ram_s1_readdata_from_sa;
  output           onchip_ram_s1_reset;
  output           onchip_ram_s1_write;
  output  [ 31: 0] onchip_ram_s1_writedata;
  output           registered_cpu_data_master_read_data_valid_onchip_ram_s1;
  input            clk;
  input   [ 16: 0] cpu_data_master_address_to_slave;
  input   [  3: 0] cpu_data_master_byteenable;
  input            cpu_data_master_read;
  input            cpu_data_master_waitrequest;
  input            cpu_data_master_write;
  input   [ 31: 0] cpu_data_master_writedata;
  input   [ 16: 0] cpu_instruction_master_address_to_slave;
  input            cpu_instruction_master_read;
  input            mm_console_master_latency_counter;
  input   [ 31: 0] mm_console_master_master_address_to_slave;
  input   [  3: 0] mm_console_master_master_byteenable;
  input            mm_console_master_master_read;
  input            mm_console_master_master_write;
  input   [ 31: 0] mm_console_master_master_writedata;
  input   [ 31: 0] onchip_ram_s1_readdata;
  input            reset_n;

  wire             cpu_data_master_arbiterlock;
  wire             cpu_data_master_arbiterlock2;
  wire             cpu_data_master_continuerequest;
  wire             cpu_data_master_granted_onchip_ram_s1;
  wire             cpu_data_master_qualified_request_onchip_ram_s1;
  wire             cpu_data_master_read_data_valid_onchip_ram_s1;
  reg              cpu_data_master_read_data_valid_onchip_ram_s1_shift_register;
  wire             cpu_data_master_read_data_valid_onchip_ram_s1_shift_register_in;
  wire             cpu_data_master_requests_onchip_ram_s1;
  wire             cpu_data_master_saved_grant_onchip_ram_s1;
  wire             cpu_instruction_master_arbiterlock;
  wire             cpu_instruction_master_arbiterlock2;
  wire             cpu_instruction_master_continuerequest;
  wire             cpu_instruction_master_granted_onchip_ram_s1;
  wire             cpu_instruction_master_qualified_request_onchip_ram_s1;
  wire             cpu_instruction_master_read_data_valid_onchip_ram_s1;
  reg              cpu_instruction_master_read_data_valid_onchip_ram_s1_shift_register;
  wire             cpu_instruction_master_read_data_valid_onchip_ram_s1_shift_register_in;
  wire             cpu_instruction_master_requests_onchip_ram_s1;
  wire             cpu_instruction_master_saved_grant_onchip_ram_s1;
  reg              d1_onchip_ram_s1_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_onchip_ram_s1;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  reg              last_cycle_cpu_data_master_granted_slave_onchip_ram_s1;
  reg              last_cycle_cpu_instruction_master_granted_slave_onchip_ram_s1;
  reg              last_cycle_mm_console_master_master_granted_slave_onchip_ram_s1;
  wire             mm_console_master_granted_onchip_ram_s1;
  wire             mm_console_master_master_arbiterlock;
  wire             mm_console_master_master_arbiterlock2;
  wire             mm_console_master_master_continuerequest;
  wire             mm_console_master_qualified_request_onchip_ram_s1;
  wire             mm_console_master_read_data_valid_onchip_ram_s1;
  reg              mm_console_master_read_data_valid_onchip_ram_s1_shift_register;
  wire             mm_console_master_read_data_valid_onchip_ram_s1_shift_register_in;
  wire             mm_console_master_requests_onchip_ram_s1;
  wire             mm_console_master_saved_grant_onchip_ram_s1;
  wire    [ 13: 0] onchip_ram_s1_address;
  wire             onchip_ram_s1_allgrants;
  wire             onchip_ram_s1_allow_new_arb_cycle;
  wire             onchip_ram_s1_any_bursting_master_saved_grant;
  wire             onchip_ram_s1_any_continuerequest;
  reg     [  2: 0] onchip_ram_s1_arb_addend;
  wire             onchip_ram_s1_arb_counter_enable;
  reg              onchip_ram_s1_arb_share_counter;
  wire             onchip_ram_s1_arb_share_counter_next_value;
  wire             onchip_ram_s1_arb_share_set_values;
  wire    [  2: 0] onchip_ram_s1_arb_winner;
  wire             onchip_ram_s1_arbitration_holdoff_internal;
  wire             onchip_ram_s1_beginbursttransfer_internal;
  wire             onchip_ram_s1_begins_xfer;
  wire    [  3: 0] onchip_ram_s1_byteenable;
  wire             onchip_ram_s1_chipselect;
  wire    [  5: 0] onchip_ram_s1_chosen_master_double_vector;
  wire    [  2: 0] onchip_ram_s1_chosen_master_rot_left;
  wire             onchip_ram_s1_clken;
  wire             onchip_ram_s1_end_xfer;
  wire             onchip_ram_s1_firsttransfer;
  wire    [  2: 0] onchip_ram_s1_grant_vector;
  wire             onchip_ram_s1_in_a_read_cycle;
  wire             onchip_ram_s1_in_a_write_cycle;
  wire    [  2: 0] onchip_ram_s1_master_qreq_vector;
  wire             onchip_ram_s1_non_bursting_master_requests;
  wire    [ 31: 0] onchip_ram_s1_readdata_from_sa;
  reg              onchip_ram_s1_reg_firsttransfer;
  wire             onchip_ram_s1_reset;
  reg     [  2: 0] onchip_ram_s1_saved_chosen_master_vector;
  reg              onchip_ram_s1_slavearbiterlockenable;
  wire             onchip_ram_s1_slavearbiterlockenable2;
  wire             onchip_ram_s1_unreg_firsttransfer;
  wire             onchip_ram_s1_waits_for_read;
  wire             onchip_ram_s1_waits_for_write;
  wire             onchip_ram_s1_write;
  wire    [ 31: 0] onchip_ram_s1_writedata;
  wire             p1_cpu_data_master_read_data_valid_onchip_ram_s1_shift_register;
  wire             p1_cpu_instruction_master_read_data_valid_onchip_ram_s1_shift_register;
  wire             p1_mm_console_master_read_data_valid_onchip_ram_s1_shift_register;
  wire             registered_cpu_data_master_read_data_valid_onchip_ram_s1;
  wire    [ 16: 0] shifted_address_to_onchip_ram_s1_from_cpu_data_master;
  wire    [ 16: 0] shifted_address_to_onchip_ram_s1_from_cpu_instruction_master;
  wire    [ 31: 0] shifted_address_to_onchip_ram_s1_from_mm_console_master_master;
  wire             wait_for_onchip_ram_s1_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else 
        d1_reasons_to_wait <= ~onchip_ram_s1_end_xfer;
    end


  assign onchip_ram_s1_begins_xfer = ~d1_reasons_to_wait & ((cpu_data_master_qualified_request_onchip_ram_s1 | cpu_instruction_master_qualified_request_onchip_ram_s1 | mm_console_master_qualified_request_onchip_ram_s1));
  //assign onchip_ram_s1_readdata_from_sa = onchip_ram_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign onchip_ram_s1_readdata_from_sa = onchip_ram_s1_readdata;

  assign cpu_data_master_requests_onchip_ram_s1 = ({cpu_data_master_address_to_slave[16] , 16'b0} == 17'h10000) & (cpu_data_master_read | cpu_data_master_write);
  //registered rdv signal_name registered_cpu_data_master_read_data_valid_onchip_ram_s1 assignment, which is an e_assign
  assign registered_cpu_data_master_read_data_valid_onchip_ram_s1 = cpu_data_master_read_data_valid_onchip_ram_s1_shift_register_in;

  //onchip_ram_s1_arb_share_counter set values, which is an e_mux
  assign onchip_ram_s1_arb_share_set_values = 1;

  //onchip_ram_s1_non_bursting_master_requests mux, which is an e_mux
  assign onchip_ram_s1_non_bursting_master_requests = cpu_data_master_requests_onchip_ram_s1 |
    cpu_instruction_master_requests_onchip_ram_s1 |
    mm_console_master_requests_onchip_ram_s1 |
    cpu_data_master_requests_onchip_ram_s1 |
    cpu_instruction_master_requests_onchip_ram_s1 |
    mm_console_master_requests_onchip_ram_s1 |
    cpu_data_master_requests_onchip_ram_s1 |
    cpu_instruction_master_requests_onchip_ram_s1 |
    mm_console_master_requests_onchip_ram_s1;

  //onchip_ram_s1_any_bursting_master_saved_grant mux, which is an e_mux
  assign onchip_ram_s1_any_bursting_master_saved_grant = 0;

  //onchip_ram_s1_arb_share_counter_next_value assignment, which is an e_assign
  assign onchip_ram_s1_arb_share_counter_next_value = onchip_ram_s1_firsttransfer ? (onchip_ram_s1_arb_share_set_values - 1) : |onchip_ram_s1_arb_share_counter ? (onchip_ram_s1_arb_share_counter - 1) : 0;

  //onchip_ram_s1_allgrants all slave grants, which is an e_mux
  assign onchip_ram_s1_allgrants = (|onchip_ram_s1_grant_vector) |
    (|onchip_ram_s1_grant_vector) |
    (|onchip_ram_s1_grant_vector) |
    (|onchip_ram_s1_grant_vector) |
    (|onchip_ram_s1_grant_vector) |
    (|onchip_ram_s1_grant_vector) |
    (|onchip_ram_s1_grant_vector) |
    (|onchip_ram_s1_grant_vector) |
    (|onchip_ram_s1_grant_vector);

  //onchip_ram_s1_end_xfer assignment, which is an e_assign
  assign onchip_ram_s1_end_xfer = ~(onchip_ram_s1_waits_for_read | onchip_ram_s1_waits_for_write);

  //end_xfer_arb_share_counter_term_onchip_ram_s1 arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_onchip_ram_s1 = onchip_ram_s1_end_xfer & (~onchip_ram_s1_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //onchip_ram_s1_arb_share_counter arbitration counter enable, which is an e_assign
  assign onchip_ram_s1_arb_counter_enable = (end_xfer_arb_share_counter_term_onchip_ram_s1 & onchip_ram_s1_allgrants) | (end_xfer_arb_share_counter_term_onchip_ram_s1 & ~onchip_ram_s1_non_bursting_master_requests);

  //onchip_ram_s1_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          onchip_ram_s1_arb_share_counter <= 0;
      else if (onchip_ram_s1_arb_counter_enable)
          onchip_ram_s1_arb_share_counter <= onchip_ram_s1_arb_share_counter_next_value;
    end


  //onchip_ram_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          onchip_ram_s1_slavearbiterlockenable <= 0;
      else if ((|onchip_ram_s1_master_qreq_vector & end_xfer_arb_share_counter_term_onchip_ram_s1) | (end_xfer_arb_share_counter_term_onchip_ram_s1 & ~onchip_ram_s1_non_bursting_master_requests))
          onchip_ram_s1_slavearbiterlockenable <= |onchip_ram_s1_arb_share_counter_next_value;
    end


  //cpu/data_master onchip_ram/s1 arbiterlock, which is an e_assign
  assign cpu_data_master_arbiterlock = onchip_ram_s1_slavearbiterlockenable & cpu_data_master_continuerequest;

  //onchip_ram_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign onchip_ram_s1_slavearbiterlockenable2 = |onchip_ram_s1_arb_share_counter_next_value;

  //cpu/data_master onchip_ram/s1 arbiterlock2, which is an e_assign
  assign cpu_data_master_arbiterlock2 = onchip_ram_s1_slavearbiterlockenable2 & cpu_data_master_continuerequest;

  //cpu/instruction_master onchip_ram/s1 arbiterlock, which is an e_assign
  assign cpu_instruction_master_arbiterlock = onchip_ram_s1_slavearbiterlockenable & cpu_instruction_master_continuerequest;

  //cpu/instruction_master onchip_ram/s1 arbiterlock2, which is an e_assign
  assign cpu_instruction_master_arbiterlock2 = onchip_ram_s1_slavearbiterlockenable2 & cpu_instruction_master_continuerequest;

  //cpu/instruction_master granted onchip_ram/s1 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_instruction_master_granted_slave_onchip_ram_s1 <= 0;
      else 
        last_cycle_cpu_instruction_master_granted_slave_onchip_ram_s1 <= cpu_instruction_master_saved_grant_onchip_ram_s1 ? 1 : (onchip_ram_s1_arbitration_holdoff_internal | ~cpu_instruction_master_requests_onchip_ram_s1) ? 0 : last_cycle_cpu_instruction_master_granted_slave_onchip_ram_s1;
    end


  //cpu_instruction_master_continuerequest continued request, which is an e_mux
  assign cpu_instruction_master_continuerequest = (last_cycle_cpu_instruction_master_granted_slave_onchip_ram_s1 & cpu_instruction_master_requests_onchip_ram_s1) |
    (last_cycle_cpu_instruction_master_granted_slave_onchip_ram_s1 & cpu_instruction_master_requests_onchip_ram_s1);

  //onchip_ram_s1_any_continuerequest at least one master continues requesting, which is an e_mux
  assign onchip_ram_s1_any_continuerequest = cpu_instruction_master_continuerequest |
    mm_console_master_master_continuerequest |
    cpu_data_master_continuerequest |
    mm_console_master_master_continuerequest |
    cpu_data_master_continuerequest |
    cpu_instruction_master_continuerequest;

  //mm_console_master/master onchip_ram/s1 arbiterlock, which is an e_assign
  assign mm_console_master_master_arbiterlock = onchip_ram_s1_slavearbiterlockenable & mm_console_master_master_continuerequest;

  //mm_console_master/master onchip_ram/s1 arbiterlock2, which is an e_assign
  assign mm_console_master_master_arbiterlock2 = onchip_ram_s1_slavearbiterlockenable2 & mm_console_master_master_continuerequest;

  //mm_console_master/master granted onchip_ram/s1 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_mm_console_master_master_granted_slave_onchip_ram_s1 <= 0;
      else 
        last_cycle_mm_console_master_master_granted_slave_onchip_ram_s1 <= mm_console_master_saved_grant_onchip_ram_s1 ? 1 : (onchip_ram_s1_arbitration_holdoff_internal | ~mm_console_master_requests_onchip_ram_s1) ? 0 : last_cycle_mm_console_master_master_granted_slave_onchip_ram_s1;
    end


  //mm_console_master_master_continuerequest continued request, which is an e_mux
  assign mm_console_master_master_continuerequest = (last_cycle_mm_console_master_master_granted_slave_onchip_ram_s1 & mm_console_master_requests_onchip_ram_s1) |
    (last_cycle_mm_console_master_master_granted_slave_onchip_ram_s1 & mm_console_master_requests_onchip_ram_s1);

  assign cpu_data_master_qualified_request_onchip_ram_s1 = cpu_data_master_requests_onchip_ram_s1 & ~((cpu_data_master_read & ((|cpu_data_master_read_data_valid_onchip_ram_s1_shift_register))) | ((~cpu_data_master_waitrequest) & cpu_data_master_write) | cpu_instruction_master_arbiterlock | mm_console_master_master_arbiterlock);
  //cpu_data_master_read_data_valid_onchip_ram_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  assign cpu_data_master_read_data_valid_onchip_ram_s1_shift_register_in = cpu_data_master_granted_onchip_ram_s1 & cpu_data_master_read & ~onchip_ram_s1_waits_for_read & ~(|cpu_data_master_read_data_valid_onchip_ram_s1_shift_register);

  //shift register p1 cpu_data_master_read_data_valid_onchip_ram_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  assign p1_cpu_data_master_read_data_valid_onchip_ram_s1_shift_register = {cpu_data_master_read_data_valid_onchip_ram_s1_shift_register, cpu_data_master_read_data_valid_onchip_ram_s1_shift_register_in};

  //cpu_data_master_read_data_valid_onchip_ram_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_data_master_read_data_valid_onchip_ram_s1_shift_register <= 0;
      else 
        cpu_data_master_read_data_valid_onchip_ram_s1_shift_register <= p1_cpu_data_master_read_data_valid_onchip_ram_s1_shift_register;
    end


  //local readdatavalid cpu_data_master_read_data_valid_onchip_ram_s1, which is an e_mux
  assign cpu_data_master_read_data_valid_onchip_ram_s1 = cpu_data_master_read_data_valid_onchip_ram_s1_shift_register;

  //onchip_ram_s1_writedata mux, which is an e_mux
  assign onchip_ram_s1_writedata = (cpu_data_master_granted_onchip_ram_s1)? cpu_data_master_writedata :
    mm_console_master_master_writedata;

  //mux onchip_ram_s1_clken, which is an e_mux
  assign onchip_ram_s1_clken = 1'b1;

  assign cpu_instruction_master_requests_onchip_ram_s1 = (({cpu_instruction_master_address_to_slave[16] , 16'b0} == 17'h10000) & (cpu_instruction_master_read)) & cpu_instruction_master_read;
  //cpu/data_master granted onchip_ram/s1 last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          last_cycle_cpu_data_master_granted_slave_onchip_ram_s1 <= 0;
      else 
        last_cycle_cpu_data_master_granted_slave_onchip_ram_s1 <= cpu_data_master_saved_grant_onchip_ram_s1 ? 1 : (onchip_ram_s1_arbitration_holdoff_internal | ~cpu_data_master_requests_onchip_ram_s1) ? 0 : last_cycle_cpu_data_master_granted_slave_onchip_ram_s1;
    end


  //cpu_data_master_continuerequest continued request, which is an e_mux
  assign cpu_data_master_continuerequest = (last_cycle_cpu_data_master_granted_slave_onchip_ram_s1 & cpu_data_master_requests_onchip_ram_s1) |
    (last_cycle_cpu_data_master_granted_slave_onchip_ram_s1 & cpu_data_master_requests_onchip_ram_s1);

  assign cpu_instruction_master_qualified_request_onchip_ram_s1 = cpu_instruction_master_requests_onchip_ram_s1 & ~((cpu_instruction_master_read & ((|cpu_instruction_master_read_data_valid_onchip_ram_s1_shift_register))) | cpu_data_master_arbiterlock | mm_console_master_master_arbiterlock);
  //cpu_instruction_master_read_data_valid_onchip_ram_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  assign cpu_instruction_master_read_data_valid_onchip_ram_s1_shift_register_in = cpu_instruction_master_granted_onchip_ram_s1 & cpu_instruction_master_read & ~onchip_ram_s1_waits_for_read & ~(|cpu_instruction_master_read_data_valid_onchip_ram_s1_shift_register);

  //shift register p1 cpu_instruction_master_read_data_valid_onchip_ram_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  assign p1_cpu_instruction_master_read_data_valid_onchip_ram_s1_shift_register = {cpu_instruction_master_read_data_valid_onchip_ram_s1_shift_register, cpu_instruction_master_read_data_valid_onchip_ram_s1_shift_register_in};

  //cpu_instruction_master_read_data_valid_onchip_ram_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          cpu_instruction_master_read_data_valid_onchip_ram_s1_shift_register <= 0;
      else 
        cpu_instruction_master_read_data_valid_onchip_ram_s1_shift_register <= p1_cpu_instruction_master_read_data_valid_onchip_ram_s1_shift_register;
    end


  //local readdatavalid cpu_instruction_master_read_data_valid_onchip_ram_s1, which is an e_mux
  assign cpu_instruction_master_read_data_valid_onchip_ram_s1 = cpu_instruction_master_read_data_valid_onchip_ram_s1_shift_register;

  assign mm_console_master_requests_onchip_ram_s1 = ({mm_console_master_master_address_to_slave[31 : 16] , 16'b0} == 32'h10000) & (mm_console_master_master_read | mm_console_master_master_write);
  assign mm_console_master_qualified_request_onchip_ram_s1 = mm_console_master_requests_onchip_ram_s1 & ~(cpu_data_master_arbiterlock | cpu_instruction_master_arbiterlock);
  //mm_console_master_read_data_valid_onchip_ram_s1_shift_register_in mux for readlatency shift register, which is an e_mux
  assign mm_console_master_read_data_valid_onchip_ram_s1_shift_register_in = mm_console_master_granted_onchip_ram_s1 & mm_console_master_master_read & ~onchip_ram_s1_waits_for_read;

  //shift register p1 mm_console_master_read_data_valid_onchip_ram_s1_shift_register in if flush, otherwise shift left, which is an e_mux
  assign p1_mm_console_master_read_data_valid_onchip_ram_s1_shift_register = {mm_console_master_read_data_valid_onchip_ram_s1_shift_register, mm_console_master_read_data_valid_onchip_ram_s1_shift_register_in};

  //mm_console_master_read_data_valid_onchip_ram_s1_shift_register for remembering which master asked for a fixed latency read, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          mm_console_master_read_data_valid_onchip_ram_s1_shift_register <= 0;
      else 
        mm_console_master_read_data_valid_onchip_ram_s1_shift_register <= p1_mm_console_master_read_data_valid_onchip_ram_s1_shift_register;
    end


  //local readdatavalid mm_console_master_read_data_valid_onchip_ram_s1, which is an e_mux
  assign mm_console_master_read_data_valid_onchip_ram_s1 = mm_console_master_read_data_valid_onchip_ram_s1_shift_register;

  //allow new arb cycle for onchip_ram/s1, which is an e_assign
  assign onchip_ram_s1_allow_new_arb_cycle = ~cpu_data_master_arbiterlock & ~cpu_instruction_master_arbiterlock & ~mm_console_master_master_arbiterlock;

  //mm_console_master/master assignment into master qualified-requests vector for onchip_ram/s1, which is an e_assign
  assign onchip_ram_s1_master_qreq_vector[0] = mm_console_master_qualified_request_onchip_ram_s1;

  //mm_console_master/master grant onchip_ram/s1, which is an e_assign
  assign mm_console_master_granted_onchip_ram_s1 = onchip_ram_s1_grant_vector[0];

  //mm_console_master/master saved-grant onchip_ram/s1, which is an e_assign
  assign mm_console_master_saved_grant_onchip_ram_s1 = onchip_ram_s1_arb_winner[0] && mm_console_master_requests_onchip_ram_s1;

  //cpu/instruction_master assignment into master qualified-requests vector for onchip_ram/s1, which is an e_assign
  assign onchip_ram_s1_master_qreq_vector[1] = cpu_instruction_master_qualified_request_onchip_ram_s1;

  //cpu/instruction_master grant onchip_ram/s1, which is an e_assign
  assign cpu_instruction_master_granted_onchip_ram_s1 = onchip_ram_s1_grant_vector[1];

  //cpu/instruction_master saved-grant onchip_ram/s1, which is an e_assign
  assign cpu_instruction_master_saved_grant_onchip_ram_s1 = onchip_ram_s1_arb_winner[1] && cpu_instruction_master_requests_onchip_ram_s1;

  //cpu/data_master assignment into master qualified-requests vector for onchip_ram/s1, which is an e_assign
  assign onchip_ram_s1_master_qreq_vector[2] = cpu_data_master_qualified_request_onchip_ram_s1;

  //cpu/data_master grant onchip_ram/s1, which is an e_assign
  assign cpu_data_master_granted_onchip_ram_s1 = onchip_ram_s1_grant_vector[2];

  //cpu/data_master saved-grant onchip_ram/s1, which is an e_assign
  assign cpu_data_master_saved_grant_onchip_ram_s1 = onchip_ram_s1_arb_winner[2] && cpu_data_master_requests_onchip_ram_s1;

  //onchip_ram/s1 chosen-master double-vector, which is an e_assign
  assign onchip_ram_s1_chosen_master_double_vector = {onchip_ram_s1_master_qreq_vector, onchip_ram_s1_master_qreq_vector} & ({~onchip_ram_s1_master_qreq_vector, ~onchip_ram_s1_master_qreq_vector} + onchip_ram_s1_arb_addend);

  //stable onehot encoding of arb winner
  assign onchip_ram_s1_arb_winner = (onchip_ram_s1_allow_new_arb_cycle & | onchip_ram_s1_grant_vector) ? onchip_ram_s1_grant_vector : onchip_ram_s1_saved_chosen_master_vector;

  //saved onchip_ram_s1_grant_vector, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          onchip_ram_s1_saved_chosen_master_vector <= 0;
      else if (onchip_ram_s1_allow_new_arb_cycle)
          onchip_ram_s1_saved_chosen_master_vector <= |onchip_ram_s1_grant_vector ? onchip_ram_s1_grant_vector : onchip_ram_s1_saved_chosen_master_vector;
    end


  //onehot encoding of chosen master
  assign onchip_ram_s1_grant_vector = {(onchip_ram_s1_chosen_master_double_vector[2] | onchip_ram_s1_chosen_master_double_vector[5]),
    (onchip_ram_s1_chosen_master_double_vector[1] | onchip_ram_s1_chosen_master_double_vector[4]),
    (onchip_ram_s1_chosen_master_double_vector[0] | onchip_ram_s1_chosen_master_double_vector[3])};

  //onchip_ram/s1 chosen master rotated left, which is an e_assign
  assign onchip_ram_s1_chosen_master_rot_left = (onchip_ram_s1_arb_winner << 1) ? (onchip_ram_s1_arb_winner << 1) : 1;

  //onchip_ram/s1's addend for next-master-grant
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          onchip_ram_s1_arb_addend <= 1;
      else if (|onchip_ram_s1_grant_vector)
          onchip_ram_s1_arb_addend <= onchip_ram_s1_end_xfer? onchip_ram_s1_chosen_master_rot_left : onchip_ram_s1_grant_vector;
    end


  //~onchip_ram_s1_reset assignment, which is an e_assign
  assign onchip_ram_s1_reset = ~reset_n;

  assign onchip_ram_s1_chipselect = cpu_data_master_granted_onchip_ram_s1 | cpu_instruction_master_granted_onchip_ram_s1 | mm_console_master_granted_onchip_ram_s1;
  //onchip_ram_s1_firsttransfer first transaction, which is an e_assign
  assign onchip_ram_s1_firsttransfer = onchip_ram_s1_begins_xfer ? onchip_ram_s1_unreg_firsttransfer : onchip_ram_s1_reg_firsttransfer;

  //onchip_ram_s1_unreg_firsttransfer first transaction, which is an e_assign
  assign onchip_ram_s1_unreg_firsttransfer = ~(onchip_ram_s1_slavearbiterlockenable & onchip_ram_s1_any_continuerequest);

  //onchip_ram_s1_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          onchip_ram_s1_reg_firsttransfer <= 1'b1;
      else if (onchip_ram_s1_begins_xfer)
          onchip_ram_s1_reg_firsttransfer <= onchip_ram_s1_unreg_firsttransfer;
    end


  //onchip_ram_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign onchip_ram_s1_beginbursttransfer_internal = onchip_ram_s1_begins_xfer;

  //onchip_ram_s1_arbitration_holdoff_internal arbitration_holdoff, which is an e_assign
  assign onchip_ram_s1_arbitration_holdoff_internal = onchip_ram_s1_begins_xfer & onchip_ram_s1_firsttransfer;

  //onchip_ram_s1_write assignment, which is an e_mux
  assign onchip_ram_s1_write = (cpu_data_master_granted_onchip_ram_s1 & cpu_data_master_write) | (mm_console_master_granted_onchip_ram_s1 & mm_console_master_master_write);

  assign shifted_address_to_onchip_ram_s1_from_cpu_data_master = cpu_data_master_address_to_slave;
  //onchip_ram_s1_address mux, which is an e_mux
  assign onchip_ram_s1_address = (cpu_data_master_granted_onchip_ram_s1)? (shifted_address_to_onchip_ram_s1_from_cpu_data_master >> 2) :
    (cpu_instruction_master_granted_onchip_ram_s1)? (shifted_address_to_onchip_ram_s1_from_cpu_instruction_master >> 2) :
    (shifted_address_to_onchip_ram_s1_from_mm_console_master_master >> 2);

  assign shifted_address_to_onchip_ram_s1_from_cpu_instruction_master = cpu_instruction_master_address_to_slave;
  assign shifted_address_to_onchip_ram_s1_from_mm_console_master_master = mm_console_master_master_address_to_slave;
  //d1_onchip_ram_s1_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_onchip_ram_s1_end_xfer <= 1;
      else 
        d1_onchip_ram_s1_end_xfer <= onchip_ram_s1_end_xfer;
    end


  //onchip_ram_s1_waits_for_read in a cycle, which is an e_mux
  assign onchip_ram_s1_waits_for_read = onchip_ram_s1_in_a_read_cycle & 0;

  //onchip_ram_s1_in_a_read_cycle assignment, which is an e_assign
  assign onchip_ram_s1_in_a_read_cycle = (cpu_data_master_granted_onchip_ram_s1 & cpu_data_master_read) | (cpu_instruction_master_granted_onchip_ram_s1 & cpu_instruction_master_read) | (mm_console_master_granted_onchip_ram_s1 & mm_console_master_master_read);

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = onchip_ram_s1_in_a_read_cycle;

  //onchip_ram_s1_waits_for_write in a cycle, which is an e_mux
  assign onchip_ram_s1_waits_for_write = onchip_ram_s1_in_a_write_cycle & 0;

  //onchip_ram_s1_in_a_write_cycle assignment, which is an e_assign
  assign onchip_ram_s1_in_a_write_cycle = (cpu_data_master_granted_onchip_ram_s1 & cpu_data_master_write) | (mm_console_master_granted_onchip_ram_s1 & mm_console_master_master_write);

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = onchip_ram_s1_in_a_write_cycle;

  assign wait_for_onchip_ram_s1_counter = 0;
  //onchip_ram_s1_byteenable byte enable port mux, which is an e_mux
  assign onchip_ram_s1_byteenable = (cpu_data_master_granted_onchip_ram_s1)? cpu_data_master_byteenable :
    (mm_console_master_granted_onchip_ram_s1)? mm_console_master_master_byteenable :
    -1;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //onchip_ram/s1 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else 
        enable_nonzero_assertions <= 1'b1;
    end


  //grant signals are active simultaneously, which is an e_process
  always @(posedge clk)
    begin
      if (cpu_data_master_granted_onchip_ram_s1 + cpu_instruction_master_granted_onchip_ram_s1 + mm_console_master_granted_onchip_ram_s1 > 1)
        begin
          $write("%0d ns: > 1 of grant signals are active simultaneously", $time);
          $stop;
        end
    end


  //saved_grant signals are active simultaneously, which is an e_process
  always @(posedge clk)
    begin
      if (cpu_data_master_saved_grant_onchip_ram_s1 + cpu_instruction_master_saved_grant_onchip_ram_s1 + mm_console_master_saved_grant_onchip_ram_s1 > 1)
        begin
          $write("%0d ns: > 1 of saved_grant signals are active simultaneously", $time);
          $stop;
        end
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module opencores_i2c_0_avalon_slave_arbitrator (
                                                 // inputs:
                                                  clk,
                                                  cpu_data_master_address_to_slave,
                                                  cpu_data_master_byteenable,
                                                  cpu_data_master_read,
                                                  cpu_data_master_waitrequest,
                                                  cpu_data_master_write,
                                                  cpu_data_master_writedata,
                                                  opencores_i2c_0_avalon_slave_irq,
                                                  opencores_i2c_0_avalon_slave_readdata,
                                                  opencores_i2c_0_avalon_slave_waitrequest_n,
                                                  reset_n,

                                                 // outputs:
                                                  cpu_data_master_granted_opencores_i2c_0_avalon_slave,
                                                  cpu_data_master_qualified_request_opencores_i2c_0_avalon_slave,
                                                  cpu_data_master_read_data_valid_opencores_i2c_0_avalon_slave,
                                                  cpu_data_master_requests_opencores_i2c_0_avalon_slave,
                                                  d1_opencores_i2c_0_avalon_slave_end_xfer,
                                                  opencores_i2c_0_avalon_slave_address,
                                                  opencores_i2c_0_avalon_slave_chipselect,
                                                  opencores_i2c_0_avalon_slave_irq_from_sa,
                                                  opencores_i2c_0_avalon_slave_readdata_from_sa,
                                                  opencores_i2c_0_avalon_slave_reset,
                                                  opencores_i2c_0_avalon_slave_waitrequest_n_from_sa,
                                                  opencores_i2c_0_avalon_slave_write,
                                                  opencores_i2c_0_avalon_slave_writedata
                                               )
;

  output           cpu_data_master_granted_opencores_i2c_0_avalon_slave;
  output           cpu_data_master_qualified_request_opencores_i2c_0_avalon_slave;
  output           cpu_data_master_read_data_valid_opencores_i2c_0_avalon_slave;
  output           cpu_data_master_requests_opencores_i2c_0_avalon_slave;
  output           d1_opencores_i2c_0_avalon_slave_end_xfer;
  output  [  2: 0] opencores_i2c_0_avalon_slave_address;
  output           opencores_i2c_0_avalon_slave_chipselect;
  output           opencores_i2c_0_avalon_slave_irq_from_sa;
  output  [  7: 0] opencores_i2c_0_avalon_slave_readdata_from_sa;
  output           opencores_i2c_0_avalon_slave_reset;
  output           opencores_i2c_0_avalon_slave_waitrequest_n_from_sa;
  output           opencores_i2c_0_avalon_slave_write;
  output  [  7: 0] opencores_i2c_0_avalon_slave_writedata;
  input            clk;
  input   [ 16: 0] cpu_data_master_address_to_slave;
  input   [  3: 0] cpu_data_master_byteenable;
  input            cpu_data_master_read;
  input            cpu_data_master_waitrequest;
  input            cpu_data_master_write;
  input   [ 31: 0] cpu_data_master_writedata;
  input            opencores_i2c_0_avalon_slave_irq;
  input   [  7: 0] opencores_i2c_0_avalon_slave_readdata;
  input            opencores_i2c_0_avalon_slave_waitrequest_n;
  input            reset_n;

  wire             cpu_data_master_arbiterlock;
  wire             cpu_data_master_arbiterlock2;
  wire             cpu_data_master_continuerequest;
  wire             cpu_data_master_granted_opencores_i2c_0_avalon_slave;
  wire             cpu_data_master_qualified_request_opencores_i2c_0_avalon_slave;
  wire             cpu_data_master_read_data_valid_opencores_i2c_0_avalon_slave;
  wire             cpu_data_master_requests_opencores_i2c_0_avalon_slave;
  wire             cpu_data_master_saved_grant_opencores_i2c_0_avalon_slave;
  reg              d1_opencores_i2c_0_avalon_slave_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_opencores_i2c_0_avalon_slave;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [  2: 0] opencores_i2c_0_avalon_slave_address;
  wire             opencores_i2c_0_avalon_slave_allgrants;
  wire             opencores_i2c_0_avalon_slave_allow_new_arb_cycle;
  wire             opencores_i2c_0_avalon_slave_any_bursting_master_saved_grant;
  wire             opencores_i2c_0_avalon_slave_any_continuerequest;
  wire             opencores_i2c_0_avalon_slave_arb_counter_enable;
  reg              opencores_i2c_0_avalon_slave_arb_share_counter;
  wire             opencores_i2c_0_avalon_slave_arb_share_counter_next_value;
  wire             opencores_i2c_0_avalon_slave_arb_share_set_values;
  wire             opencores_i2c_0_avalon_slave_beginbursttransfer_internal;
  wire             opencores_i2c_0_avalon_slave_begins_xfer;
  wire             opencores_i2c_0_avalon_slave_chipselect;
  wire             opencores_i2c_0_avalon_slave_end_xfer;
  wire             opencores_i2c_0_avalon_slave_firsttransfer;
  wire             opencores_i2c_0_avalon_slave_grant_vector;
  wire             opencores_i2c_0_avalon_slave_in_a_read_cycle;
  wire             opencores_i2c_0_avalon_slave_in_a_write_cycle;
  wire             opencores_i2c_0_avalon_slave_irq_from_sa;
  wire             opencores_i2c_0_avalon_slave_master_qreq_vector;
  wire             opencores_i2c_0_avalon_slave_non_bursting_master_requests;
  wire             opencores_i2c_0_avalon_slave_pretend_byte_enable;
  wire    [  7: 0] opencores_i2c_0_avalon_slave_readdata_from_sa;
  reg              opencores_i2c_0_avalon_slave_reg_firsttransfer;
  wire             opencores_i2c_0_avalon_slave_reset;
  reg              opencores_i2c_0_avalon_slave_slavearbiterlockenable;
  wire             opencores_i2c_0_avalon_slave_slavearbiterlockenable2;
  wire             opencores_i2c_0_avalon_slave_unreg_firsttransfer;
  wire             opencores_i2c_0_avalon_slave_waitrequest_n_from_sa;
  wire             opencores_i2c_0_avalon_slave_waits_for_read;
  wire             opencores_i2c_0_avalon_slave_waits_for_write;
  wire             opencores_i2c_0_avalon_slave_write;
  wire    [  7: 0] opencores_i2c_0_avalon_slave_writedata;
  wire    [ 16: 0] shifted_address_to_opencores_i2c_0_avalon_slave_from_cpu_data_master;
  wire             wait_for_opencores_i2c_0_avalon_slave_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else 
        d1_reasons_to_wait <= ~opencores_i2c_0_avalon_slave_end_xfer;
    end


  assign opencores_i2c_0_avalon_slave_begins_xfer = ~d1_reasons_to_wait & ((cpu_data_master_qualified_request_opencores_i2c_0_avalon_slave));
  //assign opencores_i2c_0_avalon_slave_readdata_from_sa = opencores_i2c_0_avalon_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign opencores_i2c_0_avalon_slave_readdata_from_sa = opencores_i2c_0_avalon_slave_readdata;

  assign cpu_data_master_requests_opencores_i2c_0_avalon_slave = ({cpu_data_master_address_to_slave[16 : 5] , 5'b0} == 17'hc0) & (cpu_data_master_read | cpu_data_master_write);
  //assign opencores_i2c_0_avalon_slave_waitrequest_n_from_sa = opencores_i2c_0_avalon_slave_waitrequest_n so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign opencores_i2c_0_avalon_slave_waitrequest_n_from_sa = opencores_i2c_0_avalon_slave_waitrequest_n;

  //opencores_i2c_0_avalon_slave_arb_share_counter set values, which is an e_mux
  assign opencores_i2c_0_avalon_slave_arb_share_set_values = 1;

  //opencores_i2c_0_avalon_slave_non_bursting_master_requests mux, which is an e_mux
  assign opencores_i2c_0_avalon_slave_non_bursting_master_requests = cpu_data_master_requests_opencores_i2c_0_avalon_slave;

  //opencores_i2c_0_avalon_slave_any_bursting_master_saved_grant mux, which is an e_mux
  assign opencores_i2c_0_avalon_slave_any_bursting_master_saved_grant = 0;

  //opencores_i2c_0_avalon_slave_arb_share_counter_next_value assignment, which is an e_assign
  assign opencores_i2c_0_avalon_slave_arb_share_counter_next_value = opencores_i2c_0_avalon_slave_firsttransfer ? (opencores_i2c_0_avalon_slave_arb_share_set_values - 1) : |opencores_i2c_0_avalon_slave_arb_share_counter ? (opencores_i2c_0_avalon_slave_arb_share_counter - 1) : 0;

  //opencores_i2c_0_avalon_slave_allgrants all slave grants, which is an e_mux
  assign opencores_i2c_0_avalon_slave_allgrants = |opencores_i2c_0_avalon_slave_grant_vector;

  //opencores_i2c_0_avalon_slave_end_xfer assignment, which is an e_assign
  assign opencores_i2c_0_avalon_slave_end_xfer = ~(opencores_i2c_0_avalon_slave_waits_for_read | opencores_i2c_0_avalon_slave_waits_for_write);

  //end_xfer_arb_share_counter_term_opencores_i2c_0_avalon_slave arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_opencores_i2c_0_avalon_slave = opencores_i2c_0_avalon_slave_end_xfer & (~opencores_i2c_0_avalon_slave_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //opencores_i2c_0_avalon_slave_arb_share_counter arbitration counter enable, which is an e_assign
  assign opencores_i2c_0_avalon_slave_arb_counter_enable = (end_xfer_arb_share_counter_term_opencores_i2c_0_avalon_slave & opencores_i2c_0_avalon_slave_allgrants) | (end_xfer_arb_share_counter_term_opencores_i2c_0_avalon_slave & ~opencores_i2c_0_avalon_slave_non_bursting_master_requests);

  //opencores_i2c_0_avalon_slave_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          opencores_i2c_0_avalon_slave_arb_share_counter <= 0;
      else if (opencores_i2c_0_avalon_slave_arb_counter_enable)
          opencores_i2c_0_avalon_slave_arb_share_counter <= opencores_i2c_0_avalon_slave_arb_share_counter_next_value;
    end


  //opencores_i2c_0_avalon_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          opencores_i2c_0_avalon_slave_slavearbiterlockenable <= 0;
      else if ((|opencores_i2c_0_avalon_slave_master_qreq_vector & end_xfer_arb_share_counter_term_opencores_i2c_0_avalon_slave) | (end_xfer_arb_share_counter_term_opencores_i2c_0_avalon_slave & ~opencores_i2c_0_avalon_slave_non_bursting_master_requests))
          opencores_i2c_0_avalon_slave_slavearbiterlockenable <= |opencores_i2c_0_avalon_slave_arb_share_counter_next_value;
    end


  //cpu/data_master opencores_i2c_0/avalon_slave arbiterlock, which is an e_assign
  assign cpu_data_master_arbiterlock = opencores_i2c_0_avalon_slave_slavearbiterlockenable & cpu_data_master_continuerequest;

  //opencores_i2c_0_avalon_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign opencores_i2c_0_avalon_slave_slavearbiterlockenable2 = |opencores_i2c_0_avalon_slave_arb_share_counter_next_value;

  //cpu/data_master opencores_i2c_0/avalon_slave arbiterlock2, which is an e_assign
  assign cpu_data_master_arbiterlock2 = opencores_i2c_0_avalon_slave_slavearbiterlockenable2 & cpu_data_master_continuerequest;

  //opencores_i2c_0_avalon_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  assign opencores_i2c_0_avalon_slave_any_continuerequest = 1;

  //cpu_data_master_continuerequest continued request, which is an e_assign
  assign cpu_data_master_continuerequest = 1;

  assign cpu_data_master_qualified_request_opencores_i2c_0_avalon_slave = cpu_data_master_requests_opencores_i2c_0_avalon_slave & ~((cpu_data_master_read & (~cpu_data_master_waitrequest)) | ((~cpu_data_master_waitrequest) & cpu_data_master_write));
  //opencores_i2c_0_avalon_slave_writedata mux, which is an e_mux
  assign opencores_i2c_0_avalon_slave_writedata = cpu_data_master_writedata;

  //master is always granted when requested
  assign cpu_data_master_granted_opencores_i2c_0_avalon_slave = cpu_data_master_qualified_request_opencores_i2c_0_avalon_slave;

  //cpu/data_master saved-grant opencores_i2c_0/avalon_slave, which is an e_assign
  assign cpu_data_master_saved_grant_opencores_i2c_0_avalon_slave = cpu_data_master_requests_opencores_i2c_0_avalon_slave;

  //allow new arb cycle for opencores_i2c_0/avalon_slave, which is an e_assign
  assign opencores_i2c_0_avalon_slave_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign opencores_i2c_0_avalon_slave_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign opencores_i2c_0_avalon_slave_master_qreq_vector = 1;

  //~opencores_i2c_0_avalon_slave_reset assignment, which is an e_assign
  assign opencores_i2c_0_avalon_slave_reset = ~reset_n;

  assign opencores_i2c_0_avalon_slave_chipselect = cpu_data_master_granted_opencores_i2c_0_avalon_slave;
  //opencores_i2c_0_avalon_slave_firsttransfer first transaction, which is an e_assign
  assign opencores_i2c_0_avalon_slave_firsttransfer = opencores_i2c_0_avalon_slave_begins_xfer ? opencores_i2c_0_avalon_slave_unreg_firsttransfer : opencores_i2c_0_avalon_slave_reg_firsttransfer;

  //opencores_i2c_0_avalon_slave_unreg_firsttransfer first transaction, which is an e_assign
  assign opencores_i2c_0_avalon_slave_unreg_firsttransfer = ~(opencores_i2c_0_avalon_slave_slavearbiterlockenable & opencores_i2c_0_avalon_slave_any_continuerequest);

  //opencores_i2c_0_avalon_slave_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          opencores_i2c_0_avalon_slave_reg_firsttransfer <= 1'b1;
      else if (opencores_i2c_0_avalon_slave_begins_xfer)
          opencores_i2c_0_avalon_slave_reg_firsttransfer <= opencores_i2c_0_avalon_slave_unreg_firsttransfer;
    end


  //opencores_i2c_0_avalon_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign opencores_i2c_0_avalon_slave_beginbursttransfer_internal = opencores_i2c_0_avalon_slave_begins_xfer;

  //opencores_i2c_0_avalon_slave_write assignment, which is an e_mux
  assign opencores_i2c_0_avalon_slave_write = ((cpu_data_master_granted_opencores_i2c_0_avalon_slave & cpu_data_master_write)) & opencores_i2c_0_avalon_slave_pretend_byte_enable;

  assign shifted_address_to_opencores_i2c_0_avalon_slave_from_cpu_data_master = cpu_data_master_address_to_slave;
  //opencores_i2c_0_avalon_slave_address mux, which is an e_mux
  assign opencores_i2c_0_avalon_slave_address = shifted_address_to_opencores_i2c_0_avalon_slave_from_cpu_data_master >> 2;

  //d1_opencores_i2c_0_avalon_slave_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_opencores_i2c_0_avalon_slave_end_xfer <= 1;
      else 
        d1_opencores_i2c_0_avalon_slave_end_xfer <= opencores_i2c_0_avalon_slave_end_xfer;
    end


  //opencores_i2c_0_avalon_slave_waits_for_read in a cycle, which is an e_mux
  assign opencores_i2c_0_avalon_slave_waits_for_read = opencores_i2c_0_avalon_slave_in_a_read_cycle & ~opencores_i2c_0_avalon_slave_waitrequest_n_from_sa;

  //opencores_i2c_0_avalon_slave_in_a_read_cycle assignment, which is an e_assign
  assign opencores_i2c_0_avalon_slave_in_a_read_cycle = cpu_data_master_granted_opencores_i2c_0_avalon_slave & cpu_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = opencores_i2c_0_avalon_slave_in_a_read_cycle;

  //opencores_i2c_0_avalon_slave_waits_for_write in a cycle, which is an e_mux
  assign opencores_i2c_0_avalon_slave_waits_for_write = opencores_i2c_0_avalon_slave_in_a_write_cycle & ~opencores_i2c_0_avalon_slave_waitrequest_n_from_sa;

  //opencores_i2c_0_avalon_slave_in_a_write_cycle assignment, which is an e_assign
  assign opencores_i2c_0_avalon_slave_in_a_write_cycle = cpu_data_master_granted_opencores_i2c_0_avalon_slave & cpu_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = opencores_i2c_0_avalon_slave_in_a_write_cycle;

  assign wait_for_opencores_i2c_0_avalon_slave_counter = 0;
  //opencores_i2c_0_avalon_slave_pretend_byte_enable byte enable port mux, which is an e_mux
  assign opencores_i2c_0_avalon_slave_pretend_byte_enable = (cpu_data_master_granted_opencores_i2c_0_avalon_slave)? cpu_data_master_byteenable :
    -1;

  //assign opencores_i2c_0_avalon_slave_irq_from_sa = opencores_i2c_0_avalon_slave_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign opencores_i2c_0_avalon_slave_irq_from_sa = opencores_i2c_0_avalon_slave_irq;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //opencores_i2c_0/avalon_slave enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else 
        enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module opencores_i2c_1_avalon_slave_arbitrator (
                                                 // inputs:
                                                  clk,
                                                  cpu_data_master_address_to_slave,
                                                  cpu_data_master_byteenable,
                                                  cpu_data_master_read,
                                                  cpu_data_master_waitrequest,
                                                  cpu_data_master_write,
                                                  cpu_data_master_writedata,
                                                  opencores_i2c_1_avalon_slave_irq,
                                                  opencores_i2c_1_avalon_slave_readdata,
                                                  opencores_i2c_1_avalon_slave_waitrequest_n,
                                                  reset_n,

                                                 // outputs:
                                                  cpu_data_master_granted_opencores_i2c_1_avalon_slave,
                                                  cpu_data_master_qualified_request_opencores_i2c_1_avalon_slave,
                                                  cpu_data_master_read_data_valid_opencores_i2c_1_avalon_slave,
                                                  cpu_data_master_requests_opencores_i2c_1_avalon_slave,
                                                  d1_opencores_i2c_1_avalon_slave_end_xfer,
                                                  opencores_i2c_1_avalon_slave_address,
                                                  opencores_i2c_1_avalon_slave_chipselect,
                                                  opencores_i2c_1_avalon_slave_irq_from_sa,
                                                  opencores_i2c_1_avalon_slave_readdata_from_sa,
                                                  opencores_i2c_1_avalon_slave_reset,
                                                  opencores_i2c_1_avalon_slave_waitrequest_n_from_sa,
                                                  opencores_i2c_1_avalon_slave_write,
                                                  opencores_i2c_1_avalon_slave_writedata
                                               )
;

  output           cpu_data_master_granted_opencores_i2c_1_avalon_slave;
  output           cpu_data_master_qualified_request_opencores_i2c_1_avalon_slave;
  output           cpu_data_master_read_data_valid_opencores_i2c_1_avalon_slave;
  output           cpu_data_master_requests_opencores_i2c_1_avalon_slave;
  output           d1_opencores_i2c_1_avalon_slave_end_xfer;
  output  [  2: 0] opencores_i2c_1_avalon_slave_address;
  output           opencores_i2c_1_avalon_slave_chipselect;
  output           opencores_i2c_1_avalon_slave_irq_from_sa;
  output  [  7: 0] opencores_i2c_1_avalon_slave_readdata_from_sa;
  output           opencores_i2c_1_avalon_slave_reset;
  output           opencores_i2c_1_avalon_slave_waitrequest_n_from_sa;
  output           opencores_i2c_1_avalon_slave_write;
  output  [  7: 0] opencores_i2c_1_avalon_slave_writedata;
  input            clk;
  input   [ 16: 0] cpu_data_master_address_to_slave;
  input   [  3: 0] cpu_data_master_byteenable;
  input            cpu_data_master_read;
  input            cpu_data_master_waitrequest;
  input            cpu_data_master_write;
  input   [ 31: 0] cpu_data_master_writedata;
  input            opencores_i2c_1_avalon_slave_irq;
  input   [  7: 0] opencores_i2c_1_avalon_slave_readdata;
  input            opencores_i2c_1_avalon_slave_waitrequest_n;
  input            reset_n;

  wire             cpu_data_master_arbiterlock;
  wire             cpu_data_master_arbiterlock2;
  wire             cpu_data_master_continuerequest;
  wire             cpu_data_master_granted_opencores_i2c_1_avalon_slave;
  wire             cpu_data_master_qualified_request_opencores_i2c_1_avalon_slave;
  wire             cpu_data_master_read_data_valid_opencores_i2c_1_avalon_slave;
  wire             cpu_data_master_requests_opencores_i2c_1_avalon_slave;
  wire             cpu_data_master_saved_grant_opencores_i2c_1_avalon_slave;
  reg              d1_opencores_i2c_1_avalon_slave_end_xfer;
  reg              d1_reasons_to_wait;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_opencores_i2c_1_avalon_slave;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [  2: 0] opencores_i2c_1_avalon_slave_address;
  wire             opencores_i2c_1_avalon_slave_allgrants;
  wire             opencores_i2c_1_avalon_slave_allow_new_arb_cycle;
  wire             opencores_i2c_1_avalon_slave_any_bursting_master_saved_grant;
  wire             opencores_i2c_1_avalon_slave_any_continuerequest;
  wire             opencores_i2c_1_avalon_slave_arb_counter_enable;
  reg              opencores_i2c_1_avalon_slave_arb_share_counter;
  wire             opencores_i2c_1_avalon_slave_arb_share_counter_next_value;
  wire             opencores_i2c_1_avalon_slave_arb_share_set_values;
  wire             opencores_i2c_1_avalon_slave_beginbursttransfer_internal;
  wire             opencores_i2c_1_avalon_slave_begins_xfer;
  wire             opencores_i2c_1_avalon_slave_chipselect;
  wire             opencores_i2c_1_avalon_slave_end_xfer;
  wire             opencores_i2c_1_avalon_slave_firsttransfer;
  wire             opencores_i2c_1_avalon_slave_grant_vector;
  wire             opencores_i2c_1_avalon_slave_in_a_read_cycle;
  wire             opencores_i2c_1_avalon_slave_in_a_write_cycle;
  wire             opencores_i2c_1_avalon_slave_irq_from_sa;
  wire             opencores_i2c_1_avalon_slave_master_qreq_vector;
  wire             opencores_i2c_1_avalon_slave_non_bursting_master_requests;
  wire             opencores_i2c_1_avalon_slave_pretend_byte_enable;
  wire    [  7: 0] opencores_i2c_1_avalon_slave_readdata_from_sa;
  reg              opencores_i2c_1_avalon_slave_reg_firsttransfer;
  wire             opencores_i2c_1_avalon_slave_reset;
  reg              opencores_i2c_1_avalon_slave_slavearbiterlockenable;
  wire             opencores_i2c_1_avalon_slave_slavearbiterlockenable2;
  wire             opencores_i2c_1_avalon_slave_unreg_firsttransfer;
  wire             opencores_i2c_1_avalon_slave_waitrequest_n_from_sa;
  wire             opencores_i2c_1_avalon_slave_waits_for_read;
  wire             opencores_i2c_1_avalon_slave_waits_for_write;
  wire             opencores_i2c_1_avalon_slave_write;
  wire    [  7: 0] opencores_i2c_1_avalon_slave_writedata;
  wire    [ 16: 0] shifted_address_to_opencores_i2c_1_avalon_slave_from_cpu_data_master;
  wire             wait_for_opencores_i2c_1_avalon_slave_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else 
        d1_reasons_to_wait <= ~opencores_i2c_1_avalon_slave_end_xfer;
    end


  assign opencores_i2c_1_avalon_slave_begins_xfer = ~d1_reasons_to_wait & ((cpu_data_master_qualified_request_opencores_i2c_1_avalon_slave));
  //assign opencores_i2c_1_avalon_slave_readdata_from_sa = opencores_i2c_1_avalon_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign opencores_i2c_1_avalon_slave_readdata_from_sa = opencores_i2c_1_avalon_slave_readdata;

  assign cpu_data_master_requests_opencores_i2c_1_avalon_slave = ({cpu_data_master_address_to_slave[16 : 5] , 5'b0} == 17'he0) & (cpu_data_master_read | cpu_data_master_write);
  //assign opencores_i2c_1_avalon_slave_waitrequest_n_from_sa = opencores_i2c_1_avalon_slave_waitrequest_n so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign opencores_i2c_1_avalon_slave_waitrequest_n_from_sa = opencores_i2c_1_avalon_slave_waitrequest_n;

  //opencores_i2c_1_avalon_slave_arb_share_counter set values, which is an e_mux
  assign opencores_i2c_1_avalon_slave_arb_share_set_values = 1;

  //opencores_i2c_1_avalon_slave_non_bursting_master_requests mux, which is an e_mux
  assign opencores_i2c_1_avalon_slave_non_bursting_master_requests = cpu_data_master_requests_opencores_i2c_1_avalon_slave;

  //opencores_i2c_1_avalon_slave_any_bursting_master_saved_grant mux, which is an e_mux
  assign opencores_i2c_1_avalon_slave_any_bursting_master_saved_grant = 0;

  //opencores_i2c_1_avalon_slave_arb_share_counter_next_value assignment, which is an e_assign
  assign opencores_i2c_1_avalon_slave_arb_share_counter_next_value = opencores_i2c_1_avalon_slave_firsttransfer ? (opencores_i2c_1_avalon_slave_arb_share_set_values - 1) : |opencores_i2c_1_avalon_slave_arb_share_counter ? (opencores_i2c_1_avalon_slave_arb_share_counter - 1) : 0;

  //opencores_i2c_1_avalon_slave_allgrants all slave grants, which is an e_mux
  assign opencores_i2c_1_avalon_slave_allgrants = |opencores_i2c_1_avalon_slave_grant_vector;

  //opencores_i2c_1_avalon_slave_end_xfer assignment, which is an e_assign
  assign opencores_i2c_1_avalon_slave_end_xfer = ~(opencores_i2c_1_avalon_slave_waits_for_read | opencores_i2c_1_avalon_slave_waits_for_write);

  //end_xfer_arb_share_counter_term_opencores_i2c_1_avalon_slave arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_opencores_i2c_1_avalon_slave = opencores_i2c_1_avalon_slave_end_xfer & (~opencores_i2c_1_avalon_slave_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //opencores_i2c_1_avalon_slave_arb_share_counter arbitration counter enable, which is an e_assign
  assign opencores_i2c_1_avalon_slave_arb_counter_enable = (end_xfer_arb_share_counter_term_opencores_i2c_1_avalon_slave & opencores_i2c_1_avalon_slave_allgrants) | (end_xfer_arb_share_counter_term_opencores_i2c_1_avalon_slave & ~opencores_i2c_1_avalon_slave_non_bursting_master_requests);

  //opencores_i2c_1_avalon_slave_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          opencores_i2c_1_avalon_slave_arb_share_counter <= 0;
      else if (opencores_i2c_1_avalon_slave_arb_counter_enable)
          opencores_i2c_1_avalon_slave_arb_share_counter <= opencores_i2c_1_avalon_slave_arb_share_counter_next_value;
    end


  //opencores_i2c_1_avalon_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          opencores_i2c_1_avalon_slave_slavearbiterlockenable <= 0;
      else if ((|opencores_i2c_1_avalon_slave_master_qreq_vector & end_xfer_arb_share_counter_term_opencores_i2c_1_avalon_slave) | (end_xfer_arb_share_counter_term_opencores_i2c_1_avalon_slave & ~opencores_i2c_1_avalon_slave_non_bursting_master_requests))
          opencores_i2c_1_avalon_slave_slavearbiterlockenable <= |opencores_i2c_1_avalon_slave_arb_share_counter_next_value;
    end


  //cpu/data_master opencores_i2c_1/avalon_slave arbiterlock, which is an e_assign
  assign cpu_data_master_arbiterlock = opencores_i2c_1_avalon_slave_slavearbiterlockenable & cpu_data_master_continuerequest;

  //opencores_i2c_1_avalon_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign opencores_i2c_1_avalon_slave_slavearbiterlockenable2 = |opencores_i2c_1_avalon_slave_arb_share_counter_next_value;

  //cpu/data_master opencores_i2c_1/avalon_slave arbiterlock2, which is an e_assign
  assign cpu_data_master_arbiterlock2 = opencores_i2c_1_avalon_slave_slavearbiterlockenable2 & cpu_data_master_continuerequest;

  //opencores_i2c_1_avalon_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  assign opencores_i2c_1_avalon_slave_any_continuerequest = 1;

  //cpu_data_master_continuerequest continued request, which is an e_assign
  assign cpu_data_master_continuerequest = 1;

  assign cpu_data_master_qualified_request_opencores_i2c_1_avalon_slave = cpu_data_master_requests_opencores_i2c_1_avalon_slave & ~((cpu_data_master_read & (~cpu_data_master_waitrequest)) | ((~cpu_data_master_waitrequest) & cpu_data_master_write));
  //opencores_i2c_1_avalon_slave_writedata mux, which is an e_mux
  assign opencores_i2c_1_avalon_slave_writedata = cpu_data_master_writedata;

  //master is always granted when requested
  assign cpu_data_master_granted_opencores_i2c_1_avalon_slave = cpu_data_master_qualified_request_opencores_i2c_1_avalon_slave;

  //cpu/data_master saved-grant opencores_i2c_1/avalon_slave, which is an e_assign
  assign cpu_data_master_saved_grant_opencores_i2c_1_avalon_slave = cpu_data_master_requests_opencores_i2c_1_avalon_slave;

  //allow new arb cycle for opencores_i2c_1/avalon_slave, which is an e_assign
  assign opencores_i2c_1_avalon_slave_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign opencores_i2c_1_avalon_slave_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign opencores_i2c_1_avalon_slave_master_qreq_vector = 1;

  //~opencores_i2c_1_avalon_slave_reset assignment, which is an e_assign
  assign opencores_i2c_1_avalon_slave_reset = ~reset_n;

  assign opencores_i2c_1_avalon_slave_chipselect = cpu_data_master_granted_opencores_i2c_1_avalon_slave;
  //opencores_i2c_1_avalon_slave_firsttransfer first transaction, which is an e_assign
  assign opencores_i2c_1_avalon_slave_firsttransfer = opencores_i2c_1_avalon_slave_begins_xfer ? opencores_i2c_1_avalon_slave_unreg_firsttransfer : opencores_i2c_1_avalon_slave_reg_firsttransfer;

  //opencores_i2c_1_avalon_slave_unreg_firsttransfer first transaction, which is an e_assign
  assign opencores_i2c_1_avalon_slave_unreg_firsttransfer = ~(opencores_i2c_1_avalon_slave_slavearbiterlockenable & opencores_i2c_1_avalon_slave_any_continuerequest);

  //opencores_i2c_1_avalon_slave_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          opencores_i2c_1_avalon_slave_reg_firsttransfer <= 1'b1;
      else if (opencores_i2c_1_avalon_slave_begins_xfer)
          opencores_i2c_1_avalon_slave_reg_firsttransfer <= opencores_i2c_1_avalon_slave_unreg_firsttransfer;
    end


  //opencores_i2c_1_avalon_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign opencores_i2c_1_avalon_slave_beginbursttransfer_internal = opencores_i2c_1_avalon_slave_begins_xfer;

  //opencores_i2c_1_avalon_slave_write assignment, which is an e_mux
  assign opencores_i2c_1_avalon_slave_write = ((cpu_data_master_granted_opencores_i2c_1_avalon_slave & cpu_data_master_write)) & opencores_i2c_1_avalon_slave_pretend_byte_enable;

  assign shifted_address_to_opencores_i2c_1_avalon_slave_from_cpu_data_master = cpu_data_master_address_to_slave;
  //opencores_i2c_1_avalon_slave_address mux, which is an e_mux
  assign opencores_i2c_1_avalon_slave_address = shifted_address_to_opencores_i2c_1_avalon_slave_from_cpu_data_master >> 2;

  //d1_opencores_i2c_1_avalon_slave_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_opencores_i2c_1_avalon_slave_end_xfer <= 1;
      else 
        d1_opencores_i2c_1_avalon_slave_end_xfer <= opencores_i2c_1_avalon_slave_end_xfer;
    end


  //opencores_i2c_1_avalon_slave_waits_for_read in a cycle, which is an e_mux
  assign opencores_i2c_1_avalon_slave_waits_for_read = opencores_i2c_1_avalon_slave_in_a_read_cycle & ~opencores_i2c_1_avalon_slave_waitrequest_n_from_sa;

  //opencores_i2c_1_avalon_slave_in_a_read_cycle assignment, which is an e_assign
  assign opencores_i2c_1_avalon_slave_in_a_read_cycle = cpu_data_master_granted_opencores_i2c_1_avalon_slave & cpu_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = opencores_i2c_1_avalon_slave_in_a_read_cycle;

  //opencores_i2c_1_avalon_slave_waits_for_write in a cycle, which is an e_mux
  assign opencores_i2c_1_avalon_slave_waits_for_write = opencores_i2c_1_avalon_slave_in_a_write_cycle & ~opencores_i2c_1_avalon_slave_waitrequest_n_from_sa;

  //opencores_i2c_1_avalon_slave_in_a_write_cycle assignment, which is an e_assign
  assign opencores_i2c_1_avalon_slave_in_a_write_cycle = cpu_data_master_granted_opencores_i2c_1_avalon_slave & cpu_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = opencores_i2c_1_avalon_slave_in_a_write_cycle;

  assign wait_for_opencores_i2c_1_avalon_slave_counter = 0;
  //opencores_i2c_1_avalon_slave_pretend_byte_enable byte enable port mux, which is an e_mux
  assign opencores_i2c_1_avalon_slave_pretend_byte_enable = (cpu_data_master_granted_opencores_i2c_1_avalon_slave)? cpu_data_master_byteenable :
    -1;

  //assign opencores_i2c_1_avalon_slave_irq_from_sa = opencores_i2c_1_avalon_slave_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign opencores_i2c_1_avalon_slave_irq_from_sa = opencores_i2c_1_avalon_slave_irq;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //opencores_i2c_1/avalon_slave enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else 
        enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module spi_0_p0_spi_control_port_arbitrator (
                                              // inputs:
                                               clk,
                                               cpu_data_master_address_to_slave,
                                               cpu_data_master_read,
                                               cpu_data_master_write,
                                               cpu_data_master_writedata,
                                               reset_n,
                                               spi_0_p0_spi_control_port_dataavailable,
                                               spi_0_p0_spi_control_port_endofpacket,
                                               spi_0_p0_spi_control_port_irq,
                                               spi_0_p0_spi_control_port_readdata,
                                               spi_0_p0_spi_control_port_readyfordata,

                                              // outputs:
                                               cpu_data_master_granted_spi_0_p0_spi_control_port,
                                               cpu_data_master_qualified_request_spi_0_p0_spi_control_port,
                                               cpu_data_master_read_data_valid_spi_0_p0_spi_control_port,
                                               cpu_data_master_requests_spi_0_p0_spi_control_port,
                                               d1_spi_0_p0_spi_control_port_end_xfer,
                                               spi_0_p0_spi_control_port_address,
                                               spi_0_p0_spi_control_port_chipselect,
                                               spi_0_p0_spi_control_port_dataavailable_from_sa,
                                               spi_0_p0_spi_control_port_endofpacket_from_sa,
                                               spi_0_p0_spi_control_port_irq_from_sa,
                                               spi_0_p0_spi_control_port_read_n,
                                               spi_0_p0_spi_control_port_readdata_from_sa,
                                               spi_0_p0_spi_control_port_readyfordata_from_sa,
                                               spi_0_p0_spi_control_port_reset_n,
                                               spi_0_p0_spi_control_port_write_n,
                                               spi_0_p0_spi_control_port_writedata
                                            )
;

  output           cpu_data_master_granted_spi_0_p0_spi_control_port;
  output           cpu_data_master_qualified_request_spi_0_p0_spi_control_port;
  output           cpu_data_master_read_data_valid_spi_0_p0_spi_control_port;
  output           cpu_data_master_requests_spi_0_p0_spi_control_port;
  output           d1_spi_0_p0_spi_control_port_end_xfer;
  output  [  2: 0] spi_0_p0_spi_control_port_address;
  output           spi_0_p0_spi_control_port_chipselect;
  output           spi_0_p0_spi_control_port_dataavailable_from_sa;
  output           spi_0_p0_spi_control_port_endofpacket_from_sa;
  output           spi_0_p0_spi_control_port_irq_from_sa;
  output           spi_0_p0_spi_control_port_read_n;
  output  [ 15: 0] spi_0_p0_spi_control_port_readdata_from_sa;
  output           spi_0_p0_spi_control_port_readyfordata_from_sa;
  output           spi_0_p0_spi_control_port_reset_n;
  output           spi_0_p0_spi_control_port_write_n;
  output  [ 15: 0] spi_0_p0_spi_control_port_writedata;
  input            clk;
  input   [ 16: 0] cpu_data_master_address_to_slave;
  input            cpu_data_master_read;
  input            cpu_data_master_write;
  input   [ 31: 0] cpu_data_master_writedata;
  input            reset_n;
  input            spi_0_p0_spi_control_port_dataavailable;
  input            spi_0_p0_spi_control_port_endofpacket;
  input            spi_0_p0_spi_control_port_irq;
  input   [ 15: 0] spi_0_p0_spi_control_port_readdata;
  input            spi_0_p0_spi_control_port_readyfordata;

  wire             cpu_data_master_arbiterlock;
  wire             cpu_data_master_arbiterlock2;
  wire             cpu_data_master_continuerequest;
  wire             cpu_data_master_granted_spi_0_p0_spi_control_port;
  wire             cpu_data_master_qualified_request_spi_0_p0_spi_control_port;
  wire             cpu_data_master_read_data_valid_spi_0_p0_spi_control_port;
  wire             cpu_data_master_requests_spi_0_p0_spi_control_port;
  wire             cpu_data_master_saved_grant_spi_0_p0_spi_control_port;
  reg              d1_reasons_to_wait;
  reg              d1_spi_0_p0_spi_control_port_end_xfer;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_spi_0_p0_spi_control_port;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [ 16: 0] shifted_address_to_spi_0_p0_spi_control_port_from_cpu_data_master;
  wire    [  2: 0] spi_0_p0_spi_control_port_address;
  wire             spi_0_p0_spi_control_port_allgrants;
  wire             spi_0_p0_spi_control_port_allow_new_arb_cycle;
  wire             spi_0_p0_spi_control_port_any_bursting_master_saved_grant;
  wire             spi_0_p0_spi_control_port_any_continuerequest;
  wire             spi_0_p0_spi_control_port_arb_counter_enable;
  reg              spi_0_p0_spi_control_port_arb_share_counter;
  wire             spi_0_p0_spi_control_port_arb_share_counter_next_value;
  wire             spi_0_p0_spi_control_port_arb_share_set_values;
  wire             spi_0_p0_spi_control_port_beginbursttransfer_internal;
  wire             spi_0_p0_spi_control_port_begins_xfer;
  wire             spi_0_p0_spi_control_port_chipselect;
  wire             spi_0_p0_spi_control_port_dataavailable_from_sa;
  wire             spi_0_p0_spi_control_port_end_xfer;
  wire             spi_0_p0_spi_control_port_endofpacket_from_sa;
  wire             spi_0_p0_spi_control_port_firsttransfer;
  wire             spi_0_p0_spi_control_port_grant_vector;
  wire             spi_0_p0_spi_control_port_in_a_read_cycle;
  wire             spi_0_p0_spi_control_port_in_a_write_cycle;
  wire             spi_0_p0_spi_control_port_irq_from_sa;
  wire             spi_0_p0_spi_control_port_master_qreq_vector;
  wire             spi_0_p0_spi_control_port_non_bursting_master_requests;
  wire             spi_0_p0_spi_control_port_read_n;
  wire    [ 15: 0] spi_0_p0_spi_control_port_readdata_from_sa;
  wire             spi_0_p0_spi_control_port_readyfordata_from_sa;
  reg              spi_0_p0_spi_control_port_reg_firsttransfer;
  wire             spi_0_p0_spi_control_port_reset_n;
  reg              spi_0_p0_spi_control_port_slavearbiterlockenable;
  wire             spi_0_p0_spi_control_port_slavearbiterlockenable2;
  wire             spi_0_p0_spi_control_port_unreg_firsttransfer;
  wire             spi_0_p0_spi_control_port_waits_for_read;
  wire             spi_0_p0_spi_control_port_waits_for_write;
  wire             spi_0_p0_spi_control_port_write_n;
  wire    [ 15: 0] spi_0_p0_spi_control_port_writedata;
  wire             wait_for_spi_0_p0_spi_control_port_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else 
        d1_reasons_to_wait <= ~spi_0_p0_spi_control_port_end_xfer;
    end


  assign spi_0_p0_spi_control_port_begins_xfer = ~d1_reasons_to_wait & ((cpu_data_master_qualified_request_spi_0_p0_spi_control_port));
  //assign spi_0_p0_spi_control_port_readdata_from_sa = spi_0_p0_spi_control_port_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_0_p0_spi_control_port_readdata_from_sa = spi_0_p0_spi_control_port_readdata;

  assign cpu_data_master_requests_spi_0_p0_spi_control_port = ({cpu_data_master_address_to_slave[16 : 5] , 5'b0} == 17'h2000) & (cpu_data_master_read | cpu_data_master_write);
  //assign spi_0_p0_spi_control_port_dataavailable_from_sa = spi_0_p0_spi_control_port_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_0_p0_spi_control_port_dataavailable_from_sa = spi_0_p0_spi_control_port_dataavailable;

  //assign spi_0_p0_spi_control_port_readyfordata_from_sa = spi_0_p0_spi_control_port_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_0_p0_spi_control_port_readyfordata_from_sa = spi_0_p0_spi_control_port_readyfordata;

  //spi_0_p0_spi_control_port_arb_share_counter set values, which is an e_mux
  assign spi_0_p0_spi_control_port_arb_share_set_values = 1;

  //spi_0_p0_spi_control_port_non_bursting_master_requests mux, which is an e_mux
  assign spi_0_p0_spi_control_port_non_bursting_master_requests = cpu_data_master_requests_spi_0_p0_spi_control_port;

  //spi_0_p0_spi_control_port_any_bursting_master_saved_grant mux, which is an e_mux
  assign spi_0_p0_spi_control_port_any_bursting_master_saved_grant = 0;

  //spi_0_p0_spi_control_port_arb_share_counter_next_value assignment, which is an e_assign
  assign spi_0_p0_spi_control_port_arb_share_counter_next_value = spi_0_p0_spi_control_port_firsttransfer ? (spi_0_p0_spi_control_port_arb_share_set_values - 1) : |spi_0_p0_spi_control_port_arb_share_counter ? (spi_0_p0_spi_control_port_arb_share_counter - 1) : 0;

  //spi_0_p0_spi_control_port_allgrants all slave grants, which is an e_mux
  assign spi_0_p0_spi_control_port_allgrants = |spi_0_p0_spi_control_port_grant_vector;

  //spi_0_p0_spi_control_port_end_xfer assignment, which is an e_assign
  assign spi_0_p0_spi_control_port_end_xfer = ~(spi_0_p0_spi_control_port_waits_for_read | spi_0_p0_spi_control_port_waits_for_write);

  //end_xfer_arb_share_counter_term_spi_0_p0_spi_control_port arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_spi_0_p0_spi_control_port = spi_0_p0_spi_control_port_end_xfer & (~spi_0_p0_spi_control_port_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //spi_0_p0_spi_control_port_arb_share_counter arbitration counter enable, which is an e_assign
  assign spi_0_p0_spi_control_port_arb_counter_enable = (end_xfer_arb_share_counter_term_spi_0_p0_spi_control_port & spi_0_p0_spi_control_port_allgrants) | (end_xfer_arb_share_counter_term_spi_0_p0_spi_control_port & ~spi_0_p0_spi_control_port_non_bursting_master_requests);

  //spi_0_p0_spi_control_port_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          spi_0_p0_spi_control_port_arb_share_counter <= 0;
      else if (spi_0_p0_spi_control_port_arb_counter_enable)
          spi_0_p0_spi_control_port_arb_share_counter <= spi_0_p0_spi_control_port_arb_share_counter_next_value;
    end


  //spi_0_p0_spi_control_port_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          spi_0_p0_spi_control_port_slavearbiterlockenable <= 0;
      else if ((|spi_0_p0_spi_control_port_master_qreq_vector & end_xfer_arb_share_counter_term_spi_0_p0_spi_control_port) | (end_xfer_arb_share_counter_term_spi_0_p0_spi_control_port & ~spi_0_p0_spi_control_port_non_bursting_master_requests))
          spi_0_p0_spi_control_port_slavearbiterlockenable <= |spi_0_p0_spi_control_port_arb_share_counter_next_value;
    end


  //cpu/data_master spi_0_p0/spi_control_port arbiterlock, which is an e_assign
  assign cpu_data_master_arbiterlock = spi_0_p0_spi_control_port_slavearbiterlockenable & cpu_data_master_continuerequest;

  //spi_0_p0_spi_control_port_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign spi_0_p0_spi_control_port_slavearbiterlockenable2 = |spi_0_p0_spi_control_port_arb_share_counter_next_value;

  //cpu/data_master spi_0_p0/spi_control_port arbiterlock2, which is an e_assign
  assign cpu_data_master_arbiterlock2 = spi_0_p0_spi_control_port_slavearbiterlockenable2 & cpu_data_master_continuerequest;

  //spi_0_p0_spi_control_port_any_continuerequest at least one master continues requesting, which is an e_assign
  assign spi_0_p0_spi_control_port_any_continuerequest = 1;

  //cpu_data_master_continuerequest continued request, which is an e_assign
  assign cpu_data_master_continuerequest = 1;

  assign cpu_data_master_qualified_request_spi_0_p0_spi_control_port = cpu_data_master_requests_spi_0_p0_spi_control_port;
  //spi_0_p0_spi_control_port_writedata mux, which is an e_mux
  assign spi_0_p0_spi_control_port_writedata = cpu_data_master_writedata;

  //assign spi_0_p0_spi_control_port_endofpacket_from_sa = spi_0_p0_spi_control_port_endofpacket so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_0_p0_spi_control_port_endofpacket_from_sa = spi_0_p0_spi_control_port_endofpacket;

  //master is always granted when requested
  assign cpu_data_master_granted_spi_0_p0_spi_control_port = cpu_data_master_qualified_request_spi_0_p0_spi_control_port;

  //cpu/data_master saved-grant spi_0_p0/spi_control_port, which is an e_assign
  assign cpu_data_master_saved_grant_spi_0_p0_spi_control_port = cpu_data_master_requests_spi_0_p0_spi_control_port;

  //allow new arb cycle for spi_0_p0/spi_control_port, which is an e_assign
  assign spi_0_p0_spi_control_port_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign spi_0_p0_spi_control_port_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign spi_0_p0_spi_control_port_master_qreq_vector = 1;

  //spi_0_p0_spi_control_port_reset_n assignment, which is an e_assign
  assign spi_0_p0_spi_control_port_reset_n = reset_n;

  assign spi_0_p0_spi_control_port_chipselect = cpu_data_master_granted_spi_0_p0_spi_control_port;
  //spi_0_p0_spi_control_port_firsttransfer first transaction, which is an e_assign
  assign spi_0_p0_spi_control_port_firsttransfer = spi_0_p0_spi_control_port_begins_xfer ? spi_0_p0_spi_control_port_unreg_firsttransfer : spi_0_p0_spi_control_port_reg_firsttransfer;

  //spi_0_p0_spi_control_port_unreg_firsttransfer first transaction, which is an e_assign
  assign spi_0_p0_spi_control_port_unreg_firsttransfer = ~(spi_0_p0_spi_control_port_slavearbiterlockenable & spi_0_p0_spi_control_port_any_continuerequest);

  //spi_0_p0_spi_control_port_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          spi_0_p0_spi_control_port_reg_firsttransfer <= 1'b1;
      else if (spi_0_p0_spi_control_port_begins_xfer)
          spi_0_p0_spi_control_port_reg_firsttransfer <= spi_0_p0_spi_control_port_unreg_firsttransfer;
    end


  //spi_0_p0_spi_control_port_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign spi_0_p0_spi_control_port_beginbursttransfer_internal = spi_0_p0_spi_control_port_begins_xfer;

  //~spi_0_p0_spi_control_port_read_n assignment, which is an e_mux
  assign spi_0_p0_spi_control_port_read_n = ~(cpu_data_master_granted_spi_0_p0_spi_control_port & cpu_data_master_read);

  //~spi_0_p0_spi_control_port_write_n assignment, which is an e_mux
  assign spi_0_p0_spi_control_port_write_n = ~(cpu_data_master_granted_spi_0_p0_spi_control_port & cpu_data_master_write);

  assign shifted_address_to_spi_0_p0_spi_control_port_from_cpu_data_master = cpu_data_master_address_to_slave;
  //spi_0_p0_spi_control_port_address mux, which is an e_mux
  assign spi_0_p0_spi_control_port_address = shifted_address_to_spi_0_p0_spi_control_port_from_cpu_data_master >> 2;

  //d1_spi_0_p0_spi_control_port_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_spi_0_p0_spi_control_port_end_xfer <= 1;
      else 
        d1_spi_0_p0_spi_control_port_end_xfer <= spi_0_p0_spi_control_port_end_xfer;
    end


  //spi_0_p0_spi_control_port_waits_for_read in a cycle, which is an e_mux
  assign spi_0_p0_spi_control_port_waits_for_read = spi_0_p0_spi_control_port_in_a_read_cycle & spi_0_p0_spi_control_port_begins_xfer;

  //spi_0_p0_spi_control_port_in_a_read_cycle assignment, which is an e_assign
  assign spi_0_p0_spi_control_port_in_a_read_cycle = cpu_data_master_granted_spi_0_p0_spi_control_port & cpu_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = spi_0_p0_spi_control_port_in_a_read_cycle;

  //spi_0_p0_spi_control_port_waits_for_write in a cycle, which is an e_mux
  assign spi_0_p0_spi_control_port_waits_for_write = spi_0_p0_spi_control_port_in_a_write_cycle & spi_0_p0_spi_control_port_begins_xfer;

  //spi_0_p0_spi_control_port_in_a_write_cycle assignment, which is an e_assign
  assign spi_0_p0_spi_control_port_in_a_write_cycle = cpu_data_master_granted_spi_0_p0_spi_control_port & cpu_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = spi_0_p0_spi_control_port_in_a_write_cycle;

  assign wait_for_spi_0_p0_spi_control_port_counter = 0;
  //assign spi_0_p0_spi_control_port_irq_from_sa = spi_0_p0_spi_control_port_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_0_p0_spi_control_port_irq_from_sa = spi_0_p0_spi_control_port_irq;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //spi_0_p0/spi_control_port enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else 
        enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module spi_0_p1_spi_control_port_arbitrator (
                                              // inputs:
                                               clk,
                                               cpu_data_master_address_to_slave,
                                               cpu_data_master_read,
                                               cpu_data_master_write,
                                               cpu_data_master_writedata,
                                               reset_n,
                                               spi_0_p1_spi_control_port_dataavailable,
                                               spi_0_p1_spi_control_port_endofpacket,
                                               spi_0_p1_spi_control_port_irq,
                                               spi_0_p1_spi_control_port_readdata,
                                               spi_0_p1_spi_control_port_readyfordata,

                                              // outputs:
                                               cpu_data_master_granted_spi_0_p1_spi_control_port,
                                               cpu_data_master_qualified_request_spi_0_p1_spi_control_port,
                                               cpu_data_master_read_data_valid_spi_0_p1_spi_control_port,
                                               cpu_data_master_requests_spi_0_p1_spi_control_port,
                                               d1_spi_0_p1_spi_control_port_end_xfer,
                                               spi_0_p1_spi_control_port_address,
                                               spi_0_p1_spi_control_port_chipselect,
                                               spi_0_p1_spi_control_port_dataavailable_from_sa,
                                               spi_0_p1_spi_control_port_endofpacket_from_sa,
                                               spi_0_p1_spi_control_port_irq_from_sa,
                                               spi_0_p1_spi_control_port_read_n,
                                               spi_0_p1_spi_control_port_readdata_from_sa,
                                               spi_0_p1_spi_control_port_readyfordata_from_sa,
                                               spi_0_p1_spi_control_port_reset_n,
                                               spi_0_p1_spi_control_port_write_n,
                                               spi_0_p1_spi_control_port_writedata
                                            )
;

  output           cpu_data_master_granted_spi_0_p1_spi_control_port;
  output           cpu_data_master_qualified_request_spi_0_p1_spi_control_port;
  output           cpu_data_master_read_data_valid_spi_0_p1_spi_control_port;
  output           cpu_data_master_requests_spi_0_p1_spi_control_port;
  output           d1_spi_0_p1_spi_control_port_end_xfer;
  output  [  2: 0] spi_0_p1_spi_control_port_address;
  output           spi_0_p1_spi_control_port_chipselect;
  output           spi_0_p1_spi_control_port_dataavailable_from_sa;
  output           spi_0_p1_spi_control_port_endofpacket_from_sa;
  output           spi_0_p1_spi_control_port_irq_from_sa;
  output           spi_0_p1_spi_control_port_read_n;
  output  [ 15: 0] spi_0_p1_spi_control_port_readdata_from_sa;
  output           spi_0_p1_spi_control_port_readyfordata_from_sa;
  output           spi_0_p1_spi_control_port_reset_n;
  output           spi_0_p1_spi_control_port_write_n;
  output  [ 15: 0] spi_0_p1_spi_control_port_writedata;
  input            clk;
  input   [ 16: 0] cpu_data_master_address_to_slave;
  input            cpu_data_master_read;
  input            cpu_data_master_write;
  input   [ 31: 0] cpu_data_master_writedata;
  input            reset_n;
  input            spi_0_p1_spi_control_port_dataavailable;
  input            spi_0_p1_spi_control_port_endofpacket;
  input            spi_0_p1_spi_control_port_irq;
  input   [ 15: 0] spi_0_p1_spi_control_port_readdata;
  input            spi_0_p1_spi_control_port_readyfordata;

  wire             cpu_data_master_arbiterlock;
  wire             cpu_data_master_arbiterlock2;
  wire             cpu_data_master_continuerequest;
  wire             cpu_data_master_granted_spi_0_p1_spi_control_port;
  wire             cpu_data_master_qualified_request_spi_0_p1_spi_control_port;
  wire             cpu_data_master_read_data_valid_spi_0_p1_spi_control_port;
  wire             cpu_data_master_requests_spi_0_p1_spi_control_port;
  wire             cpu_data_master_saved_grant_spi_0_p1_spi_control_port;
  reg              d1_reasons_to_wait;
  reg              d1_spi_0_p1_spi_control_port_end_xfer;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_spi_0_p1_spi_control_port;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [ 16: 0] shifted_address_to_spi_0_p1_spi_control_port_from_cpu_data_master;
  wire    [  2: 0] spi_0_p1_spi_control_port_address;
  wire             spi_0_p1_spi_control_port_allgrants;
  wire             spi_0_p1_spi_control_port_allow_new_arb_cycle;
  wire             spi_0_p1_spi_control_port_any_bursting_master_saved_grant;
  wire             spi_0_p1_spi_control_port_any_continuerequest;
  wire             spi_0_p1_spi_control_port_arb_counter_enable;
  reg              spi_0_p1_spi_control_port_arb_share_counter;
  wire             spi_0_p1_spi_control_port_arb_share_counter_next_value;
  wire             spi_0_p1_spi_control_port_arb_share_set_values;
  wire             spi_0_p1_spi_control_port_beginbursttransfer_internal;
  wire             spi_0_p1_spi_control_port_begins_xfer;
  wire             spi_0_p1_spi_control_port_chipselect;
  wire             spi_0_p1_spi_control_port_dataavailable_from_sa;
  wire             spi_0_p1_spi_control_port_end_xfer;
  wire             spi_0_p1_spi_control_port_endofpacket_from_sa;
  wire             spi_0_p1_spi_control_port_firsttransfer;
  wire             spi_0_p1_spi_control_port_grant_vector;
  wire             spi_0_p1_spi_control_port_in_a_read_cycle;
  wire             spi_0_p1_spi_control_port_in_a_write_cycle;
  wire             spi_0_p1_spi_control_port_irq_from_sa;
  wire             spi_0_p1_spi_control_port_master_qreq_vector;
  wire             spi_0_p1_spi_control_port_non_bursting_master_requests;
  wire             spi_0_p1_spi_control_port_read_n;
  wire    [ 15: 0] spi_0_p1_spi_control_port_readdata_from_sa;
  wire             spi_0_p1_spi_control_port_readyfordata_from_sa;
  reg              spi_0_p1_spi_control_port_reg_firsttransfer;
  wire             spi_0_p1_spi_control_port_reset_n;
  reg              spi_0_p1_spi_control_port_slavearbiterlockenable;
  wire             spi_0_p1_spi_control_port_slavearbiterlockenable2;
  wire             spi_0_p1_spi_control_port_unreg_firsttransfer;
  wire             spi_0_p1_spi_control_port_waits_for_read;
  wire             spi_0_p1_spi_control_port_waits_for_write;
  wire             spi_0_p1_spi_control_port_write_n;
  wire    [ 15: 0] spi_0_p1_spi_control_port_writedata;
  wire             wait_for_spi_0_p1_spi_control_port_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else 
        d1_reasons_to_wait <= ~spi_0_p1_spi_control_port_end_xfer;
    end


  assign spi_0_p1_spi_control_port_begins_xfer = ~d1_reasons_to_wait & ((cpu_data_master_qualified_request_spi_0_p1_spi_control_port));
  //assign spi_0_p1_spi_control_port_readdata_from_sa = spi_0_p1_spi_control_port_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_0_p1_spi_control_port_readdata_from_sa = spi_0_p1_spi_control_port_readdata;

  assign cpu_data_master_requests_spi_0_p1_spi_control_port = ({cpu_data_master_address_to_slave[16 : 5] , 5'b0} == 17'h0) & (cpu_data_master_read | cpu_data_master_write);
  //assign spi_0_p1_spi_control_port_dataavailable_from_sa = spi_0_p1_spi_control_port_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_0_p1_spi_control_port_dataavailable_from_sa = spi_0_p1_spi_control_port_dataavailable;

  //assign spi_0_p1_spi_control_port_readyfordata_from_sa = spi_0_p1_spi_control_port_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_0_p1_spi_control_port_readyfordata_from_sa = spi_0_p1_spi_control_port_readyfordata;

  //spi_0_p1_spi_control_port_arb_share_counter set values, which is an e_mux
  assign spi_0_p1_spi_control_port_arb_share_set_values = 1;

  //spi_0_p1_spi_control_port_non_bursting_master_requests mux, which is an e_mux
  assign spi_0_p1_spi_control_port_non_bursting_master_requests = cpu_data_master_requests_spi_0_p1_spi_control_port;

  //spi_0_p1_spi_control_port_any_bursting_master_saved_grant mux, which is an e_mux
  assign spi_0_p1_spi_control_port_any_bursting_master_saved_grant = 0;

  //spi_0_p1_spi_control_port_arb_share_counter_next_value assignment, which is an e_assign
  assign spi_0_p1_spi_control_port_arb_share_counter_next_value = spi_0_p1_spi_control_port_firsttransfer ? (spi_0_p1_spi_control_port_arb_share_set_values - 1) : |spi_0_p1_spi_control_port_arb_share_counter ? (spi_0_p1_spi_control_port_arb_share_counter - 1) : 0;

  //spi_0_p1_spi_control_port_allgrants all slave grants, which is an e_mux
  assign spi_0_p1_spi_control_port_allgrants = |spi_0_p1_spi_control_port_grant_vector;

  //spi_0_p1_spi_control_port_end_xfer assignment, which is an e_assign
  assign spi_0_p1_spi_control_port_end_xfer = ~(spi_0_p1_spi_control_port_waits_for_read | spi_0_p1_spi_control_port_waits_for_write);

  //end_xfer_arb_share_counter_term_spi_0_p1_spi_control_port arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_spi_0_p1_spi_control_port = spi_0_p1_spi_control_port_end_xfer & (~spi_0_p1_spi_control_port_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //spi_0_p1_spi_control_port_arb_share_counter arbitration counter enable, which is an e_assign
  assign spi_0_p1_spi_control_port_arb_counter_enable = (end_xfer_arb_share_counter_term_spi_0_p1_spi_control_port & spi_0_p1_spi_control_port_allgrants) | (end_xfer_arb_share_counter_term_spi_0_p1_spi_control_port & ~spi_0_p1_spi_control_port_non_bursting_master_requests);

  //spi_0_p1_spi_control_port_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          spi_0_p1_spi_control_port_arb_share_counter <= 0;
      else if (spi_0_p1_spi_control_port_arb_counter_enable)
          spi_0_p1_spi_control_port_arb_share_counter <= spi_0_p1_spi_control_port_arb_share_counter_next_value;
    end


  //spi_0_p1_spi_control_port_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          spi_0_p1_spi_control_port_slavearbiterlockenable <= 0;
      else if ((|spi_0_p1_spi_control_port_master_qreq_vector & end_xfer_arb_share_counter_term_spi_0_p1_spi_control_port) | (end_xfer_arb_share_counter_term_spi_0_p1_spi_control_port & ~spi_0_p1_spi_control_port_non_bursting_master_requests))
          spi_0_p1_spi_control_port_slavearbiterlockenable <= |spi_0_p1_spi_control_port_arb_share_counter_next_value;
    end


  //cpu/data_master spi_0_p1/spi_control_port arbiterlock, which is an e_assign
  assign cpu_data_master_arbiterlock = spi_0_p1_spi_control_port_slavearbiterlockenable & cpu_data_master_continuerequest;

  //spi_0_p1_spi_control_port_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign spi_0_p1_spi_control_port_slavearbiterlockenable2 = |spi_0_p1_spi_control_port_arb_share_counter_next_value;

  //cpu/data_master spi_0_p1/spi_control_port arbiterlock2, which is an e_assign
  assign cpu_data_master_arbiterlock2 = spi_0_p1_spi_control_port_slavearbiterlockenable2 & cpu_data_master_continuerequest;

  //spi_0_p1_spi_control_port_any_continuerequest at least one master continues requesting, which is an e_assign
  assign spi_0_p1_spi_control_port_any_continuerequest = 1;

  //cpu_data_master_continuerequest continued request, which is an e_assign
  assign cpu_data_master_continuerequest = 1;

  assign cpu_data_master_qualified_request_spi_0_p1_spi_control_port = cpu_data_master_requests_spi_0_p1_spi_control_port;
  //spi_0_p1_spi_control_port_writedata mux, which is an e_mux
  assign spi_0_p1_spi_control_port_writedata = cpu_data_master_writedata;

  //assign spi_0_p1_spi_control_port_endofpacket_from_sa = spi_0_p1_spi_control_port_endofpacket so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_0_p1_spi_control_port_endofpacket_from_sa = spi_0_p1_spi_control_port_endofpacket;

  //master is always granted when requested
  assign cpu_data_master_granted_spi_0_p1_spi_control_port = cpu_data_master_qualified_request_spi_0_p1_spi_control_port;

  //cpu/data_master saved-grant spi_0_p1/spi_control_port, which is an e_assign
  assign cpu_data_master_saved_grant_spi_0_p1_spi_control_port = cpu_data_master_requests_spi_0_p1_spi_control_port;

  //allow new arb cycle for spi_0_p1/spi_control_port, which is an e_assign
  assign spi_0_p1_spi_control_port_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign spi_0_p1_spi_control_port_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign spi_0_p1_spi_control_port_master_qreq_vector = 1;

  //spi_0_p1_spi_control_port_reset_n assignment, which is an e_assign
  assign spi_0_p1_spi_control_port_reset_n = reset_n;

  assign spi_0_p1_spi_control_port_chipselect = cpu_data_master_granted_spi_0_p1_spi_control_port;
  //spi_0_p1_spi_control_port_firsttransfer first transaction, which is an e_assign
  assign spi_0_p1_spi_control_port_firsttransfer = spi_0_p1_spi_control_port_begins_xfer ? spi_0_p1_spi_control_port_unreg_firsttransfer : spi_0_p1_spi_control_port_reg_firsttransfer;

  //spi_0_p1_spi_control_port_unreg_firsttransfer first transaction, which is an e_assign
  assign spi_0_p1_spi_control_port_unreg_firsttransfer = ~(spi_0_p1_spi_control_port_slavearbiterlockenable & spi_0_p1_spi_control_port_any_continuerequest);

  //spi_0_p1_spi_control_port_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          spi_0_p1_spi_control_port_reg_firsttransfer <= 1'b1;
      else if (spi_0_p1_spi_control_port_begins_xfer)
          spi_0_p1_spi_control_port_reg_firsttransfer <= spi_0_p1_spi_control_port_unreg_firsttransfer;
    end


  //spi_0_p1_spi_control_port_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign spi_0_p1_spi_control_port_beginbursttransfer_internal = spi_0_p1_spi_control_port_begins_xfer;

  //~spi_0_p1_spi_control_port_read_n assignment, which is an e_mux
  assign spi_0_p1_spi_control_port_read_n = ~(cpu_data_master_granted_spi_0_p1_spi_control_port & cpu_data_master_read);

  //~spi_0_p1_spi_control_port_write_n assignment, which is an e_mux
  assign spi_0_p1_spi_control_port_write_n = ~(cpu_data_master_granted_spi_0_p1_spi_control_port & cpu_data_master_write);

  assign shifted_address_to_spi_0_p1_spi_control_port_from_cpu_data_master = cpu_data_master_address_to_slave;
  //spi_0_p1_spi_control_port_address mux, which is an e_mux
  assign spi_0_p1_spi_control_port_address = shifted_address_to_spi_0_p1_spi_control_port_from_cpu_data_master >> 2;

  //d1_spi_0_p1_spi_control_port_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_spi_0_p1_spi_control_port_end_xfer <= 1;
      else 
        d1_spi_0_p1_spi_control_port_end_xfer <= spi_0_p1_spi_control_port_end_xfer;
    end


  //spi_0_p1_spi_control_port_waits_for_read in a cycle, which is an e_mux
  assign spi_0_p1_spi_control_port_waits_for_read = spi_0_p1_spi_control_port_in_a_read_cycle & spi_0_p1_spi_control_port_begins_xfer;

  //spi_0_p1_spi_control_port_in_a_read_cycle assignment, which is an e_assign
  assign spi_0_p1_spi_control_port_in_a_read_cycle = cpu_data_master_granted_spi_0_p1_spi_control_port & cpu_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = spi_0_p1_spi_control_port_in_a_read_cycle;

  //spi_0_p1_spi_control_port_waits_for_write in a cycle, which is an e_mux
  assign spi_0_p1_spi_control_port_waits_for_write = spi_0_p1_spi_control_port_in_a_write_cycle & spi_0_p1_spi_control_port_begins_xfer;

  //spi_0_p1_spi_control_port_in_a_write_cycle assignment, which is an e_assign
  assign spi_0_p1_spi_control_port_in_a_write_cycle = cpu_data_master_granted_spi_0_p1_spi_control_port & cpu_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = spi_0_p1_spi_control_port_in_a_write_cycle;

  assign wait_for_spi_0_p1_spi_control_port_counter = 0;
  //assign spi_0_p1_spi_control_port_irq_from_sa = spi_0_p1_spi_control_port_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_0_p1_spi_control_port_irq_from_sa = spi_0_p1_spi_control_port_irq;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //spi_0_p1/spi_control_port enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else 
        enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module spi_1_p0_spi_control_port_arbitrator (
                                              // inputs:
                                               clk,
                                               cpu_data_master_address_to_slave,
                                               cpu_data_master_read,
                                               cpu_data_master_write,
                                               cpu_data_master_writedata,
                                               reset_n,
                                               spi_1_p0_spi_control_port_dataavailable,
                                               spi_1_p0_spi_control_port_endofpacket,
                                               spi_1_p0_spi_control_port_irq,
                                               spi_1_p0_spi_control_port_readdata,
                                               spi_1_p0_spi_control_port_readyfordata,

                                              // outputs:
                                               cpu_data_master_granted_spi_1_p0_spi_control_port,
                                               cpu_data_master_qualified_request_spi_1_p0_spi_control_port,
                                               cpu_data_master_read_data_valid_spi_1_p0_spi_control_port,
                                               cpu_data_master_requests_spi_1_p0_spi_control_port,
                                               d1_spi_1_p0_spi_control_port_end_xfer,
                                               spi_1_p0_spi_control_port_address,
                                               spi_1_p0_spi_control_port_chipselect,
                                               spi_1_p0_spi_control_port_dataavailable_from_sa,
                                               spi_1_p0_spi_control_port_endofpacket_from_sa,
                                               spi_1_p0_spi_control_port_irq_from_sa,
                                               spi_1_p0_spi_control_port_read_n,
                                               spi_1_p0_spi_control_port_readdata_from_sa,
                                               spi_1_p0_spi_control_port_readyfordata_from_sa,
                                               spi_1_p0_spi_control_port_reset_n,
                                               spi_1_p0_spi_control_port_write_n,
                                               spi_1_p0_spi_control_port_writedata
                                            )
;

  output           cpu_data_master_granted_spi_1_p0_spi_control_port;
  output           cpu_data_master_qualified_request_spi_1_p0_spi_control_port;
  output           cpu_data_master_read_data_valid_spi_1_p0_spi_control_port;
  output           cpu_data_master_requests_spi_1_p0_spi_control_port;
  output           d1_spi_1_p0_spi_control_port_end_xfer;
  output  [  2: 0] spi_1_p0_spi_control_port_address;
  output           spi_1_p0_spi_control_port_chipselect;
  output           spi_1_p0_spi_control_port_dataavailable_from_sa;
  output           spi_1_p0_spi_control_port_endofpacket_from_sa;
  output           spi_1_p0_spi_control_port_irq_from_sa;
  output           spi_1_p0_spi_control_port_read_n;
  output  [ 15: 0] spi_1_p0_spi_control_port_readdata_from_sa;
  output           spi_1_p0_spi_control_port_readyfordata_from_sa;
  output           spi_1_p0_spi_control_port_reset_n;
  output           spi_1_p0_spi_control_port_write_n;
  output  [ 15: 0] spi_1_p0_spi_control_port_writedata;
  input            clk;
  input   [ 16: 0] cpu_data_master_address_to_slave;
  input            cpu_data_master_read;
  input            cpu_data_master_write;
  input   [ 31: 0] cpu_data_master_writedata;
  input            reset_n;
  input            spi_1_p0_spi_control_port_dataavailable;
  input            spi_1_p0_spi_control_port_endofpacket;
  input            spi_1_p0_spi_control_port_irq;
  input   [ 15: 0] spi_1_p0_spi_control_port_readdata;
  input            spi_1_p0_spi_control_port_readyfordata;

  wire             cpu_data_master_arbiterlock;
  wire             cpu_data_master_arbiterlock2;
  wire             cpu_data_master_continuerequest;
  wire             cpu_data_master_granted_spi_1_p0_spi_control_port;
  wire             cpu_data_master_qualified_request_spi_1_p0_spi_control_port;
  wire             cpu_data_master_read_data_valid_spi_1_p0_spi_control_port;
  wire             cpu_data_master_requests_spi_1_p0_spi_control_port;
  wire             cpu_data_master_saved_grant_spi_1_p0_spi_control_port;
  reg              d1_reasons_to_wait;
  reg              d1_spi_1_p0_spi_control_port_end_xfer;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_spi_1_p0_spi_control_port;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [ 16: 0] shifted_address_to_spi_1_p0_spi_control_port_from_cpu_data_master;
  wire    [  2: 0] spi_1_p0_spi_control_port_address;
  wire             spi_1_p0_spi_control_port_allgrants;
  wire             spi_1_p0_spi_control_port_allow_new_arb_cycle;
  wire             spi_1_p0_spi_control_port_any_bursting_master_saved_grant;
  wire             spi_1_p0_spi_control_port_any_continuerequest;
  wire             spi_1_p0_spi_control_port_arb_counter_enable;
  reg              spi_1_p0_spi_control_port_arb_share_counter;
  wire             spi_1_p0_spi_control_port_arb_share_counter_next_value;
  wire             spi_1_p0_spi_control_port_arb_share_set_values;
  wire             spi_1_p0_spi_control_port_beginbursttransfer_internal;
  wire             spi_1_p0_spi_control_port_begins_xfer;
  wire             spi_1_p0_spi_control_port_chipselect;
  wire             spi_1_p0_spi_control_port_dataavailable_from_sa;
  wire             spi_1_p0_spi_control_port_end_xfer;
  wire             spi_1_p0_spi_control_port_endofpacket_from_sa;
  wire             spi_1_p0_spi_control_port_firsttransfer;
  wire             spi_1_p0_spi_control_port_grant_vector;
  wire             spi_1_p0_spi_control_port_in_a_read_cycle;
  wire             spi_1_p0_spi_control_port_in_a_write_cycle;
  wire             spi_1_p0_spi_control_port_irq_from_sa;
  wire             spi_1_p0_spi_control_port_master_qreq_vector;
  wire             spi_1_p0_spi_control_port_non_bursting_master_requests;
  wire             spi_1_p0_spi_control_port_read_n;
  wire    [ 15: 0] spi_1_p0_spi_control_port_readdata_from_sa;
  wire             spi_1_p0_spi_control_port_readyfordata_from_sa;
  reg              spi_1_p0_spi_control_port_reg_firsttransfer;
  wire             spi_1_p0_spi_control_port_reset_n;
  reg              spi_1_p0_spi_control_port_slavearbiterlockenable;
  wire             spi_1_p0_spi_control_port_slavearbiterlockenable2;
  wire             spi_1_p0_spi_control_port_unreg_firsttransfer;
  wire             spi_1_p0_spi_control_port_waits_for_read;
  wire             spi_1_p0_spi_control_port_waits_for_write;
  wire             spi_1_p0_spi_control_port_write_n;
  wire    [ 15: 0] spi_1_p0_spi_control_port_writedata;
  wire             wait_for_spi_1_p0_spi_control_port_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else 
        d1_reasons_to_wait <= ~spi_1_p0_spi_control_port_end_xfer;
    end


  assign spi_1_p0_spi_control_port_begins_xfer = ~d1_reasons_to_wait & ((cpu_data_master_qualified_request_spi_1_p0_spi_control_port));
  //assign spi_1_p0_spi_control_port_readdata_from_sa = spi_1_p0_spi_control_port_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_1_p0_spi_control_port_readdata_from_sa = spi_1_p0_spi_control_port_readdata;

  assign cpu_data_master_requests_spi_1_p0_spi_control_port = ({cpu_data_master_address_to_slave[16 : 5] , 5'b0} == 17'h2040) & (cpu_data_master_read | cpu_data_master_write);
  //assign spi_1_p0_spi_control_port_dataavailable_from_sa = spi_1_p0_spi_control_port_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_1_p0_spi_control_port_dataavailable_from_sa = spi_1_p0_spi_control_port_dataavailable;

  //assign spi_1_p0_spi_control_port_readyfordata_from_sa = spi_1_p0_spi_control_port_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_1_p0_spi_control_port_readyfordata_from_sa = spi_1_p0_spi_control_port_readyfordata;

  //spi_1_p0_spi_control_port_arb_share_counter set values, which is an e_mux
  assign spi_1_p0_spi_control_port_arb_share_set_values = 1;

  //spi_1_p0_spi_control_port_non_bursting_master_requests mux, which is an e_mux
  assign spi_1_p0_spi_control_port_non_bursting_master_requests = cpu_data_master_requests_spi_1_p0_spi_control_port;

  //spi_1_p0_spi_control_port_any_bursting_master_saved_grant mux, which is an e_mux
  assign spi_1_p0_spi_control_port_any_bursting_master_saved_grant = 0;

  //spi_1_p0_spi_control_port_arb_share_counter_next_value assignment, which is an e_assign
  assign spi_1_p0_spi_control_port_arb_share_counter_next_value = spi_1_p0_spi_control_port_firsttransfer ? (spi_1_p0_spi_control_port_arb_share_set_values - 1) : |spi_1_p0_spi_control_port_arb_share_counter ? (spi_1_p0_spi_control_port_arb_share_counter - 1) : 0;

  //spi_1_p0_spi_control_port_allgrants all slave grants, which is an e_mux
  assign spi_1_p0_spi_control_port_allgrants = |spi_1_p0_spi_control_port_grant_vector;

  //spi_1_p0_spi_control_port_end_xfer assignment, which is an e_assign
  assign spi_1_p0_spi_control_port_end_xfer = ~(spi_1_p0_spi_control_port_waits_for_read | spi_1_p0_spi_control_port_waits_for_write);

  //end_xfer_arb_share_counter_term_spi_1_p0_spi_control_port arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_spi_1_p0_spi_control_port = spi_1_p0_spi_control_port_end_xfer & (~spi_1_p0_spi_control_port_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //spi_1_p0_spi_control_port_arb_share_counter arbitration counter enable, which is an e_assign
  assign spi_1_p0_spi_control_port_arb_counter_enable = (end_xfer_arb_share_counter_term_spi_1_p0_spi_control_port & spi_1_p0_spi_control_port_allgrants) | (end_xfer_arb_share_counter_term_spi_1_p0_spi_control_port & ~spi_1_p0_spi_control_port_non_bursting_master_requests);

  //spi_1_p0_spi_control_port_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          spi_1_p0_spi_control_port_arb_share_counter <= 0;
      else if (spi_1_p0_spi_control_port_arb_counter_enable)
          spi_1_p0_spi_control_port_arb_share_counter <= spi_1_p0_spi_control_port_arb_share_counter_next_value;
    end


  //spi_1_p0_spi_control_port_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          spi_1_p0_spi_control_port_slavearbiterlockenable <= 0;
      else if ((|spi_1_p0_spi_control_port_master_qreq_vector & end_xfer_arb_share_counter_term_spi_1_p0_spi_control_port) | (end_xfer_arb_share_counter_term_spi_1_p0_spi_control_port & ~spi_1_p0_spi_control_port_non_bursting_master_requests))
          spi_1_p0_spi_control_port_slavearbiterlockenable <= |spi_1_p0_spi_control_port_arb_share_counter_next_value;
    end


  //cpu/data_master spi_1_p0/spi_control_port arbiterlock, which is an e_assign
  assign cpu_data_master_arbiterlock = spi_1_p0_spi_control_port_slavearbiterlockenable & cpu_data_master_continuerequest;

  //spi_1_p0_spi_control_port_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign spi_1_p0_spi_control_port_slavearbiterlockenable2 = |spi_1_p0_spi_control_port_arb_share_counter_next_value;

  //cpu/data_master spi_1_p0/spi_control_port arbiterlock2, which is an e_assign
  assign cpu_data_master_arbiterlock2 = spi_1_p0_spi_control_port_slavearbiterlockenable2 & cpu_data_master_continuerequest;

  //spi_1_p0_spi_control_port_any_continuerequest at least one master continues requesting, which is an e_assign
  assign spi_1_p0_spi_control_port_any_continuerequest = 1;

  //cpu_data_master_continuerequest continued request, which is an e_assign
  assign cpu_data_master_continuerequest = 1;

  assign cpu_data_master_qualified_request_spi_1_p0_spi_control_port = cpu_data_master_requests_spi_1_p0_spi_control_port;
  //spi_1_p0_spi_control_port_writedata mux, which is an e_mux
  assign spi_1_p0_spi_control_port_writedata = cpu_data_master_writedata;

  //assign spi_1_p0_spi_control_port_endofpacket_from_sa = spi_1_p0_spi_control_port_endofpacket so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_1_p0_spi_control_port_endofpacket_from_sa = spi_1_p0_spi_control_port_endofpacket;

  //master is always granted when requested
  assign cpu_data_master_granted_spi_1_p0_spi_control_port = cpu_data_master_qualified_request_spi_1_p0_spi_control_port;

  //cpu/data_master saved-grant spi_1_p0/spi_control_port, which is an e_assign
  assign cpu_data_master_saved_grant_spi_1_p0_spi_control_port = cpu_data_master_requests_spi_1_p0_spi_control_port;

  //allow new arb cycle for spi_1_p0/spi_control_port, which is an e_assign
  assign spi_1_p0_spi_control_port_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign spi_1_p0_spi_control_port_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign spi_1_p0_spi_control_port_master_qreq_vector = 1;

  //spi_1_p0_spi_control_port_reset_n assignment, which is an e_assign
  assign spi_1_p0_spi_control_port_reset_n = reset_n;

  assign spi_1_p0_spi_control_port_chipselect = cpu_data_master_granted_spi_1_p0_spi_control_port;
  //spi_1_p0_spi_control_port_firsttransfer first transaction, which is an e_assign
  assign spi_1_p0_spi_control_port_firsttransfer = spi_1_p0_spi_control_port_begins_xfer ? spi_1_p0_spi_control_port_unreg_firsttransfer : spi_1_p0_spi_control_port_reg_firsttransfer;

  //spi_1_p0_spi_control_port_unreg_firsttransfer first transaction, which is an e_assign
  assign spi_1_p0_spi_control_port_unreg_firsttransfer = ~(spi_1_p0_spi_control_port_slavearbiterlockenable & spi_1_p0_spi_control_port_any_continuerequest);

  //spi_1_p0_spi_control_port_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          spi_1_p0_spi_control_port_reg_firsttransfer <= 1'b1;
      else if (spi_1_p0_spi_control_port_begins_xfer)
          spi_1_p0_spi_control_port_reg_firsttransfer <= spi_1_p0_spi_control_port_unreg_firsttransfer;
    end


  //spi_1_p0_spi_control_port_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign spi_1_p0_spi_control_port_beginbursttransfer_internal = spi_1_p0_spi_control_port_begins_xfer;

  //~spi_1_p0_spi_control_port_read_n assignment, which is an e_mux
  assign spi_1_p0_spi_control_port_read_n = ~(cpu_data_master_granted_spi_1_p0_spi_control_port & cpu_data_master_read);

  //~spi_1_p0_spi_control_port_write_n assignment, which is an e_mux
  assign spi_1_p0_spi_control_port_write_n = ~(cpu_data_master_granted_spi_1_p0_spi_control_port & cpu_data_master_write);

  assign shifted_address_to_spi_1_p0_spi_control_port_from_cpu_data_master = cpu_data_master_address_to_slave;
  //spi_1_p0_spi_control_port_address mux, which is an e_mux
  assign spi_1_p0_spi_control_port_address = shifted_address_to_spi_1_p0_spi_control_port_from_cpu_data_master >> 2;

  //d1_spi_1_p0_spi_control_port_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_spi_1_p0_spi_control_port_end_xfer <= 1;
      else 
        d1_spi_1_p0_spi_control_port_end_xfer <= spi_1_p0_spi_control_port_end_xfer;
    end


  //spi_1_p0_spi_control_port_waits_for_read in a cycle, which is an e_mux
  assign spi_1_p0_spi_control_port_waits_for_read = spi_1_p0_spi_control_port_in_a_read_cycle & spi_1_p0_spi_control_port_begins_xfer;

  //spi_1_p0_spi_control_port_in_a_read_cycle assignment, which is an e_assign
  assign spi_1_p0_spi_control_port_in_a_read_cycle = cpu_data_master_granted_spi_1_p0_spi_control_port & cpu_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = spi_1_p0_spi_control_port_in_a_read_cycle;

  //spi_1_p0_spi_control_port_waits_for_write in a cycle, which is an e_mux
  assign spi_1_p0_spi_control_port_waits_for_write = spi_1_p0_spi_control_port_in_a_write_cycle & spi_1_p0_spi_control_port_begins_xfer;

  //spi_1_p0_spi_control_port_in_a_write_cycle assignment, which is an e_assign
  assign spi_1_p0_spi_control_port_in_a_write_cycle = cpu_data_master_granted_spi_1_p0_spi_control_port & cpu_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = spi_1_p0_spi_control_port_in_a_write_cycle;

  assign wait_for_spi_1_p0_spi_control_port_counter = 0;
  //assign spi_1_p0_spi_control_port_irq_from_sa = spi_1_p0_spi_control_port_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_1_p0_spi_control_port_irq_from_sa = spi_1_p0_spi_control_port_irq;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //spi_1_p0/spi_control_port enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else 
        enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module spi_1_p1_spi_control_port_arbitrator (
                                              // inputs:
                                               clk,
                                               cpu_data_master_address_to_slave,
                                               cpu_data_master_read,
                                               cpu_data_master_write,
                                               cpu_data_master_writedata,
                                               reset_n,
                                               spi_1_p1_spi_control_port_dataavailable,
                                               spi_1_p1_spi_control_port_endofpacket,
                                               spi_1_p1_spi_control_port_irq,
                                               spi_1_p1_spi_control_port_readdata,
                                               spi_1_p1_spi_control_port_readyfordata,

                                              // outputs:
                                               cpu_data_master_granted_spi_1_p1_spi_control_port,
                                               cpu_data_master_qualified_request_spi_1_p1_spi_control_port,
                                               cpu_data_master_read_data_valid_spi_1_p1_spi_control_port,
                                               cpu_data_master_requests_spi_1_p1_spi_control_port,
                                               d1_spi_1_p1_spi_control_port_end_xfer,
                                               spi_1_p1_spi_control_port_address,
                                               spi_1_p1_spi_control_port_chipselect,
                                               spi_1_p1_spi_control_port_dataavailable_from_sa,
                                               spi_1_p1_spi_control_port_endofpacket_from_sa,
                                               spi_1_p1_spi_control_port_irq_from_sa,
                                               spi_1_p1_spi_control_port_read_n,
                                               spi_1_p1_spi_control_port_readdata_from_sa,
                                               spi_1_p1_spi_control_port_readyfordata_from_sa,
                                               spi_1_p1_spi_control_port_reset_n,
                                               spi_1_p1_spi_control_port_write_n,
                                               spi_1_p1_spi_control_port_writedata
                                            )
;

  output           cpu_data_master_granted_spi_1_p1_spi_control_port;
  output           cpu_data_master_qualified_request_spi_1_p1_spi_control_port;
  output           cpu_data_master_read_data_valid_spi_1_p1_spi_control_port;
  output           cpu_data_master_requests_spi_1_p1_spi_control_port;
  output           d1_spi_1_p1_spi_control_port_end_xfer;
  output  [  2: 0] spi_1_p1_spi_control_port_address;
  output           spi_1_p1_spi_control_port_chipselect;
  output           spi_1_p1_spi_control_port_dataavailable_from_sa;
  output           spi_1_p1_spi_control_port_endofpacket_from_sa;
  output           spi_1_p1_spi_control_port_irq_from_sa;
  output           spi_1_p1_spi_control_port_read_n;
  output  [ 15: 0] spi_1_p1_spi_control_port_readdata_from_sa;
  output           spi_1_p1_spi_control_port_readyfordata_from_sa;
  output           spi_1_p1_spi_control_port_reset_n;
  output           spi_1_p1_spi_control_port_write_n;
  output  [ 15: 0] spi_1_p1_spi_control_port_writedata;
  input            clk;
  input   [ 16: 0] cpu_data_master_address_to_slave;
  input            cpu_data_master_read;
  input            cpu_data_master_write;
  input   [ 31: 0] cpu_data_master_writedata;
  input            reset_n;
  input            spi_1_p1_spi_control_port_dataavailable;
  input            spi_1_p1_spi_control_port_endofpacket;
  input            spi_1_p1_spi_control_port_irq;
  input   [ 15: 0] spi_1_p1_spi_control_port_readdata;
  input            spi_1_p1_spi_control_port_readyfordata;

  wire             cpu_data_master_arbiterlock;
  wire             cpu_data_master_arbiterlock2;
  wire             cpu_data_master_continuerequest;
  wire             cpu_data_master_granted_spi_1_p1_spi_control_port;
  wire             cpu_data_master_qualified_request_spi_1_p1_spi_control_port;
  wire             cpu_data_master_read_data_valid_spi_1_p1_spi_control_port;
  wire             cpu_data_master_requests_spi_1_p1_spi_control_port;
  wire             cpu_data_master_saved_grant_spi_1_p1_spi_control_port;
  reg              d1_reasons_to_wait;
  reg              d1_spi_1_p1_spi_control_port_end_xfer;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_spi_1_p1_spi_control_port;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [ 16: 0] shifted_address_to_spi_1_p1_spi_control_port_from_cpu_data_master;
  wire    [  2: 0] spi_1_p1_spi_control_port_address;
  wire             spi_1_p1_spi_control_port_allgrants;
  wire             spi_1_p1_spi_control_port_allow_new_arb_cycle;
  wire             spi_1_p1_spi_control_port_any_bursting_master_saved_grant;
  wire             spi_1_p1_spi_control_port_any_continuerequest;
  wire             spi_1_p1_spi_control_port_arb_counter_enable;
  reg              spi_1_p1_spi_control_port_arb_share_counter;
  wire             spi_1_p1_spi_control_port_arb_share_counter_next_value;
  wire             spi_1_p1_spi_control_port_arb_share_set_values;
  wire             spi_1_p1_spi_control_port_beginbursttransfer_internal;
  wire             spi_1_p1_spi_control_port_begins_xfer;
  wire             spi_1_p1_spi_control_port_chipselect;
  wire             spi_1_p1_spi_control_port_dataavailable_from_sa;
  wire             spi_1_p1_spi_control_port_end_xfer;
  wire             spi_1_p1_spi_control_port_endofpacket_from_sa;
  wire             spi_1_p1_spi_control_port_firsttransfer;
  wire             spi_1_p1_spi_control_port_grant_vector;
  wire             spi_1_p1_spi_control_port_in_a_read_cycle;
  wire             spi_1_p1_spi_control_port_in_a_write_cycle;
  wire             spi_1_p1_spi_control_port_irq_from_sa;
  wire             spi_1_p1_spi_control_port_master_qreq_vector;
  wire             spi_1_p1_spi_control_port_non_bursting_master_requests;
  wire             spi_1_p1_spi_control_port_read_n;
  wire    [ 15: 0] spi_1_p1_spi_control_port_readdata_from_sa;
  wire             spi_1_p1_spi_control_port_readyfordata_from_sa;
  reg              spi_1_p1_spi_control_port_reg_firsttransfer;
  wire             spi_1_p1_spi_control_port_reset_n;
  reg              spi_1_p1_spi_control_port_slavearbiterlockenable;
  wire             spi_1_p1_spi_control_port_slavearbiterlockenable2;
  wire             spi_1_p1_spi_control_port_unreg_firsttransfer;
  wire             spi_1_p1_spi_control_port_waits_for_read;
  wire             spi_1_p1_spi_control_port_waits_for_write;
  wire             spi_1_p1_spi_control_port_write_n;
  wire    [ 15: 0] spi_1_p1_spi_control_port_writedata;
  wire             wait_for_spi_1_p1_spi_control_port_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else 
        d1_reasons_to_wait <= ~spi_1_p1_spi_control_port_end_xfer;
    end


  assign spi_1_p1_spi_control_port_begins_xfer = ~d1_reasons_to_wait & ((cpu_data_master_qualified_request_spi_1_p1_spi_control_port));
  //assign spi_1_p1_spi_control_port_readdata_from_sa = spi_1_p1_spi_control_port_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_1_p1_spi_control_port_readdata_from_sa = spi_1_p1_spi_control_port_readdata;

  assign cpu_data_master_requests_spi_1_p1_spi_control_port = ({cpu_data_master_address_to_slave[16 : 5] , 5'b0} == 17'h20) & (cpu_data_master_read | cpu_data_master_write);
  //assign spi_1_p1_spi_control_port_dataavailable_from_sa = spi_1_p1_spi_control_port_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_1_p1_spi_control_port_dataavailable_from_sa = spi_1_p1_spi_control_port_dataavailable;

  //assign spi_1_p1_spi_control_port_readyfordata_from_sa = spi_1_p1_spi_control_port_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_1_p1_spi_control_port_readyfordata_from_sa = spi_1_p1_spi_control_port_readyfordata;

  //spi_1_p1_spi_control_port_arb_share_counter set values, which is an e_mux
  assign spi_1_p1_spi_control_port_arb_share_set_values = 1;

  //spi_1_p1_spi_control_port_non_bursting_master_requests mux, which is an e_mux
  assign spi_1_p1_spi_control_port_non_bursting_master_requests = cpu_data_master_requests_spi_1_p1_spi_control_port;

  //spi_1_p1_spi_control_port_any_bursting_master_saved_grant mux, which is an e_mux
  assign spi_1_p1_spi_control_port_any_bursting_master_saved_grant = 0;

  //spi_1_p1_spi_control_port_arb_share_counter_next_value assignment, which is an e_assign
  assign spi_1_p1_spi_control_port_arb_share_counter_next_value = spi_1_p1_spi_control_port_firsttransfer ? (spi_1_p1_spi_control_port_arb_share_set_values - 1) : |spi_1_p1_spi_control_port_arb_share_counter ? (spi_1_p1_spi_control_port_arb_share_counter - 1) : 0;

  //spi_1_p1_spi_control_port_allgrants all slave grants, which is an e_mux
  assign spi_1_p1_spi_control_port_allgrants = |spi_1_p1_spi_control_port_grant_vector;

  //spi_1_p1_spi_control_port_end_xfer assignment, which is an e_assign
  assign spi_1_p1_spi_control_port_end_xfer = ~(spi_1_p1_spi_control_port_waits_for_read | spi_1_p1_spi_control_port_waits_for_write);

  //end_xfer_arb_share_counter_term_spi_1_p1_spi_control_port arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_spi_1_p1_spi_control_port = spi_1_p1_spi_control_port_end_xfer & (~spi_1_p1_spi_control_port_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //spi_1_p1_spi_control_port_arb_share_counter arbitration counter enable, which is an e_assign
  assign spi_1_p1_spi_control_port_arb_counter_enable = (end_xfer_arb_share_counter_term_spi_1_p1_spi_control_port & spi_1_p1_spi_control_port_allgrants) | (end_xfer_arb_share_counter_term_spi_1_p1_spi_control_port & ~spi_1_p1_spi_control_port_non_bursting_master_requests);

  //spi_1_p1_spi_control_port_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          spi_1_p1_spi_control_port_arb_share_counter <= 0;
      else if (spi_1_p1_spi_control_port_arb_counter_enable)
          spi_1_p1_spi_control_port_arb_share_counter <= spi_1_p1_spi_control_port_arb_share_counter_next_value;
    end


  //spi_1_p1_spi_control_port_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          spi_1_p1_spi_control_port_slavearbiterlockenable <= 0;
      else if ((|spi_1_p1_spi_control_port_master_qreq_vector & end_xfer_arb_share_counter_term_spi_1_p1_spi_control_port) | (end_xfer_arb_share_counter_term_spi_1_p1_spi_control_port & ~spi_1_p1_spi_control_port_non_bursting_master_requests))
          spi_1_p1_spi_control_port_slavearbiterlockenable <= |spi_1_p1_spi_control_port_arb_share_counter_next_value;
    end


  //cpu/data_master spi_1_p1/spi_control_port arbiterlock, which is an e_assign
  assign cpu_data_master_arbiterlock = spi_1_p1_spi_control_port_slavearbiterlockenable & cpu_data_master_continuerequest;

  //spi_1_p1_spi_control_port_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign spi_1_p1_spi_control_port_slavearbiterlockenable2 = |spi_1_p1_spi_control_port_arb_share_counter_next_value;

  //cpu/data_master spi_1_p1/spi_control_port arbiterlock2, which is an e_assign
  assign cpu_data_master_arbiterlock2 = spi_1_p1_spi_control_port_slavearbiterlockenable2 & cpu_data_master_continuerequest;

  //spi_1_p1_spi_control_port_any_continuerequest at least one master continues requesting, which is an e_assign
  assign spi_1_p1_spi_control_port_any_continuerequest = 1;

  //cpu_data_master_continuerequest continued request, which is an e_assign
  assign cpu_data_master_continuerequest = 1;

  assign cpu_data_master_qualified_request_spi_1_p1_spi_control_port = cpu_data_master_requests_spi_1_p1_spi_control_port;
  //spi_1_p1_spi_control_port_writedata mux, which is an e_mux
  assign spi_1_p1_spi_control_port_writedata = cpu_data_master_writedata;

  //assign spi_1_p1_spi_control_port_endofpacket_from_sa = spi_1_p1_spi_control_port_endofpacket so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_1_p1_spi_control_port_endofpacket_from_sa = spi_1_p1_spi_control_port_endofpacket;

  //master is always granted when requested
  assign cpu_data_master_granted_spi_1_p1_spi_control_port = cpu_data_master_qualified_request_spi_1_p1_spi_control_port;

  //cpu/data_master saved-grant spi_1_p1/spi_control_port, which is an e_assign
  assign cpu_data_master_saved_grant_spi_1_p1_spi_control_port = cpu_data_master_requests_spi_1_p1_spi_control_port;

  //allow new arb cycle for spi_1_p1/spi_control_port, which is an e_assign
  assign spi_1_p1_spi_control_port_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign spi_1_p1_spi_control_port_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign spi_1_p1_spi_control_port_master_qreq_vector = 1;

  //spi_1_p1_spi_control_port_reset_n assignment, which is an e_assign
  assign spi_1_p1_spi_control_port_reset_n = reset_n;

  assign spi_1_p1_spi_control_port_chipselect = cpu_data_master_granted_spi_1_p1_spi_control_port;
  //spi_1_p1_spi_control_port_firsttransfer first transaction, which is an e_assign
  assign spi_1_p1_spi_control_port_firsttransfer = spi_1_p1_spi_control_port_begins_xfer ? spi_1_p1_spi_control_port_unreg_firsttransfer : spi_1_p1_spi_control_port_reg_firsttransfer;

  //spi_1_p1_spi_control_port_unreg_firsttransfer first transaction, which is an e_assign
  assign spi_1_p1_spi_control_port_unreg_firsttransfer = ~(spi_1_p1_spi_control_port_slavearbiterlockenable & spi_1_p1_spi_control_port_any_continuerequest);

  //spi_1_p1_spi_control_port_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          spi_1_p1_spi_control_port_reg_firsttransfer <= 1'b1;
      else if (spi_1_p1_spi_control_port_begins_xfer)
          spi_1_p1_spi_control_port_reg_firsttransfer <= spi_1_p1_spi_control_port_unreg_firsttransfer;
    end


  //spi_1_p1_spi_control_port_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign spi_1_p1_spi_control_port_beginbursttransfer_internal = spi_1_p1_spi_control_port_begins_xfer;

  //~spi_1_p1_spi_control_port_read_n assignment, which is an e_mux
  assign spi_1_p1_spi_control_port_read_n = ~(cpu_data_master_granted_spi_1_p1_spi_control_port & cpu_data_master_read);

  //~spi_1_p1_spi_control_port_write_n assignment, which is an e_mux
  assign spi_1_p1_spi_control_port_write_n = ~(cpu_data_master_granted_spi_1_p1_spi_control_port & cpu_data_master_write);

  assign shifted_address_to_spi_1_p1_spi_control_port_from_cpu_data_master = cpu_data_master_address_to_slave;
  //spi_1_p1_spi_control_port_address mux, which is an e_mux
  assign spi_1_p1_spi_control_port_address = shifted_address_to_spi_1_p1_spi_control_port_from_cpu_data_master >> 2;

  //d1_spi_1_p1_spi_control_port_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_spi_1_p1_spi_control_port_end_xfer <= 1;
      else 
        d1_spi_1_p1_spi_control_port_end_xfer <= spi_1_p1_spi_control_port_end_xfer;
    end


  //spi_1_p1_spi_control_port_waits_for_read in a cycle, which is an e_mux
  assign spi_1_p1_spi_control_port_waits_for_read = spi_1_p1_spi_control_port_in_a_read_cycle & spi_1_p1_spi_control_port_begins_xfer;

  //spi_1_p1_spi_control_port_in_a_read_cycle assignment, which is an e_assign
  assign spi_1_p1_spi_control_port_in_a_read_cycle = cpu_data_master_granted_spi_1_p1_spi_control_port & cpu_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = spi_1_p1_spi_control_port_in_a_read_cycle;

  //spi_1_p1_spi_control_port_waits_for_write in a cycle, which is an e_mux
  assign spi_1_p1_spi_control_port_waits_for_write = spi_1_p1_spi_control_port_in_a_write_cycle & spi_1_p1_spi_control_port_begins_xfer;

  //spi_1_p1_spi_control_port_in_a_write_cycle assignment, which is an e_assign
  assign spi_1_p1_spi_control_port_in_a_write_cycle = cpu_data_master_granted_spi_1_p1_spi_control_port & cpu_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = spi_1_p1_spi_control_port_in_a_write_cycle;

  assign wait_for_spi_1_p1_spi_control_port_counter = 0;
  //assign spi_1_p1_spi_control_port_irq_from_sa = spi_1_p1_spi_control_port_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign spi_1_p1_spi_control_port_irq_from_sa = spi_1_p1_spi_control_port_irq;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //spi_1_p1/spi_control_port enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else 
        enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module sysid_control_slave_arbitrator (
                                        // inputs:
                                         clk,
                                         cpu_data_master_address_to_slave,
                                         cpu_data_master_read,
                                         cpu_data_master_write,
                                         reset_n,
                                         sysid_control_slave_readdata,

                                        // outputs:
                                         cpu_data_master_granted_sysid_control_slave,
                                         cpu_data_master_qualified_request_sysid_control_slave,
                                         cpu_data_master_read_data_valid_sysid_control_slave,
                                         cpu_data_master_requests_sysid_control_slave,
                                         d1_sysid_control_slave_end_xfer,
                                         sysid_control_slave_address,
                                         sysid_control_slave_readdata_from_sa,
                                         sysid_control_slave_reset_n
                                      )
;

  output           cpu_data_master_granted_sysid_control_slave;
  output           cpu_data_master_qualified_request_sysid_control_slave;
  output           cpu_data_master_read_data_valid_sysid_control_slave;
  output           cpu_data_master_requests_sysid_control_slave;
  output           d1_sysid_control_slave_end_xfer;
  output           sysid_control_slave_address;
  output  [ 31: 0] sysid_control_slave_readdata_from_sa;
  output           sysid_control_slave_reset_n;
  input            clk;
  input   [ 16: 0] cpu_data_master_address_to_slave;
  input            cpu_data_master_read;
  input            cpu_data_master_write;
  input            reset_n;
  input   [ 31: 0] sysid_control_slave_readdata;

  wire             cpu_data_master_arbiterlock;
  wire             cpu_data_master_arbiterlock2;
  wire             cpu_data_master_continuerequest;
  wire             cpu_data_master_granted_sysid_control_slave;
  wire             cpu_data_master_qualified_request_sysid_control_slave;
  wire             cpu_data_master_read_data_valid_sysid_control_slave;
  wire             cpu_data_master_requests_sysid_control_slave;
  wire             cpu_data_master_saved_grant_sysid_control_slave;
  reg              d1_reasons_to_wait;
  reg              d1_sysid_control_slave_end_xfer;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_sysid_control_slave;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [ 16: 0] shifted_address_to_sysid_control_slave_from_cpu_data_master;
  wire             sysid_control_slave_address;
  wire             sysid_control_slave_allgrants;
  wire             sysid_control_slave_allow_new_arb_cycle;
  wire             sysid_control_slave_any_bursting_master_saved_grant;
  wire             sysid_control_slave_any_continuerequest;
  wire             sysid_control_slave_arb_counter_enable;
  reg              sysid_control_slave_arb_share_counter;
  wire             sysid_control_slave_arb_share_counter_next_value;
  wire             sysid_control_slave_arb_share_set_values;
  wire             sysid_control_slave_beginbursttransfer_internal;
  wire             sysid_control_slave_begins_xfer;
  wire             sysid_control_slave_end_xfer;
  wire             sysid_control_slave_firsttransfer;
  wire             sysid_control_slave_grant_vector;
  wire             sysid_control_slave_in_a_read_cycle;
  wire             sysid_control_slave_in_a_write_cycle;
  wire             sysid_control_slave_master_qreq_vector;
  wire             sysid_control_slave_non_bursting_master_requests;
  wire    [ 31: 0] sysid_control_slave_readdata_from_sa;
  reg              sysid_control_slave_reg_firsttransfer;
  wire             sysid_control_slave_reset_n;
  reg              sysid_control_slave_slavearbiterlockenable;
  wire             sysid_control_slave_slavearbiterlockenable2;
  wire             sysid_control_slave_unreg_firsttransfer;
  wire             sysid_control_slave_waits_for_read;
  wire             sysid_control_slave_waits_for_write;
  wire             wait_for_sysid_control_slave_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else 
        d1_reasons_to_wait <= ~sysid_control_slave_end_xfer;
    end


  assign sysid_control_slave_begins_xfer = ~d1_reasons_to_wait & ((cpu_data_master_qualified_request_sysid_control_slave));
  //assign sysid_control_slave_readdata_from_sa = sysid_control_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign sysid_control_slave_readdata_from_sa = sysid_control_slave_readdata;

  assign cpu_data_master_requests_sysid_control_slave = (({cpu_data_master_address_to_slave[16 : 3] , 3'b0} == 17'h40) & (cpu_data_master_read | cpu_data_master_write)) & cpu_data_master_read;
  //sysid_control_slave_arb_share_counter set values, which is an e_mux
  assign sysid_control_slave_arb_share_set_values = 1;

  //sysid_control_slave_non_bursting_master_requests mux, which is an e_mux
  assign sysid_control_slave_non_bursting_master_requests = cpu_data_master_requests_sysid_control_slave;

  //sysid_control_slave_any_bursting_master_saved_grant mux, which is an e_mux
  assign sysid_control_slave_any_bursting_master_saved_grant = 0;

  //sysid_control_slave_arb_share_counter_next_value assignment, which is an e_assign
  assign sysid_control_slave_arb_share_counter_next_value = sysid_control_slave_firsttransfer ? (sysid_control_slave_arb_share_set_values - 1) : |sysid_control_slave_arb_share_counter ? (sysid_control_slave_arb_share_counter - 1) : 0;

  //sysid_control_slave_allgrants all slave grants, which is an e_mux
  assign sysid_control_slave_allgrants = |sysid_control_slave_grant_vector;

  //sysid_control_slave_end_xfer assignment, which is an e_assign
  assign sysid_control_slave_end_xfer = ~(sysid_control_slave_waits_for_read | sysid_control_slave_waits_for_write);

  //end_xfer_arb_share_counter_term_sysid_control_slave arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_sysid_control_slave = sysid_control_slave_end_xfer & (~sysid_control_slave_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //sysid_control_slave_arb_share_counter arbitration counter enable, which is an e_assign
  assign sysid_control_slave_arb_counter_enable = (end_xfer_arb_share_counter_term_sysid_control_slave & sysid_control_slave_allgrants) | (end_xfer_arb_share_counter_term_sysid_control_slave & ~sysid_control_slave_non_bursting_master_requests);

  //sysid_control_slave_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          sysid_control_slave_arb_share_counter <= 0;
      else if (sysid_control_slave_arb_counter_enable)
          sysid_control_slave_arb_share_counter <= sysid_control_slave_arb_share_counter_next_value;
    end


  //sysid_control_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          sysid_control_slave_slavearbiterlockenable <= 0;
      else if ((|sysid_control_slave_master_qreq_vector & end_xfer_arb_share_counter_term_sysid_control_slave) | (end_xfer_arb_share_counter_term_sysid_control_slave & ~sysid_control_slave_non_bursting_master_requests))
          sysid_control_slave_slavearbiterlockenable <= |sysid_control_slave_arb_share_counter_next_value;
    end


  //cpu/data_master sysid/control_slave arbiterlock, which is an e_assign
  assign cpu_data_master_arbiterlock = sysid_control_slave_slavearbiterlockenable & cpu_data_master_continuerequest;

  //sysid_control_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign sysid_control_slave_slavearbiterlockenable2 = |sysid_control_slave_arb_share_counter_next_value;

  //cpu/data_master sysid/control_slave arbiterlock2, which is an e_assign
  assign cpu_data_master_arbiterlock2 = sysid_control_slave_slavearbiterlockenable2 & cpu_data_master_continuerequest;

  //sysid_control_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  assign sysid_control_slave_any_continuerequest = 1;

  //cpu_data_master_continuerequest continued request, which is an e_assign
  assign cpu_data_master_continuerequest = 1;

  assign cpu_data_master_qualified_request_sysid_control_slave = cpu_data_master_requests_sysid_control_slave;
  //master is always granted when requested
  assign cpu_data_master_granted_sysid_control_slave = cpu_data_master_qualified_request_sysid_control_slave;

  //cpu/data_master saved-grant sysid/control_slave, which is an e_assign
  assign cpu_data_master_saved_grant_sysid_control_slave = cpu_data_master_requests_sysid_control_slave;

  //allow new arb cycle for sysid/control_slave, which is an e_assign
  assign sysid_control_slave_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign sysid_control_slave_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign sysid_control_slave_master_qreq_vector = 1;

  //sysid_control_slave_reset_n assignment, which is an e_assign
  assign sysid_control_slave_reset_n = reset_n;

  //sysid_control_slave_firsttransfer first transaction, which is an e_assign
  assign sysid_control_slave_firsttransfer = sysid_control_slave_begins_xfer ? sysid_control_slave_unreg_firsttransfer : sysid_control_slave_reg_firsttransfer;

  //sysid_control_slave_unreg_firsttransfer first transaction, which is an e_assign
  assign sysid_control_slave_unreg_firsttransfer = ~(sysid_control_slave_slavearbiterlockenable & sysid_control_slave_any_continuerequest);

  //sysid_control_slave_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          sysid_control_slave_reg_firsttransfer <= 1'b1;
      else if (sysid_control_slave_begins_xfer)
          sysid_control_slave_reg_firsttransfer <= sysid_control_slave_unreg_firsttransfer;
    end


  //sysid_control_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign sysid_control_slave_beginbursttransfer_internal = sysid_control_slave_begins_xfer;

  assign shifted_address_to_sysid_control_slave_from_cpu_data_master = cpu_data_master_address_to_slave;
  //sysid_control_slave_address mux, which is an e_mux
  assign sysid_control_slave_address = shifted_address_to_sysid_control_slave_from_cpu_data_master >> 2;

  //d1_sysid_control_slave_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_sysid_control_slave_end_xfer <= 1;
      else 
        d1_sysid_control_slave_end_xfer <= sysid_control_slave_end_xfer;
    end


  //sysid_control_slave_waits_for_read in a cycle, which is an e_mux
  assign sysid_control_slave_waits_for_read = sysid_control_slave_in_a_read_cycle & sysid_control_slave_begins_xfer;

  //sysid_control_slave_in_a_read_cycle assignment, which is an e_assign
  assign sysid_control_slave_in_a_read_cycle = cpu_data_master_granted_sysid_control_slave & cpu_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = sysid_control_slave_in_a_read_cycle;

  //sysid_control_slave_waits_for_write in a cycle, which is an e_mux
  assign sysid_control_slave_waits_for_write = sysid_control_slave_in_a_write_cycle & 0;

  //sysid_control_slave_in_a_write_cycle assignment, which is an e_assign
  assign sysid_control_slave_in_a_write_cycle = cpu_data_master_granted_sysid_control_slave & cpu_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = sysid_control_slave_in_a_write_cycle;

  assign wait_for_sysid_control_slave_counter = 0;

//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //sysid/control_slave enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else 
        enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module timer_s1_arbitrator (
                             // inputs:
                              clk,
                              cpu_data_master_address_to_slave,
                              cpu_data_master_read,
                              cpu_data_master_waitrequest,
                              cpu_data_master_write,
                              cpu_data_master_writedata,
                              reset_n,
                              timer_s1_irq,
                              timer_s1_readdata,

                             // outputs:
                              cpu_data_master_granted_timer_s1,
                              cpu_data_master_qualified_request_timer_s1,
                              cpu_data_master_read_data_valid_timer_s1,
                              cpu_data_master_requests_timer_s1,
                              d1_timer_s1_end_xfer,
                              timer_s1_address,
                              timer_s1_chipselect,
                              timer_s1_irq_from_sa,
                              timer_s1_readdata_from_sa,
                              timer_s1_reset_n,
                              timer_s1_write_n,
                              timer_s1_writedata
                           )
;

  output           cpu_data_master_granted_timer_s1;
  output           cpu_data_master_qualified_request_timer_s1;
  output           cpu_data_master_read_data_valid_timer_s1;
  output           cpu_data_master_requests_timer_s1;
  output           d1_timer_s1_end_xfer;
  output  [  2: 0] timer_s1_address;
  output           timer_s1_chipselect;
  output           timer_s1_irq_from_sa;
  output  [ 15: 0] timer_s1_readdata_from_sa;
  output           timer_s1_reset_n;
  output           timer_s1_write_n;
  output  [ 15: 0] timer_s1_writedata;
  input            clk;
  input   [ 16: 0] cpu_data_master_address_to_slave;
  input            cpu_data_master_read;
  input            cpu_data_master_waitrequest;
  input            cpu_data_master_write;
  input   [ 31: 0] cpu_data_master_writedata;
  input            reset_n;
  input            timer_s1_irq;
  input   [ 15: 0] timer_s1_readdata;

  wire             cpu_data_master_arbiterlock;
  wire             cpu_data_master_arbiterlock2;
  wire             cpu_data_master_continuerequest;
  wire             cpu_data_master_granted_timer_s1;
  wire             cpu_data_master_qualified_request_timer_s1;
  wire             cpu_data_master_read_data_valid_timer_s1;
  wire             cpu_data_master_requests_timer_s1;
  wire             cpu_data_master_saved_grant_timer_s1;
  reg              d1_reasons_to_wait;
  reg              d1_timer_s1_end_xfer;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_timer_s1;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [ 16: 0] shifted_address_to_timer_s1_from_cpu_data_master;
  wire    [  2: 0] timer_s1_address;
  wire             timer_s1_allgrants;
  wire             timer_s1_allow_new_arb_cycle;
  wire             timer_s1_any_bursting_master_saved_grant;
  wire             timer_s1_any_continuerequest;
  wire             timer_s1_arb_counter_enable;
  reg              timer_s1_arb_share_counter;
  wire             timer_s1_arb_share_counter_next_value;
  wire             timer_s1_arb_share_set_values;
  wire             timer_s1_beginbursttransfer_internal;
  wire             timer_s1_begins_xfer;
  wire             timer_s1_chipselect;
  wire             timer_s1_end_xfer;
  wire             timer_s1_firsttransfer;
  wire             timer_s1_grant_vector;
  wire             timer_s1_in_a_read_cycle;
  wire             timer_s1_in_a_write_cycle;
  wire             timer_s1_irq_from_sa;
  wire             timer_s1_master_qreq_vector;
  wire             timer_s1_non_bursting_master_requests;
  wire    [ 15: 0] timer_s1_readdata_from_sa;
  reg              timer_s1_reg_firsttransfer;
  wire             timer_s1_reset_n;
  reg              timer_s1_slavearbiterlockenable;
  wire             timer_s1_slavearbiterlockenable2;
  wire             timer_s1_unreg_firsttransfer;
  wire             timer_s1_waits_for_read;
  wire             timer_s1_waits_for_write;
  wire             timer_s1_write_n;
  wire    [ 15: 0] timer_s1_writedata;
  wire             wait_for_timer_s1_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else 
        d1_reasons_to_wait <= ~timer_s1_end_xfer;
    end


  assign timer_s1_begins_xfer = ~d1_reasons_to_wait & ((cpu_data_master_qualified_request_timer_s1));
  //assign timer_s1_readdata_from_sa = timer_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign timer_s1_readdata_from_sa = timer_s1_readdata;

  assign cpu_data_master_requests_timer_s1 = ({cpu_data_master_address_to_slave[16 : 5] , 5'b0} == 17'h60) & (cpu_data_master_read | cpu_data_master_write);
  //timer_s1_arb_share_counter set values, which is an e_mux
  assign timer_s1_arb_share_set_values = 1;

  //timer_s1_non_bursting_master_requests mux, which is an e_mux
  assign timer_s1_non_bursting_master_requests = cpu_data_master_requests_timer_s1;

  //timer_s1_any_bursting_master_saved_grant mux, which is an e_mux
  assign timer_s1_any_bursting_master_saved_grant = 0;

  //timer_s1_arb_share_counter_next_value assignment, which is an e_assign
  assign timer_s1_arb_share_counter_next_value = timer_s1_firsttransfer ? (timer_s1_arb_share_set_values - 1) : |timer_s1_arb_share_counter ? (timer_s1_arb_share_counter - 1) : 0;

  //timer_s1_allgrants all slave grants, which is an e_mux
  assign timer_s1_allgrants = |timer_s1_grant_vector;

  //timer_s1_end_xfer assignment, which is an e_assign
  assign timer_s1_end_xfer = ~(timer_s1_waits_for_read | timer_s1_waits_for_write);

  //end_xfer_arb_share_counter_term_timer_s1 arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_timer_s1 = timer_s1_end_xfer & (~timer_s1_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //timer_s1_arb_share_counter arbitration counter enable, which is an e_assign
  assign timer_s1_arb_counter_enable = (end_xfer_arb_share_counter_term_timer_s1 & timer_s1_allgrants) | (end_xfer_arb_share_counter_term_timer_s1 & ~timer_s1_non_bursting_master_requests);

  //timer_s1_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          timer_s1_arb_share_counter <= 0;
      else if (timer_s1_arb_counter_enable)
          timer_s1_arb_share_counter <= timer_s1_arb_share_counter_next_value;
    end


  //timer_s1_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          timer_s1_slavearbiterlockenable <= 0;
      else if ((|timer_s1_master_qreq_vector & end_xfer_arb_share_counter_term_timer_s1) | (end_xfer_arb_share_counter_term_timer_s1 & ~timer_s1_non_bursting_master_requests))
          timer_s1_slavearbiterlockenable <= |timer_s1_arb_share_counter_next_value;
    end


  //cpu/data_master timer/s1 arbiterlock, which is an e_assign
  assign cpu_data_master_arbiterlock = timer_s1_slavearbiterlockenable & cpu_data_master_continuerequest;

  //timer_s1_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign timer_s1_slavearbiterlockenable2 = |timer_s1_arb_share_counter_next_value;

  //cpu/data_master timer/s1 arbiterlock2, which is an e_assign
  assign cpu_data_master_arbiterlock2 = timer_s1_slavearbiterlockenable2 & cpu_data_master_continuerequest;

  //timer_s1_any_continuerequest at least one master continues requesting, which is an e_assign
  assign timer_s1_any_continuerequest = 1;

  //cpu_data_master_continuerequest continued request, which is an e_assign
  assign cpu_data_master_continuerequest = 1;

  assign cpu_data_master_qualified_request_timer_s1 = cpu_data_master_requests_timer_s1 & ~(((~cpu_data_master_waitrequest) & cpu_data_master_write));
  //timer_s1_writedata mux, which is an e_mux
  assign timer_s1_writedata = cpu_data_master_writedata;

  //master is always granted when requested
  assign cpu_data_master_granted_timer_s1 = cpu_data_master_qualified_request_timer_s1;

  //cpu/data_master saved-grant timer/s1, which is an e_assign
  assign cpu_data_master_saved_grant_timer_s1 = cpu_data_master_requests_timer_s1;

  //allow new arb cycle for timer/s1, which is an e_assign
  assign timer_s1_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign timer_s1_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign timer_s1_master_qreq_vector = 1;

  //timer_s1_reset_n assignment, which is an e_assign
  assign timer_s1_reset_n = reset_n;

  assign timer_s1_chipselect = cpu_data_master_granted_timer_s1;
  //timer_s1_firsttransfer first transaction, which is an e_assign
  assign timer_s1_firsttransfer = timer_s1_begins_xfer ? timer_s1_unreg_firsttransfer : timer_s1_reg_firsttransfer;

  //timer_s1_unreg_firsttransfer first transaction, which is an e_assign
  assign timer_s1_unreg_firsttransfer = ~(timer_s1_slavearbiterlockenable & timer_s1_any_continuerequest);

  //timer_s1_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          timer_s1_reg_firsttransfer <= 1'b1;
      else if (timer_s1_begins_xfer)
          timer_s1_reg_firsttransfer <= timer_s1_unreg_firsttransfer;
    end


  //timer_s1_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign timer_s1_beginbursttransfer_internal = timer_s1_begins_xfer;

  //~timer_s1_write_n assignment, which is an e_mux
  assign timer_s1_write_n = ~(cpu_data_master_granted_timer_s1 & cpu_data_master_write);

  assign shifted_address_to_timer_s1_from_cpu_data_master = cpu_data_master_address_to_slave;
  //timer_s1_address mux, which is an e_mux
  assign timer_s1_address = shifted_address_to_timer_s1_from_cpu_data_master >> 2;

  //d1_timer_s1_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_timer_s1_end_xfer <= 1;
      else 
        d1_timer_s1_end_xfer <= timer_s1_end_xfer;
    end


  //timer_s1_waits_for_read in a cycle, which is an e_mux
  assign timer_s1_waits_for_read = timer_s1_in_a_read_cycle & timer_s1_begins_xfer;

  //timer_s1_in_a_read_cycle assignment, which is an e_assign
  assign timer_s1_in_a_read_cycle = cpu_data_master_granted_timer_s1 & cpu_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = timer_s1_in_a_read_cycle;

  //timer_s1_waits_for_write in a cycle, which is an e_mux
  assign timer_s1_waits_for_write = timer_s1_in_a_write_cycle & 0;

  //timer_s1_in_a_write_cycle assignment, which is an e_assign
  assign timer_s1_in_a_write_cycle = cpu_data_master_granted_timer_s1 & cpu_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = timer_s1_in_a_write_cycle;

  assign wait_for_timer_s1_counter = 0;
  //assign timer_s1_irq_from_sa = timer_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign timer_s1_irq_from_sa = timer_s1_irq;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //timer/s1 enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else 
        enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module uCProbe_uart_avalon_jtag_slave_arbitrator (
                                                   // inputs:
                                                    clk,
                                                    cpu_data_master_address_to_slave,
                                                    cpu_data_master_read,
                                                    cpu_data_master_waitrequest,
                                                    cpu_data_master_write,
                                                    cpu_data_master_writedata,
                                                    reset_n,
                                                    uCProbe_uart_avalon_jtag_slave_dataavailable,
                                                    uCProbe_uart_avalon_jtag_slave_irq,
                                                    uCProbe_uart_avalon_jtag_slave_readdata,
                                                    uCProbe_uart_avalon_jtag_slave_readyfordata,
                                                    uCProbe_uart_avalon_jtag_slave_waitrequest,

                                                   // outputs:
                                                    cpu_data_master_granted_uCProbe_uart_avalon_jtag_slave,
                                                    cpu_data_master_qualified_request_uCProbe_uart_avalon_jtag_slave,
                                                    cpu_data_master_read_data_valid_uCProbe_uart_avalon_jtag_slave,
                                                    cpu_data_master_requests_uCProbe_uart_avalon_jtag_slave,
                                                    d1_uCProbe_uart_avalon_jtag_slave_end_xfer,
                                                    uCProbe_uart_avalon_jtag_slave_address,
                                                    uCProbe_uart_avalon_jtag_slave_chipselect,
                                                    uCProbe_uart_avalon_jtag_slave_dataavailable_from_sa,
                                                    uCProbe_uart_avalon_jtag_slave_irq_from_sa,
                                                    uCProbe_uart_avalon_jtag_slave_read_n,
                                                    uCProbe_uart_avalon_jtag_slave_readdata_from_sa,
                                                    uCProbe_uart_avalon_jtag_slave_readyfordata_from_sa,
                                                    uCProbe_uart_avalon_jtag_slave_reset_n,
                                                    uCProbe_uart_avalon_jtag_slave_waitrequest_from_sa,
                                                    uCProbe_uart_avalon_jtag_slave_write_n,
                                                    uCProbe_uart_avalon_jtag_slave_writedata
                                                 )
;

  output           cpu_data_master_granted_uCProbe_uart_avalon_jtag_slave;
  output           cpu_data_master_qualified_request_uCProbe_uart_avalon_jtag_slave;
  output           cpu_data_master_read_data_valid_uCProbe_uart_avalon_jtag_slave;
  output           cpu_data_master_requests_uCProbe_uart_avalon_jtag_slave;
  output           d1_uCProbe_uart_avalon_jtag_slave_end_xfer;
  output           uCProbe_uart_avalon_jtag_slave_address;
  output           uCProbe_uart_avalon_jtag_slave_chipselect;
  output           uCProbe_uart_avalon_jtag_slave_dataavailable_from_sa;
  output           uCProbe_uart_avalon_jtag_slave_irq_from_sa;
  output           uCProbe_uart_avalon_jtag_slave_read_n;
  output  [ 31: 0] uCProbe_uart_avalon_jtag_slave_readdata_from_sa;
  output           uCProbe_uart_avalon_jtag_slave_readyfordata_from_sa;
  output           uCProbe_uart_avalon_jtag_slave_reset_n;
  output           uCProbe_uart_avalon_jtag_slave_waitrequest_from_sa;
  output           uCProbe_uart_avalon_jtag_slave_write_n;
  output  [ 31: 0] uCProbe_uart_avalon_jtag_slave_writedata;
  input            clk;
  input   [ 16: 0] cpu_data_master_address_to_slave;
  input            cpu_data_master_read;
  input            cpu_data_master_waitrequest;
  input            cpu_data_master_write;
  input   [ 31: 0] cpu_data_master_writedata;
  input            reset_n;
  input            uCProbe_uart_avalon_jtag_slave_dataavailable;
  input            uCProbe_uart_avalon_jtag_slave_irq;
  input   [ 31: 0] uCProbe_uart_avalon_jtag_slave_readdata;
  input            uCProbe_uart_avalon_jtag_slave_readyfordata;
  input            uCProbe_uart_avalon_jtag_slave_waitrequest;

  wire             cpu_data_master_arbiterlock;
  wire             cpu_data_master_arbiterlock2;
  wire             cpu_data_master_continuerequest;
  wire             cpu_data_master_granted_uCProbe_uart_avalon_jtag_slave;
  wire             cpu_data_master_qualified_request_uCProbe_uart_avalon_jtag_slave;
  wire             cpu_data_master_read_data_valid_uCProbe_uart_avalon_jtag_slave;
  wire             cpu_data_master_requests_uCProbe_uart_avalon_jtag_slave;
  wire             cpu_data_master_saved_grant_uCProbe_uart_avalon_jtag_slave;
  reg              d1_reasons_to_wait;
  reg              d1_uCProbe_uart_avalon_jtag_slave_end_xfer;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_uCProbe_uart_avalon_jtag_slave;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [ 16: 0] shifted_address_to_uCProbe_uart_avalon_jtag_slave_from_cpu_data_master;
  wire             uCProbe_uart_avalon_jtag_slave_address;
  wire             uCProbe_uart_avalon_jtag_slave_allgrants;
  wire             uCProbe_uart_avalon_jtag_slave_allow_new_arb_cycle;
  wire             uCProbe_uart_avalon_jtag_slave_any_bursting_master_saved_grant;
  wire             uCProbe_uart_avalon_jtag_slave_any_continuerequest;
  wire             uCProbe_uart_avalon_jtag_slave_arb_counter_enable;
  reg              uCProbe_uart_avalon_jtag_slave_arb_share_counter;
  wire             uCProbe_uart_avalon_jtag_slave_arb_share_counter_next_value;
  wire             uCProbe_uart_avalon_jtag_slave_arb_share_set_values;
  wire             uCProbe_uart_avalon_jtag_slave_beginbursttransfer_internal;
  wire             uCProbe_uart_avalon_jtag_slave_begins_xfer;
  wire             uCProbe_uart_avalon_jtag_slave_chipselect;
  wire             uCProbe_uart_avalon_jtag_slave_dataavailable_from_sa;
  wire             uCProbe_uart_avalon_jtag_slave_end_xfer;
  wire             uCProbe_uart_avalon_jtag_slave_firsttransfer;
  wire             uCProbe_uart_avalon_jtag_slave_grant_vector;
  wire             uCProbe_uart_avalon_jtag_slave_in_a_read_cycle;
  wire             uCProbe_uart_avalon_jtag_slave_in_a_write_cycle;
  wire             uCProbe_uart_avalon_jtag_slave_irq_from_sa;
  wire             uCProbe_uart_avalon_jtag_slave_master_qreq_vector;
  wire             uCProbe_uart_avalon_jtag_slave_non_bursting_master_requests;
  wire             uCProbe_uart_avalon_jtag_slave_read_n;
  wire    [ 31: 0] uCProbe_uart_avalon_jtag_slave_readdata_from_sa;
  wire             uCProbe_uart_avalon_jtag_slave_readyfordata_from_sa;
  reg              uCProbe_uart_avalon_jtag_slave_reg_firsttransfer;
  wire             uCProbe_uart_avalon_jtag_slave_reset_n;
  reg              uCProbe_uart_avalon_jtag_slave_slavearbiterlockenable;
  wire             uCProbe_uart_avalon_jtag_slave_slavearbiterlockenable2;
  wire             uCProbe_uart_avalon_jtag_slave_unreg_firsttransfer;
  wire             uCProbe_uart_avalon_jtag_slave_waitrequest_from_sa;
  wire             uCProbe_uart_avalon_jtag_slave_waits_for_read;
  wire             uCProbe_uart_avalon_jtag_slave_waits_for_write;
  wire             uCProbe_uart_avalon_jtag_slave_write_n;
  wire    [ 31: 0] uCProbe_uart_avalon_jtag_slave_writedata;
  wire             wait_for_uCProbe_uart_avalon_jtag_slave_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else 
        d1_reasons_to_wait <= ~uCProbe_uart_avalon_jtag_slave_end_xfer;
    end


  assign uCProbe_uart_avalon_jtag_slave_begins_xfer = ~d1_reasons_to_wait & ((cpu_data_master_qualified_request_uCProbe_uart_avalon_jtag_slave));
  //assign uCProbe_uart_avalon_jtag_slave_readdata_from_sa = uCProbe_uart_avalon_jtag_slave_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign uCProbe_uart_avalon_jtag_slave_readdata_from_sa = uCProbe_uart_avalon_jtag_slave_readdata;

  assign cpu_data_master_requests_uCProbe_uart_avalon_jtag_slave = ({cpu_data_master_address_to_slave[16 : 3] , 3'b0} == 17'ha0) & (cpu_data_master_read | cpu_data_master_write);
  //assign uCProbe_uart_avalon_jtag_slave_dataavailable_from_sa = uCProbe_uart_avalon_jtag_slave_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign uCProbe_uart_avalon_jtag_slave_dataavailable_from_sa = uCProbe_uart_avalon_jtag_slave_dataavailable;

  //assign uCProbe_uart_avalon_jtag_slave_readyfordata_from_sa = uCProbe_uart_avalon_jtag_slave_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign uCProbe_uart_avalon_jtag_slave_readyfordata_from_sa = uCProbe_uart_avalon_jtag_slave_readyfordata;

  //assign uCProbe_uart_avalon_jtag_slave_waitrequest_from_sa = uCProbe_uart_avalon_jtag_slave_waitrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign uCProbe_uart_avalon_jtag_slave_waitrequest_from_sa = uCProbe_uart_avalon_jtag_slave_waitrequest;

  //uCProbe_uart_avalon_jtag_slave_arb_share_counter set values, which is an e_mux
  assign uCProbe_uart_avalon_jtag_slave_arb_share_set_values = 1;

  //uCProbe_uart_avalon_jtag_slave_non_bursting_master_requests mux, which is an e_mux
  assign uCProbe_uart_avalon_jtag_slave_non_bursting_master_requests = cpu_data_master_requests_uCProbe_uart_avalon_jtag_slave;

  //uCProbe_uart_avalon_jtag_slave_any_bursting_master_saved_grant mux, which is an e_mux
  assign uCProbe_uart_avalon_jtag_slave_any_bursting_master_saved_grant = 0;

  //uCProbe_uart_avalon_jtag_slave_arb_share_counter_next_value assignment, which is an e_assign
  assign uCProbe_uart_avalon_jtag_slave_arb_share_counter_next_value = uCProbe_uart_avalon_jtag_slave_firsttransfer ? (uCProbe_uart_avalon_jtag_slave_arb_share_set_values - 1) : |uCProbe_uart_avalon_jtag_slave_arb_share_counter ? (uCProbe_uart_avalon_jtag_slave_arb_share_counter - 1) : 0;

  //uCProbe_uart_avalon_jtag_slave_allgrants all slave grants, which is an e_mux
  assign uCProbe_uart_avalon_jtag_slave_allgrants = |uCProbe_uart_avalon_jtag_slave_grant_vector;

  //uCProbe_uart_avalon_jtag_slave_end_xfer assignment, which is an e_assign
  assign uCProbe_uart_avalon_jtag_slave_end_xfer = ~(uCProbe_uart_avalon_jtag_slave_waits_for_read | uCProbe_uart_avalon_jtag_slave_waits_for_write);

  //end_xfer_arb_share_counter_term_uCProbe_uart_avalon_jtag_slave arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_uCProbe_uart_avalon_jtag_slave = uCProbe_uart_avalon_jtag_slave_end_xfer & (~uCProbe_uart_avalon_jtag_slave_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //uCProbe_uart_avalon_jtag_slave_arb_share_counter arbitration counter enable, which is an e_assign
  assign uCProbe_uart_avalon_jtag_slave_arb_counter_enable = (end_xfer_arb_share_counter_term_uCProbe_uart_avalon_jtag_slave & uCProbe_uart_avalon_jtag_slave_allgrants) | (end_xfer_arb_share_counter_term_uCProbe_uart_avalon_jtag_slave & ~uCProbe_uart_avalon_jtag_slave_non_bursting_master_requests);

  //uCProbe_uart_avalon_jtag_slave_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          uCProbe_uart_avalon_jtag_slave_arb_share_counter <= 0;
      else if (uCProbe_uart_avalon_jtag_slave_arb_counter_enable)
          uCProbe_uart_avalon_jtag_slave_arb_share_counter <= uCProbe_uart_avalon_jtag_slave_arb_share_counter_next_value;
    end


  //uCProbe_uart_avalon_jtag_slave_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          uCProbe_uart_avalon_jtag_slave_slavearbiterlockenable <= 0;
      else if ((|uCProbe_uart_avalon_jtag_slave_master_qreq_vector & end_xfer_arb_share_counter_term_uCProbe_uart_avalon_jtag_slave) | (end_xfer_arb_share_counter_term_uCProbe_uart_avalon_jtag_slave & ~uCProbe_uart_avalon_jtag_slave_non_bursting_master_requests))
          uCProbe_uart_avalon_jtag_slave_slavearbiterlockenable <= |uCProbe_uart_avalon_jtag_slave_arb_share_counter_next_value;
    end


  //cpu/data_master uCProbe_uart/avalon_jtag_slave arbiterlock, which is an e_assign
  assign cpu_data_master_arbiterlock = uCProbe_uart_avalon_jtag_slave_slavearbiterlockenable & cpu_data_master_continuerequest;

  //uCProbe_uart_avalon_jtag_slave_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign uCProbe_uart_avalon_jtag_slave_slavearbiterlockenable2 = |uCProbe_uart_avalon_jtag_slave_arb_share_counter_next_value;

  //cpu/data_master uCProbe_uart/avalon_jtag_slave arbiterlock2, which is an e_assign
  assign cpu_data_master_arbiterlock2 = uCProbe_uart_avalon_jtag_slave_slavearbiterlockenable2 & cpu_data_master_continuerequest;

  //uCProbe_uart_avalon_jtag_slave_any_continuerequest at least one master continues requesting, which is an e_assign
  assign uCProbe_uart_avalon_jtag_slave_any_continuerequest = 1;

  //cpu_data_master_continuerequest continued request, which is an e_assign
  assign cpu_data_master_continuerequest = 1;

  assign cpu_data_master_qualified_request_uCProbe_uart_avalon_jtag_slave = cpu_data_master_requests_uCProbe_uart_avalon_jtag_slave & ~((cpu_data_master_read & (~cpu_data_master_waitrequest)) | ((~cpu_data_master_waitrequest) & cpu_data_master_write));
  //uCProbe_uart_avalon_jtag_slave_writedata mux, which is an e_mux
  assign uCProbe_uart_avalon_jtag_slave_writedata = cpu_data_master_writedata;

  //master is always granted when requested
  assign cpu_data_master_granted_uCProbe_uart_avalon_jtag_slave = cpu_data_master_qualified_request_uCProbe_uart_avalon_jtag_slave;

  //cpu/data_master saved-grant uCProbe_uart/avalon_jtag_slave, which is an e_assign
  assign cpu_data_master_saved_grant_uCProbe_uart_avalon_jtag_slave = cpu_data_master_requests_uCProbe_uart_avalon_jtag_slave;

  //allow new arb cycle for uCProbe_uart/avalon_jtag_slave, which is an e_assign
  assign uCProbe_uart_avalon_jtag_slave_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign uCProbe_uart_avalon_jtag_slave_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign uCProbe_uart_avalon_jtag_slave_master_qreq_vector = 1;

  //uCProbe_uart_avalon_jtag_slave_reset_n assignment, which is an e_assign
  assign uCProbe_uart_avalon_jtag_slave_reset_n = reset_n;

  assign uCProbe_uart_avalon_jtag_slave_chipselect = cpu_data_master_granted_uCProbe_uart_avalon_jtag_slave;
  //uCProbe_uart_avalon_jtag_slave_firsttransfer first transaction, which is an e_assign
  assign uCProbe_uart_avalon_jtag_slave_firsttransfer = uCProbe_uart_avalon_jtag_slave_begins_xfer ? uCProbe_uart_avalon_jtag_slave_unreg_firsttransfer : uCProbe_uart_avalon_jtag_slave_reg_firsttransfer;

  //uCProbe_uart_avalon_jtag_slave_unreg_firsttransfer first transaction, which is an e_assign
  assign uCProbe_uart_avalon_jtag_slave_unreg_firsttransfer = ~(uCProbe_uart_avalon_jtag_slave_slavearbiterlockenable & uCProbe_uart_avalon_jtag_slave_any_continuerequest);

  //uCProbe_uart_avalon_jtag_slave_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          uCProbe_uart_avalon_jtag_slave_reg_firsttransfer <= 1'b1;
      else if (uCProbe_uart_avalon_jtag_slave_begins_xfer)
          uCProbe_uart_avalon_jtag_slave_reg_firsttransfer <= uCProbe_uart_avalon_jtag_slave_unreg_firsttransfer;
    end


  //uCProbe_uart_avalon_jtag_slave_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign uCProbe_uart_avalon_jtag_slave_beginbursttransfer_internal = uCProbe_uart_avalon_jtag_slave_begins_xfer;

  //~uCProbe_uart_avalon_jtag_slave_read_n assignment, which is an e_mux
  assign uCProbe_uart_avalon_jtag_slave_read_n = ~(cpu_data_master_granted_uCProbe_uart_avalon_jtag_slave & cpu_data_master_read);

  //~uCProbe_uart_avalon_jtag_slave_write_n assignment, which is an e_mux
  assign uCProbe_uart_avalon_jtag_slave_write_n = ~(cpu_data_master_granted_uCProbe_uart_avalon_jtag_slave & cpu_data_master_write);

  assign shifted_address_to_uCProbe_uart_avalon_jtag_slave_from_cpu_data_master = cpu_data_master_address_to_slave;
  //uCProbe_uart_avalon_jtag_slave_address mux, which is an e_mux
  assign uCProbe_uart_avalon_jtag_slave_address = shifted_address_to_uCProbe_uart_avalon_jtag_slave_from_cpu_data_master >> 2;

  //d1_uCProbe_uart_avalon_jtag_slave_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_uCProbe_uart_avalon_jtag_slave_end_xfer <= 1;
      else 
        d1_uCProbe_uart_avalon_jtag_slave_end_xfer <= uCProbe_uart_avalon_jtag_slave_end_xfer;
    end


  //uCProbe_uart_avalon_jtag_slave_waits_for_read in a cycle, which is an e_mux
  assign uCProbe_uart_avalon_jtag_slave_waits_for_read = uCProbe_uart_avalon_jtag_slave_in_a_read_cycle & uCProbe_uart_avalon_jtag_slave_waitrequest_from_sa;

  //uCProbe_uart_avalon_jtag_slave_in_a_read_cycle assignment, which is an e_assign
  assign uCProbe_uart_avalon_jtag_slave_in_a_read_cycle = cpu_data_master_granted_uCProbe_uart_avalon_jtag_slave & cpu_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = uCProbe_uart_avalon_jtag_slave_in_a_read_cycle;

  //uCProbe_uart_avalon_jtag_slave_waits_for_write in a cycle, which is an e_mux
  assign uCProbe_uart_avalon_jtag_slave_waits_for_write = uCProbe_uart_avalon_jtag_slave_in_a_write_cycle & uCProbe_uart_avalon_jtag_slave_waitrequest_from_sa;

  //uCProbe_uart_avalon_jtag_slave_in_a_write_cycle assignment, which is an e_assign
  assign uCProbe_uart_avalon_jtag_slave_in_a_write_cycle = cpu_data_master_granted_uCProbe_uart_avalon_jtag_slave & cpu_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = uCProbe_uart_avalon_jtag_slave_in_a_write_cycle;

  assign wait_for_uCProbe_uart_avalon_jtag_slave_counter = 0;
  //assign uCProbe_uart_avalon_jtag_slave_irq_from_sa = uCProbe_uart_avalon_jtag_slave_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign uCProbe_uart_avalon_jtag_slave_irq_from_sa = uCProbe_uart_avalon_jtag_slave_irq;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //uCProbe_uart/avalon_jtag_slave enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else 
        enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module uC_clock_0_in_arbitrator (
                                  // inputs:
                                   clk,
                                   cpu_data_master_address_to_slave,
                                   cpu_data_master_byteenable,
                                   cpu_data_master_read,
                                   cpu_data_master_waitrequest,
                                   cpu_data_master_write,
                                   cpu_data_master_writedata,
                                   reset_n,
                                   uC_clock_0_in_endofpacket,
                                   uC_clock_0_in_readdata,
                                   uC_clock_0_in_waitrequest,

                                  // outputs:
                                   cpu_data_master_granted_uC_clock_0_in,
                                   cpu_data_master_qualified_request_uC_clock_0_in,
                                   cpu_data_master_read_data_valid_uC_clock_0_in,
                                   cpu_data_master_requests_uC_clock_0_in,
                                   d1_uC_clock_0_in_end_xfer,
                                   uC_clock_0_in_address,
                                   uC_clock_0_in_byteenable,
                                   uC_clock_0_in_endofpacket_from_sa,
                                   uC_clock_0_in_nativeaddress,
                                   uC_clock_0_in_read,
                                   uC_clock_0_in_readdata_from_sa,
                                   uC_clock_0_in_reset_n,
                                   uC_clock_0_in_waitrequest_from_sa,
                                   uC_clock_0_in_write,
                                   uC_clock_0_in_writedata
                                )
;

  output           cpu_data_master_granted_uC_clock_0_in;
  output           cpu_data_master_qualified_request_uC_clock_0_in;
  output           cpu_data_master_read_data_valid_uC_clock_0_in;
  output           cpu_data_master_requests_uC_clock_0_in;
  output           d1_uC_clock_0_in_end_xfer;
  output  [  3: 0] uC_clock_0_in_address;
  output  [  3: 0] uC_clock_0_in_byteenable;
  output           uC_clock_0_in_endofpacket_from_sa;
  output  [  1: 0] uC_clock_0_in_nativeaddress;
  output           uC_clock_0_in_read;
  output  [ 31: 0] uC_clock_0_in_readdata_from_sa;
  output           uC_clock_0_in_reset_n;
  output           uC_clock_0_in_waitrequest_from_sa;
  output           uC_clock_0_in_write;
  output  [ 31: 0] uC_clock_0_in_writedata;
  input            clk;
  input   [ 16: 0] cpu_data_master_address_to_slave;
  input   [  3: 0] cpu_data_master_byteenable;
  input            cpu_data_master_read;
  input            cpu_data_master_waitrequest;
  input            cpu_data_master_write;
  input   [ 31: 0] cpu_data_master_writedata;
  input            reset_n;
  input            uC_clock_0_in_endofpacket;
  input   [ 31: 0] uC_clock_0_in_readdata;
  input            uC_clock_0_in_waitrequest;

  wire             cpu_data_master_arbiterlock;
  wire             cpu_data_master_arbiterlock2;
  wire             cpu_data_master_continuerequest;
  wire             cpu_data_master_granted_uC_clock_0_in;
  wire             cpu_data_master_qualified_request_uC_clock_0_in;
  wire             cpu_data_master_read_data_valid_uC_clock_0_in;
  wire             cpu_data_master_requests_uC_clock_0_in;
  wire             cpu_data_master_saved_grant_uC_clock_0_in;
  reg              d1_reasons_to_wait;
  reg              d1_uC_clock_0_in_end_xfer;
  reg              enable_nonzero_assertions;
  wire             end_xfer_arb_share_counter_term_uC_clock_0_in;
  wire             in_a_read_cycle;
  wire             in_a_write_cycle;
  wire    [  3: 0] uC_clock_0_in_address;
  wire             uC_clock_0_in_allgrants;
  wire             uC_clock_0_in_allow_new_arb_cycle;
  wire             uC_clock_0_in_any_bursting_master_saved_grant;
  wire             uC_clock_0_in_any_continuerequest;
  wire             uC_clock_0_in_arb_counter_enable;
  reg              uC_clock_0_in_arb_share_counter;
  wire             uC_clock_0_in_arb_share_counter_next_value;
  wire             uC_clock_0_in_arb_share_set_values;
  wire             uC_clock_0_in_beginbursttransfer_internal;
  wire             uC_clock_0_in_begins_xfer;
  wire    [  3: 0] uC_clock_0_in_byteenable;
  wire             uC_clock_0_in_end_xfer;
  wire             uC_clock_0_in_endofpacket_from_sa;
  wire             uC_clock_0_in_firsttransfer;
  wire             uC_clock_0_in_grant_vector;
  wire             uC_clock_0_in_in_a_read_cycle;
  wire             uC_clock_0_in_in_a_write_cycle;
  wire             uC_clock_0_in_master_qreq_vector;
  wire    [  1: 0] uC_clock_0_in_nativeaddress;
  wire             uC_clock_0_in_non_bursting_master_requests;
  wire             uC_clock_0_in_read;
  wire    [ 31: 0] uC_clock_0_in_readdata_from_sa;
  reg              uC_clock_0_in_reg_firsttransfer;
  wire             uC_clock_0_in_reset_n;
  reg              uC_clock_0_in_slavearbiterlockenable;
  wire             uC_clock_0_in_slavearbiterlockenable2;
  wire             uC_clock_0_in_unreg_firsttransfer;
  wire             uC_clock_0_in_waitrequest_from_sa;
  wire             uC_clock_0_in_waits_for_read;
  wire             uC_clock_0_in_waits_for_write;
  wire             uC_clock_0_in_write;
  wire    [ 31: 0] uC_clock_0_in_writedata;
  wire             wait_for_uC_clock_0_in_counter;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_reasons_to_wait <= 0;
      else 
        d1_reasons_to_wait <= ~uC_clock_0_in_end_xfer;
    end


  assign uC_clock_0_in_begins_xfer = ~d1_reasons_to_wait & ((cpu_data_master_qualified_request_uC_clock_0_in));
  //assign uC_clock_0_in_readdata_from_sa = uC_clock_0_in_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign uC_clock_0_in_readdata_from_sa = uC_clock_0_in_readdata;

  assign cpu_data_master_requests_uC_clock_0_in = ({cpu_data_master_address_to_slave[16 : 4] , 4'b0} == 17'h50) & (cpu_data_master_read | cpu_data_master_write);
  //assign uC_clock_0_in_waitrequest_from_sa = uC_clock_0_in_waitrequest so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign uC_clock_0_in_waitrequest_from_sa = uC_clock_0_in_waitrequest;

  //uC_clock_0_in_arb_share_counter set values, which is an e_mux
  assign uC_clock_0_in_arb_share_set_values = 1;

  //uC_clock_0_in_non_bursting_master_requests mux, which is an e_mux
  assign uC_clock_0_in_non_bursting_master_requests = cpu_data_master_requests_uC_clock_0_in;

  //uC_clock_0_in_any_bursting_master_saved_grant mux, which is an e_mux
  assign uC_clock_0_in_any_bursting_master_saved_grant = 0;

  //uC_clock_0_in_arb_share_counter_next_value assignment, which is an e_assign
  assign uC_clock_0_in_arb_share_counter_next_value = uC_clock_0_in_firsttransfer ? (uC_clock_0_in_arb_share_set_values - 1) : |uC_clock_0_in_arb_share_counter ? (uC_clock_0_in_arb_share_counter - 1) : 0;

  //uC_clock_0_in_allgrants all slave grants, which is an e_mux
  assign uC_clock_0_in_allgrants = |uC_clock_0_in_grant_vector;

  //uC_clock_0_in_end_xfer assignment, which is an e_assign
  assign uC_clock_0_in_end_xfer = ~(uC_clock_0_in_waits_for_read | uC_clock_0_in_waits_for_write);

  //end_xfer_arb_share_counter_term_uC_clock_0_in arb share counter enable term, which is an e_assign
  assign end_xfer_arb_share_counter_term_uC_clock_0_in = uC_clock_0_in_end_xfer & (~uC_clock_0_in_any_bursting_master_saved_grant | in_a_read_cycle | in_a_write_cycle);

  //uC_clock_0_in_arb_share_counter arbitration counter enable, which is an e_assign
  assign uC_clock_0_in_arb_counter_enable = (end_xfer_arb_share_counter_term_uC_clock_0_in & uC_clock_0_in_allgrants) | (end_xfer_arb_share_counter_term_uC_clock_0_in & ~uC_clock_0_in_non_bursting_master_requests);

  //uC_clock_0_in_arb_share_counter counter, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          uC_clock_0_in_arb_share_counter <= 0;
      else if (uC_clock_0_in_arb_counter_enable)
          uC_clock_0_in_arb_share_counter <= uC_clock_0_in_arb_share_counter_next_value;
    end


  //uC_clock_0_in_slavearbiterlockenable slave enables arbiterlock, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          uC_clock_0_in_slavearbiterlockenable <= 0;
      else if ((|uC_clock_0_in_master_qreq_vector & end_xfer_arb_share_counter_term_uC_clock_0_in) | (end_xfer_arb_share_counter_term_uC_clock_0_in & ~uC_clock_0_in_non_bursting_master_requests))
          uC_clock_0_in_slavearbiterlockenable <= |uC_clock_0_in_arb_share_counter_next_value;
    end


  //cpu/data_master uC_clock_0/in arbiterlock, which is an e_assign
  assign cpu_data_master_arbiterlock = uC_clock_0_in_slavearbiterlockenable & cpu_data_master_continuerequest;

  //uC_clock_0_in_slavearbiterlockenable2 slave enables arbiterlock2, which is an e_assign
  assign uC_clock_0_in_slavearbiterlockenable2 = |uC_clock_0_in_arb_share_counter_next_value;

  //cpu/data_master uC_clock_0/in arbiterlock2, which is an e_assign
  assign cpu_data_master_arbiterlock2 = uC_clock_0_in_slavearbiterlockenable2 & cpu_data_master_continuerequest;

  //uC_clock_0_in_any_continuerequest at least one master continues requesting, which is an e_assign
  assign uC_clock_0_in_any_continuerequest = 1;

  //cpu_data_master_continuerequest continued request, which is an e_assign
  assign cpu_data_master_continuerequest = 1;

  assign cpu_data_master_qualified_request_uC_clock_0_in = cpu_data_master_requests_uC_clock_0_in & ~((cpu_data_master_read & (~cpu_data_master_waitrequest)) | ((~cpu_data_master_waitrequest) & cpu_data_master_write));
  //uC_clock_0_in_writedata mux, which is an e_mux
  assign uC_clock_0_in_writedata = cpu_data_master_writedata;

  //assign uC_clock_0_in_endofpacket_from_sa = uC_clock_0_in_endofpacket so that symbol knows where to group signals which may go to master only, which is an e_assign
  assign uC_clock_0_in_endofpacket_from_sa = uC_clock_0_in_endofpacket;

  //master is always granted when requested
  assign cpu_data_master_granted_uC_clock_0_in = cpu_data_master_qualified_request_uC_clock_0_in;

  //cpu/data_master saved-grant uC_clock_0/in, which is an e_assign
  assign cpu_data_master_saved_grant_uC_clock_0_in = cpu_data_master_requests_uC_clock_0_in;

  //allow new arb cycle for uC_clock_0/in, which is an e_assign
  assign uC_clock_0_in_allow_new_arb_cycle = 1;

  //placeholder chosen master
  assign uC_clock_0_in_grant_vector = 1;

  //placeholder vector of master qualified-requests
  assign uC_clock_0_in_master_qreq_vector = 1;

  //uC_clock_0_in_reset_n assignment, which is an e_assign
  assign uC_clock_0_in_reset_n = reset_n;

  //uC_clock_0_in_firsttransfer first transaction, which is an e_assign
  assign uC_clock_0_in_firsttransfer = uC_clock_0_in_begins_xfer ? uC_clock_0_in_unreg_firsttransfer : uC_clock_0_in_reg_firsttransfer;

  //uC_clock_0_in_unreg_firsttransfer first transaction, which is an e_assign
  assign uC_clock_0_in_unreg_firsttransfer = ~(uC_clock_0_in_slavearbiterlockenable & uC_clock_0_in_any_continuerequest);

  //uC_clock_0_in_reg_firsttransfer first transaction, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          uC_clock_0_in_reg_firsttransfer <= 1'b1;
      else if (uC_clock_0_in_begins_xfer)
          uC_clock_0_in_reg_firsttransfer <= uC_clock_0_in_unreg_firsttransfer;
    end


  //uC_clock_0_in_beginbursttransfer_internal begin burst transfer, which is an e_assign
  assign uC_clock_0_in_beginbursttransfer_internal = uC_clock_0_in_begins_xfer;

  //uC_clock_0_in_read assignment, which is an e_mux
  assign uC_clock_0_in_read = cpu_data_master_granted_uC_clock_0_in & cpu_data_master_read;

  //uC_clock_0_in_write assignment, which is an e_mux
  assign uC_clock_0_in_write = cpu_data_master_granted_uC_clock_0_in & cpu_data_master_write;

  //uC_clock_0_in_address mux, which is an e_mux
  assign uC_clock_0_in_address = cpu_data_master_address_to_slave;

  //slaveid uC_clock_0_in_nativeaddress nativeaddress mux, which is an e_mux
  assign uC_clock_0_in_nativeaddress = cpu_data_master_address_to_slave >> 2;

  //d1_uC_clock_0_in_end_xfer register, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          d1_uC_clock_0_in_end_xfer <= 1;
      else 
        d1_uC_clock_0_in_end_xfer <= uC_clock_0_in_end_xfer;
    end


  //uC_clock_0_in_waits_for_read in a cycle, which is an e_mux
  assign uC_clock_0_in_waits_for_read = uC_clock_0_in_in_a_read_cycle & uC_clock_0_in_waitrequest_from_sa;

  //uC_clock_0_in_in_a_read_cycle assignment, which is an e_assign
  assign uC_clock_0_in_in_a_read_cycle = cpu_data_master_granted_uC_clock_0_in & cpu_data_master_read;

  //in_a_read_cycle assignment, which is an e_mux
  assign in_a_read_cycle = uC_clock_0_in_in_a_read_cycle;

  //uC_clock_0_in_waits_for_write in a cycle, which is an e_mux
  assign uC_clock_0_in_waits_for_write = uC_clock_0_in_in_a_write_cycle & uC_clock_0_in_waitrequest_from_sa;

  //uC_clock_0_in_in_a_write_cycle assignment, which is an e_assign
  assign uC_clock_0_in_in_a_write_cycle = cpu_data_master_granted_uC_clock_0_in & cpu_data_master_write;

  //in_a_write_cycle assignment, which is an e_mux
  assign in_a_write_cycle = uC_clock_0_in_in_a_write_cycle;

  assign wait_for_uC_clock_0_in_counter = 0;
  //uC_clock_0_in_byteenable byte enable port mux, which is an e_mux
  assign uC_clock_0_in_byteenable = (cpu_data_master_granted_uC_clock_0_in)? cpu_data_master_byteenable :
    -1;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //uC_clock_0/in enable non-zero assertions, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          enable_nonzero_assertions <= 0;
      else 
        enable_nonzero_assertions <= 1'b1;
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module uC_clock_0_out_arbitrator (
                                   // inputs:
                                    altpll_0_pll_slave_readdata_from_sa,
                                    clk,
                                    d1_altpll_0_pll_slave_end_xfer,
                                    reset_n,
                                    uC_clock_0_out_address,
                                    uC_clock_0_out_byteenable,
                                    uC_clock_0_out_granted_altpll_0_pll_slave,
                                    uC_clock_0_out_qualified_request_altpll_0_pll_slave,
                                    uC_clock_0_out_read,
                                    uC_clock_0_out_read_data_valid_altpll_0_pll_slave,
                                    uC_clock_0_out_requests_altpll_0_pll_slave,
                                    uC_clock_0_out_write,
                                    uC_clock_0_out_writedata,

                                   // outputs:
                                    uC_clock_0_out_address_to_slave,
                                    uC_clock_0_out_readdata,
                                    uC_clock_0_out_reset_n,
                                    uC_clock_0_out_waitrequest
                                 )
;

  output  [  3: 0] uC_clock_0_out_address_to_slave;
  output  [ 31: 0] uC_clock_0_out_readdata;
  output           uC_clock_0_out_reset_n;
  output           uC_clock_0_out_waitrequest;
  input   [ 31: 0] altpll_0_pll_slave_readdata_from_sa;
  input            clk;
  input            d1_altpll_0_pll_slave_end_xfer;
  input            reset_n;
  input   [  3: 0] uC_clock_0_out_address;
  input   [  3: 0] uC_clock_0_out_byteenable;
  input            uC_clock_0_out_granted_altpll_0_pll_slave;
  input            uC_clock_0_out_qualified_request_altpll_0_pll_slave;
  input            uC_clock_0_out_read;
  input            uC_clock_0_out_read_data_valid_altpll_0_pll_slave;
  input            uC_clock_0_out_requests_altpll_0_pll_slave;
  input            uC_clock_0_out_write;
  input   [ 31: 0] uC_clock_0_out_writedata;

  reg              active_and_waiting_last_time;
  wire             r_0;
  reg     [  3: 0] uC_clock_0_out_address_last_time;
  wire    [  3: 0] uC_clock_0_out_address_to_slave;
  reg     [  3: 0] uC_clock_0_out_byteenable_last_time;
  reg              uC_clock_0_out_read_last_time;
  wire    [ 31: 0] uC_clock_0_out_readdata;
  wire             uC_clock_0_out_reset_n;
  wire             uC_clock_0_out_run;
  wire             uC_clock_0_out_waitrequest;
  reg              uC_clock_0_out_write_last_time;
  reg     [ 31: 0] uC_clock_0_out_writedata_last_time;
  //r_0 master_run cascaded wait assignment, which is an e_assign
  assign r_0 = 1 & ((~uC_clock_0_out_qualified_request_altpll_0_pll_slave | ~(uC_clock_0_out_read | uC_clock_0_out_write) | (1 & (uC_clock_0_out_read | uC_clock_0_out_write)))) & ((~uC_clock_0_out_qualified_request_altpll_0_pll_slave | ~(uC_clock_0_out_read | uC_clock_0_out_write) | (1 & (uC_clock_0_out_read | uC_clock_0_out_write))));

  //cascaded wait assignment, which is an e_assign
  assign uC_clock_0_out_run = r_0;

  //optimize select-logic by passing only those address bits which matter.
  assign uC_clock_0_out_address_to_slave = uC_clock_0_out_address;

  //uC_clock_0/out readdata mux, which is an e_mux
  assign uC_clock_0_out_readdata = altpll_0_pll_slave_readdata_from_sa;

  //actual waitrequest port, which is an e_assign
  assign uC_clock_0_out_waitrequest = ~uC_clock_0_out_run;

  //uC_clock_0_out_reset_n assignment, which is an e_assign
  assign uC_clock_0_out_reset_n = reset_n;


//synthesis translate_off
//////////////// SIMULATION-ONLY CONTENTS
  //uC_clock_0_out_address check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          uC_clock_0_out_address_last_time <= 0;
      else 
        uC_clock_0_out_address_last_time <= uC_clock_0_out_address;
    end


  //uC_clock_0/out waited last time, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          active_and_waiting_last_time <= 0;
      else 
        active_and_waiting_last_time <= uC_clock_0_out_waitrequest & (uC_clock_0_out_read | uC_clock_0_out_write);
    end


  //uC_clock_0_out_address matches last port_name, which is an e_process
  always @(posedge clk)
    begin
      if (active_and_waiting_last_time & (uC_clock_0_out_address != uC_clock_0_out_address_last_time))
        begin
          $write("%0d ns: uC_clock_0_out_address did not heed wait!!!", $time);
          $stop;
        end
    end


  //uC_clock_0_out_byteenable check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          uC_clock_0_out_byteenable_last_time <= 0;
      else 
        uC_clock_0_out_byteenable_last_time <= uC_clock_0_out_byteenable;
    end


  //uC_clock_0_out_byteenable matches last port_name, which is an e_process
  always @(posedge clk)
    begin
      if (active_and_waiting_last_time & (uC_clock_0_out_byteenable != uC_clock_0_out_byteenable_last_time))
        begin
          $write("%0d ns: uC_clock_0_out_byteenable did not heed wait!!!", $time);
          $stop;
        end
    end


  //uC_clock_0_out_read check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          uC_clock_0_out_read_last_time <= 0;
      else 
        uC_clock_0_out_read_last_time <= uC_clock_0_out_read;
    end


  //uC_clock_0_out_read matches last port_name, which is an e_process
  always @(posedge clk)
    begin
      if (active_and_waiting_last_time & (uC_clock_0_out_read != uC_clock_0_out_read_last_time))
        begin
          $write("%0d ns: uC_clock_0_out_read did not heed wait!!!", $time);
          $stop;
        end
    end


  //uC_clock_0_out_write check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          uC_clock_0_out_write_last_time <= 0;
      else 
        uC_clock_0_out_write_last_time <= uC_clock_0_out_write;
    end


  //uC_clock_0_out_write matches last port_name, which is an e_process
  always @(posedge clk)
    begin
      if (active_and_waiting_last_time & (uC_clock_0_out_write != uC_clock_0_out_write_last_time))
        begin
          $write("%0d ns: uC_clock_0_out_write did not heed wait!!!", $time);
          $stop;
        end
    end


  //uC_clock_0_out_writedata check against wait, which is an e_register
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          uC_clock_0_out_writedata_last_time <= 0;
      else 
        uC_clock_0_out_writedata_last_time <= uC_clock_0_out_writedata;
    end


  //uC_clock_0_out_writedata matches last port_name, which is an e_process
  always @(posedge clk)
    begin
      if (active_and_waiting_last_time & (uC_clock_0_out_writedata != uC_clock_0_out_writedata_last_time) & uC_clock_0_out_write)
        begin
          $write("%0d ns: uC_clock_0_out_writedata did not heed wait!!!", $time);
          $stop;
        end
    end



//////////////// END SIMULATION-ONLY CONTENTS

//synthesis translate_on

endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module uC_reset_sys_clk_domain_synch_module (
                                              // inputs:
                                               clk,
                                               data_in,
                                               reset_n,

                                              // outputs:
                                               data_out
                                            )
;

  output           data_out;
  input            clk;
  input            data_in;
  input            reset_n;

  reg              data_in_d1 /* synthesis ALTERA_ATTRIBUTE = "{-from \"*\"} CUT=ON ; PRESERVE_REGISTER=ON ; SUPPRESS_DA_RULE_INTERNAL=R101"  */;
  reg              data_out /* synthesis ALTERA_ATTRIBUTE = "PRESERVE_REGISTER=ON ; SUPPRESS_DA_RULE_INTERNAL=R101"  */;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          data_in_d1 <= 0;
      else 
        data_in_d1 <= data_in;
    end


  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          data_out <= 0;
      else 
        data_out <= data_in_d1;
    end



endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module uC_reset_ext_clk_domain_synch_module (
                                              // inputs:
                                               clk,
                                               data_in,
                                               reset_n,

                                              // outputs:
                                               data_out
                                            )
;

  output           data_out;
  input            clk;
  input            data_in;
  input            reset_n;

  reg              data_in_d1 /* synthesis ALTERA_ATTRIBUTE = "{-from \"*\"} CUT=ON ; PRESERVE_REGISTER=ON ; SUPPRESS_DA_RULE_INTERNAL=R101"  */;
  reg              data_out /* synthesis ALTERA_ATTRIBUTE = "PRESERVE_REGISTER=ON ; SUPPRESS_DA_RULE_INTERNAL=R101"  */;
  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          data_in_d1 <= 0;
      else 
        data_in_d1 <= data_in;
    end


  always @(posedge clk or negedge reset_n)
    begin
      if (reset_n == 0)
          data_out <= 0;
      else 
        data_out <= data_in_d1;
    end



endmodule


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module uC (
            // 1) global signals:
             ext_clk,
             reset_n,
             sys_clk,

            // the_adc_data_ready
             in_port_to_the_adc_data_ready,

            // the_altpll_0
             areset_to_the_altpll_0,
             locked_from_the_altpll_0,
             phasedone_from_the_altpll_0,

            // the_ctrl
             out_port_from_the_ctrl,

            // the_epcs_flash_controller
             data0_to_the_epcs_flash_controller,
             dclk_from_the_epcs_flash_controller,
             sce_from_the_epcs_flash_controller,
             sdo_from_the_epcs_flash_controller,

            // the_gpio
             bidir_port_to_and_from_the_gpio,

            // the_led
             out_port_from_the_led,

            // the_opencores_i2c_0
             scl_pad_io_to_and_from_the_opencores_i2c_0,
             sda_pad_io_to_and_from_the_opencores_i2c_0,

            // the_opencores_i2c_1
             scl_pad_io_to_and_from_the_opencores_i2c_1,
             sda_pad_io_to_and_from_the_opencores_i2c_1,

            // the_spi_0_p0
             MISO_to_the_spi_0_p0,
             MOSI_from_the_spi_0_p0,
             SCLK_from_the_spi_0_p0,
             SS_n_from_the_spi_0_p0,

            // the_spi_0_p1
             MISO_to_the_spi_0_p1,
             MOSI_from_the_spi_0_p1,
             SCLK_from_the_spi_0_p1,
             SS_n_from_the_spi_0_p1,

            // the_spi_1_p0
             MISO_to_the_spi_1_p0,
             MOSI_from_the_spi_1_p0,
             SCLK_from_the_spi_1_p0,
             SS_n_from_the_spi_1_p0,

            // the_spi_1_p1
             MISO_to_the_spi_1_p1,
             MOSI_from_the_spi_1_p1,
             SCLK_from_the_spi_1_p1,
             SS_n_from_the_spi_1_p1
          )
;

  output           MOSI_from_the_spi_0_p0;
  output           MOSI_from_the_spi_0_p1;
  output           MOSI_from_the_spi_1_p0;
  output           MOSI_from_the_spi_1_p1;
  output           SCLK_from_the_spi_0_p0;
  output           SCLK_from_the_spi_0_p1;
  output           SCLK_from_the_spi_1_p0;
  output           SCLK_from_the_spi_1_p1;
  output  [  2: 0] SS_n_from_the_spi_0_p0;
  output  [  2: 0] SS_n_from_the_spi_0_p1;
  output  [  2: 0] SS_n_from_the_spi_1_p0;
  output  [  2: 0] SS_n_from_the_spi_1_p1;
  inout   [  7: 0] bidir_port_to_and_from_the_gpio;
  output           dclk_from_the_epcs_flash_controller;
  output           locked_from_the_altpll_0;
  output  [  7: 0] out_port_from_the_ctrl;
  output  [  7: 0] out_port_from_the_led;
  output           phasedone_from_the_altpll_0;
  output           sce_from_the_epcs_flash_controller;
  inout            scl_pad_io_to_and_from_the_opencores_i2c_0;
  inout            scl_pad_io_to_and_from_the_opencores_i2c_1;
  inout            sda_pad_io_to_and_from_the_opencores_i2c_0;
  inout            sda_pad_io_to_and_from_the_opencores_i2c_1;
  output           sdo_from_the_epcs_flash_controller;
  output           sys_clk;
  input            MISO_to_the_spi_0_p0;
  input            MISO_to_the_spi_0_p1;
  input            MISO_to_the_spi_1_p0;
  input            MISO_to_the_spi_1_p1;
  input            areset_to_the_altpll_0;
  input            data0_to_the_epcs_flash_controller;
  input            ext_clk;
  input   [  2: 0] in_port_to_the_adc_data_ready;
  input            reset_n;

  wire             MOSI_from_the_spi_0_p0;
  wire             MOSI_from_the_spi_0_p1;
  wire             MOSI_from_the_spi_1_p0;
  wire             MOSI_from_the_spi_1_p1;
  wire             SCLK_from_the_spi_0_p0;
  wire             SCLK_from_the_spi_0_p1;
  wire             SCLK_from_the_spi_1_p0;
  wire             SCLK_from_the_spi_1_p1;
  wire    [  2: 0] SS_n_from_the_spi_0_p0;
  wire    [  2: 0] SS_n_from_the_spi_0_p1;
  wire    [  2: 0] SS_n_from_the_spi_1_p0;
  wire    [  2: 0] SS_n_from_the_spi_1_p1;
  wire    [  1: 0] adc_data_ready_s1_address;
  wire    [ 31: 0] adc_data_ready_s1_readdata;
  wire    [ 31: 0] adc_data_ready_s1_readdata_from_sa;
  wire             adc_data_ready_s1_reset_n;
  wire    [  1: 0] altpll_0_pll_slave_address;
  wire             altpll_0_pll_slave_read;
  wire    [ 31: 0] altpll_0_pll_slave_readdata;
  wire    [ 31: 0] altpll_0_pll_slave_readdata_from_sa;
  wire             altpll_0_pll_slave_reset;
  wire             altpll_0_pll_slave_write;
  wire    [ 31: 0] altpll_0_pll_slave_writedata;
  wire    [  7: 0] bidir_port_to_and_from_the_gpio;
  wire    [ 16: 0] cpu_data_master_address;
  wire    [ 16: 0] cpu_data_master_address_to_slave;
  wire    [  3: 0] cpu_data_master_byteenable;
  wire             cpu_data_master_debugaccess;
  wire             cpu_data_master_granted_adc_data_ready_s1;
  wire             cpu_data_master_granted_cpu_jtag_debug_module;
  wire             cpu_data_master_granted_ctrl_s1;
  wire             cpu_data_master_granted_epcs_flash_controller_epcs_control_port;
  wire             cpu_data_master_granted_gpio_s1;
  wire             cpu_data_master_granted_jtag_uart_avalon_jtag_slave;
  wire             cpu_data_master_granted_led_s1;
  wire             cpu_data_master_granted_onchip_ram_s1;
  wire             cpu_data_master_granted_opencores_i2c_0_avalon_slave;
  wire             cpu_data_master_granted_opencores_i2c_1_avalon_slave;
  wire             cpu_data_master_granted_spi_0_p0_spi_control_port;
  wire             cpu_data_master_granted_spi_0_p1_spi_control_port;
  wire             cpu_data_master_granted_spi_1_p0_spi_control_port;
  wire             cpu_data_master_granted_spi_1_p1_spi_control_port;
  wire             cpu_data_master_granted_sysid_control_slave;
  wire             cpu_data_master_granted_timer_s1;
  wire             cpu_data_master_granted_uCProbe_uart_avalon_jtag_slave;
  wire             cpu_data_master_granted_uC_clock_0_in;
  wire    [ 31: 0] cpu_data_master_irq;
  wire             cpu_data_master_qualified_request_adc_data_ready_s1;
  wire             cpu_data_master_qualified_request_cpu_jtag_debug_module;
  wire             cpu_data_master_qualified_request_ctrl_s1;
  wire             cpu_data_master_qualified_request_epcs_flash_controller_epcs_control_port;
  wire             cpu_data_master_qualified_request_gpio_s1;
  wire             cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave;
  wire             cpu_data_master_qualified_request_led_s1;
  wire             cpu_data_master_qualified_request_onchip_ram_s1;
  wire             cpu_data_master_qualified_request_opencores_i2c_0_avalon_slave;
  wire             cpu_data_master_qualified_request_opencores_i2c_1_avalon_slave;
  wire             cpu_data_master_qualified_request_spi_0_p0_spi_control_port;
  wire             cpu_data_master_qualified_request_spi_0_p1_spi_control_port;
  wire             cpu_data_master_qualified_request_spi_1_p0_spi_control_port;
  wire             cpu_data_master_qualified_request_spi_1_p1_spi_control_port;
  wire             cpu_data_master_qualified_request_sysid_control_slave;
  wire             cpu_data_master_qualified_request_timer_s1;
  wire             cpu_data_master_qualified_request_uCProbe_uart_avalon_jtag_slave;
  wire             cpu_data_master_qualified_request_uC_clock_0_in;
  wire             cpu_data_master_read;
  wire             cpu_data_master_read_data_valid_adc_data_ready_s1;
  wire             cpu_data_master_read_data_valid_cpu_jtag_debug_module;
  wire             cpu_data_master_read_data_valid_ctrl_s1;
  wire             cpu_data_master_read_data_valid_epcs_flash_controller_epcs_control_port;
  wire             cpu_data_master_read_data_valid_gpio_s1;
  wire             cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave;
  wire             cpu_data_master_read_data_valid_led_s1;
  wire             cpu_data_master_read_data_valid_onchip_ram_s1;
  wire             cpu_data_master_read_data_valid_opencores_i2c_0_avalon_slave;
  wire             cpu_data_master_read_data_valid_opencores_i2c_1_avalon_slave;
  wire             cpu_data_master_read_data_valid_spi_0_p0_spi_control_port;
  wire             cpu_data_master_read_data_valid_spi_0_p1_spi_control_port;
  wire             cpu_data_master_read_data_valid_spi_1_p0_spi_control_port;
  wire             cpu_data_master_read_data_valid_spi_1_p1_spi_control_port;
  wire             cpu_data_master_read_data_valid_sysid_control_slave;
  wire             cpu_data_master_read_data_valid_timer_s1;
  wire             cpu_data_master_read_data_valid_uCProbe_uart_avalon_jtag_slave;
  wire             cpu_data_master_read_data_valid_uC_clock_0_in;
  wire    [ 31: 0] cpu_data_master_readdata;
  wire             cpu_data_master_requests_adc_data_ready_s1;
  wire             cpu_data_master_requests_cpu_jtag_debug_module;
  wire             cpu_data_master_requests_ctrl_s1;
  wire             cpu_data_master_requests_epcs_flash_controller_epcs_control_port;
  wire             cpu_data_master_requests_gpio_s1;
  wire             cpu_data_master_requests_jtag_uart_avalon_jtag_slave;
  wire             cpu_data_master_requests_led_s1;
  wire             cpu_data_master_requests_onchip_ram_s1;
  wire             cpu_data_master_requests_opencores_i2c_0_avalon_slave;
  wire             cpu_data_master_requests_opencores_i2c_1_avalon_slave;
  wire             cpu_data_master_requests_spi_0_p0_spi_control_port;
  wire             cpu_data_master_requests_spi_0_p1_spi_control_port;
  wire             cpu_data_master_requests_spi_1_p0_spi_control_port;
  wire             cpu_data_master_requests_spi_1_p1_spi_control_port;
  wire             cpu_data_master_requests_sysid_control_slave;
  wire             cpu_data_master_requests_timer_s1;
  wire             cpu_data_master_requests_uCProbe_uart_avalon_jtag_slave;
  wire             cpu_data_master_requests_uC_clock_0_in;
  wire             cpu_data_master_waitrequest;
  wire             cpu_data_master_write;
  wire    [ 31: 0] cpu_data_master_writedata;
  wire    [ 16: 0] cpu_instruction_master_address;
  wire    [ 16: 0] cpu_instruction_master_address_to_slave;
  wire             cpu_instruction_master_granted_cpu_jtag_debug_module;
  wire             cpu_instruction_master_granted_epcs_flash_controller_epcs_control_port;
  wire             cpu_instruction_master_granted_onchip_ram_s1;
  wire             cpu_instruction_master_qualified_request_cpu_jtag_debug_module;
  wire             cpu_instruction_master_qualified_request_epcs_flash_controller_epcs_control_port;
  wire             cpu_instruction_master_qualified_request_onchip_ram_s1;
  wire             cpu_instruction_master_read;
  wire             cpu_instruction_master_read_data_valid_cpu_jtag_debug_module;
  wire             cpu_instruction_master_read_data_valid_epcs_flash_controller_epcs_control_port;
  wire             cpu_instruction_master_read_data_valid_onchip_ram_s1;
  wire    [ 31: 0] cpu_instruction_master_readdata;
  wire             cpu_instruction_master_requests_cpu_jtag_debug_module;
  wire             cpu_instruction_master_requests_epcs_flash_controller_epcs_control_port;
  wire             cpu_instruction_master_requests_onchip_ram_s1;
  wire             cpu_instruction_master_waitrequest;
  wire    [  8: 0] cpu_jtag_debug_module_address;
  wire             cpu_jtag_debug_module_begintransfer;
  wire    [  3: 0] cpu_jtag_debug_module_byteenable;
  wire             cpu_jtag_debug_module_chipselect;
  wire             cpu_jtag_debug_module_debugaccess;
  wire    [ 31: 0] cpu_jtag_debug_module_readdata;
  wire    [ 31: 0] cpu_jtag_debug_module_readdata_from_sa;
  wire             cpu_jtag_debug_module_reset_n;
  wire             cpu_jtag_debug_module_resetrequest;
  wire             cpu_jtag_debug_module_resetrequest_from_sa;
  wire             cpu_jtag_debug_module_write;
  wire    [ 31: 0] cpu_jtag_debug_module_writedata;
  wire    [  1: 0] ctrl_s1_address;
  wire             ctrl_s1_chipselect;
  wire    [ 31: 0] ctrl_s1_readdata;
  wire    [ 31: 0] ctrl_s1_readdata_from_sa;
  wire             ctrl_s1_reset_n;
  wire             ctrl_s1_write_n;
  wire    [ 31: 0] ctrl_s1_writedata;
  wire             d1_adc_data_ready_s1_end_xfer;
  wire             d1_altpll_0_pll_slave_end_xfer;
  wire             d1_cpu_jtag_debug_module_end_xfer;
  wire             d1_ctrl_s1_end_xfer;
  wire             d1_epcs_flash_controller_epcs_control_port_end_xfer;
  wire             d1_gpio_s1_end_xfer;
  wire             d1_jtag_uart_avalon_jtag_slave_end_xfer;
  wire             d1_led_s1_end_xfer;
  wire             d1_onchip_ram_s1_end_xfer;
  wire             d1_opencores_i2c_0_avalon_slave_end_xfer;
  wire             d1_opencores_i2c_1_avalon_slave_end_xfer;
  wire             d1_spi_0_p0_spi_control_port_end_xfer;
  wire             d1_spi_0_p1_spi_control_port_end_xfer;
  wire             d1_spi_1_p0_spi_control_port_end_xfer;
  wire             d1_spi_1_p1_spi_control_port_end_xfer;
  wire             d1_sysid_control_slave_end_xfer;
  wire             d1_timer_s1_end_xfer;
  wire             d1_uCProbe_uart_avalon_jtag_slave_end_xfer;
  wire             d1_uC_clock_0_in_end_xfer;
  wire             dclk_from_the_epcs_flash_controller;
  wire    [  8: 0] epcs_flash_controller_epcs_control_port_address;
  wire             epcs_flash_controller_epcs_control_port_chipselect;
  wire             epcs_flash_controller_epcs_control_port_dataavailable;
  wire             epcs_flash_controller_epcs_control_port_dataavailable_from_sa;
  wire             epcs_flash_controller_epcs_control_port_endofpacket;
  wire             epcs_flash_controller_epcs_control_port_endofpacket_from_sa;
  wire             epcs_flash_controller_epcs_control_port_irq;
  wire             epcs_flash_controller_epcs_control_port_irq_from_sa;
  wire             epcs_flash_controller_epcs_control_port_read_n;
  wire    [ 31: 0] epcs_flash_controller_epcs_control_port_readdata;
  wire    [ 31: 0] epcs_flash_controller_epcs_control_port_readdata_from_sa;
  wire             epcs_flash_controller_epcs_control_port_readyfordata;
  wire             epcs_flash_controller_epcs_control_port_readyfordata_from_sa;
  wire             epcs_flash_controller_epcs_control_port_reset_n;
  wire             epcs_flash_controller_epcs_control_port_write_n;
  wire    [ 31: 0] epcs_flash_controller_epcs_control_port_writedata;
  wire             ext_clk_reset_n;
  wire    [  2: 0] gpio_s1_address;
  wire             gpio_s1_chipselect;
  wire    [ 31: 0] gpio_s1_readdata;
  wire    [ 31: 0] gpio_s1_readdata_from_sa;
  wire             gpio_s1_reset_n;
  wire             gpio_s1_write_n;
  wire    [ 31: 0] gpio_s1_writedata;
  wire             jtag_uart_avalon_jtag_slave_address;
  wire             jtag_uart_avalon_jtag_slave_chipselect;
  wire             jtag_uart_avalon_jtag_slave_dataavailable;
  wire             jtag_uart_avalon_jtag_slave_dataavailable_from_sa;
  wire             jtag_uart_avalon_jtag_slave_irq;
  wire             jtag_uart_avalon_jtag_slave_irq_from_sa;
  wire             jtag_uart_avalon_jtag_slave_read_n;
  wire    [ 31: 0] jtag_uart_avalon_jtag_slave_readdata;
  wire    [ 31: 0] jtag_uart_avalon_jtag_slave_readdata_from_sa;
  wire             jtag_uart_avalon_jtag_slave_readyfordata;
  wire             jtag_uart_avalon_jtag_slave_readyfordata_from_sa;
  wire             jtag_uart_avalon_jtag_slave_reset_n;
  wire             jtag_uart_avalon_jtag_slave_waitrequest;
  wire             jtag_uart_avalon_jtag_slave_waitrequest_from_sa;
  wire             jtag_uart_avalon_jtag_slave_write_n;
  wire    [ 31: 0] jtag_uart_avalon_jtag_slave_writedata;
  wire    [  1: 0] led_s1_address;
  wire             led_s1_chipselect;
  wire    [ 31: 0] led_s1_readdata;
  wire    [ 31: 0] led_s1_readdata_from_sa;
  wire             led_s1_reset_n;
  wire             led_s1_write_n;
  wire    [ 31: 0] led_s1_writedata;
  wire             locked_from_the_altpll_0;
  wire             mm_console_master_granted_onchip_ram_s1;
  wire             mm_console_master_latency_counter;
  wire    [ 31: 0] mm_console_master_master_address;
  wire    [ 31: 0] mm_console_master_master_address_to_slave;
  wire    [  3: 0] mm_console_master_master_byteenable;
  wire             mm_console_master_master_read;
  wire    [ 31: 0] mm_console_master_master_readdata;
  wire             mm_console_master_master_readdatavalid;
  wire             mm_console_master_master_reset;
  wire             mm_console_master_master_waitrequest;
  wire             mm_console_master_master_write;
  wire    [ 31: 0] mm_console_master_master_writedata;
  wire             mm_console_master_qualified_request_onchip_ram_s1;
  wire             mm_console_master_read_data_valid_onchip_ram_s1;
  wire             mm_console_master_requests_onchip_ram_s1;
  wire    [ 13: 0] onchip_ram_s1_address;
  wire    [  3: 0] onchip_ram_s1_byteenable;
  wire             onchip_ram_s1_chipselect;
  wire             onchip_ram_s1_clken;
  wire    [ 31: 0] onchip_ram_s1_readdata;
  wire    [ 31: 0] onchip_ram_s1_readdata_from_sa;
  wire             onchip_ram_s1_reset;
  wire             onchip_ram_s1_write;
  wire    [ 31: 0] onchip_ram_s1_writedata;
  wire    [  2: 0] opencores_i2c_0_avalon_slave_address;
  wire             opencores_i2c_0_avalon_slave_chipselect;
  wire             opencores_i2c_0_avalon_slave_irq;
  wire             opencores_i2c_0_avalon_slave_irq_from_sa;
  wire    [  7: 0] opencores_i2c_0_avalon_slave_readdata;
  wire    [  7: 0] opencores_i2c_0_avalon_slave_readdata_from_sa;
  wire             opencores_i2c_0_avalon_slave_reset;
  wire             opencores_i2c_0_avalon_slave_waitrequest_n;
  wire             opencores_i2c_0_avalon_slave_waitrequest_n_from_sa;
  wire             opencores_i2c_0_avalon_slave_write;
  wire    [  7: 0] opencores_i2c_0_avalon_slave_writedata;
  wire    [  2: 0] opencores_i2c_1_avalon_slave_address;
  wire             opencores_i2c_1_avalon_slave_chipselect;
  wire             opencores_i2c_1_avalon_slave_irq;
  wire             opencores_i2c_1_avalon_slave_irq_from_sa;
  wire    [  7: 0] opencores_i2c_1_avalon_slave_readdata;
  wire    [  7: 0] opencores_i2c_1_avalon_slave_readdata_from_sa;
  wire             opencores_i2c_1_avalon_slave_reset;
  wire             opencores_i2c_1_avalon_slave_waitrequest_n;
  wire             opencores_i2c_1_avalon_slave_waitrequest_n_from_sa;
  wire             opencores_i2c_1_avalon_slave_write;
  wire    [  7: 0] opencores_i2c_1_avalon_slave_writedata;
  wire             out_clk_altpll_0_c0;
  wire    [  7: 0] out_port_from_the_ctrl;
  wire    [  7: 0] out_port_from_the_led;
  wire             phasedone_from_the_altpll_0;
  wire             registered_cpu_data_master_read_data_valid_onchip_ram_s1;
  wire             reset_n_sources;
  wire             sce_from_the_epcs_flash_controller;
  wire             scl_pad_io_to_and_from_the_opencores_i2c_0;
  wire             scl_pad_io_to_and_from_the_opencores_i2c_1;
  wire             sda_pad_io_to_and_from_the_opencores_i2c_0;
  wire             sda_pad_io_to_and_from_the_opencores_i2c_1;
  wire             sdo_from_the_epcs_flash_controller;
  wire    [  2: 0] spi_0_p0_spi_control_port_address;
  wire             spi_0_p0_spi_control_port_chipselect;
  wire             spi_0_p0_spi_control_port_dataavailable;
  wire             spi_0_p0_spi_control_port_dataavailable_from_sa;
  wire             spi_0_p0_spi_control_port_endofpacket;
  wire             spi_0_p0_spi_control_port_endofpacket_from_sa;
  wire             spi_0_p0_spi_control_port_irq;
  wire             spi_0_p0_spi_control_port_irq_from_sa;
  wire             spi_0_p0_spi_control_port_read_n;
  wire    [ 15: 0] spi_0_p0_spi_control_port_readdata;
  wire    [ 15: 0] spi_0_p0_spi_control_port_readdata_from_sa;
  wire             spi_0_p0_spi_control_port_readyfordata;
  wire             spi_0_p0_spi_control_port_readyfordata_from_sa;
  wire             spi_0_p0_spi_control_port_reset_n;
  wire             spi_0_p0_spi_control_port_write_n;
  wire    [ 15: 0] spi_0_p0_spi_control_port_writedata;
  wire    [  2: 0] spi_0_p1_spi_control_port_address;
  wire             spi_0_p1_spi_control_port_chipselect;
  wire             spi_0_p1_spi_control_port_dataavailable;
  wire             spi_0_p1_spi_control_port_dataavailable_from_sa;
  wire             spi_0_p1_spi_control_port_endofpacket;
  wire             spi_0_p1_spi_control_port_endofpacket_from_sa;
  wire             spi_0_p1_spi_control_port_irq;
  wire             spi_0_p1_spi_control_port_irq_from_sa;
  wire             spi_0_p1_spi_control_port_read_n;
  wire    [ 15: 0] spi_0_p1_spi_control_port_readdata;
  wire    [ 15: 0] spi_0_p1_spi_control_port_readdata_from_sa;
  wire             spi_0_p1_spi_control_port_readyfordata;
  wire             spi_0_p1_spi_control_port_readyfordata_from_sa;
  wire             spi_0_p1_spi_control_port_reset_n;
  wire             spi_0_p1_spi_control_port_write_n;
  wire    [ 15: 0] spi_0_p1_spi_control_port_writedata;
  wire    [  2: 0] spi_1_p0_spi_control_port_address;
  wire             spi_1_p0_spi_control_port_chipselect;
  wire             spi_1_p0_spi_control_port_dataavailable;
  wire             spi_1_p0_spi_control_port_dataavailable_from_sa;
  wire             spi_1_p0_spi_control_port_endofpacket;
  wire             spi_1_p0_spi_control_port_endofpacket_from_sa;
  wire             spi_1_p0_spi_control_port_irq;
  wire             spi_1_p0_spi_control_port_irq_from_sa;
  wire             spi_1_p0_spi_control_port_read_n;
  wire    [ 15: 0] spi_1_p0_spi_control_port_readdata;
  wire    [ 15: 0] spi_1_p0_spi_control_port_readdata_from_sa;
  wire             spi_1_p0_spi_control_port_readyfordata;
  wire             spi_1_p0_spi_control_port_readyfordata_from_sa;
  wire             spi_1_p0_spi_control_port_reset_n;
  wire             spi_1_p0_spi_control_port_write_n;
  wire    [ 15: 0] spi_1_p0_spi_control_port_writedata;
  wire    [  2: 0] spi_1_p1_spi_control_port_address;
  wire             spi_1_p1_spi_control_port_chipselect;
  wire             spi_1_p1_spi_control_port_dataavailable;
  wire             spi_1_p1_spi_control_port_dataavailable_from_sa;
  wire             spi_1_p1_spi_control_port_endofpacket;
  wire             spi_1_p1_spi_control_port_endofpacket_from_sa;
  wire             spi_1_p1_spi_control_port_irq;
  wire             spi_1_p1_spi_control_port_irq_from_sa;
  wire             spi_1_p1_spi_control_port_read_n;
  wire    [ 15: 0] spi_1_p1_spi_control_port_readdata;
  wire    [ 15: 0] spi_1_p1_spi_control_port_readdata_from_sa;
  wire             spi_1_p1_spi_control_port_readyfordata;
  wire             spi_1_p1_spi_control_port_readyfordata_from_sa;
  wire             spi_1_p1_spi_control_port_reset_n;
  wire             spi_1_p1_spi_control_port_write_n;
  wire    [ 15: 0] spi_1_p1_spi_control_port_writedata;
  wire             sys_clk;
  wire             sys_clk_reset_n;
  wire             sysid_control_slave_address;
  wire             sysid_control_slave_clock;
  wire    [ 31: 0] sysid_control_slave_readdata;
  wire    [ 31: 0] sysid_control_slave_readdata_from_sa;
  wire             sysid_control_slave_reset_n;
  wire    [  2: 0] timer_s1_address;
  wire             timer_s1_chipselect;
  wire             timer_s1_irq;
  wire             timer_s1_irq_from_sa;
  wire    [ 15: 0] timer_s1_readdata;
  wire    [ 15: 0] timer_s1_readdata_from_sa;
  wire             timer_s1_reset_n;
  wire             timer_s1_write_n;
  wire    [ 15: 0] timer_s1_writedata;
  wire             uCProbe_uart_avalon_jtag_slave_address;
  wire             uCProbe_uart_avalon_jtag_slave_chipselect;
  wire             uCProbe_uart_avalon_jtag_slave_dataavailable;
  wire             uCProbe_uart_avalon_jtag_slave_dataavailable_from_sa;
  wire             uCProbe_uart_avalon_jtag_slave_irq;
  wire             uCProbe_uart_avalon_jtag_slave_irq_from_sa;
  wire             uCProbe_uart_avalon_jtag_slave_read_n;
  wire    [ 31: 0] uCProbe_uart_avalon_jtag_slave_readdata;
  wire    [ 31: 0] uCProbe_uart_avalon_jtag_slave_readdata_from_sa;
  wire             uCProbe_uart_avalon_jtag_slave_readyfordata;
  wire             uCProbe_uart_avalon_jtag_slave_readyfordata_from_sa;
  wire             uCProbe_uart_avalon_jtag_slave_reset_n;
  wire             uCProbe_uart_avalon_jtag_slave_waitrequest;
  wire             uCProbe_uart_avalon_jtag_slave_waitrequest_from_sa;
  wire             uCProbe_uart_avalon_jtag_slave_write_n;
  wire    [ 31: 0] uCProbe_uart_avalon_jtag_slave_writedata;
  wire    [  3: 0] uC_clock_0_in_address;
  wire    [  3: 0] uC_clock_0_in_byteenable;
  wire             uC_clock_0_in_endofpacket;
  wire             uC_clock_0_in_endofpacket_from_sa;
  wire    [  1: 0] uC_clock_0_in_nativeaddress;
  wire             uC_clock_0_in_read;
  wire    [ 31: 0] uC_clock_0_in_readdata;
  wire    [ 31: 0] uC_clock_0_in_readdata_from_sa;
  wire             uC_clock_0_in_reset_n;
  wire             uC_clock_0_in_waitrequest;
  wire             uC_clock_0_in_waitrequest_from_sa;
  wire             uC_clock_0_in_write;
  wire    [ 31: 0] uC_clock_0_in_writedata;
  wire    [  3: 0] uC_clock_0_out_address;
  wire    [  3: 0] uC_clock_0_out_address_to_slave;
  wire    [  3: 0] uC_clock_0_out_byteenable;
  wire             uC_clock_0_out_endofpacket;
  wire             uC_clock_0_out_granted_altpll_0_pll_slave;
  wire    [  1: 0] uC_clock_0_out_nativeaddress;
  wire             uC_clock_0_out_qualified_request_altpll_0_pll_slave;
  wire             uC_clock_0_out_read;
  wire             uC_clock_0_out_read_data_valid_altpll_0_pll_slave;
  wire    [ 31: 0] uC_clock_0_out_readdata;
  wire             uC_clock_0_out_requests_altpll_0_pll_slave;
  wire             uC_clock_0_out_reset_n;
  wire             uC_clock_0_out_waitrequest;
  wire             uC_clock_0_out_write;
  wire    [ 31: 0] uC_clock_0_out_writedata;
  adc_data_ready_s1_arbitrator the_adc_data_ready_s1
    (
      .adc_data_ready_s1_address                           (adc_data_ready_s1_address),
      .adc_data_ready_s1_readdata                          (adc_data_ready_s1_readdata),
      .adc_data_ready_s1_readdata_from_sa                  (adc_data_ready_s1_readdata_from_sa),
      .adc_data_ready_s1_reset_n                           (adc_data_ready_s1_reset_n),
      .clk                                                 (sys_clk),
      .cpu_data_master_address_to_slave                    (cpu_data_master_address_to_slave),
      .cpu_data_master_granted_adc_data_ready_s1           (cpu_data_master_granted_adc_data_ready_s1),
      .cpu_data_master_qualified_request_adc_data_ready_s1 (cpu_data_master_qualified_request_adc_data_ready_s1),
      .cpu_data_master_read                                (cpu_data_master_read),
      .cpu_data_master_read_data_valid_adc_data_ready_s1   (cpu_data_master_read_data_valid_adc_data_ready_s1),
      .cpu_data_master_requests_adc_data_ready_s1          (cpu_data_master_requests_adc_data_ready_s1),
      .cpu_data_master_write                               (cpu_data_master_write),
      .d1_adc_data_ready_s1_end_xfer                       (d1_adc_data_ready_s1_end_xfer),
      .reset_n                                             (sys_clk_reset_n)
    );

  adc_data_ready the_adc_data_ready
    (
      .address  (adc_data_ready_s1_address),
      .clk      (sys_clk),
      .in_port  (in_port_to_the_adc_data_ready),
      .readdata (adc_data_ready_s1_readdata),
      .reset_n  (adc_data_ready_s1_reset_n)
    );

  altpll_0_pll_slave_arbitrator the_altpll_0_pll_slave
    (
      .altpll_0_pll_slave_address                          (altpll_0_pll_slave_address),
      .altpll_0_pll_slave_read                             (altpll_0_pll_slave_read),
      .altpll_0_pll_slave_readdata                         (altpll_0_pll_slave_readdata),
      .altpll_0_pll_slave_readdata_from_sa                 (altpll_0_pll_slave_readdata_from_sa),
      .altpll_0_pll_slave_reset                            (altpll_0_pll_slave_reset),
      .altpll_0_pll_slave_write                            (altpll_0_pll_slave_write),
      .altpll_0_pll_slave_writedata                        (altpll_0_pll_slave_writedata),
      .clk                                                 (ext_clk),
      .d1_altpll_0_pll_slave_end_xfer                      (d1_altpll_0_pll_slave_end_xfer),
      .reset_n                                             (ext_clk_reset_n),
      .uC_clock_0_out_address_to_slave                     (uC_clock_0_out_address_to_slave),
      .uC_clock_0_out_granted_altpll_0_pll_slave           (uC_clock_0_out_granted_altpll_0_pll_slave),
      .uC_clock_0_out_qualified_request_altpll_0_pll_slave (uC_clock_0_out_qualified_request_altpll_0_pll_slave),
      .uC_clock_0_out_read                                 (uC_clock_0_out_read),
      .uC_clock_0_out_read_data_valid_altpll_0_pll_slave   (uC_clock_0_out_read_data_valid_altpll_0_pll_slave),
      .uC_clock_0_out_requests_altpll_0_pll_slave          (uC_clock_0_out_requests_altpll_0_pll_slave),
      .uC_clock_0_out_write                                (uC_clock_0_out_write),
      .uC_clock_0_out_writedata                            (uC_clock_0_out_writedata)
    );

  //sys_clk out_clk assignment, which is an e_assign
  assign sys_clk = out_clk_altpll_0_c0;

  altpll_0 the_altpll_0
    (
      .address   (altpll_0_pll_slave_address),
      .areset    (areset_to_the_altpll_0),
      .c0        (out_clk_altpll_0_c0),
      .clk       (ext_clk),
      .locked    (locked_from_the_altpll_0),
      .phasedone (phasedone_from_the_altpll_0),
      .read      (altpll_0_pll_slave_read),
      .readdata  (altpll_0_pll_slave_readdata),
      .reset     (altpll_0_pll_slave_reset),
      .write     (altpll_0_pll_slave_write),
      .writedata (altpll_0_pll_slave_writedata)
    );

  cpu_jtag_debug_module_arbitrator the_cpu_jtag_debug_module
    (
      .clk                                                            (sys_clk),
      .cpu_data_master_address_to_slave                               (cpu_data_master_address_to_slave),
      .cpu_data_master_byteenable                                     (cpu_data_master_byteenable),
      .cpu_data_master_debugaccess                                    (cpu_data_master_debugaccess),
      .cpu_data_master_granted_cpu_jtag_debug_module                  (cpu_data_master_granted_cpu_jtag_debug_module),
      .cpu_data_master_qualified_request_cpu_jtag_debug_module        (cpu_data_master_qualified_request_cpu_jtag_debug_module),
      .cpu_data_master_read                                           (cpu_data_master_read),
      .cpu_data_master_read_data_valid_cpu_jtag_debug_module          (cpu_data_master_read_data_valid_cpu_jtag_debug_module),
      .cpu_data_master_requests_cpu_jtag_debug_module                 (cpu_data_master_requests_cpu_jtag_debug_module),
      .cpu_data_master_waitrequest                                    (cpu_data_master_waitrequest),
      .cpu_data_master_write                                          (cpu_data_master_write),
      .cpu_data_master_writedata                                      (cpu_data_master_writedata),
      .cpu_instruction_master_address_to_slave                        (cpu_instruction_master_address_to_slave),
      .cpu_instruction_master_granted_cpu_jtag_debug_module           (cpu_instruction_master_granted_cpu_jtag_debug_module),
      .cpu_instruction_master_qualified_request_cpu_jtag_debug_module (cpu_instruction_master_qualified_request_cpu_jtag_debug_module),
      .cpu_instruction_master_read                                    (cpu_instruction_master_read),
      .cpu_instruction_master_read_data_valid_cpu_jtag_debug_module   (cpu_instruction_master_read_data_valid_cpu_jtag_debug_module),
      .cpu_instruction_master_requests_cpu_jtag_debug_module          (cpu_instruction_master_requests_cpu_jtag_debug_module),
      .cpu_jtag_debug_module_address                                  (cpu_jtag_debug_module_address),
      .cpu_jtag_debug_module_begintransfer                            (cpu_jtag_debug_module_begintransfer),
      .cpu_jtag_debug_module_byteenable                               (cpu_jtag_debug_module_byteenable),
      .cpu_jtag_debug_module_chipselect                               (cpu_jtag_debug_module_chipselect),
      .cpu_jtag_debug_module_debugaccess                              (cpu_jtag_debug_module_debugaccess),
      .cpu_jtag_debug_module_readdata                                 (cpu_jtag_debug_module_readdata),
      .cpu_jtag_debug_module_readdata_from_sa                         (cpu_jtag_debug_module_readdata_from_sa),
      .cpu_jtag_debug_module_reset_n                                  (cpu_jtag_debug_module_reset_n),
      .cpu_jtag_debug_module_resetrequest                             (cpu_jtag_debug_module_resetrequest),
      .cpu_jtag_debug_module_resetrequest_from_sa                     (cpu_jtag_debug_module_resetrequest_from_sa),
      .cpu_jtag_debug_module_write                                    (cpu_jtag_debug_module_write),
      .cpu_jtag_debug_module_writedata                                (cpu_jtag_debug_module_writedata),
      .d1_cpu_jtag_debug_module_end_xfer                              (d1_cpu_jtag_debug_module_end_xfer),
      .reset_n                                                        (sys_clk_reset_n)
    );

  cpu_data_master_arbitrator the_cpu_data_master
    (
      .adc_data_ready_s1_readdata_from_sa                                        (adc_data_ready_s1_readdata_from_sa),
      .clk                                                                       (sys_clk),
      .cpu_data_master_address                                                   (cpu_data_master_address),
      .cpu_data_master_address_to_slave                                          (cpu_data_master_address_to_slave),
      .cpu_data_master_granted_adc_data_ready_s1                                 (cpu_data_master_granted_adc_data_ready_s1),
      .cpu_data_master_granted_cpu_jtag_debug_module                             (cpu_data_master_granted_cpu_jtag_debug_module),
      .cpu_data_master_granted_ctrl_s1                                           (cpu_data_master_granted_ctrl_s1),
      .cpu_data_master_granted_epcs_flash_controller_epcs_control_port           (cpu_data_master_granted_epcs_flash_controller_epcs_control_port),
      .cpu_data_master_granted_gpio_s1                                           (cpu_data_master_granted_gpio_s1),
      .cpu_data_master_granted_jtag_uart_avalon_jtag_slave                       (cpu_data_master_granted_jtag_uart_avalon_jtag_slave),
      .cpu_data_master_granted_led_s1                                            (cpu_data_master_granted_led_s1),
      .cpu_data_master_granted_onchip_ram_s1                                     (cpu_data_master_granted_onchip_ram_s1),
      .cpu_data_master_granted_opencores_i2c_0_avalon_slave                      (cpu_data_master_granted_opencores_i2c_0_avalon_slave),
      .cpu_data_master_granted_opencores_i2c_1_avalon_slave                      (cpu_data_master_granted_opencores_i2c_1_avalon_slave),
      .cpu_data_master_granted_spi_0_p0_spi_control_port                         (cpu_data_master_granted_spi_0_p0_spi_control_port),
      .cpu_data_master_granted_spi_0_p1_spi_control_port                         (cpu_data_master_granted_spi_0_p1_spi_control_port),
      .cpu_data_master_granted_spi_1_p0_spi_control_port                         (cpu_data_master_granted_spi_1_p0_spi_control_port),
      .cpu_data_master_granted_spi_1_p1_spi_control_port                         (cpu_data_master_granted_spi_1_p1_spi_control_port),
      .cpu_data_master_granted_sysid_control_slave                               (cpu_data_master_granted_sysid_control_slave),
      .cpu_data_master_granted_timer_s1                                          (cpu_data_master_granted_timer_s1),
      .cpu_data_master_granted_uCProbe_uart_avalon_jtag_slave                    (cpu_data_master_granted_uCProbe_uart_avalon_jtag_slave),
      .cpu_data_master_granted_uC_clock_0_in                                     (cpu_data_master_granted_uC_clock_0_in),
      .cpu_data_master_irq                                                       (cpu_data_master_irq),
      .cpu_data_master_qualified_request_adc_data_ready_s1                       (cpu_data_master_qualified_request_adc_data_ready_s1),
      .cpu_data_master_qualified_request_cpu_jtag_debug_module                   (cpu_data_master_qualified_request_cpu_jtag_debug_module),
      .cpu_data_master_qualified_request_ctrl_s1                                 (cpu_data_master_qualified_request_ctrl_s1),
      .cpu_data_master_qualified_request_epcs_flash_controller_epcs_control_port (cpu_data_master_qualified_request_epcs_flash_controller_epcs_control_port),
      .cpu_data_master_qualified_request_gpio_s1                                 (cpu_data_master_qualified_request_gpio_s1),
      .cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave             (cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave),
      .cpu_data_master_qualified_request_led_s1                                  (cpu_data_master_qualified_request_led_s1),
      .cpu_data_master_qualified_request_onchip_ram_s1                           (cpu_data_master_qualified_request_onchip_ram_s1),
      .cpu_data_master_qualified_request_opencores_i2c_0_avalon_slave            (cpu_data_master_qualified_request_opencores_i2c_0_avalon_slave),
      .cpu_data_master_qualified_request_opencores_i2c_1_avalon_slave            (cpu_data_master_qualified_request_opencores_i2c_1_avalon_slave),
      .cpu_data_master_qualified_request_spi_0_p0_spi_control_port               (cpu_data_master_qualified_request_spi_0_p0_spi_control_port),
      .cpu_data_master_qualified_request_spi_0_p1_spi_control_port               (cpu_data_master_qualified_request_spi_0_p1_spi_control_port),
      .cpu_data_master_qualified_request_spi_1_p0_spi_control_port               (cpu_data_master_qualified_request_spi_1_p0_spi_control_port),
      .cpu_data_master_qualified_request_spi_1_p1_spi_control_port               (cpu_data_master_qualified_request_spi_1_p1_spi_control_port),
      .cpu_data_master_qualified_request_sysid_control_slave                     (cpu_data_master_qualified_request_sysid_control_slave),
      .cpu_data_master_qualified_request_timer_s1                                (cpu_data_master_qualified_request_timer_s1),
      .cpu_data_master_qualified_request_uCProbe_uart_avalon_jtag_slave          (cpu_data_master_qualified_request_uCProbe_uart_avalon_jtag_slave),
      .cpu_data_master_qualified_request_uC_clock_0_in                           (cpu_data_master_qualified_request_uC_clock_0_in),
      .cpu_data_master_read                                                      (cpu_data_master_read),
      .cpu_data_master_read_data_valid_adc_data_ready_s1                         (cpu_data_master_read_data_valid_adc_data_ready_s1),
      .cpu_data_master_read_data_valid_cpu_jtag_debug_module                     (cpu_data_master_read_data_valid_cpu_jtag_debug_module),
      .cpu_data_master_read_data_valid_ctrl_s1                                   (cpu_data_master_read_data_valid_ctrl_s1),
      .cpu_data_master_read_data_valid_epcs_flash_controller_epcs_control_port   (cpu_data_master_read_data_valid_epcs_flash_controller_epcs_control_port),
      .cpu_data_master_read_data_valid_gpio_s1                                   (cpu_data_master_read_data_valid_gpio_s1),
      .cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave               (cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave),
      .cpu_data_master_read_data_valid_led_s1                                    (cpu_data_master_read_data_valid_led_s1),
      .cpu_data_master_read_data_valid_onchip_ram_s1                             (cpu_data_master_read_data_valid_onchip_ram_s1),
      .cpu_data_master_read_data_valid_opencores_i2c_0_avalon_slave              (cpu_data_master_read_data_valid_opencores_i2c_0_avalon_slave),
      .cpu_data_master_read_data_valid_opencores_i2c_1_avalon_slave              (cpu_data_master_read_data_valid_opencores_i2c_1_avalon_slave),
      .cpu_data_master_read_data_valid_spi_0_p0_spi_control_port                 (cpu_data_master_read_data_valid_spi_0_p0_spi_control_port),
      .cpu_data_master_read_data_valid_spi_0_p1_spi_control_port                 (cpu_data_master_read_data_valid_spi_0_p1_spi_control_port),
      .cpu_data_master_read_data_valid_spi_1_p0_spi_control_port                 (cpu_data_master_read_data_valid_spi_1_p0_spi_control_port),
      .cpu_data_master_read_data_valid_spi_1_p1_spi_control_port                 (cpu_data_master_read_data_valid_spi_1_p1_spi_control_port),
      .cpu_data_master_read_data_valid_sysid_control_slave                       (cpu_data_master_read_data_valid_sysid_control_slave),
      .cpu_data_master_read_data_valid_timer_s1                                  (cpu_data_master_read_data_valid_timer_s1),
      .cpu_data_master_read_data_valid_uCProbe_uart_avalon_jtag_slave            (cpu_data_master_read_data_valid_uCProbe_uart_avalon_jtag_slave),
      .cpu_data_master_read_data_valid_uC_clock_0_in                             (cpu_data_master_read_data_valid_uC_clock_0_in),
      .cpu_data_master_readdata                                                  (cpu_data_master_readdata),
      .cpu_data_master_requests_adc_data_ready_s1                                (cpu_data_master_requests_adc_data_ready_s1),
      .cpu_data_master_requests_cpu_jtag_debug_module                            (cpu_data_master_requests_cpu_jtag_debug_module),
      .cpu_data_master_requests_ctrl_s1                                          (cpu_data_master_requests_ctrl_s1),
      .cpu_data_master_requests_epcs_flash_controller_epcs_control_port          (cpu_data_master_requests_epcs_flash_controller_epcs_control_port),
      .cpu_data_master_requests_gpio_s1                                          (cpu_data_master_requests_gpio_s1),
      .cpu_data_master_requests_jtag_uart_avalon_jtag_slave                      (cpu_data_master_requests_jtag_uart_avalon_jtag_slave),
      .cpu_data_master_requests_led_s1                                           (cpu_data_master_requests_led_s1),
      .cpu_data_master_requests_onchip_ram_s1                                    (cpu_data_master_requests_onchip_ram_s1),
      .cpu_data_master_requests_opencores_i2c_0_avalon_slave                     (cpu_data_master_requests_opencores_i2c_0_avalon_slave),
      .cpu_data_master_requests_opencores_i2c_1_avalon_slave                     (cpu_data_master_requests_opencores_i2c_1_avalon_slave),
      .cpu_data_master_requests_spi_0_p0_spi_control_port                        (cpu_data_master_requests_spi_0_p0_spi_control_port),
      .cpu_data_master_requests_spi_0_p1_spi_control_port                        (cpu_data_master_requests_spi_0_p1_spi_control_port),
      .cpu_data_master_requests_spi_1_p0_spi_control_port                        (cpu_data_master_requests_spi_1_p0_spi_control_port),
      .cpu_data_master_requests_spi_1_p1_spi_control_port                        (cpu_data_master_requests_spi_1_p1_spi_control_port),
      .cpu_data_master_requests_sysid_control_slave                              (cpu_data_master_requests_sysid_control_slave),
      .cpu_data_master_requests_timer_s1                                         (cpu_data_master_requests_timer_s1),
      .cpu_data_master_requests_uCProbe_uart_avalon_jtag_slave                   (cpu_data_master_requests_uCProbe_uart_avalon_jtag_slave),
      .cpu_data_master_requests_uC_clock_0_in                                    (cpu_data_master_requests_uC_clock_0_in),
      .cpu_data_master_waitrequest                                               (cpu_data_master_waitrequest),
      .cpu_data_master_write                                                     (cpu_data_master_write),
      .cpu_jtag_debug_module_readdata_from_sa                                    (cpu_jtag_debug_module_readdata_from_sa),
      .ctrl_s1_readdata_from_sa                                                  (ctrl_s1_readdata_from_sa),
      .d1_adc_data_ready_s1_end_xfer                                             (d1_adc_data_ready_s1_end_xfer),
      .d1_cpu_jtag_debug_module_end_xfer                                         (d1_cpu_jtag_debug_module_end_xfer),
      .d1_ctrl_s1_end_xfer                                                       (d1_ctrl_s1_end_xfer),
      .d1_epcs_flash_controller_epcs_control_port_end_xfer                       (d1_epcs_flash_controller_epcs_control_port_end_xfer),
      .d1_gpio_s1_end_xfer                                                       (d1_gpio_s1_end_xfer),
      .d1_jtag_uart_avalon_jtag_slave_end_xfer                                   (d1_jtag_uart_avalon_jtag_slave_end_xfer),
      .d1_led_s1_end_xfer                                                        (d1_led_s1_end_xfer),
      .d1_onchip_ram_s1_end_xfer                                                 (d1_onchip_ram_s1_end_xfer),
      .d1_opencores_i2c_0_avalon_slave_end_xfer                                  (d1_opencores_i2c_0_avalon_slave_end_xfer),
      .d1_opencores_i2c_1_avalon_slave_end_xfer                                  (d1_opencores_i2c_1_avalon_slave_end_xfer),
      .d1_spi_0_p0_spi_control_port_end_xfer                                     (d1_spi_0_p0_spi_control_port_end_xfer),
      .d1_spi_0_p1_spi_control_port_end_xfer                                     (d1_spi_0_p1_spi_control_port_end_xfer),
      .d1_spi_1_p0_spi_control_port_end_xfer                                     (d1_spi_1_p0_spi_control_port_end_xfer),
      .d1_spi_1_p1_spi_control_port_end_xfer                                     (d1_spi_1_p1_spi_control_port_end_xfer),
      .d1_sysid_control_slave_end_xfer                                           (d1_sysid_control_slave_end_xfer),
      .d1_timer_s1_end_xfer                                                      (d1_timer_s1_end_xfer),
      .d1_uCProbe_uart_avalon_jtag_slave_end_xfer                                (d1_uCProbe_uart_avalon_jtag_slave_end_xfer),
      .d1_uC_clock_0_in_end_xfer                                                 (d1_uC_clock_0_in_end_xfer),
      .epcs_flash_controller_epcs_control_port_irq_from_sa                       (epcs_flash_controller_epcs_control_port_irq_from_sa),
      .epcs_flash_controller_epcs_control_port_readdata_from_sa                  (epcs_flash_controller_epcs_control_port_readdata_from_sa),
      .gpio_s1_readdata_from_sa                                                  (gpio_s1_readdata_from_sa),
      .jtag_uart_avalon_jtag_slave_irq_from_sa                                   (jtag_uart_avalon_jtag_slave_irq_from_sa),
      .jtag_uart_avalon_jtag_slave_readdata_from_sa                              (jtag_uart_avalon_jtag_slave_readdata_from_sa),
      .jtag_uart_avalon_jtag_slave_waitrequest_from_sa                           (jtag_uart_avalon_jtag_slave_waitrequest_from_sa),
      .led_s1_readdata_from_sa                                                   (led_s1_readdata_from_sa),
      .onchip_ram_s1_readdata_from_sa                                            (onchip_ram_s1_readdata_from_sa),
      .opencores_i2c_0_avalon_slave_irq_from_sa                                  (opencores_i2c_0_avalon_slave_irq_from_sa),
      .opencores_i2c_0_avalon_slave_readdata_from_sa                             (opencores_i2c_0_avalon_slave_readdata_from_sa),
      .opencores_i2c_0_avalon_slave_waitrequest_n_from_sa                        (opencores_i2c_0_avalon_slave_waitrequest_n_from_sa),
      .opencores_i2c_1_avalon_slave_irq_from_sa                                  (opencores_i2c_1_avalon_slave_irq_from_sa),
      .opencores_i2c_1_avalon_slave_readdata_from_sa                             (opencores_i2c_1_avalon_slave_readdata_from_sa),
      .opencores_i2c_1_avalon_slave_waitrequest_n_from_sa                        (opencores_i2c_1_avalon_slave_waitrequest_n_from_sa),
      .registered_cpu_data_master_read_data_valid_onchip_ram_s1                  (registered_cpu_data_master_read_data_valid_onchip_ram_s1),
      .reset_n                                                                   (sys_clk_reset_n),
      .spi_0_p0_spi_control_port_irq_from_sa                                     (spi_0_p0_spi_control_port_irq_from_sa),
      .spi_0_p0_spi_control_port_readdata_from_sa                                (spi_0_p0_spi_control_port_readdata_from_sa),
      .spi_0_p1_spi_control_port_irq_from_sa                                     (spi_0_p1_spi_control_port_irq_from_sa),
      .spi_0_p1_spi_control_port_readdata_from_sa                                (spi_0_p1_spi_control_port_readdata_from_sa),
      .spi_1_p0_spi_control_port_irq_from_sa                                     (spi_1_p0_spi_control_port_irq_from_sa),
      .spi_1_p0_spi_control_port_readdata_from_sa                                (spi_1_p0_spi_control_port_readdata_from_sa),
      .spi_1_p1_spi_control_port_irq_from_sa                                     (spi_1_p1_spi_control_port_irq_from_sa),
      .spi_1_p1_spi_control_port_readdata_from_sa                                (spi_1_p1_spi_control_port_readdata_from_sa),
      .sysid_control_slave_readdata_from_sa                                      (sysid_control_slave_readdata_from_sa),
      .timer_s1_irq_from_sa                                                      (timer_s1_irq_from_sa),
      .timer_s1_readdata_from_sa                                                 (timer_s1_readdata_from_sa),
      .uCProbe_uart_avalon_jtag_slave_irq_from_sa                                (uCProbe_uart_avalon_jtag_slave_irq_from_sa),
      .uCProbe_uart_avalon_jtag_slave_readdata_from_sa                           (uCProbe_uart_avalon_jtag_slave_readdata_from_sa),
      .uCProbe_uart_avalon_jtag_slave_waitrequest_from_sa                        (uCProbe_uart_avalon_jtag_slave_waitrequest_from_sa),
      .uC_clock_0_in_readdata_from_sa                                            (uC_clock_0_in_readdata_from_sa),
      .uC_clock_0_in_waitrequest_from_sa                                         (uC_clock_0_in_waitrequest_from_sa)
    );

  cpu_instruction_master_arbitrator the_cpu_instruction_master
    (
      .clk                                                                              (sys_clk),
      .cpu_instruction_master_address                                                   (cpu_instruction_master_address),
      .cpu_instruction_master_address_to_slave                                          (cpu_instruction_master_address_to_slave),
      .cpu_instruction_master_granted_cpu_jtag_debug_module                             (cpu_instruction_master_granted_cpu_jtag_debug_module),
      .cpu_instruction_master_granted_epcs_flash_controller_epcs_control_port           (cpu_instruction_master_granted_epcs_flash_controller_epcs_control_port),
      .cpu_instruction_master_granted_onchip_ram_s1                                     (cpu_instruction_master_granted_onchip_ram_s1),
      .cpu_instruction_master_qualified_request_cpu_jtag_debug_module                   (cpu_instruction_master_qualified_request_cpu_jtag_debug_module),
      .cpu_instruction_master_qualified_request_epcs_flash_controller_epcs_control_port (cpu_instruction_master_qualified_request_epcs_flash_controller_epcs_control_port),
      .cpu_instruction_master_qualified_request_onchip_ram_s1                           (cpu_instruction_master_qualified_request_onchip_ram_s1),
      .cpu_instruction_master_read                                                      (cpu_instruction_master_read),
      .cpu_instruction_master_read_data_valid_cpu_jtag_debug_module                     (cpu_instruction_master_read_data_valid_cpu_jtag_debug_module),
      .cpu_instruction_master_read_data_valid_epcs_flash_controller_epcs_control_port   (cpu_instruction_master_read_data_valid_epcs_flash_controller_epcs_control_port),
      .cpu_instruction_master_read_data_valid_onchip_ram_s1                             (cpu_instruction_master_read_data_valid_onchip_ram_s1),
      .cpu_instruction_master_readdata                                                  (cpu_instruction_master_readdata),
      .cpu_instruction_master_requests_cpu_jtag_debug_module                            (cpu_instruction_master_requests_cpu_jtag_debug_module),
      .cpu_instruction_master_requests_epcs_flash_controller_epcs_control_port          (cpu_instruction_master_requests_epcs_flash_controller_epcs_control_port),
      .cpu_instruction_master_requests_onchip_ram_s1                                    (cpu_instruction_master_requests_onchip_ram_s1),
      .cpu_instruction_master_waitrequest                                               (cpu_instruction_master_waitrequest),
      .cpu_jtag_debug_module_readdata_from_sa                                           (cpu_jtag_debug_module_readdata_from_sa),
      .d1_cpu_jtag_debug_module_end_xfer                                                (d1_cpu_jtag_debug_module_end_xfer),
      .d1_epcs_flash_controller_epcs_control_port_end_xfer                              (d1_epcs_flash_controller_epcs_control_port_end_xfer),
      .d1_onchip_ram_s1_end_xfer                                                        (d1_onchip_ram_s1_end_xfer),
      .epcs_flash_controller_epcs_control_port_readdata_from_sa                         (epcs_flash_controller_epcs_control_port_readdata_from_sa),
      .onchip_ram_s1_readdata_from_sa                                                   (onchip_ram_s1_readdata_from_sa),
      .reset_n                                                                          (sys_clk_reset_n)
    );

  cpu the_cpu
    (
      .clk                                   (sys_clk),
      .d_address                             (cpu_data_master_address),
      .d_byteenable                          (cpu_data_master_byteenable),
      .d_irq                                 (cpu_data_master_irq),
      .d_read                                (cpu_data_master_read),
      .d_readdata                            (cpu_data_master_readdata),
      .d_waitrequest                         (cpu_data_master_waitrequest),
      .d_write                               (cpu_data_master_write),
      .d_writedata                           (cpu_data_master_writedata),
      .i_address                             (cpu_instruction_master_address),
      .i_read                                (cpu_instruction_master_read),
      .i_readdata                            (cpu_instruction_master_readdata),
      .i_waitrequest                         (cpu_instruction_master_waitrequest),
      .jtag_debug_module_address             (cpu_jtag_debug_module_address),
      .jtag_debug_module_begintransfer       (cpu_jtag_debug_module_begintransfer),
      .jtag_debug_module_byteenable          (cpu_jtag_debug_module_byteenable),
      .jtag_debug_module_debugaccess         (cpu_jtag_debug_module_debugaccess),
      .jtag_debug_module_debugaccess_to_roms (cpu_data_master_debugaccess),
      .jtag_debug_module_readdata            (cpu_jtag_debug_module_readdata),
      .jtag_debug_module_resetrequest        (cpu_jtag_debug_module_resetrequest),
      .jtag_debug_module_select              (cpu_jtag_debug_module_chipselect),
      .jtag_debug_module_write               (cpu_jtag_debug_module_write),
      .jtag_debug_module_writedata           (cpu_jtag_debug_module_writedata),
      .reset_n                               (cpu_jtag_debug_module_reset_n)
    );

  ctrl_s1_arbitrator the_ctrl_s1
    (
      .clk                                       (sys_clk),
      .cpu_data_master_address_to_slave          (cpu_data_master_address_to_slave),
      .cpu_data_master_granted_ctrl_s1           (cpu_data_master_granted_ctrl_s1),
      .cpu_data_master_qualified_request_ctrl_s1 (cpu_data_master_qualified_request_ctrl_s1),
      .cpu_data_master_read                      (cpu_data_master_read),
      .cpu_data_master_read_data_valid_ctrl_s1   (cpu_data_master_read_data_valid_ctrl_s1),
      .cpu_data_master_requests_ctrl_s1          (cpu_data_master_requests_ctrl_s1),
      .cpu_data_master_waitrequest               (cpu_data_master_waitrequest),
      .cpu_data_master_write                     (cpu_data_master_write),
      .cpu_data_master_writedata                 (cpu_data_master_writedata),
      .ctrl_s1_address                           (ctrl_s1_address),
      .ctrl_s1_chipselect                        (ctrl_s1_chipselect),
      .ctrl_s1_readdata                          (ctrl_s1_readdata),
      .ctrl_s1_readdata_from_sa                  (ctrl_s1_readdata_from_sa),
      .ctrl_s1_reset_n                           (ctrl_s1_reset_n),
      .ctrl_s1_write_n                           (ctrl_s1_write_n),
      .ctrl_s1_writedata                         (ctrl_s1_writedata),
      .d1_ctrl_s1_end_xfer                       (d1_ctrl_s1_end_xfer),
      .reset_n                                   (sys_clk_reset_n)
    );

  ctrl the_ctrl
    (
      .address    (ctrl_s1_address),
      .chipselect (ctrl_s1_chipselect),
      .clk        (sys_clk),
      .out_port   (out_port_from_the_ctrl),
      .readdata   (ctrl_s1_readdata),
      .reset_n    (ctrl_s1_reset_n),
      .write_n    (ctrl_s1_write_n),
      .writedata  (ctrl_s1_writedata)
    );

  epcs_flash_controller_epcs_control_port_arbitrator the_epcs_flash_controller_epcs_control_port
    (
      .clk                                                                              (sys_clk),
      .cpu_data_master_address_to_slave                                                 (cpu_data_master_address_to_slave),
      .cpu_data_master_granted_epcs_flash_controller_epcs_control_port                  (cpu_data_master_granted_epcs_flash_controller_epcs_control_port),
      .cpu_data_master_qualified_request_epcs_flash_controller_epcs_control_port        (cpu_data_master_qualified_request_epcs_flash_controller_epcs_control_port),
      .cpu_data_master_read                                                             (cpu_data_master_read),
      .cpu_data_master_read_data_valid_epcs_flash_controller_epcs_control_port          (cpu_data_master_read_data_valid_epcs_flash_controller_epcs_control_port),
      .cpu_data_master_requests_epcs_flash_controller_epcs_control_port                 (cpu_data_master_requests_epcs_flash_controller_epcs_control_port),
      .cpu_data_master_write                                                            (cpu_data_master_write),
      .cpu_data_master_writedata                                                        (cpu_data_master_writedata),
      .cpu_instruction_master_address_to_slave                                          (cpu_instruction_master_address_to_slave),
      .cpu_instruction_master_granted_epcs_flash_controller_epcs_control_port           (cpu_instruction_master_granted_epcs_flash_controller_epcs_control_port),
      .cpu_instruction_master_qualified_request_epcs_flash_controller_epcs_control_port (cpu_instruction_master_qualified_request_epcs_flash_controller_epcs_control_port),
      .cpu_instruction_master_read                                                      (cpu_instruction_master_read),
      .cpu_instruction_master_read_data_valid_epcs_flash_controller_epcs_control_port   (cpu_instruction_master_read_data_valid_epcs_flash_controller_epcs_control_port),
      .cpu_instruction_master_requests_epcs_flash_controller_epcs_control_port          (cpu_instruction_master_requests_epcs_flash_controller_epcs_control_port),
      .d1_epcs_flash_controller_epcs_control_port_end_xfer                              (d1_epcs_flash_controller_epcs_control_port_end_xfer),
      .epcs_flash_controller_epcs_control_port_address                                  (epcs_flash_controller_epcs_control_port_address),
      .epcs_flash_controller_epcs_control_port_chipselect                               (epcs_flash_controller_epcs_control_port_chipselect),
      .epcs_flash_controller_epcs_control_port_dataavailable                            (epcs_flash_controller_epcs_control_port_dataavailable),
      .epcs_flash_controller_epcs_control_port_dataavailable_from_sa                    (epcs_flash_controller_epcs_control_port_dataavailable_from_sa),
      .epcs_flash_controller_epcs_control_port_endofpacket                              (epcs_flash_controller_epcs_control_port_endofpacket),
      .epcs_flash_controller_epcs_control_port_endofpacket_from_sa                      (epcs_flash_controller_epcs_control_port_endofpacket_from_sa),
      .epcs_flash_controller_epcs_control_port_irq                                      (epcs_flash_controller_epcs_control_port_irq),
      .epcs_flash_controller_epcs_control_port_irq_from_sa                              (epcs_flash_controller_epcs_control_port_irq_from_sa),
      .epcs_flash_controller_epcs_control_port_read_n                                   (epcs_flash_controller_epcs_control_port_read_n),
      .epcs_flash_controller_epcs_control_port_readdata                                 (epcs_flash_controller_epcs_control_port_readdata),
      .epcs_flash_controller_epcs_control_port_readdata_from_sa                         (epcs_flash_controller_epcs_control_port_readdata_from_sa),
      .epcs_flash_controller_epcs_control_port_readyfordata                             (epcs_flash_controller_epcs_control_port_readyfordata),
      .epcs_flash_controller_epcs_control_port_readyfordata_from_sa                     (epcs_flash_controller_epcs_control_port_readyfordata_from_sa),
      .epcs_flash_controller_epcs_control_port_reset_n                                  (epcs_flash_controller_epcs_control_port_reset_n),
      .epcs_flash_controller_epcs_control_port_write_n                                  (epcs_flash_controller_epcs_control_port_write_n),
      .epcs_flash_controller_epcs_control_port_writedata                                (epcs_flash_controller_epcs_control_port_writedata),
      .reset_n                                                                          (sys_clk_reset_n)
    );

  epcs_flash_controller the_epcs_flash_controller
    (
      .address       (epcs_flash_controller_epcs_control_port_address),
      .chipselect    (epcs_flash_controller_epcs_control_port_chipselect),
      .clk           (sys_clk),
      .data0         (data0_to_the_epcs_flash_controller),
      .dataavailable (epcs_flash_controller_epcs_control_port_dataavailable),
      .dclk          (dclk_from_the_epcs_flash_controller),
      .endofpacket   (epcs_flash_controller_epcs_control_port_endofpacket),
      .irq           (epcs_flash_controller_epcs_control_port_irq),
      .read_n        (epcs_flash_controller_epcs_control_port_read_n),
      .readdata      (epcs_flash_controller_epcs_control_port_readdata),
      .readyfordata  (epcs_flash_controller_epcs_control_port_readyfordata),
      .reset_n       (epcs_flash_controller_epcs_control_port_reset_n),
      .sce           (sce_from_the_epcs_flash_controller),
      .sdo           (sdo_from_the_epcs_flash_controller),
      .write_n       (epcs_flash_controller_epcs_control_port_write_n),
      .writedata     (epcs_flash_controller_epcs_control_port_writedata)
    );

  gpio_s1_arbitrator the_gpio_s1
    (
      .clk                                       (sys_clk),
      .cpu_data_master_address_to_slave          (cpu_data_master_address_to_slave),
      .cpu_data_master_granted_gpio_s1           (cpu_data_master_granted_gpio_s1),
      .cpu_data_master_qualified_request_gpio_s1 (cpu_data_master_qualified_request_gpio_s1),
      .cpu_data_master_read                      (cpu_data_master_read),
      .cpu_data_master_read_data_valid_gpio_s1   (cpu_data_master_read_data_valid_gpio_s1),
      .cpu_data_master_requests_gpio_s1          (cpu_data_master_requests_gpio_s1),
      .cpu_data_master_waitrequest               (cpu_data_master_waitrequest),
      .cpu_data_master_write                     (cpu_data_master_write),
      .cpu_data_master_writedata                 (cpu_data_master_writedata),
      .d1_gpio_s1_end_xfer                       (d1_gpio_s1_end_xfer),
      .gpio_s1_address                           (gpio_s1_address),
      .gpio_s1_chipselect                        (gpio_s1_chipselect),
      .gpio_s1_readdata                          (gpio_s1_readdata),
      .gpio_s1_readdata_from_sa                  (gpio_s1_readdata_from_sa),
      .gpio_s1_reset_n                           (gpio_s1_reset_n),
      .gpio_s1_write_n                           (gpio_s1_write_n),
      .gpio_s1_writedata                         (gpio_s1_writedata),
      .reset_n                                   (sys_clk_reset_n)
    );

  gpio the_gpio
    (
      .address    (gpio_s1_address),
      .bidir_port (bidir_port_to_and_from_the_gpio),
      .chipselect (gpio_s1_chipselect),
      .clk        (sys_clk),
      .readdata   (gpio_s1_readdata),
      .reset_n    (gpio_s1_reset_n),
      .write_n    (gpio_s1_write_n),
      .writedata  (gpio_s1_writedata)
    );

  jtag_uart_avalon_jtag_slave_arbitrator the_jtag_uart_avalon_jtag_slave
    (
      .clk                                                           (sys_clk),
      .cpu_data_master_address_to_slave                              (cpu_data_master_address_to_slave),
      .cpu_data_master_granted_jtag_uart_avalon_jtag_slave           (cpu_data_master_granted_jtag_uart_avalon_jtag_slave),
      .cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave (cpu_data_master_qualified_request_jtag_uart_avalon_jtag_slave),
      .cpu_data_master_read                                          (cpu_data_master_read),
      .cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave   (cpu_data_master_read_data_valid_jtag_uart_avalon_jtag_slave),
      .cpu_data_master_requests_jtag_uart_avalon_jtag_slave          (cpu_data_master_requests_jtag_uart_avalon_jtag_slave),
      .cpu_data_master_waitrequest                                   (cpu_data_master_waitrequest),
      .cpu_data_master_write                                         (cpu_data_master_write),
      .cpu_data_master_writedata                                     (cpu_data_master_writedata),
      .d1_jtag_uart_avalon_jtag_slave_end_xfer                       (d1_jtag_uart_avalon_jtag_slave_end_xfer),
      .jtag_uart_avalon_jtag_slave_address                           (jtag_uart_avalon_jtag_slave_address),
      .jtag_uart_avalon_jtag_slave_chipselect                        (jtag_uart_avalon_jtag_slave_chipselect),
      .jtag_uart_avalon_jtag_slave_dataavailable                     (jtag_uart_avalon_jtag_slave_dataavailable),
      .jtag_uart_avalon_jtag_slave_dataavailable_from_sa             (jtag_uart_avalon_jtag_slave_dataavailable_from_sa),
      .jtag_uart_avalon_jtag_slave_irq                               (jtag_uart_avalon_jtag_slave_irq),
      .jtag_uart_avalon_jtag_slave_irq_from_sa                       (jtag_uart_avalon_jtag_slave_irq_from_sa),
      .jtag_uart_avalon_jtag_slave_read_n                            (jtag_uart_avalon_jtag_slave_read_n),
      .jtag_uart_avalon_jtag_slave_readdata                          (jtag_uart_avalon_jtag_slave_readdata),
      .jtag_uart_avalon_jtag_slave_readdata_from_sa                  (jtag_uart_avalon_jtag_slave_readdata_from_sa),
      .jtag_uart_avalon_jtag_slave_readyfordata                      (jtag_uart_avalon_jtag_slave_readyfordata),
      .jtag_uart_avalon_jtag_slave_readyfordata_from_sa              (jtag_uart_avalon_jtag_slave_readyfordata_from_sa),
      .jtag_uart_avalon_jtag_slave_reset_n                           (jtag_uart_avalon_jtag_slave_reset_n),
      .jtag_uart_avalon_jtag_slave_waitrequest                       (jtag_uart_avalon_jtag_slave_waitrequest),
      .jtag_uart_avalon_jtag_slave_waitrequest_from_sa               (jtag_uart_avalon_jtag_slave_waitrequest_from_sa),
      .jtag_uart_avalon_jtag_slave_write_n                           (jtag_uart_avalon_jtag_slave_write_n),
      .jtag_uart_avalon_jtag_slave_writedata                         (jtag_uart_avalon_jtag_slave_writedata),
      .reset_n                                                       (sys_clk_reset_n)
    );

  jtag_uart the_jtag_uart
    (
      .av_address     (jtag_uart_avalon_jtag_slave_address),
      .av_chipselect  (jtag_uart_avalon_jtag_slave_chipselect),
      .av_irq         (jtag_uart_avalon_jtag_slave_irq),
      .av_read_n      (jtag_uart_avalon_jtag_slave_read_n),
      .av_readdata    (jtag_uart_avalon_jtag_slave_readdata),
      .av_waitrequest (jtag_uart_avalon_jtag_slave_waitrequest),
      .av_write_n     (jtag_uart_avalon_jtag_slave_write_n),
      .av_writedata   (jtag_uart_avalon_jtag_slave_writedata),
      .clk            (sys_clk),
      .dataavailable  (jtag_uart_avalon_jtag_slave_dataavailable),
      .readyfordata   (jtag_uart_avalon_jtag_slave_readyfordata),
      .rst_n          (jtag_uart_avalon_jtag_slave_reset_n)
    );

  led_s1_arbitrator the_led_s1
    (
      .clk                                      (sys_clk),
      .cpu_data_master_address_to_slave         (cpu_data_master_address_to_slave),
      .cpu_data_master_granted_led_s1           (cpu_data_master_granted_led_s1),
      .cpu_data_master_qualified_request_led_s1 (cpu_data_master_qualified_request_led_s1),
      .cpu_data_master_read                     (cpu_data_master_read),
      .cpu_data_master_read_data_valid_led_s1   (cpu_data_master_read_data_valid_led_s1),
      .cpu_data_master_requests_led_s1          (cpu_data_master_requests_led_s1),
      .cpu_data_master_waitrequest              (cpu_data_master_waitrequest),
      .cpu_data_master_write                    (cpu_data_master_write),
      .cpu_data_master_writedata                (cpu_data_master_writedata),
      .d1_led_s1_end_xfer                       (d1_led_s1_end_xfer),
      .led_s1_address                           (led_s1_address),
      .led_s1_chipselect                        (led_s1_chipselect),
      .led_s1_readdata                          (led_s1_readdata),
      .led_s1_readdata_from_sa                  (led_s1_readdata_from_sa),
      .led_s1_reset_n                           (led_s1_reset_n),
      .led_s1_write_n                           (led_s1_write_n),
      .led_s1_writedata                         (led_s1_writedata),
      .reset_n                                  (sys_clk_reset_n)
    );

  led the_led
    (
      .address    (led_s1_address),
      .chipselect (led_s1_chipselect),
      .clk        (sys_clk),
      .out_port   (out_port_from_the_led),
      .readdata   (led_s1_readdata),
      .reset_n    (led_s1_reset_n),
      .write_n    (led_s1_write_n),
      .writedata  (led_s1_writedata)
    );

  mm_console_master_master_arbitrator the_mm_console_master_master
    (
      .clk                                               (sys_clk),
      .d1_onchip_ram_s1_end_xfer                         (d1_onchip_ram_s1_end_xfer),
      .mm_console_master_granted_onchip_ram_s1           (mm_console_master_granted_onchip_ram_s1),
      .mm_console_master_latency_counter                 (mm_console_master_latency_counter),
      .mm_console_master_master_address                  (mm_console_master_master_address),
      .mm_console_master_master_address_to_slave         (mm_console_master_master_address_to_slave),
      .mm_console_master_master_byteenable               (mm_console_master_master_byteenable),
      .mm_console_master_master_read                     (mm_console_master_master_read),
      .mm_console_master_master_readdata                 (mm_console_master_master_readdata),
      .mm_console_master_master_readdatavalid            (mm_console_master_master_readdatavalid),
      .mm_console_master_master_reset                    (mm_console_master_master_reset),
      .mm_console_master_master_waitrequest              (mm_console_master_master_waitrequest),
      .mm_console_master_master_write                    (mm_console_master_master_write),
      .mm_console_master_master_writedata                (mm_console_master_master_writedata),
      .mm_console_master_qualified_request_onchip_ram_s1 (mm_console_master_qualified_request_onchip_ram_s1),
      .mm_console_master_read_data_valid_onchip_ram_s1   (mm_console_master_read_data_valid_onchip_ram_s1),
      .mm_console_master_requests_onchip_ram_s1          (mm_console_master_requests_onchip_ram_s1),
      .onchip_ram_s1_readdata_from_sa                    (onchip_ram_s1_readdata_from_sa),
      .reset_n                                           (sys_clk_reset_n)
    );

  mm_console_master the_mm_console_master
    (
      .clk_clk              (sys_clk),
      .clk_reset_reset      (mm_console_master_master_reset),
      .master_address       (mm_console_master_master_address),
      .master_byteenable    (mm_console_master_master_byteenable),
      .master_read          (mm_console_master_master_read),
      .master_readdata      (mm_console_master_master_readdata),
      .master_readdatavalid (mm_console_master_master_readdatavalid),
      .master_waitrequest   (mm_console_master_master_waitrequest),
      .master_write         (mm_console_master_master_write),
      .master_writedata     (mm_console_master_master_writedata)
    );

  onchip_ram_s1_arbitrator the_onchip_ram_s1
    (
      .clk                                                      (sys_clk),
      .cpu_data_master_address_to_slave                         (cpu_data_master_address_to_slave),
      .cpu_data_master_byteenable                               (cpu_data_master_byteenable),
      .cpu_data_master_granted_onchip_ram_s1                    (cpu_data_master_granted_onchip_ram_s1),
      .cpu_data_master_qualified_request_onchip_ram_s1          (cpu_data_master_qualified_request_onchip_ram_s1),
      .cpu_data_master_read                                     (cpu_data_master_read),
      .cpu_data_master_read_data_valid_onchip_ram_s1            (cpu_data_master_read_data_valid_onchip_ram_s1),
      .cpu_data_master_requests_onchip_ram_s1                   (cpu_data_master_requests_onchip_ram_s1),
      .cpu_data_master_waitrequest                              (cpu_data_master_waitrequest),
      .cpu_data_master_write                                    (cpu_data_master_write),
      .cpu_data_master_writedata                                (cpu_data_master_writedata),
      .cpu_instruction_master_address_to_slave                  (cpu_instruction_master_address_to_slave),
      .cpu_instruction_master_granted_onchip_ram_s1             (cpu_instruction_master_granted_onchip_ram_s1),
      .cpu_instruction_master_qualified_request_onchip_ram_s1   (cpu_instruction_master_qualified_request_onchip_ram_s1),
      .cpu_instruction_master_read                              (cpu_instruction_master_read),
      .cpu_instruction_master_read_data_valid_onchip_ram_s1     (cpu_instruction_master_read_data_valid_onchip_ram_s1),
      .cpu_instruction_master_requests_onchip_ram_s1            (cpu_instruction_master_requests_onchip_ram_s1),
      .d1_onchip_ram_s1_end_xfer                                (d1_onchip_ram_s1_end_xfer),
      .mm_console_master_granted_onchip_ram_s1                  (mm_console_master_granted_onchip_ram_s1),
      .mm_console_master_latency_counter                        (mm_console_master_latency_counter),
      .mm_console_master_master_address_to_slave                (mm_console_master_master_address_to_slave),
      .mm_console_master_master_byteenable                      (mm_console_master_master_byteenable),
      .mm_console_master_master_read                            (mm_console_master_master_read),
      .mm_console_master_master_write                           (mm_console_master_master_write),
      .mm_console_master_master_writedata                       (mm_console_master_master_writedata),
      .mm_console_master_qualified_request_onchip_ram_s1        (mm_console_master_qualified_request_onchip_ram_s1),
      .mm_console_master_read_data_valid_onchip_ram_s1          (mm_console_master_read_data_valid_onchip_ram_s1),
      .mm_console_master_requests_onchip_ram_s1                 (mm_console_master_requests_onchip_ram_s1),
      .onchip_ram_s1_address                                    (onchip_ram_s1_address),
      .onchip_ram_s1_byteenable                                 (onchip_ram_s1_byteenable),
      .onchip_ram_s1_chipselect                                 (onchip_ram_s1_chipselect),
      .onchip_ram_s1_clken                                      (onchip_ram_s1_clken),
      .onchip_ram_s1_readdata                                   (onchip_ram_s1_readdata),
      .onchip_ram_s1_readdata_from_sa                           (onchip_ram_s1_readdata_from_sa),
      .onchip_ram_s1_reset                                      (onchip_ram_s1_reset),
      .onchip_ram_s1_write                                      (onchip_ram_s1_write),
      .onchip_ram_s1_writedata                                  (onchip_ram_s1_writedata),
      .registered_cpu_data_master_read_data_valid_onchip_ram_s1 (registered_cpu_data_master_read_data_valid_onchip_ram_s1),
      .reset_n                                                  (sys_clk_reset_n)
    );

  onchip_ram the_onchip_ram
    (
      .address    (onchip_ram_s1_address),
      .byteenable (onchip_ram_s1_byteenable),
      .chipselect (onchip_ram_s1_chipselect),
      .clk        (sys_clk),
      .clken      (onchip_ram_s1_clken),
      .readdata   (onchip_ram_s1_readdata),
      .reset      (onchip_ram_s1_reset),
      .write      (onchip_ram_s1_write),
      .writedata  (onchip_ram_s1_writedata)
    );

  opencores_i2c_0_avalon_slave_arbitrator the_opencores_i2c_0_avalon_slave
    (
      .clk                                                            (sys_clk),
      .cpu_data_master_address_to_slave                               (cpu_data_master_address_to_slave),
      .cpu_data_master_byteenable                                     (cpu_data_master_byteenable),
      .cpu_data_master_granted_opencores_i2c_0_avalon_slave           (cpu_data_master_granted_opencores_i2c_0_avalon_slave),
      .cpu_data_master_qualified_request_opencores_i2c_0_avalon_slave (cpu_data_master_qualified_request_opencores_i2c_0_avalon_slave),
      .cpu_data_master_read                                           (cpu_data_master_read),
      .cpu_data_master_read_data_valid_opencores_i2c_0_avalon_slave   (cpu_data_master_read_data_valid_opencores_i2c_0_avalon_slave),
      .cpu_data_master_requests_opencores_i2c_0_avalon_slave          (cpu_data_master_requests_opencores_i2c_0_avalon_slave),
      .cpu_data_master_waitrequest                                    (cpu_data_master_waitrequest),
      .cpu_data_master_write                                          (cpu_data_master_write),
      .cpu_data_master_writedata                                      (cpu_data_master_writedata),
      .d1_opencores_i2c_0_avalon_slave_end_xfer                       (d1_opencores_i2c_0_avalon_slave_end_xfer),
      .opencores_i2c_0_avalon_slave_address                           (opencores_i2c_0_avalon_slave_address),
      .opencores_i2c_0_avalon_slave_chipselect                        (opencores_i2c_0_avalon_slave_chipselect),
      .opencores_i2c_0_avalon_slave_irq                               (opencores_i2c_0_avalon_slave_irq),
      .opencores_i2c_0_avalon_slave_irq_from_sa                       (opencores_i2c_0_avalon_slave_irq_from_sa),
      .opencores_i2c_0_avalon_slave_readdata                          (opencores_i2c_0_avalon_slave_readdata),
      .opencores_i2c_0_avalon_slave_readdata_from_sa                  (opencores_i2c_0_avalon_slave_readdata_from_sa),
      .opencores_i2c_0_avalon_slave_reset                             (opencores_i2c_0_avalon_slave_reset),
      .opencores_i2c_0_avalon_slave_waitrequest_n                     (opencores_i2c_0_avalon_slave_waitrequest_n),
      .opencores_i2c_0_avalon_slave_waitrequest_n_from_sa             (opencores_i2c_0_avalon_slave_waitrequest_n_from_sa),
      .opencores_i2c_0_avalon_slave_write                             (opencores_i2c_0_avalon_slave_write),
      .opencores_i2c_0_avalon_slave_writedata                         (opencores_i2c_0_avalon_slave_writedata),
      .reset_n                                                        (sys_clk_reset_n)
    );

  opencores_i2c_0 the_opencores_i2c_0
    (
      .scl_pad_io (scl_pad_io_to_and_from_the_opencores_i2c_0),
      .sda_pad_io (sda_pad_io_to_and_from_the_opencores_i2c_0),
      .wb_ack_o   (opencores_i2c_0_avalon_slave_waitrequest_n),
      .wb_adr_i   (opencores_i2c_0_avalon_slave_address),
      .wb_clk_i   (sys_clk),
      .wb_dat_i   (opencores_i2c_0_avalon_slave_writedata),
      .wb_dat_o   (opencores_i2c_0_avalon_slave_readdata),
      .wb_inta_o  (opencores_i2c_0_avalon_slave_irq),
      .wb_rst_i   (opencores_i2c_0_avalon_slave_reset),
      .wb_stb_i   (opencores_i2c_0_avalon_slave_chipselect),
      .wb_we_i    (opencores_i2c_0_avalon_slave_write)
    );

  opencores_i2c_1_avalon_slave_arbitrator the_opencores_i2c_1_avalon_slave
    (
      .clk                                                            (sys_clk),
      .cpu_data_master_address_to_slave                               (cpu_data_master_address_to_slave),
      .cpu_data_master_byteenable                                     (cpu_data_master_byteenable),
      .cpu_data_master_granted_opencores_i2c_1_avalon_slave           (cpu_data_master_granted_opencores_i2c_1_avalon_slave),
      .cpu_data_master_qualified_request_opencores_i2c_1_avalon_slave (cpu_data_master_qualified_request_opencores_i2c_1_avalon_slave),
      .cpu_data_master_read                                           (cpu_data_master_read),
      .cpu_data_master_read_data_valid_opencores_i2c_1_avalon_slave   (cpu_data_master_read_data_valid_opencores_i2c_1_avalon_slave),
      .cpu_data_master_requests_opencores_i2c_1_avalon_slave          (cpu_data_master_requests_opencores_i2c_1_avalon_slave),
      .cpu_data_master_waitrequest                                    (cpu_data_master_waitrequest),
      .cpu_data_master_write                                          (cpu_data_master_write),
      .cpu_data_master_writedata                                      (cpu_data_master_writedata),
      .d1_opencores_i2c_1_avalon_slave_end_xfer                       (d1_opencores_i2c_1_avalon_slave_end_xfer),
      .opencores_i2c_1_avalon_slave_address                           (opencores_i2c_1_avalon_slave_address),
      .opencores_i2c_1_avalon_slave_chipselect                        (opencores_i2c_1_avalon_slave_chipselect),
      .opencores_i2c_1_avalon_slave_irq                               (opencores_i2c_1_avalon_slave_irq),
      .opencores_i2c_1_avalon_slave_irq_from_sa                       (opencores_i2c_1_avalon_slave_irq_from_sa),
      .opencores_i2c_1_avalon_slave_readdata                          (opencores_i2c_1_avalon_slave_readdata),
      .opencores_i2c_1_avalon_slave_readdata_from_sa                  (opencores_i2c_1_avalon_slave_readdata_from_sa),
      .opencores_i2c_1_avalon_slave_reset                             (opencores_i2c_1_avalon_slave_reset),
      .opencores_i2c_1_avalon_slave_waitrequest_n                     (opencores_i2c_1_avalon_slave_waitrequest_n),
      .opencores_i2c_1_avalon_slave_waitrequest_n_from_sa             (opencores_i2c_1_avalon_slave_waitrequest_n_from_sa),
      .opencores_i2c_1_avalon_slave_write                             (opencores_i2c_1_avalon_slave_write),
      .opencores_i2c_1_avalon_slave_writedata                         (opencores_i2c_1_avalon_slave_writedata),
      .reset_n                                                        (sys_clk_reset_n)
    );

  opencores_i2c_1 the_opencores_i2c_1
    (
      .scl_pad_io (scl_pad_io_to_and_from_the_opencores_i2c_1),
      .sda_pad_io (sda_pad_io_to_and_from_the_opencores_i2c_1),
      .wb_ack_o   (opencores_i2c_1_avalon_slave_waitrequest_n),
      .wb_adr_i   (opencores_i2c_1_avalon_slave_address),
      .wb_clk_i   (sys_clk),
      .wb_dat_i   (opencores_i2c_1_avalon_slave_writedata),
      .wb_dat_o   (opencores_i2c_1_avalon_slave_readdata),
      .wb_inta_o  (opencores_i2c_1_avalon_slave_irq),
      .wb_rst_i   (opencores_i2c_1_avalon_slave_reset),
      .wb_stb_i   (opencores_i2c_1_avalon_slave_chipselect),
      .wb_we_i    (opencores_i2c_1_avalon_slave_write)
    );

  spi_0_p0_spi_control_port_arbitrator the_spi_0_p0_spi_control_port
    (
      .clk                                                         (sys_clk),
      .cpu_data_master_address_to_slave                            (cpu_data_master_address_to_slave),
      .cpu_data_master_granted_spi_0_p0_spi_control_port           (cpu_data_master_granted_spi_0_p0_spi_control_port),
      .cpu_data_master_qualified_request_spi_0_p0_spi_control_port (cpu_data_master_qualified_request_spi_0_p0_spi_control_port),
      .cpu_data_master_read                                        (cpu_data_master_read),
      .cpu_data_master_read_data_valid_spi_0_p0_spi_control_port   (cpu_data_master_read_data_valid_spi_0_p0_spi_control_port),
      .cpu_data_master_requests_spi_0_p0_spi_control_port          (cpu_data_master_requests_spi_0_p0_spi_control_port),
      .cpu_data_master_write                                       (cpu_data_master_write),
      .cpu_data_master_writedata                                   (cpu_data_master_writedata),
      .d1_spi_0_p0_spi_control_port_end_xfer                       (d1_spi_0_p0_spi_control_port_end_xfer),
      .reset_n                                                     (sys_clk_reset_n),
      .spi_0_p0_spi_control_port_address                           (spi_0_p0_spi_control_port_address),
      .spi_0_p0_spi_control_port_chipselect                        (spi_0_p0_spi_control_port_chipselect),
      .spi_0_p0_spi_control_port_dataavailable                     (spi_0_p0_spi_control_port_dataavailable),
      .spi_0_p0_spi_control_port_dataavailable_from_sa             (spi_0_p0_spi_control_port_dataavailable_from_sa),
      .spi_0_p0_spi_control_port_endofpacket                       (spi_0_p0_spi_control_port_endofpacket),
      .spi_0_p0_spi_control_port_endofpacket_from_sa               (spi_0_p0_spi_control_port_endofpacket_from_sa),
      .spi_0_p0_spi_control_port_irq                               (spi_0_p0_spi_control_port_irq),
      .spi_0_p0_spi_control_port_irq_from_sa                       (spi_0_p0_spi_control_port_irq_from_sa),
      .spi_0_p0_spi_control_port_read_n                            (spi_0_p0_spi_control_port_read_n),
      .spi_0_p0_spi_control_port_readdata                          (spi_0_p0_spi_control_port_readdata),
      .spi_0_p0_spi_control_port_readdata_from_sa                  (spi_0_p0_spi_control_port_readdata_from_sa),
      .spi_0_p0_spi_control_port_readyfordata                      (spi_0_p0_spi_control_port_readyfordata),
      .spi_0_p0_spi_control_port_readyfordata_from_sa              (spi_0_p0_spi_control_port_readyfordata_from_sa),
      .spi_0_p0_spi_control_port_reset_n                           (spi_0_p0_spi_control_port_reset_n),
      .spi_0_p0_spi_control_port_write_n                           (spi_0_p0_spi_control_port_write_n),
      .spi_0_p0_spi_control_port_writedata                         (spi_0_p0_spi_control_port_writedata)
    );

  spi_0_p0 the_spi_0_p0
    (
      .MISO          (MISO_to_the_spi_0_p0),
      .MOSI          (MOSI_from_the_spi_0_p0),
      .SCLK          (SCLK_from_the_spi_0_p0),
      .SS_n          (SS_n_from_the_spi_0_p0),
      .clk           (sys_clk),
      .data_from_cpu (spi_0_p0_spi_control_port_writedata),
      .data_to_cpu   (spi_0_p0_spi_control_port_readdata),
      .dataavailable (spi_0_p0_spi_control_port_dataavailable),
      .endofpacket   (spi_0_p0_spi_control_port_endofpacket),
      .irq           (spi_0_p0_spi_control_port_irq),
      .mem_addr      (spi_0_p0_spi_control_port_address),
      .read_n        (spi_0_p0_spi_control_port_read_n),
      .readyfordata  (spi_0_p0_spi_control_port_readyfordata),
      .reset_n       (spi_0_p0_spi_control_port_reset_n),
      .spi_select    (spi_0_p0_spi_control_port_chipselect),
      .write_n       (spi_0_p0_spi_control_port_write_n)
    );

  spi_0_p1_spi_control_port_arbitrator the_spi_0_p1_spi_control_port
    (
      .clk                                                         (sys_clk),
      .cpu_data_master_address_to_slave                            (cpu_data_master_address_to_slave),
      .cpu_data_master_granted_spi_0_p1_spi_control_port           (cpu_data_master_granted_spi_0_p1_spi_control_port),
      .cpu_data_master_qualified_request_spi_0_p1_spi_control_port (cpu_data_master_qualified_request_spi_0_p1_spi_control_port),
      .cpu_data_master_read                                        (cpu_data_master_read),
      .cpu_data_master_read_data_valid_spi_0_p1_spi_control_port   (cpu_data_master_read_data_valid_spi_0_p1_spi_control_port),
      .cpu_data_master_requests_spi_0_p1_spi_control_port          (cpu_data_master_requests_spi_0_p1_spi_control_port),
      .cpu_data_master_write                                       (cpu_data_master_write),
      .cpu_data_master_writedata                                   (cpu_data_master_writedata),
      .d1_spi_0_p1_spi_control_port_end_xfer                       (d1_spi_0_p1_spi_control_port_end_xfer),
      .reset_n                                                     (sys_clk_reset_n),
      .spi_0_p1_spi_control_port_address                           (spi_0_p1_spi_control_port_address),
      .spi_0_p1_spi_control_port_chipselect                        (spi_0_p1_spi_control_port_chipselect),
      .spi_0_p1_spi_control_port_dataavailable                     (spi_0_p1_spi_control_port_dataavailable),
      .spi_0_p1_spi_control_port_dataavailable_from_sa             (spi_0_p1_spi_control_port_dataavailable_from_sa),
      .spi_0_p1_spi_control_port_endofpacket                       (spi_0_p1_spi_control_port_endofpacket),
      .spi_0_p1_spi_control_port_endofpacket_from_sa               (spi_0_p1_spi_control_port_endofpacket_from_sa),
      .spi_0_p1_spi_control_port_irq                               (spi_0_p1_spi_control_port_irq),
      .spi_0_p1_spi_control_port_irq_from_sa                       (spi_0_p1_spi_control_port_irq_from_sa),
      .spi_0_p1_spi_control_port_read_n                            (spi_0_p1_spi_control_port_read_n),
      .spi_0_p1_spi_control_port_readdata                          (spi_0_p1_spi_control_port_readdata),
      .spi_0_p1_spi_control_port_readdata_from_sa                  (spi_0_p1_spi_control_port_readdata_from_sa),
      .spi_0_p1_spi_control_port_readyfordata                      (spi_0_p1_spi_control_port_readyfordata),
      .spi_0_p1_spi_control_port_readyfordata_from_sa              (spi_0_p1_spi_control_port_readyfordata_from_sa),
      .spi_0_p1_spi_control_port_reset_n                           (spi_0_p1_spi_control_port_reset_n),
      .spi_0_p1_spi_control_port_write_n                           (spi_0_p1_spi_control_port_write_n),
      .spi_0_p1_spi_control_port_writedata                         (spi_0_p1_spi_control_port_writedata)
    );

  spi_0_p1 the_spi_0_p1
    (
      .MISO          (MISO_to_the_spi_0_p1),
      .MOSI          (MOSI_from_the_spi_0_p1),
      .SCLK          (SCLK_from_the_spi_0_p1),
      .SS_n          (SS_n_from_the_spi_0_p1),
      .clk           (sys_clk),
      .data_from_cpu (spi_0_p1_spi_control_port_writedata),
      .data_to_cpu   (spi_0_p1_spi_control_port_readdata),
      .dataavailable (spi_0_p1_spi_control_port_dataavailable),
      .endofpacket   (spi_0_p1_spi_control_port_endofpacket),
      .irq           (spi_0_p1_spi_control_port_irq),
      .mem_addr      (spi_0_p1_spi_control_port_address),
      .read_n        (spi_0_p1_spi_control_port_read_n),
      .readyfordata  (spi_0_p1_spi_control_port_readyfordata),
      .reset_n       (spi_0_p1_spi_control_port_reset_n),
      .spi_select    (spi_0_p1_spi_control_port_chipselect),
      .write_n       (spi_0_p1_spi_control_port_write_n)
    );

  spi_1_p0_spi_control_port_arbitrator the_spi_1_p0_spi_control_port
    (
      .clk                                                         (sys_clk),
      .cpu_data_master_address_to_slave                            (cpu_data_master_address_to_slave),
      .cpu_data_master_granted_spi_1_p0_spi_control_port           (cpu_data_master_granted_spi_1_p0_spi_control_port),
      .cpu_data_master_qualified_request_spi_1_p0_spi_control_port (cpu_data_master_qualified_request_spi_1_p0_spi_control_port),
      .cpu_data_master_read                                        (cpu_data_master_read),
      .cpu_data_master_read_data_valid_spi_1_p0_spi_control_port   (cpu_data_master_read_data_valid_spi_1_p0_spi_control_port),
      .cpu_data_master_requests_spi_1_p0_spi_control_port          (cpu_data_master_requests_spi_1_p0_spi_control_port),
      .cpu_data_master_write                                       (cpu_data_master_write),
      .cpu_data_master_writedata                                   (cpu_data_master_writedata),
      .d1_spi_1_p0_spi_control_port_end_xfer                       (d1_spi_1_p0_spi_control_port_end_xfer),
      .reset_n                                                     (sys_clk_reset_n),
      .spi_1_p0_spi_control_port_address                           (spi_1_p0_spi_control_port_address),
      .spi_1_p0_spi_control_port_chipselect                        (spi_1_p0_spi_control_port_chipselect),
      .spi_1_p0_spi_control_port_dataavailable                     (spi_1_p0_spi_control_port_dataavailable),
      .spi_1_p0_spi_control_port_dataavailable_from_sa             (spi_1_p0_spi_control_port_dataavailable_from_sa),
      .spi_1_p0_spi_control_port_endofpacket                       (spi_1_p0_spi_control_port_endofpacket),
      .spi_1_p0_spi_control_port_endofpacket_from_sa               (spi_1_p0_spi_control_port_endofpacket_from_sa),
      .spi_1_p0_spi_control_port_irq                               (spi_1_p0_spi_control_port_irq),
      .spi_1_p0_spi_control_port_irq_from_sa                       (spi_1_p0_spi_control_port_irq_from_sa),
      .spi_1_p0_spi_control_port_read_n                            (spi_1_p0_spi_control_port_read_n),
      .spi_1_p0_spi_control_port_readdata                          (spi_1_p0_spi_control_port_readdata),
      .spi_1_p0_spi_control_port_readdata_from_sa                  (spi_1_p0_spi_control_port_readdata_from_sa),
      .spi_1_p0_spi_control_port_readyfordata                      (spi_1_p0_spi_control_port_readyfordata),
      .spi_1_p0_spi_control_port_readyfordata_from_sa              (spi_1_p0_spi_control_port_readyfordata_from_sa),
      .spi_1_p0_spi_control_port_reset_n                           (spi_1_p0_spi_control_port_reset_n),
      .spi_1_p0_spi_control_port_write_n                           (spi_1_p0_spi_control_port_write_n),
      .spi_1_p0_spi_control_port_writedata                         (spi_1_p0_spi_control_port_writedata)
    );

  spi_1_p0 the_spi_1_p0
    (
      .MISO          (MISO_to_the_spi_1_p0),
      .MOSI          (MOSI_from_the_spi_1_p0),
      .SCLK          (SCLK_from_the_spi_1_p0),
      .SS_n          (SS_n_from_the_spi_1_p0),
      .clk           (sys_clk),
      .data_from_cpu (spi_1_p0_spi_control_port_writedata),
      .data_to_cpu   (spi_1_p0_spi_control_port_readdata),
      .dataavailable (spi_1_p0_spi_control_port_dataavailable),
      .endofpacket   (spi_1_p0_spi_control_port_endofpacket),
      .irq           (spi_1_p0_spi_control_port_irq),
      .mem_addr      (spi_1_p0_spi_control_port_address),
      .read_n        (spi_1_p0_spi_control_port_read_n),
      .readyfordata  (spi_1_p0_spi_control_port_readyfordata),
      .reset_n       (spi_1_p0_spi_control_port_reset_n),
      .spi_select    (spi_1_p0_spi_control_port_chipselect),
      .write_n       (spi_1_p0_spi_control_port_write_n)
    );

  spi_1_p1_spi_control_port_arbitrator the_spi_1_p1_spi_control_port
    (
      .clk                                                         (sys_clk),
      .cpu_data_master_address_to_slave                            (cpu_data_master_address_to_slave),
      .cpu_data_master_granted_spi_1_p1_spi_control_port           (cpu_data_master_granted_spi_1_p1_spi_control_port),
      .cpu_data_master_qualified_request_spi_1_p1_spi_control_port (cpu_data_master_qualified_request_spi_1_p1_spi_control_port),
      .cpu_data_master_read                                        (cpu_data_master_read),
      .cpu_data_master_read_data_valid_spi_1_p1_spi_control_port   (cpu_data_master_read_data_valid_spi_1_p1_spi_control_port),
      .cpu_data_master_requests_spi_1_p1_spi_control_port          (cpu_data_master_requests_spi_1_p1_spi_control_port),
      .cpu_data_master_write                                       (cpu_data_master_write),
      .cpu_data_master_writedata                                   (cpu_data_master_writedata),
      .d1_spi_1_p1_spi_control_port_end_xfer                       (d1_spi_1_p1_spi_control_port_end_xfer),
      .reset_n                                                     (sys_clk_reset_n),
      .spi_1_p1_spi_control_port_address                           (spi_1_p1_spi_control_port_address),
      .spi_1_p1_spi_control_port_chipselect                        (spi_1_p1_spi_control_port_chipselect),
      .spi_1_p1_spi_control_port_dataavailable                     (spi_1_p1_spi_control_port_dataavailable),
      .spi_1_p1_spi_control_port_dataavailable_from_sa             (spi_1_p1_spi_control_port_dataavailable_from_sa),
      .spi_1_p1_spi_control_port_endofpacket                       (spi_1_p1_spi_control_port_endofpacket),
      .spi_1_p1_spi_control_port_endofpacket_from_sa               (spi_1_p1_spi_control_port_endofpacket_from_sa),
      .spi_1_p1_spi_control_port_irq                               (spi_1_p1_spi_control_port_irq),
      .spi_1_p1_spi_control_port_irq_from_sa                       (spi_1_p1_spi_control_port_irq_from_sa),
      .spi_1_p1_spi_control_port_read_n                            (spi_1_p1_spi_control_port_read_n),
      .spi_1_p1_spi_control_port_readdata                          (spi_1_p1_spi_control_port_readdata),
      .spi_1_p1_spi_control_port_readdata_from_sa                  (spi_1_p1_spi_control_port_readdata_from_sa),
      .spi_1_p1_spi_control_port_readyfordata                      (spi_1_p1_spi_control_port_readyfordata),
      .spi_1_p1_spi_control_port_readyfordata_from_sa              (spi_1_p1_spi_control_port_readyfordata_from_sa),
      .spi_1_p1_spi_control_port_reset_n                           (spi_1_p1_spi_control_port_reset_n),
      .spi_1_p1_spi_control_port_write_n                           (spi_1_p1_spi_control_port_write_n),
      .spi_1_p1_spi_control_port_writedata                         (spi_1_p1_spi_control_port_writedata)
    );

  spi_1_p1 the_spi_1_p1
    (
      .MISO          (MISO_to_the_spi_1_p1),
      .MOSI          (MOSI_from_the_spi_1_p1),
      .SCLK          (SCLK_from_the_spi_1_p1),
      .SS_n          (SS_n_from_the_spi_1_p1),
      .clk           (sys_clk),
      .data_from_cpu (spi_1_p1_spi_control_port_writedata),
      .data_to_cpu   (spi_1_p1_spi_control_port_readdata),
      .dataavailable (spi_1_p1_spi_control_port_dataavailable),
      .endofpacket   (spi_1_p1_spi_control_port_endofpacket),
      .irq           (spi_1_p1_spi_control_port_irq),
      .mem_addr      (spi_1_p1_spi_control_port_address),
      .read_n        (spi_1_p1_spi_control_port_read_n),
      .readyfordata  (spi_1_p1_spi_control_port_readyfordata),
      .reset_n       (spi_1_p1_spi_control_port_reset_n),
      .spi_select    (spi_1_p1_spi_control_port_chipselect),
      .write_n       (spi_1_p1_spi_control_port_write_n)
    );

  sysid_control_slave_arbitrator the_sysid_control_slave
    (
      .clk                                                   (sys_clk),
      .cpu_data_master_address_to_slave                      (cpu_data_master_address_to_slave),
      .cpu_data_master_granted_sysid_control_slave           (cpu_data_master_granted_sysid_control_slave),
      .cpu_data_master_qualified_request_sysid_control_slave (cpu_data_master_qualified_request_sysid_control_slave),
      .cpu_data_master_read                                  (cpu_data_master_read),
      .cpu_data_master_read_data_valid_sysid_control_slave   (cpu_data_master_read_data_valid_sysid_control_slave),
      .cpu_data_master_requests_sysid_control_slave          (cpu_data_master_requests_sysid_control_slave),
      .cpu_data_master_write                                 (cpu_data_master_write),
      .d1_sysid_control_slave_end_xfer                       (d1_sysid_control_slave_end_xfer),
      .reset_n                                               (sys_clk_reset_n),
      .sysid_control_slave_address                           (sysid_control_slave_address),
      .sysid_control_slave_readdata                          (sysid_control_slave_readdata),
      .sysid_control_slave_readdata_from_sa                  (sysid_control_slave_readdata_from_sa),
      .sysid_control_slave_reset_n                           (sysid_control_slave_reset_n)
    );

  sysid the_sysid
    (
      .address  (sysid_control_slave_address),
      .clock    (sysid_control_slave_clock),
      .readdata (sysid_control_slave_readdata),
      .reset_n  (sysid_control_slave_reset_n)
    );

  timer_s1_arbitrator the_timer_s1
    (
      .clk                                        (sys_clk),
      .cpu_data_master_address_to_slave           (cpu_data_master_address_to_slave),
      .cpu_data_master_granted_timer_s1           (cpu_data_master_granted_timer_s1),
      .cpu_data_master_qualified_request_timer_s1 (cpu_data_master_qualified_request_timer_s1),
      .cpu_data_master_read                       (cpu_data_master_read),
      .cpu_data_master_read_data_valid_timer_s1   (cpu_data_master_read_data_valid_timer_s1),
      .cpu_data_master_requests_timer_s1          (cpu_data_master_requests_timer_s1),
      .cpu_data_master_waitrequest                (cpu_data_master_waitrequest),
      .cpu_data_master_write                      (cpu_data_master_write),
      .cpu_data_master_writedata                  (cpu_data_master_writedata),
      .d1_timer_s1_end_xfer                       (d1_timer_s1_end_xfer),
      .reset_n                                    (sys_clk_reset_n),
      .timer_s1_address                           (timer_s1_address),
      .timer_s1_chipselect                        (timer_s1_chipselect),
      .timer_s1_irq                               (timer_s1_irq),
      .timer_s1_irq_from_sa                       (timer_s1_irq_from_sa),
      .timer_s1_readdata                          (timer_s1_readdata),
      .timer_s1_readdata_from_sa                  (timer_s1_readdata_from_sa),
      .timer_s1_reset_n                           (timer_s1_reset_n),
      .timer_s1_write_n                           (timer_s1_write_n),
      .timer_s1_writedata                         (timer_s1_writedata)
    );

  timer the_timer
    (
      .address    (timer_s1_address),
      .chipselect (timer_s1_chipselect),
      .clk        (sys_clk),
      .irq        (timer_s1_irq),
      .readdata   (timer_s1_readdata),
      .reset_n    (timer_s1_reset_n),
      .write_n    (timer_s1_write_n),
      .writedata  (timer_s1_writedata)
    );

  uCProbe_uart_avalon_jtag_slave_arbitrator the_uCProbe_uart_avalon_jtag_slave
    (
      .clk                                                              (sys_clk),
      .cpu_data_master_address_to_slave                                 (cpu_data_master_address_to_slave),
      .cpu_data_master_granted_uCProbe_uart_avalon_jtag_slave           (cpu_data_master_granted_uCProbe_uart_avalon_jtag_slave),
      .cpu_data_master_qualified_request_uCProbe_uart_avalon_jtag_slave (cpu_data_master_qualified_request_uCProbe_uart_avalon_jtag_slave),
      .cpu_data_master_read                                             (cpu_data_master_read),
      .cpu_data_master_read_data_valid_uCProbe_uart_avalon_jtag_slave   (cpu_data_master_read_data_valid_uCProbe_uart_avalon_jtag_slave),
      .cpu_data_master_requests_uCProbe_uart_avalon_jtag_slave          (cpu_data_master_requests_uCProbe_uart_avalon_jtag_slave),
      .cpu_data_master_waitrequest                                      (cpu_data_master_waitrequest),
      .cpu_data_master_write                                            (cpu_data_master_write),
      .cpu_data_master_writedata                                        (cpu_data_master_writedata),
      .d1_uCProbe_uart_avalon_jtag_slave_end_xfer                       (d1_uCProbe_uart_avalon_jtag_slave_end_xfer),
      .reset_n                                                          (sys_clk_reset_n),
      .uCProbe_uart_avalon_jtag_slave_address                           (uCProbe_uart_avalon_jtag_slave_address),
      .uCProbe_uart_avalon_jtag_slave_chipselect                        (uCProbe_uart_avalon_jtag_slave_chipselect),
      .uCProbe_uart_avalon_jtag_slave_dataavailable                     (uCProbe_uart_avalon_jtag_slave_dataavailable),
      .uCProbe_uart_avalon_jtag_slave_dataavailable_from_sa             (uCProbe_uart_avalon_jtag_slave_dataavailable_from_sa),
      .uCProbe_uart_avalon_jtag_slave_irq                               (uCProbe_uart_avalon_jtag_slave_irq),
      .uCProbe_uart_avalon_jtag_slave_irq_from_sa                       (uCProbe_uart_avalon_jtag_slave_irq_from_sa),
      .uCProbe_uart_avalon_jtag_slave_read_n                            (uCProbe_uart_avalon_jtag_slave_read_n),
      .uCProbe_uart_avalon_jtag_slave_readdata                          (uCProbe_uart_avalon_jtag_slave_readdata),
      .uCProbe_uart_avalon_jtag_slave_readdata_from_sa                  (uCProbe_uart_avalon_jtag_slave_readdata_from_sa),
      .uCProbe_uart_avalon_jtag_slave_readyfordata                      (uCProbe_uart_avalon_jtag_slave_readyfordata),
      .uCProbe_uart_avalon_jtag_slave_readyfordata_from_sa              (uCProbe_uart_avalon_jtag_slave_readyfordata_from_sa),
      .uCProbe_uart_avalon_jtag_slave_reset_n                           (uCProbe_uart_avalon_jtag_slave_reset_n),
      .uCProbe_uart_avalon_jtag_slave_waitrequest                       (uCProbe_uart_avalon_jtag_slave_waitrequest),
      .uCProbe_uart_avalon_jtag_slave_waitrequest_from_sa               (uCProbe_uart_avalon_jtag_slave_waitrequest_from_sa),
      .uCProbe_uart_avalon_jtag_slave_write_n                           (uCProbe_uart_avalon_jtag_slave_write_n),
      .uCProbe_uart_avalon_jtag_slave_writedata                         (uCProbe_uart_avalon_jtag_slave_writedata)
    );

  uCProbe_uart the_uCProbe_uart
    (
      .av_address     (uCProbe_uart_avalon_jtag_slave_address),
      .av_chipselect  (uCProbe_uart_avalon_jtag_slave_chipselect),
      .av_irq         (uCProbe_uart_avalon_jtag_slave_irq),
      .av_read_n      (uCProbe_uart_avalon_jtag_slave_read_n),
      .av_readdata    (uCProbe_uart_avalon_jtag_slave_readdata),
      .av_waitrequest (uCProbe_uart_avalon_jtag_slave_waitrequest),
      .av_write_n     (uCProbe_uart_avalon_jtag_slave_write_n),
      .av_writedata   (uCProbe_uart_avalon_jtag_slave_writedata),
      .clk            (sys_clk),
      .dataavailable  (uCProbe_uart_avalon_jtag_slave_dataavailable),
      .readyfordata   (uCProbe_uart_avalon_jtag_slave_readyfordata),
      .rst_n          (uCProbe_uart_avalon_jtag_slave_reset_n)
    );

  uC_clock_0_in_arbitrator the_uC_clock_0_in
    (
      .clk                                             (sys_clk),
      .cpu_data_master_address_to_slave                (cpu_data_master_address_to_slave),
      .cpu_data_master_byteenable                      (cpu_data_master_byteenable),
      .cpu_data_master_granted_uC_clock_0_in           (cpu_data_master_granted_uC_clock_0_in),
      .cpu_data_master_qualified_request_uC_clock_0_in (cpu_data_master_qualified_request_uC_clock_0_in),
      .cpu_data_master_read                            (cpu_data_master_read),
      .cpu_data_master_read_data_valid_uC_clock_0_in   (cpu_data_master_read_data_valid_uC_clock_0_in),
      .cpu_data_master_requests_uC_clock_0_in          (cpu_data_master_requests_uC_clock_0_in),
      .cpu_data_master_waitrequest                     (cpu_data_master_waitrequest),
      .cpu_data_master_write                           (cpu_data_master_write),
      .cpu_data_master_writedata                       (cpu_data_master_writedata),
      .d1_uC_clock_0_in_end_xfer                       (d1_uC_clock_0_in_end_xfer),
      .reset_n                                         (sys_clk_reset_n),
      .uC_clock_0_in_address                           (uC_clock_0_in_address),
      .uC_clock_0_in_byteenable                        (uC_clock_0_in_byteenable),
      .uC_clock_0_in_endofpacket                       (uC_clock_0_in_endofpacket),
      .uC_clock_0_in_endofpacket_from_sa               (uC_clock_0_in_endofpacket_from_sa),
      .uC_clock_0_in_nativeaddress                     (uC_clock_0_in_nativeaddress),
      .uC_clock_0_in_read                              (uC_clock_0_in_read),
      .uC_clock_0_in_readdata                          (uC_clock_0_in_readdata),
      .uC_clock_0_in_readdata_from_sa                  (uC_clock_0_in_readdata_from_sa),
      .uC_clock_0_in_reset_n                           (uC_clock_0_in_reset_n),
      .uC_clock_0_in_waitrequest                       (uC_clock_0_in_waitrequest),
      .uC_clock_0_in_waitrequest_from_sa               (uC_clock_0_in_waitrequest_from_sa),
      .uC_clock_0_in_write                             (uC_clock_0_in_write),
      .uC_clock_0_in_writedata                         (uC_clock_0_in_writedata)
    );

  uC_clock_0_out_arbitrator the_uC_clock_0_out
    (
      .altpll_0_pll_slave_readdata_from_sa                 (altpll_0_pll_slave_readdata_from_sa),
      .clk                                                 (ext_clk),
      .d1_altpll_0_pll_slave_end_xfer                      (d1_altpll_0_pll_slave_end_xfer),
      .reset_n                                             (ext_clk_reset_n),
      .uC_clock_0_out_address                              (uC_clock_0_out_address),
      .uC_clock_0_out_address_to_slave                     (uC_clock_0_out_address_to_slave),
      .uC_clock_0_out_byteenable                           (uC_clock_0_out_byteenable),
      .uC_clock_0_out_granted_altpll_0_pll_slave           (uC_clock_0_out_granted_altpll_0_pll_slave),
      .uC_clock_0_out_qualified_request_altpll_0_pll_slave (uC_clock_0_out_qualified_request_altpll_0_pll_slave),
      .uC_clock_0_out_read                                 (uC_clock_0_out_read),
      .uC_clock_0_out_read_data_valid_altpll_0_pll_slave   (uC_clock_0_out_read_data_valid_altpll_0_pll_slave),
      .uC_clock_0_out_readdata                             (uC_clock_0_out_readdata),
      .uC_clock_0_out_requests_altpll_0_pll_slave          (uC_clock_0_out_requests_altpll_0_pll_slave),
      .uC_clock_0_out_reset_n                              (uC_clock_0_out_reset_n),
      .uC_clock_0_out_waitrequest                          (uC_clock_0_out_waitrequest),
      .uC_clock_0_out_write                                (uC_clock_0_out_write),
      .uC_clock_0_out_writedata                            (uC_clock_0_out_writedata)
    );

  uC_clock_0 the_uC_clock_0
    (
      .master_address       (uC_clock_0_out_address),
      .master_byteenable    (uC_clock_0_out_byteenable),
      .master_clk           (ext_clk),
      .master_endofpacket   (uC_clock_0_out_endofpacket),
      .master_nativeaddress (uC_clock_0_out_nativeaddress),
      .master_read          (uC_clock_0_out_read),
      .master_readdata      (uC_clock_0_out_readdata),
      .master_reset_n       (uC_clock_0_out_reset_n),
      .master_waitrequest   (uC_clock_0_out_waitrequest),
      .master_write         (uC_clock_0_out_write),
      .master_writedata     (uC_clock_0_out_writedata),
      .slave_address        (uC_clock_0_in_address),
      .slave_byteenable     (uC_clock_0_in_byteenable),
      .slave_clk            (sys_clk),
      .slave_endofpacket    (uC_clock_0_in_endofpacket),
      .slave_nativeaddress  (uC_clock_0_in_nativeaddress),
      .slave_read           (uC_clock_0_in_read),
      .slave_readdata       (uC_clock_0_in_readdata),
      .slave_reset_n        (uC_clock_0_in_reset_n),
      .slave_waitrequest    (uC_clock_0_in_waitrequest),
      .slave_write          (uC_clock_0_in_write),
      .slave_writedata      (uC_clock_0_in_writedata)
    );

  //reset is asserted asynchronously and deasserted synchronously
  uC_reset_sys_clk_domain_synch_module uC_reset_sys_clk_domain_synch
    (
      .clk      (sys_clk),
      .data_in  (1'b1),
      .data_out (sys_clk_reset_n),
      .reset_n  (reset_n_sources)
    );

  //reset sources mux, which is an e_mux
  assign reset_n_sources = ~(~reset_n |
    0 |
    0 |
    cpu_jtag_debug_module_resetrequest_from_sa |
    cpu_jtag_debug_module_resetrequest_from_sa);

  //reset is asserted asynchronously and deasserted synchronously
  uC_reset_ext_clk_domain_synch_module uC_reset_ext_clk_domain_synch
    (
      .clk      (ext_clk),
      .data_in  (1'b1),
      .data_out (ext_clk_reset_n),
      .reset_n  (reset_n_sources)
    );

  //sysid_control_slave_clock of type clock does not connect to anything so wire it to default (0)
  assign sysid_control_slave_clock = 0;

  //uC_clock_0_out_endofpacket of type endofpacket does not connect to anything so wire it to default (0)
  assign uC_clock_0_out_endofpacket = 0;


endmodule


//synthesis translate_off



// <ALTERA_NOTE> CODE INSERTED BETWEEN HERE

// AND HERE WILL BE PRESERVED </ALTERA_NOTE>


// If user logic components use Altsync_Ram with convert_hex2ver.dll,
// set USE_convert_hex2ver in the user comments section above

// `ifdef USE_convert_hex2ver
// `else
// `define NO_PLI 1
// `endif

`include "d:/altera/12.0/quartus/eda/sim_lib/altera_mf.v"
`include "d:/altera/12.0/quartus/eda/sim_lib/220model.v"
`include "d:/altera/12.0/quartus/eda/sim_lib/sgate.v"
`include "ip/opencores_i2c/opencores_i2c.v"
`include "ip/opencores_i2c/i2c_master_bit_ctrl.v"
`include "ip/opencores_i2c/i2c_master_byte_ctrl.v"
`include "ip/opencores_i2c/i2c_master_defines.v"
`include "ip/opencores_i2c/i2c_master_top.v"
`include "ip/opencores_i2c/timescale.v"
`include "opencores_i2c_1.v"
`include "altpll_0.vo"
`include "opencores_i2c_0.v"
`include "uCProbe_uart.v"
`include "led.v"
`include "sysid.v"
`include "timer.v"
`include "onchip_ram.v"
`include "jtag_uart.v"
`include "spi_0_p1.v"
`include "uC_clock_0.v"
`include "epcs_flash_controller.v"
`include "cpu_test_bench.v"
`include "cpu_oci_test_bench.v"
`include "cpu_jtag_debug_module_tck.v"
`include "cpu_jtag_debug_module_sysclk.v"
`include "cpu_jtag_debug_module_wrapper.v"
`include "cpu.v"
`include "spi_1_p0.v"
`include "ctrl.v"
`include "spi_0_p0.v"
`include "gpio.v"
`include "adc_data_ready.v"
`include "spi_1_p1.v"

`timescale 1ns / 1ps

module test_bench 
;


  wire             MISO_to_the_spi_0_p0;
  wire             MISO_to_the_spi_0_p1;
  wire             MISO_to_the_spi_1_p0;
  wire             MISO_to_the_spi_1_p1;
  wire             MOSI_from_the_spi_0_p0;
  wire             MOSI_from_the_spi_0_p1;
  wire             MOSI_from_the_spi_1_p0;
  wire             MOSI_from_the_spi_1_p1;
  wire             SCLK_from_the_spi_0_p0;
  wire             SCLK_from_the_spi_0_p1;
  wire             SCLK_from_the_spi_1_p0;
  wire             SCLK_from_the_spi_1_p1;
  wire    [  2: 0] SS_n_from_the_spi_0_p0;
  wire    [  2: 0] SS_n_from_the_spi_0_p1;
  wire    [  2: 0] SS_n_from_the_spi_1_p0;
  wire    [  2: 0] SS_n_from_the_spi_1_p1;
  wire             areset_to_the_altpll_0;
  wire    [  7: 0] bidir_port_to_and_from_the_gpio;
  wire             clk;
  wire             data0_to_the_epcs_flash_controller;
  wire             dclk_from_the_epcs_flash_controller;
  wire             epcs_flash_controller_epcs_control_port_dataavailable_from_sa;
  wire             epcs_flash_controller_epcs_control_port_endofpacket_from_sa;
  wire             epcs_flash_controller_epcs_control_port_readyfordata_from_sa;
  reg              ext_clk;
  wire    [  2: 0] in_port_to_the_adc_data_ready;
  wire             jtag_uart_avalon_jtag_slave_dataavailable_from_sa;
  wire             jtag_uart_avalon_jtag_slave_readyfordata_from_sa;
  wire             locked_from_the_altpll_0;
  wire    [  7: 0] out_port_from_the_ctrl;
  wire    [  7: 0] out_port_from_the_led;
  wire             phasedone_from_the_altpll_0;
  reg              reset_n;
  wire             sce_from_the_epcs_flash_controller;
  wire             scl_pad_io_to_and_from_the_opencores_i2c_0;
  wire             scl_pad_io_to_and_from_the_opencores_i2c_1;
  wire             sda_pad_io_to_and_from_the_opencores_i2c_0;
  wire             sda_pad_io_to_and_from_the_opencores_i2c_1;
  wire             sdo_from_the_epcs_flash_controller;
  wire             spi_0_p0_spi_control_port_dataavailable_from_sa;
  wire             spi_0_p0_spi_control_port_endofpacket_from_sa;
  wire             spi_0_p0_spi_control_port_readyfordata_from_sa;
  wire             spi_0_p1_spi_control_port_dataavailable_from_sa;
  wire             spi_0_p1_spi_control_port_endofpacket_from_sa;
  wire             spi_0_p1_spi_control_port_readyfordata_from_sa;
  wire             spi_1_p0_spi_control_port_dataavailable_from_sa;
  wire             spi_1_p0_spi_control_port_endofpacket_from_sa;
  wire             spi_1_p0_spi_control_port_readyfordata_from_sa;
  wire             spi_1_p1_spi_control_port_dataavailable_from_sa;
  wire             spi_1_p1_spi_control_port_endofpacket_from_sa;
  wire             spi_1_p1_spi_control_port_readyfordata_from_sa;
  wire             sys_clk;
  wire             sysid_control_slave_clock;
  wire             uCProbe_uart_avalon_jtag_slave_dataavailable_from_sa;
  wire             uCProbe_uart_avalon_jtag_slave_readyfordata_from_sa;
  wire             uC_clock_0_in_endofpacket_from_sa;
  wire             uC_clock_0_out_endofpacket;
  wire    [  1: 0] uC_clock_0_out_nativeaddress;


// <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
//  add your signals and additional architecture here
// AND HERE WILL BE PRESERVED </ALTERA_NOTE>

  //Set us up the Dut
  uC DUT
    (
      .MISO_to_the_spi_0_p0                       (MISO_to_the_spi_0_p0),
      .MISO_to_the_spi_0_p1                       (MISO_to_the_spi_0_p1),
      .MISO_to_the_spi_1_p0                       (MISO_to_the_spi_1_p0),
      .MISO_to_the_spi_1_p1                       (MISO_to_the_spi_1_p1),
      .MOSI_from_the_spi_0_p0                     (MOSI_from_the_spi_0_p0),
      .MOSI_from_the_spi_0_p1                     (MOSI_from_the_spi_0_p1),
      .MOSI_from_the_spi_1_p0                     (MOSI_from_the_spi_1_p0),
      .MOSI_from_the_spi_1_p1                     (MOSI_from_the_spi_1_p1),
      .SCLK_from_the_spi_0_p0                     (SCLK_from_the_spi_0_p0),
      .SCLK_from_the_spi_0_p1                     (SCLK_from_the_spi_0_p1),
      .SCLK_from_the_spi_1_p0                     (SCLK_from_the_spi_1_p0),
      .SCLK_from_the_spi_1_p1                     (SCLK_from_the_spi_1_p1),
      .SS_n_from_the_spi_0_p0                     (SS_n_from_the_spi_0_p0),
      .SS_n_from_the_spi_0_p1                     (SS_n_from_the_spi_0_p1),
      .SS_n_from_the_spi_1_p0                     (SS_n_from_the_spi_1_p0),
      .SS_n_from_the_spi_1_p1                     (SS_n_from_the_spi_1_p1),
      .areset_to_the_altpll_0                     (areset_to_the_altpll_0),
      .bidir_port_to_and_from_the_gpio            (bidir_port_to_and_from_the_gpio),
      .data0_to_the_epcs_flash_controller         (data0_to_the_epcs_flash_controller),
      .dclk_from_the_epcs_flash_controller        (dclk_from_the_epcs_flash_controller),
      .ext_clk                                    (ext_clk),
      .in_port_to_the_adc_data_ready              (in_port_to_the_adc_data_ready),
      .locked_from_the_altpll_0                   (locked_from_the_altpll_0),
      .out_port_from_the_ctrl                     (out_port_from_the_ctrl),
      .out_port_from_the_led                      (out_port_from_the_led),
      .phasedone_from_the_altpll_0                (phasedone_from_the_altpll_0),
      .reset_n                                    (reset_n),
      .sce_from_the_epcs_flash_controller         (sce_from_the_epcs_flash_controller),
      .scl_pad_io_to_and_from_the_opencores_i2c_0 (scl_pad_io_to_and_from_the_opencores_i2c_0),
      .scl_pad_io_to_and_from_the_opencores_i2c_1 (scl_pad_io_to_and_from_the_opencores_i2c_1),
      .sda_pad_io_to_and_from_the_opencores_i2c_0 (sda_pad_io_to_and_from_the_opencores_i2c_0),
      .sda_pad_io_to_and_from_the_opencores_i2c_1 (sda_pad_io_to_and_from_the_opencores_i2c_1),
      .sdo_from_the_epcs_flash_controller         (sdo_from_the_epcs_flash_controller),
      .sys_clk                                    (sys_clk)
    );

  initial
    ext_clk = 1'b0;
  always
    #10 ext_clk <= ~ext_clk;
  
  initial 
    begin
      reset_n <= 0;
      #200 reset_n <= 1;
    end

endmodule


//synthesis translate_on